dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
if EntityHasTag(entity_id, "polymorphed_player") then
	local x, y = EntityGetTransform(entity_id)
	local var_comp = get_variable_storage_component( entity_id, "setup_poly_player" )
	
	if var_comp == nil then
		local comps = EntityGetAllComponents( entity_id) or {}
		for _, comp in ipairs(comps) do
			--remove the enemy scaling lua script
			if ComponentHasTag(comp, "remove_when_polyd") then
				EntityRemoveComponent(entity_id, comp)
			end
			if ComponentHasTag(comp, "enable_when_polyd") then
				EntitySetComponentIsEnabled( entity_id, comp, true )
			end
		end
	
		-- local player_controls = EntityGetComponentIncludingDisabled(entity_id, "ControlsComponent") or {}
		-- for _, control in ipairs(player_controls) do
			-- EntityRemoveComponent(entity_id, control)
		-- end

		-- local player_animals = EntityGetComponentIncludingDisabled(entity_id, "AnimalAIComponent") or {}
		-- for _, animal in ipairs(player_animals) do
			-- EntityRemoveComponent(entity_id, animal)
		-- end
		
		-- local player_animators = EntityGetComponentIncludingDisabled(entity_id, "SpriteAnimatorComponent") or {}
		-- for _, animator in ipairs(player_animators) do
			-- EntityRemoveComponent(entity_id, animator)
		-- end
		
		-- EntityAddComponent2(entity_id, "ControlsComponent", {
			-- enabled=true,
			-- polymorph_hax=true,
			-- gamepad_fire_on_thumbstick_extend=false,
			-- gamepad_fire_on_thumbstick_extend_threshold=0.9,
			-- gamepad_indirect_aiming_enabled=false,
		-- })
		
		-- EntityAddComponent2(entity_id, "LuaComponent", {
			-- script_source_file="data/entities/animals/poly/controls_ghost.lua",
			-- execute_every_n_frame=1
		-- }) 
		
		local ghost_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GhostComponent")
		if ghost_component then
			ComponentSetValue2(ghost_component, "die_if_no_home", false)
		end
		
		local damage_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageNearbyEntitiesComponent")
		if damage_component then
			ComponentSetValue2(damage_component, "target_tag", "mortal")
		end
		
		local damage_component2 = EntityGetFirstComponentIncludingDisabled(entity_id, "AreaDamageComponent")
		if damage_component2 then
			ComponentSetValue2(damage_component2, "entities_with_tag", "mortal")
		end
		
		local child_id = EntityLoad( "data/entities/animals/poly/ghost_target.xml",  x, y )
		-- EntityAddChild(entity_id, child_id)
	
		EntityAddComponent2(entity_id, "VariableStorageComponent", {
			name = "setup_poly_player"
		})
	end

end