dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local has_player_tag = EntityHasTag(entity_id, "polymorphed_player")
if has_player_tag == true then
	local x, y = EntityGetTransform(entity_id)
	local var_comp = get_variable_storage_component( entity_id, "setup_poly_player" )
	
	if var_comp == nil then
		local comps = EntityGetAllComponents( entity_id) or {}
		for _, comp in ipairs(comps) do
			--remove the enemy scaling lua script
			if ComponentHasTag(comp, "remove_when_polyd") then
				EntityRemoveComponent(entity_id, comp)
			end
			if ComponentHasTag(comp, "enable_when_polyd") then
				EntitySetComponentIsEnabled( entity_id, comp, true )
			end
		end
		
		local player_controls = EntityGetComponentIncludingDisabled(entity_id, "ControlsComponent") or {}
		for _, control in ipairs(player_controls) do
			EntityRemoveComponent(entity_id, control)
		end
		
		EntityAddComponent2(entity_id, "ControlsComponent", {
			enabled=true,
			polymorph_hax=true,
			gamepad_fire_on_thumbstick_extend=false,
			gamepad_fire_on_thumbstick_extend_threshold=0.9,
			gamepad_indirect_aiming_enabled=false,
		})
		
		EntityAddComponent2(entity_id, "LuaComponent", {
			script_source_file="data/entities/animals/poly/controls_physics_box2d.lua",
			execute_every_n_frame=1
		}) 
	
		EntityAddComponent2(entity_id, "VariableStorageComponent", {
			name = "setup_poly_player"
		})
	end

end