dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

function load_particle(material, px, py)
	local particle_id = EntityCreateNew(px, py)

	local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
		emitted_material_name=material,
		x_pos_offset_min=0,
		x_pos_offset_max=0,
		y_pos_offset_min=0,
		y_pos_offset_max=0,
		x_vel_min=0,
		x_vel_max=0,
		y_vel_min=0,
		y_vel_max=0,
		count_min=1,
		count_max=1,
		emission_interval_min_frames=0,
		emission_interval_max_frames=0,
		image_animation_file="data/particles/image_emitters/material_particle.png",
		image_animation_loop=true,
		emit_cosmetic_particles=false,
		create_real_particles=true
	} )
	ComponentSetValue2(particle_comp, "offset", 0, 0)
	
	EntityAddComponent2(particle_id, "LifetimeComponent", {
		lifetime=5,
	} )
end

local random_number = Random(1,2)

if random_number == 1 then

	go_right = true
	
elseif random_number == 2 then

	go_right = false
	
end

local no_movement = false

local did_hit_left = RaytracePlatforms(x - 1, y , x - 1, y)
local did_hit_right = RaytracePlatforms(x + 1, y, x + 1, y)
local did_hit_left_up = RaytracePlatforms(x - 1, y - 1 , x - 1, y -1)
local did_hit_right_up = RaytracePlatforms(x + 1, y - 1 , x + 1, y -1)
local did_hit_bottom = RaytracePlatforms(x, y + 1, x, y + 1)

if not did_hit_bottom then

	GameCreateParticle( "ant", x, y + 1, 1, 0, 0, false )
	
elseif go_right == true then

	if did_hit_right and not did_hit_right_up then
		GameCreateParticle( "ant", x + 1 , y - 1, 1, 0, 0, false )
	elseif not did_hit_right then
		GameCreateParticle( "ant", x + 1 , y + 1, 1, 0, 0, false )
	else
		no_movement = true
	end
	
elseif go_right == false then

	if did_hit_left and not did_hit_left_up then
		GameCreateParticle( "ant", x - 1 , y - 1, 1, 0, 0, false )
	elseif not did_hit_left then
		GameCreateParticle( "ant", x - 1 , y + 1, 1, 0, 0, false )
	else
		no_movement = true
	end
	
end

if no_movement == true then
	GameCreateParticle( "ant", x, y, 1, 0, 0, false )
end

EntityKill( entity_id )
