dofile_once("data/scripts/lib/utilities.lua")

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local state = get_state()
state.offset_x = state.offset_x or 0
state.offset_y = state.offset_y or 0

local in_water, hit_x, hit_y = RaytraceSurfacesAndLiquiform( x + state.offset_x, y + state.offset_y, x + state.offset_x, y + state.offset_x )
local in_solid, hit_x2, hit_y2 = RaytracePlatforms( x + state.offset_x, y + state.offset_y, x + state.offset_x, y + state.offset_y )
local in_particle, hit_x3, hit_y3 = Raytrace( x + state.offset_x, y + state.offset_y, x + state.offset_x, y + state.offset_y )
if ( in_water and not in_solid ) and ( HasFlagPersistent("nee_water_bugs") ) then
  SetRandomSeed( GameGetFrameNum(), x + y )
  local random_number = Random(1,4)
  if random_number == 1 then
    local desired_x = x + state.offset_x + Random(-16, 16)
	local desired_y = y + state.offset_y + Random(-16, 16)
    EntityLoad("data/entities/materials/water_bug_water_checker.xml", desired_x, desired_y)
	EntityLoad("data/entities/materials/water_bug_water_swamp_checker.xml", desired_x, desired_y)
  end
elseif in_solid and ( HasFlagPersistent("nee_earth_worms") ) then
  SetRandomSeed( GameGetFrameNum(), x + y )
  local random_number = Random(1,10)
  if random_number == 1 then
    local desired_x = x + state.offset_x + Random(-16, 16)
	local desired_y = y + state.offset_y + Random(-16, 16)
    EntityLoad("data/entities/materials/earth_worm_earth_checker.xml", desired_x, desired_y)
  end
elseif ( not in_particle ) and ( HasFlagPersistent("nee_spiders") ) then
  SetRandomSeed( GameGetFrameNum(), x + y )
  local random_number = Random(1,20)
  if random_number == 1 then
    local desired_x = x + state.offset_x + Random(-16, 16)
	local desired_y = y + state.offset_y + Random(-16, 16)
	EntityLoad("data/entities/materials/spider_air_checker.xml", desired_x, desired_y)
  end
end

if state.offset_y + 16 < 511 then
  if state.offset_x + 16 < 511 then
    state.offset_x = state.offset_x + 16
  else
    state.offset_x = 0
    state.offset_y = state.offset_y + 16
  end
else
  EntityKill(entity_id)
end