dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

function load_particle(material, px, py)
	local particle_id = EntityCreateNew()
	EntitySetTransform(particle_id, px, py)
	if px > 0 and py < 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=1,
			x_pos_offset_max=1,
			y_pos_offset_min=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="data/particles/image_emitters/material_particle2.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px < 0 and py < 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_min=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="data/particles/image_emitters/material_particle2.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px < 0 and py > 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_min=1,
			y_pos_offset_max=1,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="data/particles/image_emitters/material_particle2.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px > 0 and py > 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=1,
			x_pos_offset_max=1,
			y_pos_offset_min=1,
			y_pos_offset_max=1,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="data/particles/image_emitters/material_particle2.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	end
	
	EntityAddComponent2(particle_id, "LifetimeComponent", {
		lifetime=2,
	} )
end

local did_hit = Raytrace(x, y, x, y)

GamePrint("running")

if not did_hit then
	load_particle( "templebrick_static", x, y )
	GamePrint("restored")
end

EntityKill( entity_id )
