dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

function load_particle(material, px, py)
	local particle_id = EntityCreateNew()
	EntitySetTransform(particle_id, px, py)
	if px > 0 and py < 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=1,
			x_pos_offset_max=1,
			y_pos_offset_min=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="data/particles/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px < 0 and py < 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_min=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="data/particles/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px < 0 and py > 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_min=1,
			y_pos_offset_max=1,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="data/particles/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px > 0 and py > 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=1,
			x_pos_offset_max=1,
			y_pos_offset_min=1,
			y_pos_offset_max=1,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="data/particles/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	end
	
	EntityAddComponent2(particle_id, "LifetimeComponent", {
		lifetime=2,
	} )
end

local random_number = Random(1,8)

local no_movement = false

local did_hit_left = Raytrace(x - 1, y , x - 1, y)
local did_hit_right = Raytrace(x + 1, y, x + 1, y)
local did_hit_left_top = Raytrace(x - 1, y - 1 , x - 1, y -1)
local did_hit_right_top = Raytrace(x + 1, y - 1 , x + 1, y -1)
local did_hit_left_bottom = Raytrace(x - 1, y + 1 , x - 1, y + 1)
local did_hit_right_bottom = Raytrace(x + 1, y + 1 , x + 1, y + 1)
local did_hit_bottom = Raytrace(x, y + 1, x, y + 1)
local did_hit_top = Raytrace(x, y - 1, x, y - 1)

if ( random_number == 1 ) and not did_hit_left then

	load_particle( "snake_tail", x, y )
	load_particle( "snake", x - 1, y )
	
elseif ( random_number == 2 ) and not did_hit_right then

	load_particle( "snake_tail", x, y )
	load_particle( "snake", x + 1, y )
	
elseif ( random_number == 3 ) and not did_hit_left_top then

	load_particle( "snake_tail", x, y )
	load_particle( "snake_tail", x - 1, y )
	load_particle( "snake", x - 1, y - 1 )
	
elseif ( random_number == 4 ) and not did_hit_right_top then

	load_particle( "snake_tail", x, y )
	load_particle( "snake_tail", x + 1, y )
	load_particle( "snake", x + 1, y - 1 )

elseif ( random_number == 5 ) and not did_hit_left_bottom then

	load_particle( "snake_tail", x, y )
	load_particle( "snake_tail", x - 1, y )
	load_particle( "snake", x - 1, y + 1 )
	
elseif ( random_number == 6 ) and not did_hit_right_bottom then

	load_particle( "snake_tail", x, y )
	load_particle( "snake_tail", x + 1, y )
	load_particle( "snake", x + 1, y + 1 )

elseif ( random_number == 7 ) and not did_hit_top then

	load_particle( "snake_tail", x, y )
	load_particle( "snake", x, y - 1 )
	
elseif ( random_number == 8 ) and not did_hit_bottom then

	load_particle( "snake_tail", x, y )
	load_particle( "snake", x, y + 1 )
	
else

	local random_number2 = Random(1,10)
	local random_number3 = Random(1,4)
	
	if ( did_hit_left and did_hit_right and did_hit_bottom and did_hit_top and did_hit_right_bottom and did_hit_right_top and did_hit_left_bottom and did_hit_left_top ) then

		load_particle( "snake_tail", x, y )
		
	elseif random_number2 == 1 then
	
		if random_number3 == 1 then
			load_particle( "snake_flower_blue", x, y )
		else
			load_particle( "snake_tail", x, y )
		end
		
	elseif random_number2 == 2 then
	
		if random_number3 == 1 then
			load_particle( "snake_flower_orange", x, y )
		else
			load_particle( "snake_tail", x, y )
		end
		
	elseif random_number2 == 3 then
	
		if random_number3 == 1 then
			load_particle( "snake_flower_yellow", x, y )
		else
			load_particle( "snake_tail", x, y )
		end
		
	elseif random_number2 == 4 then
	
		if random_number3 == 1 then
			load_particle( "snake_flower_red", x, y )
		else
			load_particle( "snake_tail", x, y )
		end
		
	else
		load_particle( "snake", x, y )
	end
end

EntityKill( entity_id )
