function collision_trigger(colliding_entity)

	function Distance(x1, y1, x2, y2)
		local x1,x2,y1,y2 = x1 or 0,x2 or 0,y1 or 0,y2 or 0 --SHUT UP YA STOOPID ERRORS, ARE YA HAPPY NOW
		return math.sqrt(((x1-x2)^2) + ((y1-y2)^2))
	end--> distance
	function VecToRads(x,y,x2,y2)
		return math.atan2(y2-y, x2-x)
	end--> radians
	function RadsToVec(rads)
		return math.cos(rads), math.sin(rads)
	end--> vector x, y
	function rotatePoint(x,y,cx,cy,rads)
		local dist = Distance(x,y,cx,cy)
		local angle = VecToRads(cx,cy,x,y) + rads
		local add_x, add_y = RadsToVec(angle)
		local new_x, new_y = cx+(add_x*dist), cy+(add_y*dist)
		return new_x, new_y
	end--> rotated x, y
	function rotDiff(from_angle, to_angle) 
		local end1 = math.pi
		local end2 = -end1

		if from_angle < end2 then 
			from_angle = end1 + (from_angle - end2)
		elseif from_angle > end1 then 
			from_angle = end2 + (from_angle - end1)
		end
		if to_angle < end2 then 
			to_angle = end1 + (to_angle - end2)
		elseif to_angle > end1 then 
			to_angle = end2 + (to_angle - end1)
		end


		local route1 = to_angle-from_angle
		local route2 = (end2-from_angle) + (to_angle-end1)
		local route3 = (end1-from_angle) + (to_angle-end2)

		if math.abs(route1) <= math.abs(route2) then
			if math.abs(route1) <= math.abs(route3) then
				return route1
			else
				return route3
			end
		else
			if math.abs(route2) <= math.abs(route3) then
				return route2
			else
				return route3
			end
		end
	end--rotational difference


	local entity = GetUpdatedEntityID()
	local x, y, rot, sx, sy = EntityGetTransform(entity)
	local children = EntityGetAllChildren( entity )



	local spine_count = 0 --how many spines are there currently
	local spine_target_count = 5 --how many spines do we want
	local joints_per_spine = 4 --"num_points" - 1


		for i, spine in ipairs(EntityGetAllChildren(entity) or {}) do
			if EntityGetName(spine) == "spine" then
				local verlet_physics_component = EntityGetFirstComponent(spine, "VerletPhysicsComponent")
				local positions = ComponentGetValue2(verlet_physics_component, "positions")
				local positions_prev = ComponentGetValue2(verlet_physics_component, "positions_prev")

				--make the start of the chain stick up:
				local root_x, root_y = positions[1], positions[2] --the root of the spine
				local start_x, start_y = positions[3], positions[4] --the first spine segment
				local start_prev_x, start_prev_y = positions_prev[3], positions_prev[4]

				local dist1 = Distance(start_x, start_y, root_x, root_y)
				local dist2 = Distance(x, y, root_x, root_y)

				local start_targ_x, start_targ_y = root_x + ((root_x-x)/dist2)*dist1, root_y + ((root_y-y)/dist2)*dist1
				positions_prev[3], positions_prev[4] = start_prev_x - ((start_targ_x-start_x)), start_prev_y - ((start_targ_y-start_y))

				--make each segment line up with the one before it:
				for i=5,(joints_per_spine*2)-1,2 do
					local p1_x, p1_y = positions[i-4], positions[i-3] 
					local p2_x, p2_y = positions[i-2], positions[i-1]
					local p3_x, p3_y = positions[i], positions[i+1]
					local p1_prev_x, p1_prev_y = positions_prev[i-4], positions_prev[i-3]
					local p2_prev_x, p2_prev_y = positions_prev[i-2], positions_prev[i-1]
					local p3_prev_x, p3_prev_y = positions_prev[i], positions_prev[i+1]
					local mid_x, mid_y = (p1_x + p2_x + p3_x)/3, (p1_y + p2_y + p3_y)/3

					local dist1 = Distance(p2_x, p2_y, p1_x, p1_y)
					local vec1_x, vec1_y = (p1_x-p2_x)/dist1, (p1_y-p2_y)/dist1

					local dist2 = Distance(p2_x, p2_y, p3_x, p3_y)
					local vec2_x, vec2_y = (p3_x-p2_x)/dist2, (p3_y-p2_y)/dist2

					local dist3 = Distance(mid_x, mid_y, p2_x, p2_y)
					local vec3_x, vec3_y = (mid_x-p2_x)/dist3, (mid_y-p2_y)/dist3
					local invec_x, invec_y = -vec3_y, vec3_x

					local dp = (invec_x*vec2_x) + (invec_y*vec2_y)
					local accuracy = 1.2 - ((vec1_x*vec2_x) + (vec1_y*vec2_y))
					local which_side = dp / math.abs(dp)

					local p1_targ_x, p1_targ_y = mid_x - (invec_x*dist1*which_side*accuracy), mid_y - (invec_y*dist1*which_side*accuracy)
					local p2_targ_x, p2_targ_y = mid_x, mid_y
					local p3_targ_x, p3_targ_y = mid_x + (invec_x*dist2*which_side*accuracy), mid_y + (invec_y*dist2*which_side*accuracy)

					positions_prev[i-4], positions_prev[i-3] = ((p1_prev_x*2) + (p1_x - ((p1_targ_x-p1_x))))/3, ((p1_prev_y*2) + (p1_y - ((p1_targ_y-p1_y))))/3
					positions_prev[i-2], positions_prev[i-1] = ((p2_prev_x*2) + (p2_x - ((p2_targ_x-p2_x))))/3, ((p2_prev_y*2) + (p2_y - ((p2_targ_y-p2_y))))/3
					positions_prev[i], positions_prev[i+1] = ((p3_prev_x*2) + (p3_x - ((p3_targ_x-p3_x))))/3, ((p3_prev_y*2) + (p3_y - ((p3_targ_y-p3_y))))/3
				end

				local encountered_nan = false
				for i, val in ipairs(positions_prev) do
					if not ((val >= 0) or (val <= 0)) then
						encountered_nan = true
					end
				end
				if not encountered_nan then ComponentSetValue2( verlet_physics_component, "positions_prev", positions_prev) end


				spine_count = spine_count + 1
			end
		end

end