dofile_once( "data/scripts/lib/utilities.lua" )
dofile( "data/scripts/projectiles/overmind.lua" )
-- dofile( "data/scripts/game_helpers.lua" )

local dash_velocity = 200

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

local orbcount = GameGetOrbCountThisRun()
local players = EntityGetWithTag("player_unit")

function get_distance( x1, y1, x2, y2 )
	local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
	return result
end

if #players > 0 then
	local px, py = EntityGetTransform(players[1])
	local did_hit = RaytracePlatforms(x, y, px, py)

	local dist = get_distance(x, y, px, py)
	if ( ( did_hit or (dist > 200) ) and orbcount > 5 ) and ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 2 == 0 ) then
		shoot_at_entity(entity_id, players[1], 1, 0, 0, 200, "data/entities/projectiles/bird_flame_formation.xml", 9999999, 99999999)
		if orbcount > 7 then
			shoot_projectile( entity_id, "data/entities/projectiles/ring_explosion.xml", px, py, 0, 0, false )
		end
	end
end

local enemy, enemy_x, enemy_y
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 250, "player_unit")) do
	-- is target a valid enemy
	if entity_id ~= id and EntityGetParent(id) ~= entity_id then
		local entity_x, entity_y = EntityGetFirstHitboxCenter( id )

		enemy = id
		enemy_x = entity_x
		enemy_y = entity_y
	end
end

--do nothing if there's no target

if not enemy then return end

--make sure the enemy is seeing the target

local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y - 13 , enemy_x, enemy_y)


--make sure the enemy is facing towards the target

if not did_hit and ( ( enemy_x < x and scale_x < 0 ) or ( enemy_x > x and scale_x > 0 ) ) then


	--Set velocity direction towards Target 
	-- local vel_x, vel_y = vec_sub(enemy_x, enemy_y, x, y)
	-- vel_x,vel_y = vec_normalize(vel_x, vel_y)
	-- vel_x,vel_y = vec_mult(vel_x,vel_y, dash_velocity)
	
	-- --Set power of dash depending on distance of target from enemy
	
	-- local distance = get_distance(x, y, enemy_x, enemy_y)
	-- local max_power_at_distance = 50
	-- local scaled_vel_x = math.min(1, distance / max_power_at_distance) * vel_x * 6
	-- local scaled_vel_y = math.min(1, distance / max_power_at_distance) * vel_y * 6
	
	--getting the direction to go to
	local dir = get_direction(x, y, enemy_x, enemy_y)
	local force = 200 + (orbcount * 2)
	local force_x = math.cos(dir) * ( force / 2 )
	local force_y = math.sin(dir) * ( force * 400000 )
	
	local force_x2 = math.cos(dir) * ( force / 2 )
	local force_y2 = math.sin(dir) * ( force / 2 )
	if orbcount > 12 then
		shoot_projectile( entity_id, "data/entities/projectiles/bird_flame_formation.xml", x, y, -force_x2, force_y2, false )
	end

	if orbcount > 15 then
		shoot_projectile( entity_id, "data/entities/projectiles/ring_explosion.xml", enemy_x, enemy_y, 0, 0, false )
	end
	
	local cdc_id = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
	local velocity_x, velocity_y = ComponentGetValue2(cdc_id, "mVelocity")
	
	--Add a dashing trail particle effect
	
	local child_id = EntityCreateNew()
	EntitySetTransform(child_id, x, y)
	EntityAddChild(entity_id, child_id)
	
	local particle_comp = EntityAddComponent2(child_id, "ParticleEmitterComponent", {
		  emitted_material_name="spark_yellow",
		x_pos_offset_min=-10,
		y_pos_offset_min=-22,
		x_pos_offset_max=10,
		y_pos_offset_max=15,
		  x_vel_min=-4,
		  x_vel_max=4,
		  y_vel_min=-8,
		  y_vel_max=0,
		  count_min=0,
		  count_max=1,
		  is_trail=true,
		  trail_gap=1,
		  lifetime_min=0.3,
		  lifetime_max=0.3,
		  fade_based_on_lifetime=true,
		  create_real_particles=false,
		  emit_cosmetic_particles=true,
		  collide_with_grid=false,
		  emission_interval_min_frames=0,
		  emission_interval_max_frames=0,
		  airflow_force=0.36,
		  airflow_time=1.20,
		  airflow_scale=0.28,
		  is_emitting=true,
	} )
	ComponentSetValue2(particle_comp, "gravity", 0, 0)
	ComponentSetValue2(particle_comp, "offset", 0, 0)
	
	EntityAddComponent(child_id, "LifetimeComponent", {
		lifetime="30",
	} )
	
	EntityAddComponent(child_id, "InheritTransformComponent" )
	
	ComponentSetValueVector2(cdc_id, "mVelocity", velocity_x - force_x, velocity_y + force_y)
	
	GamePlaySound("data/audio/Desktop/projectiles.bank", "fireball/create", x, y)

end
