dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity( entity_id )
local x, y, rotation = EntityGetTransform(entity_id)

--GamePlaySound( "data/audio/Desktop/animals.bank", "animals/boss_centipede/destroy_face", x, y )

local pos_x, pos_y = EntityGetTransform(entity_id)

SetRandomSeed(x + GameGetFrameNum(), y)

function rotate_degrees(x, y, degrees)
	return rotate_radians(x, y, math.rad(degrees))
end

function rotate_radians(x, y, radians)
	local ca = math.cos(radians)
	local sa = math.sin(radians)
	local out_x = ca * x - sa * y
	local out_y = sa * x + ca * y
	return out_x, out_y
end

function shoot_at_entity(self_entity, target_entity, general_offset, x_offset, y_offset, speed, projectile, maxdistance, max_player_distance, rotation_offset)
	local rad_offset = 0
	if(rotation_offset ~= nil)then
		rad_offset = rotation_offset
	end
	local x, y = EntityGetTransform(self_entity)
	
	if(target_entity ~= nil)then
		local entityX, entityY = EntityGetTransform( target_entity )

		local headingX = entityX - (pos_x + x_offset)
		local headingY = (entityY-5) - (pos_y + y_offset)
		
		local len = math.sqrt((headingX*headingX) + (headingY*headingY))

		local directionX = headingX / len
		local directionY = headingY / len

		local didHit, hitX, hitY = RaytraceSurfaces( pos_x, pos_y, entityX, entityY )

		local headingHitX = entityX - hitX
		local headingHitY = entityY - hitY

		local hitDistance = math.sqrt((headingHitX*headingHitX) + (headingHitY*headingHitY))

		local pos_x, pos_y, currentRotation = EntityGetTransform( self_entity )	

		if(directionX < 0)then
			EntitySetTransform(self_entity,pos_x,pos_y,currentRotation,-1,1)
		else
			EntitySetTransform(self_entity,pos_x,pos_y,currentRotation,1,1)
		end
	
		if(len < max_player_distance)then
			if(hitDistance < maxdistance)then
			
				directionX, directionY = rotate_degrees(directionX, directionY, rad_offset)
				
				
				local ourProjectile = shoot_projectile( self_entity, projectile, pos_x + (directionX * general_offset) + x_offset, pos_y + (directionY * general_offset) + y_offset, directionX * speed, directionY * speed, false )
				edit_component( ourProjectile, "ProjectileComponent", function(comp,vars)
					vars.mWhoShot       = self_entity
					vars.mShooterHerdId = "player"
				end)
			end
		end
	end
end

for _,id in pairs(EntityGetInRadiusWithTag(x, y, 40, "mortal")) do
	-- is target a valid enemy
	if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(entity_id, id) < 40 and ( id ~= entity_id ) and ( id ~= entity_id ) then
		local ex, ey = EntityGetFirstHitboxCenter( id )

		-- shoot_projectile( entity_id, "data/entities/projectiles/selective_hole_particle.xml", pos_x, pos_y, 0, 0 )
		shoot_at_entity(id, entity_id, 1, Random(-8,8), Random(-8,8), 50, "mods/new_enemies/files/selective_hole/selective_hole_particle.xml", 900, 99999999)
			
		-- EntityIngestMaterial( parent_id, CellFactory_GetType( "blood" ), 1 )
		EntityInflictDamage( entity_id, -0.0005, "DAMAGE_MATERIAL", "Blood Absorption", "NONE", 0, 0, root_id, ex, ey, 0)
		EntityInflictDamage( id, 0.03, "DAMAGE_BITE", "Blood Absorption", "NONE", 0, 0, entity_id, ex, ey, 0)
	end
end

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 120 == 0 then
    local rnd =(math.random(-100,100)/100) * math.pi
    local vel_x,vel_y
    vel_x = math.cos( rnd) * (180 + math.random(0,100))
    vel_y = math.sin( rnd) * (180 + math.random(0,100))
    local projectile = shoot_projectile( entity_id, "mods/new_enemies/files/blood_attack/hemokinese_projectile.xml", x, y, vel_x, vel_y )
end