dofile_once( "data/scripts/lib/utilities.lua" )

function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

--Area Checker
local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local parent_id = EntityGetParent( entity_id )
local parent_x, parent_y = EntityGetTransform(parent_id)

if parent_id > 0 then
	
	--Area Checker:
	local old_average_x = GetValueNumber("average_x", x)
	local old_average_y = GetValueNumber("average_y", y)
	
	function get_distance( x1, y1, x2, y2 )
		local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
		return result
	end

	function get_direction( x1, y1, x2, y2 )
		return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
	end

	local distance = get_distance(x, y, parent_x, parent_y)
	local max_distance = 15
	if distance > max_distance then     
	  local direction = get_direction(parent_x, parent_y, x, y)
	  x = parent_x + math.cos(direction) * max_distance
	  y = parent_y + math.sin(direction) * max_distance
	  -- EntitySetComponentIsEnabled( entity_id, physics_body_component, false )
	end
	
	if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") >= 5 then
		new_average_x = approx_rolling_average(old_average_x, x, 1)
		new_average_y = approx_rolling_average(old_average_y, y, 1)
	else
		new_average_x = x
		new_average_y = y
	end

	EntitySetTransform(entity_id, new_average_x, new_average_y)
	-- EntitySetComponentIsEnabled( entity_id, physics_body_component, true )
	
	SetValueNumber("average_x", new_average_x)
	SetValueNumber("average_y", new_average_y)
	
end

for i, child in ipairs(EntityGetAllChildren(entity_id)) do
    if EntityGetName(child) == "neck" then
        neck_id = child
		nx, ny = EntityGetTransform(neck_id)
    end
end

--Control background limb

function get_distance(x1,y1,x2,y2)
    return math.sqrt((x1 - x2)^2 + (y1 - y2)^2)
end

function get_direction( x1, y1, x2, y2 )
    return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local angle = get_direction(nx, ny, parent_x, parent_y)
local distance = get_distance(nx, ny, parent_x, parent_y)

local sprite_width = 10
local max_distance = 10
local scale = math.max(0, distance) / sprite_width
scale = math.min(scale, sprite_width / max_distance)

EntitySetTransform(neck_id, x, y, angle, scale, scale)