local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local number_of_frames = 3
local state = get_state()
state.counter = ((state.counter or 0) % number_of_frames + 1)

function get_particle_emitter_components(entity_id)
  local all_components = EntityGetAllComponents(entity_id)
  local t = {}
  for i, comp in ipairs(all_components) do
    if ComponentGetTypeName(comp) == "ParticleEmitterComponent" then
      table.insert(t, comp)
    end
  end
  return t
end

local particle_emitter_components = get_particle_emitter_components(entity_id)
local current = state.counter - 1
if current <= 0 then
  current = current + number_of_frames
end
local next = (current % number_of_frames) + 1

EntitySetComponentIsEnabled(entity_id, particle_emitter_components[current], false)
EntitySetComponentIsEnabled(entity_id, particle_emitter_components[next], true)

--disable Ghost component if player is in holy mountain:

function get_state2()
  state2 = state2 or {}
  state2[entity_id] = state2[entity_id] or {
    last_frame_hit = 0
  }
  return state2[entity_id]
end

local state2 = get_state2()
local frames_active_after_getting_hit = 600

function damage_received()
  state2.last_frame_hit = GameGetFrameNum()
end

local is_angry = state2.last_frame_hit + frames_active_after_getting_hit > GameGetFrameNum()

local players = EntityGetWithTag("player_unit")
local ghost_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GhostComponent")

if not is_angry and BiomeMapGetName() == "$biome_holymountain" and #players > 0 then
	EntitySetComponentIsEnabled( entity_id, ghost_component, false )
elseif is_angry and BiomeMapGetName() == "$biome_holymountain" and #players > 0 then
	EntitySetComponentIsEnabled( entity_id, ghost_component, true )
else
	EntitySetComponentIsEnabled( entity_id, ghost_component, true )
end