dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)
local players = EntityGetWithTag("player_unit")
SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

function get_distance( x1, y1, x2, y2 )
	local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
	return result
end

if #players > 0 then
	local px, py = EntityGetTransform(players[1])
	local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
	-- local attack_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AIAttackComponent", "enabled_in_hand")
	-- local attack_ai_component2 = EntityGetFirstComponentIncludingDisabled(entity_id, "AIAttackComponent", "enabled_in_world")
	local did_hit = RaytracePlatforms(x, y, px, py)
	
	--Make sure to not interrupt a ranged attack (state 15)
	-- local state = ComponentGetValue2(animal_ai_component, "ai_state")
	-- local difference = math.abs(16 - state)
	
	-- if ( attack_ai_component ~= nil ) and ( attack_ai_component > 0 ) then
		-- if did_hit then
			-- ComponentSetValue2( attack_ai_component, "mNextFrameUsable", 99999 )
		-- elseif ComponentGetValue2(attack_ai_component, "mNextFrameUsable") == 99999 then
			-- ComponentSetValue2( attack_ai_component, "mNextFrameUsable", 0 )
		-- end
	-- end
	
	local dist = get_distance(x, y, px, py)
	local orbcount = GameGetOrbCountThisRun()
	
	local max_count_reduction = math.min(30, orbcount)
	if ( ( did_hit or (dist > 200) ) or orbcount > 10 ) and ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % ( 60 - max_count_reduction ) == 0 ) then
		
		local max_count = math.min(33, orbcount)
		for i=1,Random(6, 22) + max_count do
			shoot_projectile( entity_id, "data/entities/projectiles/elephant_magma_shot.xml", x , y, 0, 0)
			
			GamePlaySound("data/audio/Desktop/animals.bank", "animals/boss_centipede/spawn_minion", x, y)
			
			--animation
			local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do

				ComponentSetValue2(comp, "rect_animation", "attack_ranged")
				ComponentSetValue2(comp, "next_rect_animation", "stand")
				
			end
		end
	elseif ( did_hit or (dist > 200) ) and ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 40 == 0 ) then
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/boss_centipede/prebattle_return_to_work", x, y)
	end
	-- if ( attack_ai_component2 ~= nil ) and ( attack_ai_component2 > 0 ) then
		-- if ( not did_hit ) and ComponentGetValue2(attack_ai_component2, "mNextFrameUsable") < 99999 then
			-- ComponentSetValue2( attack_ai_component2, "mNextFrameUsable", 99999 )
		-- elseif ComponentGetValue2(attack_ai_component2, "mNextFrameUsable") >= 99999 then
			-- ComponentSetValue2( attack_ai_component2, "mNextFrameUsable", 0 )
		-- end
		-- GamePrint(ComponentGetValue2(attack_ai_component, "mNextFrameUsable"))
	-- end

	if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
		-- if did_hit and not ( difference < 0.0001 ) then
			-- ComponentSetValue2( animal_ai_component, "ai_state", 16 )
			ComponentSetValue2( animal_ai_component, "mGreatestPrey", players[1] )
			ComponentSetValue2( animal_ai_component, "mHasFoundPrey", true )
		-- end
	end
	local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
	if limb_boss_component ~= nil and limb_boss_component > 0 then
		if EntityGetComponent(entity_id, "GenomeDataComponent") ~= nil and ( ( EntityGetHerdRelation(entity_id, players[1]) > 40 ) or (EntityGetHerdRelation(entity_id, players[1]) <= 0 ) ) then
			ComponentSetValue2(limb_boss_component, "state", 4)
			local px, py  = EntityGetTransform(players[1])
			ComponentSetValue2(limb_boss_component, "mMoveToPositionX", px )
			ComponentSetValue2(limb_boss_component, "mMoveToPositionY", py )
		else
			ComponentSetValue2(limb_boss_component, "state", 1)
		end
	end
end

-- SetRandomSeed(x + GameGetFrameNum(), y)
-- ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 10 + Random(140))
