dofile_once("data/scripts/lib/utilities.lua")

function damage_received(damage, message,entity_thats_responsible, is_fatal)

	function get_distance( x1, y1, x2, y2 )
		local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
		return result
	end
	
	local entity_id = GetUpdatedEntityID()
	local x, y, rot, scale_x = EntityGetTransform(entity_id)
	local player = EntityGetWithTag("player_unit")[1]

	if player > 0 then
		local px, py = EntityGetTransform(player)
		if ( entity_thats_responsible == player ) and ( get_distance(x, y, px, py) < 200) then
					
			local animation_id = EntityLoad( "data/entities/animals/boss_fungus.xml", x, y )
			EntitySetTransform(animation_id, x, y, rot, scale_x)
			GamePlaySound( "data/audio/Desktop/misc.snd", "misc/temple_collapse", x, y )
			EntityLoad( "data/entities/particles/image_emitters/magical_symbol_boss_fungus.xml", x , y )
			
			EntityKill(entity_id)
			return
		end
	end
	
	local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
	
	if damage_model_component then
	
		local hp = ComponentGetValue2(damage_model_component, "hp")
		local max_hp = ComponentGetValue2(damage_model_component, "max_hp")
		
		local percentage_hp = hp / max_hp * 100
		
		if percentage_hp < 75 then
		
			local animation_id = EntityLoad( "data/entities/animals/boss_fungus.xml", x, y )
			EntitySetTransform(animation_id, x, y, rot, scale_x)
			GamePlaySound( "data/audio/Desktop/misc.snd", "misc/temple_collapse", x, y )
			EntityLoad( "data/entities/particles/image_emitters/magical_symbol_boss_fungus.xml", x , y )
			
			EntityKill(entity_id)
			
		end
	end
	
end

function collision_trigger()
	local entity_id    = GetUpdatedEntityID()
	
	local x, y, rot, scale_x = EntityGetTransform(entity_id)
					
	local animation_id = EntityLoad( "data/entities/animals/boss_fungus.xml", x, y )
	EntitySetTransform(animation_id, x, y, rot, scale_x)
	GamePlaySound( "data/audio/Desktop/misc.snd", "misc/temple_collapse", x, y )
	EntityLoad( "data/entities/particles/image_emitters/magical_symbol_boss_fungus.xml", x , y )
	
	EntityKill(entity_id)
	
end