function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local state = get_state()

function get_magnitude( x, y )
    local result = math.sqrt( x ^ 2 + y ^ 2 )
    return result
end

function vec_normalize(x, y)
    local m = get_magnitude(x, y)
    if m == 0 then return 0,0 end
    x = x / m
    y = y / m
    return x,y
end

state.dir = state.dir or 1
state.last_frame_bounced = state.last_frame_bounced or GameGetFrameNum()

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local vel_comp = EntityGetFirstComponent(entity_id, "VelocityComponent")
local vx, vy = ComponentGetValue2(vel_comp, "mVelocity")
if vy >= 0 and vy < 0.5 then
  vy = 1
end
vx, vy = vec_normalize(vx, vy)

local found_normal,normal_x,normal_y,approximate_distance_from_surface = GetSurfaceNormal(x+vx, y+vy, 5, 16)

local inside_wall, hit_x, hit_y = RaytraceSurfaces(x, y, x, y )

local found, nx, ny, apd = GetSurfaceNormal(x, y, 5, 16)
if found then
  nx = nx * (math.abs(apd) + 2)
  ny = ny * (math.abs(apd) + 2)
else
  nx = 0
  ny = 0
end

if inside_wall then

	EntitySetTransform(entity_id, x - nx, y - ny)

end

if found_normal then
  if vy >= 0 and state.last_frame_bounced < GameGetFrameNum() - 20 then
    ComponentSetValue2(vel_comp, "mVelocity", 100 * state.dir, -200)
    state.dir = state.dir * -1
    state.last_frame_bounced = GameGetFrameNum()
	
	EntityLoad("data/entities/particles/bouncer_particle.xml", hit_x, hit_y)
  end
end