dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, roto, scale_x = EntityGetTransform(entity_id)

--This is purely turning animation code
local last_scale_x = GetValueNumber("last_xscale", scale_x)

local var_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")

if ComponentGetValue2(var_comp, "value_bool") == false then

	if last_scale_x ~= scale_x then
	
		ComponentSetValue2(var_comp, "value_bool", true)
		
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		
		for i, comp in ipairs(sprite_comps) do
		
			ComponentRemoveTag( comp, "character" )
			
			if ( ComponentGetValue2(comp, "rect_animation") == "stand" ) then
				ComponentSetValue2( comp, "rect_animation", "turn_right" )
			end
			
		end
		
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/giant/attack_shoot", x, y)
		
		SetValueNumber("timeout_frames", 0)
		
	end
	
end

if ComponentGetValue2(var_comp, "value_bool") == true then
	SetValueNumber("timeout_frames", GetValueNumber("timeout_frames", 20) + 1)
	if ( GetValueNumber("timeout_frames", 20) > 20 ) then
		ComponentSetValue2(var_comp, "value_bool", false)
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentAddTag( comp, "character" )
		end
	end
end

SetValueNumber("last_xscale", scale_x)

--Changing attacks
local ai_comp = EntityGetFirstComponent(entity_id, "AnimalAIComponent")
local attack = GetValueBool("attack", 1)

local orbcount = GameGetOrbCountThisRun()
local max_count = math.min(33, orbcount)
if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % (300 - max_count * 5) == 0 then

	if attack == false then
	
		ComponentSetValue2( ai_comp, "attack_ranged_entity_file", "data/entities/projectiles/microwave.xml" )
		ComponentSetValue2( ai_comp, "attack_ranged_entity_count_min", 1 )
		ComponentSetValue2( ai_comp, "attack_ranged_entity_count_max", 1 )
		ComponentSetValue2( ai_comp, "attack_ranged_aim_rotation_shooting_ok_angle_deg", 2 )
		ComponentSetValue2( ai_comp, "attack_ranged_frames_between", 250 - max_count * 3)
		ComponentSetValue2( ai_comp, "is_static_turret", true )
		SetValueBool("attack", true)
		
	elseif attack == true then
	
		ComponentSetValue2( ai_comp, "attack_ranged_entity_file", "data/entities/projectiles/rocket_tiny_roll_camel.xml" )
		
		if orbcount > 10 then
			local max_count2 = math.min(33, orbcount) - 10
			ComponentSetValue2( ai_comp, "attack_ranged_entity_count_min", 1 + max_count2 )
			ComponentSetValue2( ai_comp, "attack_ranged_entity_count_max", 3 + max_count2 )
		else
			ComponentSetValue2( ai_comp, "attack_ranged_entity_count_min", 1 )
			ComponentSetValue2( ai_comp, "attack_ranged_entity_count_max", 3 )
		end
		ComponentSetValue2( ai_comp, "attack_ranged_aim_rotation_shooting_ok_angle_deg", 360 )
		ComponentSetValue2( ai_comp, "attack_ranged_frames_between", 100 - max_count)
		ComponentSetValue2( ai_comp, "is_static_turret", false )
		SetValueBool("attack", false)
		
	end

end