dofile_once("data/scripts/lib/utilities.lua")

function damage_received( damage, message, entity_thats_responsible, is_fatal  )

	local entity_id    = GetUpdatedEntityID()
	local x, y, r, sx = EntityGetTransform(entity_id)
	
	offset_x = -6
	offset_y = 0
	
	function create_ragdoll(path)
	
		local ragdoll_id = EntityCreateNew()
		EntitySetTransform(ragdoll_id, x, y, r, sx)
		
		EntityAddComponent(ragdoll_id, "DamageModelComponent", {
            hp="1",
            ragdoll_material="steel_go_through",
			ragdoll_filenames_file = path ,
			blood_material="oil",
			blood_spray_material="oil",
			ragdoll_offset_y = offset_y,
			ragdoll_offset_x = offset_x
		} )
		
		local ragdoll_damage_model_component = EntityGetFirstComponentIncludingDisabled(ragdoll_id, "DamageModelComponent")
		
		ComponentSetValue2(ragdoll_damage_model_component, "hp", 0)
		ComponentSetValue2(ragdoll_damage_model_component, "air_needed", true)
		ComponentSetValue2(ragdoll_damage_model_component, "air_in_lungs", 0)
	
	end

	local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
	
	if damage_model_component then
	
		local hp = ComponentGetValue2(damage_model_component, "hp")
		local max_hp = ComponentGetValue2(damage_model_component, "max_hp")
		
		local percentage_hp = hp / max_hp * 100
		
		local sprite_components = EntityGetComponent(entity_id, "SpriteComponent") or {}
		
		for i, comp in ipairs(sprite_components) do
			if ComponentGetValue2(comp, "image_file") == "data/enemies_gfx/cargobot_eye_left.xml" then
				eye_left_sprite_component = comp
			elseif ComponentGetValue2(comp, "image_file") == "data/enemies_gfx/cargobot_eye_right.xml" then
				eye_right_sprite_component = comp
			elseif ComponentGetValue2(comp, "image_file") == "data/enemies_gfx/cargobot_flaps.xml" then
				flaps_sprite_component = comp
			end
		end
		state = 1
		old_state = GetValueInteger("state", state)
		
		if percentage_hp > 75 and not (old_state > 1) then
		
			EntitySetComponentIsEnabled( entity_id, eye_left_sprite_component, true )
			EntitySetComponentIsEnabled( entity_id, eye_right_sprite_component, true )
			EntitySetComponentIsEnabled( entity_id, flaps_sprite_component, true )
			
			state = 1
			
		elseif percentage_hp < 75 and percentage_hp > 50 and not (old_state > 2) then
		
			EntitySetComponentIsEnabled( entity_id, eye_left_sprite_component, true )
			EntitySetComponentIsEnabled( entity_id, eye_right_sprite_component, false )
			EntitySetComponentIsEnabled( entity_id, flaps_sprite_component, true )
		
			state = 2
			
		elseif percentage_hp < 50 and percentage_hp > 25 and not (old_state > 3) then
		
			EntitySetComponentIsEnabled( entity_id, eye_left_sprite_component, true )
			EntitySetComponentIsEnabled( entity_id, eye_right_sprite_component, false )
			EntitySetComponentIsEnabled( entity_id, flaps_sprite_component, false )
		
			state = 3
			
		elseif percentage_hp < 25 and percentage_hp > 0 and not (old_state > 4) then
		
			EntitySetComponentIsEnabled( entity_id, eye_left_sprite_component, false )
			EntitySetComponentIsEnabled( entity_id, eye_right_sprite_component, false )
			EntitySetComponentIsEnabled( entity_id, flaps_sprite_component, false )
			
			local hitbox_component = EntityGetFirstComponentIncludingDisabled(entity_id, "HitboxComponent")
			ComponentSetValue2( hitbox_component, "aabb_min_y", -9 )
			
			state = 4
			
		end
		
		SetValueInteger("state", state)
	end

	if (is_fatal ~= true) then 
			
		if old_state == 1 and state == 2 then

			create_ragdoll("data/ragdolls/cargobot/eye.txt")
			
		elseif old_state == 1 and state == 3 then

			create_ragdoll("data/ragdolls/cargobot/eye.txt")
			create_ragdoll("data/ragdolls/cargobot/flaps.txt")
			
		elseif old_state == 1 and state == 4 then
		
			create_ragdoll("data/ragdolls/cargobot/head.txt")
			create_ragdoll("data/ragdolls/cargobot/flaps.txt")
		
		elseif old_state == 2 and state == 3 then

			create_ragdoll("data/ragdolls/cargobot/flaps.txt")
			
		elseif old_state == 2 and state == 4 then

			create_ragdoll("data/ragdolls/cargobot/half_head.txt")
			create_ragdoll("data/ragdolls/cargobot/flaps.txt")
			
		elseif old_state == 3 and state == 4 then

			create_ragdoll("data/ragdolls/cargobot/half_head.txt")
			
		end
	
    elseif (is_fatal == true) then 
	
		if old_state == 1 then
		
			create_ragdoll("data/ragdolls/cargobot/filenames.txt")
			
		elseif old_state == 2 then

			create_ragdoll("data/ragdolls/cargobot/state2.txt")
			
		elseif old_state == 3 then

			create_ragdoll("data/ragdolls/cargobot/state3.txt")
			
		elseif old_state == 4 then

			create_ragdoll("data/ragdolls/cargobot/state4.txt")
			
		end
		
	end
	
end