dofile_once("data/scripts/lib/utilities.lua")

local range = 15
local projectile_velocity = 20
local scatter = 0

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetFirstHitboxCenter( entity_id )
local root_id = EntityGetRootEntity( entity_id )
local parent_id = EntityGetParent( entity_id )

local rx, ry = EntityGetTransform(root_id)
EntitySetTransform(parent_id, rx, ry - 6)

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 15
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, range, "mortal")) do
	-- is target a valid enemy
	if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(root_id, id) < 40 and ( id ~= entity_id ) then
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end

-- check los
local can_shoot = false
if enemy then can_shoot = not RaytracePlatforms(pos_x, pos_y, enemy_x, enemy_y) end

-- hand/shooting state & animation control
-- edit_component2( entity_id, "SpriteComponent", function(comp,vars)
	-- -- if enemy is not visible then open hand
	-- local hand_open = ComponentGetValue2(comp, "rect_animation") == "stand"
	-- if not can_shoot then
		-- if not hand_open then
			-- ComponentSetValue2( comp, "rect_animation", "stand")
			-- --EntitySetComponentsWithTagEnabled( entity_id, "enabled_when_attacking", false )
		-- end
		-- return
	-- end

	-- -- prepare to shoot
	-- if hand_open then
		-- ComponentSetValue2( comp, "rect_animation", "attack")
		-- --EntitySetComponentsWithTagEnabled( entity_id, "enabled_when_attacking", true )
		-- can_shoot = false
		-- return
	-- end
-- end)

if not can_shoot then 
	local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
	EntityLoad( "data/entities/misc/manus_cell_eater.xml", pos_x , pos_y )
	return 
end

-- direction
local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

-- scatter
SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
vel_x,vel_y = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

-- apply velocity & shoot
vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)

local distance = get_distance(pos_x, pos_y, enemy_x, enemy_y)

if distance < range and enemy then
	EntityApplyTransform(enemy, pos_x, pos_y)
end
