dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)
local x, y = EntityGetFirstHitboxCenter( entity_id )

local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 400, "mortal")) do
	-- is target a valid enemy
	if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, entity_x, entity_y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = entity_x
			enemy_y = entity_y
		end
	end
end

if not enemy then return end

local did_hit, hit_x, hit_y = RaytracePlatforms(x, y , enemy_x, enemy_y)

local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		
if not did_hit then
	ComponentSetValue2( animal_ai_component, "ai_state", 11 )
else
	ComponentSetValue2( animal_ai_component, "ai_state", 17 )
end

SetRandomSeed(x + GameGetFrameNum(), y)
ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 10 + Random(140))
