dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x,y = EntityGetTransform( entity_id )
local r = 100

local targets = EntityGetInRadiusWithTag( x, y, r, "homing_target" )
local targets2 = EntityGetInRadiusWithTag( x, y, r, "player_unit" )
local done = {}

for i,v in ipairs(targets2) do
	table.insert(targets, v)
end

for i,v in ipairs( targets ) do
	if ( v ~= entity_id ) then
		local c = EntityGetAllChildren( v )
		local root_id = EntityGetRootEntity( v )
		local valid = true
		
		if ( done[root_id] == nil ) then
			if ( c ~= nil ) then
				for a,b in ipairs( c ) do
					local comps = EntityGetComponent( b, "GameEffectComponent", "spirit_confuse" )
					
					if ( comps ~= nil ) then
						valid = false
						break
					end
				end
			end
			
			if valid then
				local vx,vy = EntityGetTransform( v )
				local eid = EntityLoad( "data/entities/misc/effect_corpse_lily_smell.xml", vx, vy )
				EntityAddChild( v, eid )
				eid = EntityLoad( "data/entities/particles/knockback_star_smell_stun.xml", vx, vy )
				EntityAddChild( v, eid )
				
				local character_platforming_component = EntityGetFirstComponentIncludingDisabled(v, "CharacterPlatformingComponent")

				if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
					ComponentSetValue2(character_platforming_component, "mIsPrecisionJumping", true)
				end
				
				done[v] = 1
			end
		end
	end
end

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 121 + Random(-50, 50))