dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

function split_string(inputstr, sep)
  sep = sep or "%s"
  local t= {}
  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
    table.insert(t, str)
  end
  return t
end

function get_material_damage(entity_id)
  local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
  if damage_model_component then
    local materials_that_damage = ComponentGetValue2(damage_model_component, "materials_that_damage") --"water,acid,blood,whatever"
    local materials_how_much_damage = ComponentGetValue2(damage_model_component, "materials_how_much_damage")--"1,-1,0.03,0.2"
    materials_that_damage = split_string(materials_that_damage, ",")
    materials_how_much_damage = split_string(materials_how_much_damage, ",")
    local material_damages = {}
    for i, v in ipairs(materials_that_damage) do
      material_damages[v] = tonumber(materials_how_much_damage[i])
    end
    return material_damages
  end
end

local entities = EntityGetInRadiusWithTag(x, y, 9999999, "mortal")

for i, entity in ipairs(entities) do

	local material_damages = get_material_damage(entity)

	if material_damages and material_damages.blood_cold_vapour and material_damages.blood_cold_vapour > 0 then

		local entity_damage_model_component = EntityGetFirstComponent(entity, "DamageModelComponent")
		
		if entity_damage_model_component then
		
			EntitySetDamageFromMaterial( entity, "liquid_nitrogen_liquid", material_damages.blood_cold_vapour )
			-- EntitySetDamageFromMaterial( entity, "liquid_nitrogen_gas", material_damages.blood_cold_vapour )
			
		end
		
	end

end