dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local parent_id = EntityGetParent( entity_id )

if parent_id > 0 then

	local parent_x, parent_y = EntityGetTransform(parent_id)
	
	local particle_emitter_component = EntityGetFirstComponent(entity_id, "ParticleEmitterComponent")

	ComponentSetValue2(particle_emitter_component, "mExPosition", parent_x, parent_y)

	local x, y = EntityGetTransform(entity_id)
	
	function constrain(entity, x2, y2, max_dist)
		local chardatacomp = EntityGetFirstComponent(entity, "CharacterDataComponent")
		local projcomp = EntityGetFirstComponent(entity, "VelocityComponent")
		local physcomp = EntityGetFirstComponent(entity, "PhysicsBodyComponent") or EntityGetFirstComponent(entity1, "PhysicsBody2Component") or EntityGetFirstComponent(entity1, "SimplePhysicsComponent")
		local vel_x, vel_y = ComponentGetValue2(chardatacomp, "mVelocity")
		local proj_vel_x, proj_vel_y = ComponentGetValue2(projcomp, "mVelocity")
		local x1, y1 = EntityGetTransform(entity)
		if (not x1) or (not x2) then return nil end
			
		local dist = math.sqrt(((x2-x1)^2) + ((y2-y1)^2))
		local target_x = x2 + (((x1-x2)/dist)*max_dist)
		local target_y = y2 + (((y1-y2)/dist)*max_dist)
		local target_vel_x = target_x - x1
		local target_vel_y = target_y - y1

		if dist > max_dist then
			if physcomp or not proj_vel_x then
				PhysicsApplyForce(entity, target_vel_x*100, target_vel_y*100)
			end
			if vel_x then
				vel_y = vel_y - 60
				local target_mag = math.sqrt((target_vel_x^2) + (target_vel_y^2))
				local mag = math.sqrt((vel_x^2) + (vel_y^2)) / 40
				local force_x = ((target_vel_x/target_mag)*mag)
				local force_y = ((target_vel_y/target_mag)*mag)

				vel_x = ((vel_x + force_x)*1.025) + (target_vel_x*dist*0.8)
				vel_y = ((vel_y + force_y)*1.025) + (target_vel_y*dist*0.8)
				EntitySetTransform(entity, target_x, target_y)
				if ComponentGetValue2(chardatacomp, "is_on_ground") == false then vel_x = vel_x*1.16 end
				ComponentSetValue2(chardatacomp, "mVelocity", vel_x, vel_y+60)
			elseif proj_vel_x then
				ComponentSetValue2(projcomp, "mVelocity", proj_vel_x+(target_vel_x*100), proj_vel_y+(target_vel_y*100))
				EntitySetTransform(entity, target_x, target_y)
			end
		end
	end
	
	constrain(entity_id, parent_x, parent_y, 250)
	
end