dofile_once("data/scripts/lib/utilities.lua")

function damage_received( damage, message, entity_thats_responsible, is_fatal  )
	
	if(is_fatal == true)then
		local entity_id = GetUpdatedEntityID()
		local pos_x, pos_y = EntityGetTransform( entity_id )
		
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
		if ( comp ~= nil ) then
			local max_hp = ComponentGetValue2( comp, "max_hp" )
			ComponentSetValue2( comp, "hp", max_hp )
			-- ComponentSetValue2( comp, "wait_for_kill_flag_on_death", true )
		end
		
		local var_comp = EntityGetFirstComponent( entity_id, "VariableStorageComponent" )
		ComponentSetValue2( var_comp, "value_bool", true )
		
		EntityLoad( "data/entities/particles/image_emitters/magical_symbol_bird.xml", pos_x, pos_y )
		GamePlaySound( "data/audio/Desktop/misc.snd", "misc/temple_collapse", pos_x, pos_y )
		
		local children = EntityGetAllChildren(entity_id)
		
		for i, child in ipairs(children) do
			if ( EntityGetName(child) == "eye" ) then
			
				-- local physics_body_component = EntityGetFirstComponentIncludingDisabled( child, "PhysicsBodyComponent" )
				-- EntitySetComponentIsEnabled( child, physics_body_component, true )

				local inherit_transform_comp = EntityGetFirstComponent( child, "InheritTransformComponent" )
				EntityRemoveComponent( child, inherit_transform_comp )
				
				EntityAddComponent2(child, "LimbBossComponent", {
					state=1,
				} )
				
				EntityAddComponent2(child, "PhysicsAIComponent", {
					target_vec_max_len=15.0,
					force_coeff=20.0,
					force_balancing_coeff=0.8,
					force_max=100,
					torque_coeff=50,
					torque_balancing_coeff=0.8,
					torque_max=50.0,
					damage_deactivation_probability=0,
					damage_deactivation_time_min=0,
					damage_deactivation_time_max=0,
				} )
				
				EntityAddComponent2(child, "PhysicsBodyComponent", {
					allow_sleep=true, 
					angular_damping=0.02,
					fixed_rotation=false,
					is_bullet=false, 
					linear_damping=0, 
					force_add_update_areas=true,
					on_death_leave_physics_body=false,
				} )
				
				-- EntityAddComponent2(child, "PhysicsShapeComponent", {
					-- is_circle=true,
					-- radius_x=10,
					-- radius_y=10,
					-- friction=0.0,
					-- restitution=0.3,
				-- } )
				
				local attack_components = EntityGetComponentIncludingDisabled(child, "AIAttackComponent")
				
				for k, attack_component in pairs(attack_components)do
					ComponentSetValue2( attack_component, "frames_between", 250 )
					ComponentSetValue2( attack_component, "frames_between_global", 250 )
				end
				
				EntityAddComponent2(child, "AIAttackComponent", {
					min_distance=0,
					max_distance=500,
					frames_between=400,
					frames_between_global=250,
					attack_ranged_aim_rotation_enabled=true,
					attack_ranged_aim_rotation_speed=0.075,
					attack_ranged_aim_rotation_shooting_ok_angle_deg=20,
					attack_ranged_offset_y=0,
					attack_ranged_offset_x=16,
					animation_name="stand",
					attack_ranged_entity_file="data/entities/projectiles/dust_devil.xml",
					attack_ranged_action_frame=2,
				} )
				
			end
		end
		
		-- EntityAddComponent(entity, "LuaComponent", {
			-- script_source_file="data/scripts/animals/desert_mage_remove_flag.lua",
			-- execute_every_n_frame=20,
			-- execute_on_added=0,
		-- })
		
		EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
		
	end
	
end