dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetParent( entity_id )
local x,y = EntityGetTransform( root_id )

local angle = 0
local players = EntityGetWithTag( "player_unit" )

if ( #players > 0 ) then
	local p = players[1]
	
	local px,py = EntityGetTransform( p )
	
	angle = get_direction( x, y, px, py )
end

angle = math.pi + angle

x = x + 3
EntitySetTransform( entity_id, x + math.cos( angle ) * 4, y - math.sin( angle ) * 4 )



local x,y = EntityGetTransform( root_id )

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 300 == 0 then
	for i=1,4 do
		shoot_projectile( root_id, "data/entities/animals/worm_skull_old.xml", x, y, 0, 0 )
	end
end

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 150 == 0 then

	local orbcount = GameGetOrbCountThisRun()

	function circleshot(angle)
		
		local this         = GetUpdatedEntityID()
		local pos_x, pos_y = EntityGetTransform( this )

		local branches = 6 + orbcount
		local space = math.floor(360 / branches)
		local speed = 80
		
		-- spawn projectiles on each branch
		for i=1,branches do
			local vel_x = math.cos( math.rad(angle) ) * speed
			local vel_y = math.sin( math.rad(angle) ) * speed
			shoot_projectile( root_id, "data/entities/projectiles/desert_skull_shot.xml", pos_x, pos_y, vel_x, vel_y )
			angle = angle + space
		end

		-- muzzle flash & audio
		EntityLoad( "data/entities/particles/muzzle_flashes/muzzle_flash_circular_pink.xml", pos_x, pos_y)
		GamePlaySound( "data/audio/Desktop/projectiles.bank", "projectiles/magic/create", pos_x, pos_y )
	end

	local shot_count = 6 + math.floor(orbcount / 3)
	local frame = GameGetFrameNum()
	local r = ProceduralRandomf(frame, frame)
	local spiral_speed = 25 * (r*2-1) -- random turn speed & direction with each attack

	for i=1,shot_count do
		circleshot(r * 180 + i*spiral_speed)
	end

end