dofile_once( "data/scripts/lib/utilities.lua" )
----------------------------------------------------------------------------

local entity = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity)

function clamp(value, min, max)
    if value > max then return max elseif value < min then return min else return value end
end
function Distance(dx, dy, dx2, dy2)
    return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
function rotatePoint(x,y,cx,cy,rads)
    --local angle = radToDeg(rads)
    local sin = math.sin(rads)
    local cos = math.cos(rads)
    x = x - cx
    y = y - cy
    local new_x = (x * cos) - (y * sin)
    local new_y = (x * sin) - (y * cos)
    x = new_x + cx
    y = new_y + cy
    return x, y
end

local prev_x, prev_y = GetValueNumber("prev_x", x), GetValueNumber("prev_y", y)
local vel_x, vel_y = x-prev_x, y-prev_y

local targ_x, targ_y = GetValueNumber("targ_x", 0), GetValueNumber("targ_y", 0)
local targ_dist = Distance(x, y, targ_x, targ_y)

local targ_entity = EntityGetWithTag("player_unit")[1]--GetValueNumber("targ_entity", EntityGetWithTag("player_unit")[1])
local px, py = EntityGetTransform(targ_entity)

local state = GetValueNumber("state", 0)
local verlet_physics_component = EntityGetFirstComponent(entity, "VerletPhysicsComponent")
local positions = ComponentGetValue2(verlet_physics_component, "positions")
local positions_prev = ComponentGetValue2(verlet_physics_component, "positions_prev")


local number_of_segments = 50
local force_amount = 0.01
local upward_force_amount = 0.01
local damping = 49

--WIGGLE AROUND:
for i=(number_of_segments*2)-3,1,-2 do
    positions_prev[i+1] = ((positions_prev[i+1]*18) + (positions_prev[i+3])) / 19
    positions_prev[i] = (((positions_prev[i]*18) + (positions_prev[i+2])) / 19) + upward_force_amount
end

--move toward target:
positions_prev[3] = positions_prev[3] - (((targ_x-positions[3])/targ_dist))
positions_prev[4] = positions_prev[4] - (((targ_y-positions[4])/targ_dist))

ComponentSetValue2(verlet_physics_component, "positions_prev", positions_prev)
ComponentSetValue2(verlet_physics_component, "positions", positions)


if state == 0 then -- Fly around seeking prey:
    local path_obstructed, block_x, block_y = RaytracePlatforms(x, y, targ_x, targ_y)
    
    if not path_obstructed and targ_dist < 20 and math.random(20) == 1 then
        SetValueNumber("targ_x", targ_x+math.random(-70,70))
        SetValueNumber("targ_y", targ_y+math.random(-70,70))
    elseif math.random(20) == 1 then
        SetValueNumber("targ_x", targ_x+math.random(-5,5))
        SetValueNumber("targ_y", targ_y+math.random(-5,5))
    end

    --find prey within line of sight:
    local newtarg = nil
    for i, creature in ipairs(EntityGetInRadiusWithTag(x,y,100, "hittable")) do
        local px, py = EntityGetTransform(creature)
        local dmc2 = EntityGetFirstComponent(creature, "DamageModelComponent")
        local path_obstructed = RaytracePlatforms(x, y, px, py)
        if not path_obstructed and dmc2 and creature ~= entity then
            SetValueNumber("targ_entity", creature)
            SetValueNumber("state", 1)
            break
        end
    end
    --if nothing living, find a random object to inspect instead:
    if not newtarg then
        for i, creature in ipairs(EntityGetInRadius(x,y,100)) do
            local px, py = EntityGetTransform(creature)
            local path_obstructed = RaytracePlatforms(x, y, px, py)
            if not path_obstructed and creature ~= entity then
                SetValueNumber("targ_entity", creature)
                SetValueNumber("state", 1)
                break
            end
        end
    end
elseif state == 1 then --Stalk potential prey:
    local path_obstructed, block_x, block_y = RaytracePlatforms(x, y, px, py) --are we in view of target entity?
    local path2_obstructed, block2_x, block2_y = RaytracePlatforms(targ_x, targ_y, px, py) --is our target position in view of target entity?
    
    --pathfind around obstacles:
    if path_obstructed and path2_obstructed then
        for i=1,10 do
            local x2, y2 = x+math.random(-60,60), y+math.random(-60,60)
            local path2_obstructed, block2_x, block2_y = RaytracePlatforms(x, y, x2, y2)
            if path2_obstructed then x2, y2 = block2_x, block2_y end
            if not RaytracePlatforms(x2, y2, px, py) then
                SetValueNumber("targ_x", x2)
                SetValueNumber("targ_y", y2)
            end
        end
    elseif math.random(100) == 1 and not path_obstructed then
        local px2, py2 = px+math.random(-60,60), py+math.random(-60,60)
        local path2_obstructed, block2_x, block2_y = RaytracePlatforms(x, y, px2, py2)
        if not path2_obstructed then
            SetValueNumber("targ_x", px2)
            SetValueNumber("targ_y", py2)
        end
    end

elseif state == 2 then --Strike prey:
    local path_obstructed, block_x, block_y = RaytracePlatforms(x, y, px, py)
    if not path_obstructed then
        SetValueNumber("targ_x", px+math.random(-30,30))
        SetValueNumber("targ_y", py+math.random(-30,30))
    else
        SetValueNumber("state", 0)
    end
end