dofile_once("data/scripts/lib/utilities.lua")

function get_player()
  local players = get_players()
  if players ~= nil then
    return players[1]
  end

  -- TODO: What does this mean anyway? Player is dead..?
  return nil
end

--rotating sprite based on velocity
function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local state = get_state()


local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x, scale_y = EntityGetTransform(entity_id)
state.prev_x = state.prev_x or x
state.prev_y = state.prev_y or y
local vx, vy = x - state.prev_x, y - state.prev_y

local dir = get_direction(vx, vy, 0, 0)
local scale_x = 1

if x < x + vx then
	scale_y = 1
elseif x > x + vx then
	scale_y = -1
end
EntitySetTransform(entity_id, x, y, dir - 185, scale_x, scale_y)

state.prev_x = x
state.prev_y = y

-- local entity_id = GetUpdatedEntityID()

-- local x, y, rot = EntityGetTransform(entity_id)

-- local x_old = GetValueNumber("x_old", x)
-- local y_old = GetValueNumber("y_old", y)

-- local angle_new = get_direction( x_old, y_old, x, y )

-- local angle = approx_rolling_average(rot, angle_new, 10)

-- EntitySetTransform(entity_id, x, y, angle)

-- SetValueNumber("x_old",x)
-- SetValueNumber("y_old",y)



--Adding detection for the surfaces
surface_found = false
surface_found_quantity = 0

for _, child1 in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	for _, child in ipairs(EntityGetAllChildren(child1) or {} ) do
		local surface_found_var_comp = EntityGetFirstComponentIncludingDisabled(child, "VariableStorageComponent")
		if ( surface_found_var_comp ~= nil ) and ( surface_found_var_comp > 0 ) then
			local surface_check_value = ComponentGetValue2(surface_found_var_comp, "value_bool")
			if surface_check_value == true then
			  surface_found_quantity = surface_found_quantity + 1
			end
		end
		
		if EntityGetName( child ) == "Wing" then
			wing_id = child
		end
	end
end

if surface_found_quantity > 0 then
	surface_found = true
end

--Toggle movement based on surfaces

-- local raytrace = RaytraceSurfaces(x, y, x, y + 40)

if surface_found == true then
	-- EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
	
	function get_player()
	  local players = get_players()
	  if players ~= nil then
		return players[1]
	  end

	  -- TODO: What does this mean anyway? Player is dead..?
	  return nil
	end
	
	local player_id = get_player()
	local px, py = EntityGetTransform(player_id)
	local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y, px, py)
	if player_id ~= nil and not did_hit and EntityGetHerdRelation(entity_id, player_id) < 40 then
		local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
		ComponentSetValue2(limb_boss_component, "mMoveToPositionX", px)
		ComponentSetValue2(limb_boss_component, "mMoveToPositionY", py)
		-- if wing_id > 0 and ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 20 == 0 then
			-- --animation
			-- local sprite_comps = EntityGetComponent(wing_id, "SpriteComponent") or {}
			-- for i, comp in ipairs(sprite_comps) do

				-- ComponentSetValue2(comp, "rect_animation", "open")
				-- ComponentSetValue2(comp, "next_rect_animation", "open")
				
			-- end
		-- end
	end
	if wing_id > 0 then
		--animation
		local sprite_comps = EntityGetComponent(wing_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
		
			local animation = ComponentGetValue2( comp, "rect_animation")
			if animation ~= "close" then
				ComponentSetValue2(comp, "rect_animation", "close")
				ComponentSetValue2(comp, "next_rect_animation", "close")
			end
		end
	end
else

	if wing_id > 0 then
		--animation
		local sprite_comps = EntityGetComponent(wing_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do

			local animation = ComponentGetValue2( comp, "rect_animation")
			if animation ~= "open" and animation ~= "fly" then
				ComponentSetValue2(comp, "rect_animation", "open")
				ComponentSetValue2(comp, "next_rect_animation", "fly")
			end
			
		end
		
		local number = GetValueNumber("number2", 0)
		SetValueNumber("number2", number + 1)
		
		if number >= 4 then
			SetValueNumber("number2", 0)
			EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", false)
		else
			EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
		end
	end

	-- EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", false)
end

--Ice Attack
local it_is_attack_frame = false

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 10 == 0 then
	it_is_attack_frame = true
end

local player_id = get_player()
local px, py = EntityGetTransform(player_id)
local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y, px, py)

local player_visible = false

if player_id ~= nil and not did_hit then
	player_visible = true
end

if player_visible == true and (EntityGetHerdRelation(entity_id, player_id) < 40) and it_is_attack_frame then

	local number = GetValueNumber("number", 0)
	SetValueNumber("number", number + 1)
	
	if number == 9 then
		if not did_hit then
			local sprite_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
			ComponentSetValue2(sprite_comp, "rect_animation", "fire")
			ComponentSetValue2(sprite_comp, "next_rect_animation", "stand")
		end
	end
	
	if number >= 10 then
		SetValueNumber("number", 0)
		if not did_hit then
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
			return
		end
	else
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
	end

end