dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local comp = EntityGetFirstComponent( entity_id, "VariableStorageComponent", "lurkershot_id" )
if ( comp ~= nil ) then
	local lurker_id = ComponentGetValue2( comp, "value_int" )
	
	local f, nx, ny, d = GetSurfaceNormal( x, y, 16, 8 )
	
	if f then
		x = x - nx * d
		y = y - ny * d
	end
	
	local test = EntityGetTransform( lurker_id )
	
	--print( tostring( nx ) .. ", " .. tostring( ny ) .. ", " .. tostring( d ) )
	
	if ( lurker_id ~= nil ) and ( lurker_id ~= NULL_ENTITY ) and ( test ~= nil ) then
	
		local who_shot_damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		local who_spawned_damage_model_component = EntityGetFirstComponentIncludingDisabled( lurker_id, "DamageModelComponent" )

		local hp = ComponentGetValue2(who_shot_damage_model_component, "hp")
		local max_hp = ComponentGetValue2(who_shot_damage_model_component, "max_hp")

		if max_hp and hp then
			if hp <= 0 then
				EntityKill(lurker_id)
				return
			end
			ComponentSetValue2( who_spawned_damage_model_component, "max_hp", max_hp )
			ComponentSetValue2( who_spawned_damage_model_component, "hp", hp )
			
		end
		
		EntitySetTransform( lurker_id, x , y )
		EntityApplyTransform( lurker_id, x, y )
		EntitySetComponentsWithTagEnabled( lurker_id, "lurker_data", true )
		
		  local comp = EntityGetFirstComponentIncludingDisabled(lurker_id, "SpriteComponent")
		  EntityRefreshSprite(entity_id, comp)
	end
end