dofile_once("data/scripts/lib/utilities.lua")

function collision_trigger(colliding_entity)
	local entity_id = GetUpdatedEntityID()
	local x,y,rot = EntityGetTransform( entity_id )

	local entities = EntityGetInRadiusWithTag( x, y, 2, "fungitrap_02" )

	if ( #entities < 1 ) then
		EntityLoad( "data/entities/projectiles/drone_trail.xml", x, y )
	end

	--Set all incoming projectile physics forces to 0:
	for i, projectile_id in ipairs(EntityGetInRadiusWithTag(x, y, 100, "projectile") or {}) do
		local projectile_comp = EntityGetFirstComponentIncludingDisabled( projectile_id, "ProjectileComponent" )
		if projectile_comp then
			ComponentSetValue2( projectile_comp, "physics_impulse_coeff", 0 )
			ComponentObjectSetValue2( projectile_comp, "config_explosion", "physics_explosion_power", 0, 0 )
			ComponentObjectSetValue2( projectile_comp, "config_explosion", "physics_throw_enabled", false )
		end
	end
end