function get_direction( x1, y1, x2, y2 )
	local result = math.pi - math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
	return result
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local root_id = EntityGetParent( entity_id )

local angle = 0

if (root_id ~= nil) and (root_id > 0) then
	x, y = EntityGetTransform( root_id )
	local players = EntityGetWithTag( "player_unit" )

	if ( #players > 0 ) then
		local p = players[1]
		
		local px,py = EntityGetTransform( p )
		
		angle = get_direction( x, y, px, py )
	else
		local players = EntityGetWithTag( "polymorphed_player" )
		if ( #players > 0 ) then
			local p = players[1]
			
			local px,py = EntityGetTransform( p )
			
			angle = get_direction( x, y, px, py )
		end
	end
end

angle = math.pi + angle

EntitySetTransform( entity_id, x + math.cos( angle ) * 0.8, y - math.sin( angle ) * 0.8 )