dofile_once("data/scripts/lib/utilities.lua")

function get_player()
  local players = get_players()
  if players ~= nil then
    return players[1]
  end

  -- TODO: What does this mean anyway? Player is dead..?
  return nil
end

--rotating sprite based on velocity
function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local state = get_state()


local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x, scale_y = EntityGetTransform(entity_id)
state.prev_x = state.prev_x or x
state.prev_y = state.prev_y or y
local vx, vy = x - state.prev_x, y - state.prev_y

local dir = get_direction(vx, vy, 0, 0)

local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")

if x < x + vx then
	
	-- scale_x = 1
	-- scale_y = 1

	EntitySetTransform(entity_id, x, y, rot, 1)
	
elseif x > x + vx then

	-- scale_x = -1
	-- scale_y = -1
	
	EntitySetTransform(entity_id, x, y, rot, -1)

end
-- EntitySetTransform(entity_id, x, y, rot, scale_x, scale_y)

state.prev_x = x
state.prev_y = y

-- local entity_id = GetUpdatedEntityID()

-- local x, y, rot = EntityGetTransform(entity_id)

-- local x_old = GetValueNumber("x_old", x)
-- local y_old = GetValueNumber("y_old", y)

-- local angle_new = get_direction( x_old, y_old, x, y )

-- local angle = approx_rolling_average(rot, angle_new, 10)

-- EntitySetTransform(entity_id, x, y, angle)

-- SetValueNumber("x_old",x)
-- SetValueNumber("y_old",y)



--Adding detection for the surfaces
surface_found = false
surface_found_quantity = 0

for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	local surface_found_var_comp = EntityGetFirstComponentIncludingDisabled(child, "VariableStorageComponent")
	if ( surface_found_var_comp ~= nil ) and ( surface_found_var_comp > 0 ) then
		local surface_check_value = ComponentGetValue2(surface_found_var_comp, "value_bool")
		if surface_check_value == true then
		  surface_found_quantity = surface_found_quantity + 1
		end
	end
	if EntityGetName(child) == "head" then
		head_id = child
	end
end

if surface_found_quantity > 0 then
	surface_found = true
end

--Toggle movement based on surfaces

-- local raytrace = RaytraceSurfaces(x, y, x, y + 40)

if surface_found == true then
	EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
	function get_player()
	  local players = get_players()
	  if players ~= nil then
		return players[1]
	  end

	  -- TODO: What does this mean anyway? Player is dead..?
	  return nil
	end
	
	local player_id = get_player()
	local px, py = EntityGetTransform(player_id)
	local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y, px, py)
	if ( player_id ~= nil ) and ( player_id > 0 ) and ( not did_hit ) and ( EntityGetHerdRelation(entity_id, player_id) < 40 ) then
		local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
		ComponentSetValue2(limb_boss_component, "mMoveToPositionX", px)
		ComponentSetValue2(limb_boss_component, "mMoveToPositionY", py)
		ComponentSetValue2(limb_boss_component, "state", 4)
		-- if wing_id > 0 and ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 20 == 0 then
			-- --animation
			-- local sprite_comps = EntityGetComponent(wing_id, "SpriteComponent") or {}
			-- for i, comp in ipairs(sprite_comps) do

				-- ComponentSetValue2(comp, "rect_animation", "open")
				-- ComponentSetValue2(comp, "next_rect_animation", "open")
				
			-- end
		-- end
	end
	
else

	local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
	-- ComponentSetValue2(limb_boss_component, "mMoveToPositionX", px)
	-- ComponentSetValue2(limb_boss_component, "mMoveToPositionY", py)
	ComponentSetValue2(limb_boss_component, "state", 1)
		
	-- local number = GetValueNumber("number2", 0)
	-- SetValueNumber("number2", number + 1)
	
	-- if number >= 4 then
		-- SetValueNumber("number2", 0)
		-- EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", false)
	-- else
		-- EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
	-- end

	EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", false)
	PhysicsApplyForce(entity_id, 0, -8.5 )
end

-------------------------------------
--Rotate based on terrain

function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

local old_average = GetValueNumber("average_rotation", 0)

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

--Moving our normal detectors based on entity rotation
local right_corner = { x1 = -40, y1 = 0 }
local right_x, right_y = vec_rotate(right_corner.x1, right_corner.y1, rot)
right_x = x + right_x
right_y = y + right_y

local left_corner = { x2 = 40, y2 = 0 }
local left_x, left_y = vec_rotate(left_corner.x2, left_corner.y2, rot)
left_x = x + left_x
left_y = y + left_y

function GetSurfaceNormal(pos_x, pos_y, ray_length, ray_count)
	local total_normal_x = 0
	local total_normal_y = 0
	local total_distance = 0
	local found_normal = false

	for i = 1, ray_count do
		local angle = (i - 1) * (2 * math.pi / ray_count)
		local ray_x = pos_x + ray_length * math.cos(angle)
		local ray_y = pos_y + ray_length * math.sin(angle)

		local did_hit, hit_x, hit_y = RaytracePlatforms(pos_x, pos_y, ray_x, ray_y)

		if did_hit then
			found_normal = true
			local normal_x, normal_y = hit_x - pos_x, hit_y - pos_y
			total_normal_x = total_normal_x + normal_x
			total_normal_y = total_normal_y + normal_y
			total_distance = total_distance + math.sqrt(normal_x^2 + normal_y^2)
		end
	end

	if found_normal then
		local average_normal_x = total_normal_x / ray_count
		local average_normal_y = total_normal_y / ray_count
		local average_distance = total_distance / ray_count
		return true, average_normal_x, average_normal_y, average_distance
	else
		return false, 0, 0, 0
	end
end

local found_normal, normal_x, normal_y, approximate_distance_from_surface = GetSurfaceNormal(right_x, right_y, 10, 30)
local found_normal2, normal_x2, normal_y2, approximate_distance_from_surface = GetSurfaceNormal(left_x, left_y, 10, 30)
local found_normal3, normal_x3, normal_y3, approximate_distance_from_surface = GetSurfaceNormal(x, y, 10, 30)

local normal_in_solid, hit_x, hit_y = RaytracePlatforms( right_x, right_y, right_x, right_y )
local normal_in_solid2, hit_x2, hit_y2 = RaytracePlatforms( left_x, left_y, left_x, left_y )
local normal_in_solid3, hit_x3, hit_y3 = RaytracePlatforms( x, y, x, y )

normal_count = 3

if normal_in_solid or not found_normal then
	normal_x = 0
	normal_y = 0
	normal_count = normal_count - 1
end

if normal_in_solid2 or not found_normal2 then
	normal_x2 = 0
	normal_y2 = 0
	normal_count = normal_count - 1
end

if normal_in_solid3 or not found_normal3 then
	normal_x3 = 0
	normal_y3 = 0
	normal_count = normal_count - 1
end


if normal_count > 0 then

	local normal_x_average = (normal_x + normal_x2 + normal_x3) / normal_count
	local normal_y_average = (normal_y + normal_y2 + normal_y3) / normal_count

	local dir = get_direction(0, 0, normal_x_average, normal_y_average)
	local degree_shift = math.rad(-90) + dir -- 90 degree rotation to properly orient the entity
	local new_average = approx_rolling_average(old_average, degree_shift, 20) -- if the number is higher than 5 the turning speed would be smoother and slower, if less it would be more instantaneous
	SetValueNumber("average_rotation", new_average)

	local max_angle = math.rad(45)
	local new_average_capped_angle = math.min(max_angle, math.max(new_average, -max_angle))
	EntitySetTransform(entity_id, x, y, new_average_capped_angle)
	
else

	local degree_shift = 0
	local new_average = approx_rolling_average(old_average, degree_shift, 50) -- if the number is higher than 5 the turning speed would be smoother and slower, if less it would be more instantaneous
	SetValueNumber("average_rotation", new_average)

	local max_angle = math.rad(45)
	local new_average_capped_angle = math.min(max_angle, math.max(new_average, -max_angle))
	EntitySetTransform(entity_id, x, y, new_average_capped_angle)
	
end

--Material comverter to melt solids

local entity_id = GetUpdatedEntityID()

local x, y, rot = EntityGetTransform(entity_id)

local components = EntityGetComponent(entity_id, "MagicConvertMaterialComponent")
if components then
	for k, component in pairs(components)do
		local old_radius = ComponentGetValue2(component, "radius")
		if(old_radius < 70)then
			ComponentSetValue2(component, "radius", old_radius + 1)
			ComponentSetValue2(component, "min_radius", old_radius)
		else
			ComponentSetValue2(component, "radius", 1)
			ComponentSetValue2(component, "min_radius", 0)
		end
	end
end

--This is purely turning animation code
local last_scale_x = GetValueNumber("last_xscale", scale_x)

local var_comp = get_variable_storage_component( entity_id, "turning" )

if ComponentGetValue2(var_comp, "value_bool") == false then
	local x, y, rot2, scale_x2 = EntityGetTransform(entity_id)
	local wanted_x, wanted_y = vec_rotate(43, -9, rot)
	wanted_x = x + wanted_x * scale_x2
	wanted_y = y + wanted_y * scale_x2
	
	EntitySetTransform(head_id, wanted_x, wanted_y)

	if last_scale_x ~= scale_x then
	
		ComponentSetValue2(var_comp, "value_bool", true)
		
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		
		for i, comp in ipairs(sprite_comps) do
			
			if ( not ComponentHasTag( comp, "health_bar" ) ) then
				-- ComponentRemoveTag( comp, "character" )
				ComponentSetValue2( comp, "rect_animation", "turn_right" )
				ComponentSetValue2( comp, "next_rect_animation", "stand" )
			end
			
		end
		
		-- GamePlayAnimation( entity_id, "turn_right", 100, "stand", 100 )
		
		-- GamePlaySound("mods/new_enemies/data/sound/more_sounds/my_mod_audio.bank", "snd_mod/clamper_move", x, y)
		
		SetValueNumber("timeout_frames", 0)
		
	end
	
end

if ComponentGetValue2(var_comp, "value_bool") == true then
	SetValueNumber("timeout_frames", GetValueNumber("timeout_frames", 40) + 1)
	
	local rot_val = GetValueNumber("rot_val", -43)
	if ( GetValueNumber("timeout_frames", 40) % 2 ) == 0 then
		rot_val = -43 + 86 * (GetValueNumber("timeout_frames", 40) / 40 )
	end
	
	-- GamePrint(rot_val)
	
	local x, y, rot, scale_x2, scale_y = EntityGetTransform(entity_id)
	local wanted_x, wanted_y = vec_rotate(rot_val, -9, rot)
	wanted_x = x + wanted_x * scale_x2
	wanted_y = y + wanted_y * scale_x2
	
	EntitySetTransform(head_id, wanted_x, wanted_y)
	
	SetValueNumber("rot_val", rot_val)
	
	if ( GetValueNumber("timeout_frames", 40) > 40 ) then
		ComponentSetValue2(var_comp, "value_bool", false)
		-- GamePlayAnimation( entity_id, "stand", 100, "stand", 100 )
		-- local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		-- for i, comp in ipairs(sprite_comps) do
			-- -- if ( ComponentGetValue2(comp, "image_file") == "data/enemies_gfx/platoon.xml" ) then
				
			-- -- end
			
			-- if ( not ComponentHasTag( comp, "health_bar" ) ) then
				-- ComponentAddTag( comp, "character" )
			-- end
		-- end
	end
end

SetValueNumber("last_xscale", scale_x)