function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local state = get_state()

local frames_to_bite = 10

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
state.prev_x = state.prev_x or x
state.prev_y = state.prev_y or y
local vx, vy = x - state.prev_x, y - state.prev_y
local worm_component = EntityGetFirstComponent(entity_id, "WormComponent")
local target_kill_radius = ComponentGetValue2(worm_component, "target_kill_radius")

local entities = EntityGetInRadiusWithTag(x + vx * frames_to_bite, y + vy * frames_to_bite, target_kill_radius + 5, "hittable")
local child_entities = EntityGetAllChildren(entity_id) or {}
local face_entity
for i, v in ipairs(child_entities) do
  if EntityGetName(v) == "face_worm_head" then
    face_entity = v
    break
  end
end

local sprite_component = EntityGetFirstComponent(face_entity, "SpriteComponent")
local dir = get_direction(vx, vy, 0, 0)
local fx, fy = EntityGetTransform(face_entity)
EntitySetTransform(face_entity, fx, fy, dir)
local mFrameNextDamage = ComponentGetValue2(worm_component, "mFrameNextDamage")

if #entities > 1 and (GameGetFrameNum() - mFrameNextDamage > 0) then
  local an = ComponentGetValue2(sprite_component, "rect_animation")
  if an ~= "bite" then
    ComponentSetValue2(sprite_component, "rect_animation", "bite")
  end
end

state.prev_x = x
state.prev_y = y

--GOTO PLAYER
local players = EntityGetInRadiusWithTag(x, y, 150, "player_unit")

if #players > 0 then
  
  local worm_ai_component = EntityGetFirstComponentIncludingDisabled( entity_id, "WormAIComponent")

  if worm_ai_component and (EntityGetHerdRelation(entity_id, players[1]) < 40) then
	ComponentSetValue2( worm_ai_component, "mTargetEntityId", players[1] )
  end
end
