dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

local enemy, enemy_x, enemy_y
local min_dist = 99999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 200, "player_unit")) do
	-- is target a valid enemy
	if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, entity_x, entity_y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = entity_x
			enemy_y = entity_y
		end
	end
end

--do nothing if there's no target
local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
local state = ComponentGetValue2(animal_ai_component, "ai_state")
local job = ComponentGetValue2(animal_ai_component, "preferred_job")

local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
local is_stuck = ComponentGetValue2(pathfinding_component, "path_is_stuck")

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )


if not enemy or ( is_stuck == true ) or ( state == 4 ) then
 
	if ( job == "Escaping" ) or ( state == 4 ) then
		ComponentSetValue2( animal_ai_component, "preferred_job", "JobDefault" )
		ComponentSetValue2( animal_ai_component, "ai_state", 18 )

	
		-- local cdc_id = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		-- local velocity_x, velocity_y = ComponentGetValue2(cdc_id, "mVelocity")
		-- ComponentSetValueVector2(cdc_id, "mVelocity", velocity_x + Random(-100, 100), velocity_y + Random(-100, 100))
		ComponentSetValue2( GetUpdatedComponentID(), "execute_every_n_frame", 30 )
	end
end

if ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 5 == 0 ) and ( state ~= 15 ) and ( state ~= 3 ) then
	ComponentSetValue2( animal_ai_component, "ai_state", 4 )
	ComponentSetValue2( GetUpdatedComponentID(), "execute_every_n_frame", 10 )
end

local cooldown = GetValueNumber("CoolDown", 10)
if cooldown < 10 then
	SetValueNumber("CoolDown", cooldown + 1)
	return
end
--make sure the enemy is seeing the target
if (enemy ~= nil) and (enemy > 0) then
	local did_hit, hit_x, hit_y = RaytracePlatforms(x, y - 10 , enemy_x, enemy_y)

	if not did_hit and ( state ~= 15 ) and ( state ~= 3 ) then

		--getting the direction to go to
		local dir = get_direction(enemy_x, enemy_y, x, y - 10)
		local force = 100
		local force_x = math.cos(dir) * (force)
		local force_y = math.sin(dir) * (force)
		
		local distance_to_check = 15
		local did_hit2, hit_x2, hit_y2 = RaytracePlatforms(x, y - 10, x - math.cos(dir) * distance_to_check, y - 10 + math.sin(dir) * distance_to_check)
		local did_hit3, hit_x3, hit_y3 = RaytracePlatforms(x, y, x - math.cos(dir) * distance_to_check, y - 10 + math.sin(dir) * distance_to_check)
		local cdc_id = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		local velocity_x, velocity_y = ComponentGetValue2(cdc_id, "mVelocity")
		
		local y_targ = y - 10 + math.sin(dir) * distance_to_check
		
		-- GameCreateSpriteForXFrames( "data/debug/circle_16.png", x - math.cos(dir) * distance_to_check, y_targ, true, 0, 0, 1, false )
		
		if not did_hit2 and not did_hit3 then
			ComponentSetValueVector2(cdc_id, "mVelocity", velocity_x - force_x, velocity_y + force_y)
			-- ComponentSetValue2( animal_ai_component, "preferred_job", "Escaping" )
		elseif ( y_targ < y + 10 ) and ( y_targ > y - 10 ) then
			ComponentSetValueVector2(cdc_id, "mVelocity", velocity_x - ( force_x * -1 ) , velocity_y + ( force_y * -1 ) )
			SetValueNumber("CoolDown", 0)
		end

	end
end