dofile_once("data/scripts/lib/utilities.lua")

local entity = GetUpdatedEntityID()

local _, _, day, hour, minute, second = GameGetDateAndTimeLocal()
SetRandomSeed(day + hour + second, minute + second + entity)

local verlet_data = {point_count = 0, positions = {}}

local x, y = EntityGetTransform(entity)

local verlet_entities = {}
local verlet_files = {}
local empty_percentage = 0

component_read( EntityGetFirstComponent( entity, "VerletPhysicsComponent" ), { positions = {} }, function(comp)

    verlet_data.point_count = ((#comp.positions) / 2)

	--manually setting the number of segments
    for i = 1, 20, 2 do
        local point = {x = 0, y = 0}
		point.x, point.y = comp.positions[i], comp.positions[i + 1]
		table.insert(verlet_data.positions, point) 
    end
end)

function set_verlet_position(verlet, x, y)
    component_readwrite( EntityGetFirstComponent( verlet, "VerletPhysicsComponent" ), { positions = {} }, function(comp)
        comp.positions[1] = x
        comp.positions[2] = y
    end)
end

function delimiter_split(input, delimiter)
    local word_table = {}
    for word in string.gmatch(input, '([^'..delimiter..']+)') do
        table.insert(word_table, word)
    end
    return word_table
end

function tablelength(T)
    local count = 0
    for _ in pairs(T) do count = count + 1 end
    return count
end

local holder = nil

local variable_storage = EntityGetComponent(entity, "VariableStorageComponent")

for k, v in pairs(variable_storage)do
    local name = ComponentGetValue2(v, "name")

    if(name == "verlet_entity")then
        table.insert(verlet_entities, tonumber(ComponentGetValue2(v, "value_string")))     
    elseif(name == "verlet_files")then
        verlet_files = delimiter_split(ComponentGetValue2(v, "value_string"), ',')
    elseif(name == "holder")then
        holder = tonumber(ComponentGetValue2(v, "value_string"))
    end
end

function get_direction( x1, y1, x2, y2 )
    local result = math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
    return result
end

for k, position in pairs(verlet_data.positions)do
    if(verlet_entities[1] ~= nil)then
        if(verlet_entities[k] ~= 0)then
            if(EntityGetIsAlive(verlet_entities[k]))then
				
				local hx, hy = EntityGetTransform(verlet_entities[k])
				local angle = get_direction( hx, hy, position.x, position.y )
				
                EntitySetTransform(verlet_entities[k], position.x, position.y, angle - 90)
                set_verlet_position(verlet_entities[k], position.x, position.y)
            end
        end
    else
        if(0 == empty_percentage) and k > 1 and k % 2 == 0 then

			local verlet_file = verlet_files[Random(1, #verlet_files)]
			local verlet = EntityLoad(verlet_file, x, y)
			EntityAddChild(entity, verlet)
			if(verlet ~= nil)then
				
				EntityAddComponent(entity, "VariableStorageComponent", {
					name="verlet_entity",
					value_string=tostring(verlet),
				})
			   -- GamePrint("holder = "..holder)
				if(holder ~= 0)then
					EntityAddComponent(holder, "VariableStorageComponent", {
						name="verlet_entity",
						value_string=tostring(verlet),
					})
				end

			end
        else
            EntityAddComponent(entity, "VariableStorageComponent", {
                name="verlet_entity",
                value_string="0",
            })           
        end
    end
end