dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local components = EntityGetComponent(entity_id, "MagicConvertMaterialComponent")
if components then
	for k, component in pairs(components)do
		local old_radius = ComponentGetValue2(component, "radius")
		if(old_radius < 300)then
			ComponentSetValue2(component, "radius", old_radius + 5)
			ComponentSetValue2(component, "min_radius", old_radius)
		else
			ComponentSetValue2(component, "radius", 1)
			ComponentSetValue2(component, "min_radius", 0)
		end
	end
end

for i, projectile_id in ipairs(EntityGetInRadiusWithTag(x, y, 300, "projectile") or {}) do
	for i, comp in ipairs(EntityGetComponentIncludingDisabled( projectile_id, "HitEffectComponent" ) or {}) do
		EntityRemoveComponent( entity_id, comp )
	end
	for i, comp in ipairs(EntityGetComponentIncludingDisabled( projectile_id, "ProjectileComponent" ) or {}) do
		ComponentSetValue2( comp, "damage_game_effect_entities", "" ) 
	end
end

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

	local game_effect_component = EntityGetFirstComponentIncludingDisabled(child_id, "GameEffectComponent")
	
	if game_effect_component  and EntityGetName(child_id) ~= "important" then
	
		EntityKill(child_id)
		
	end

end