local old_async_loop = async_loop
function async_loop(func)
  local success, err = pcall(function()
    old_async_loop(func)
  end)
  if not success then
    print("ERROR: " .. err)
  end
end

dofile_once("data/scripts/lib/coroutines.lua")
-- dofile( "data/scripts/game_helpers.lua" )
async_loop(function()

	wait(60)

	dofile_once("data/scripts/lib/utilities.lua")

	local entity_id = GetUpdatedEntityID()
	
	local x, y = EntityGetTransform(entity_id)
	
	local players = EntityGetInRadiusWithTag(x, y, 250, "player_unit")

	if #players > 0 and (EntityGetHerdRelation(entity_id, players[1]) < 40) then
	  
		local player_x, player_y = EntityGetTransform(players[1])
		local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, player_x, player_y)
	  
		if not did_hit then
		
			for i, sprite_child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
				
				edit_component2( sprite_child_id, "SpriteComponent", function(sprite_comp,vars)
					
					ComponentSetValue2( sprite_comp, "rect_animation", "open")
					
				end)
				
			end
			
			--Adding Vortex particle Effect:
			
			local vortex_id = EntityLoad( "data/particles/vortex/field.xml", x, y )
			EntitySetTransform(vortex_id, x, y)
			EntityAddChild(entity_id, vortex_id)
			
			
			--Adding Trail Particle effect:
			
			
			local child_id = EntityCreateNew()
			EntitySetTransform(child_id, x, y)
			EntityAddChild(entity_id, child_id)
			
			local particle_comp = EntityAddComponent2(child_id, "ParticleEmitterComponent", {
				  emitted_material_name="spark_white",
				  x_pos_offset_min=-2,
				  x_pos_offset_max=2,
				  y_pos_offset_min=-2,
				  y_pos_offset_max=2,
				  x_vel_min=-4,
				  x_vel_max=4,
				  y_vel_min=-8,
				  y_vel_max=0,
				  count_min=0,
				  count_max=1,
				  is_trail=true,
				  trail_gap=1,
				  lifetime_min=0.1,
				  lifetime_max=0.1,
				  fade_based_on_lifetime=true,
				  create_real_particles=false,
				  emit_cosmetic_particles=true,
				  collide_with_grid=false,
				  emission_interval_min_frames=0,
				  emission_interval_max_frames=0,
				  airflow_force=0.36,
				  airflow_time=1.20,
				  airflow_scale=0.28,
				  is_emitting=true,
			} )
			ComponentSetValue2(particle_comp, "gravity", 0, 0)
			ComponentSetValue2(particle_comp, "offset", 0, 0)
			
			EntityAddComponent(child_id, "LuaComponent", {
				script_source_file="data/scripts/projectiles/follow_player.lua",
				execute_every_n_frame="1",
				execute_on_added="1",
			} )
			
			EntityAddComponent(child_id, "LifetimeComponent", {
				lifetime="155",
			} )
			
			
			-- Adding Gravitaitonal Particle Effect to trail effect entity:
			
			
			local child_id2 = EntityCreateNew()
			EntitySetTransform(child_id2, x, y)
			
			EntityAddComponent(child_id2, "InheritTransformComponent", {} )
			
			EntityAddChild(child_id, child_id2)
			
			local comp2 = EntityAddComponent2(child_id2, "ParticleEmitterComponent", {
				emitted_material_name="spark_white",
				-- gravity.y="0.0",
				lifetime_min=0.5,
				lifetime_max=1.5,
				count_min=1,
				count_max=3,
				render_on_grid=true,
				fade_based_on_lifetime=true,
				-- area_circle_radius.max="40",
				cosmetic_force_create=false,
				airflow_force=0.5,
				airflow_time=0.01,
				airflow_scale=0.05,
				emission_interval_min_frames=1,
				emission_interval_max_frames=1,
				emit_cosmetic_particles=true,
				is_emitting=true,
				draw_as_long=true,
				attractor_force=100,
			} )
			ComponentSetValue2(comp2, "gravity", 0, 0)
			ComponentSetValue2(comp2, "area_circle_radius", 0, 20)
			
			EntityAddComponent(child_id2, "AudioComponent", {
				file="data/audio/Desktop/projectiles.bank",
				event_root="player_projectiles/megalaser",
			} )
			
			
			--Life Time Component If we ever come in need of it :)
			
			
			-- EntityAddComponent(child_id2, "LifetimeComponent", {
				-- lifetime="75",
			-- } )
			
			wait(25)
			
			for i, sprite_child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
				
				edit_component2( sprite_child_id, "SpriteComponent", function(sprite_comp,vars)
					
					ComponentSetValue2( sprite_comp, "rect_animation", "open_stand")
					
				end)
				
			end
			
			wait(125)
			
			local child_id3 = EntityCreateNew()
			EntitySetTransform(child_id3, x, y)
			EntityAddComponent(child_id3, "InheritTransformComponent", {} )
			EntityAddChild(entity_id, child_id3)
			local comp3 = EntityAddComponent2(child_id3, "ParticleEmitterComponent", {
				emitted_material_name="spark_white",
				-- gravity.y="0",
				-- offset.x="0",
				-- offset.y="0",
				x_pos_offset_min=0,
				y_pos_offset_min=0,
				x_pos_offset_max=0,
				y_pos_offset_max=0,
				x_vel_min=0,
				x_vel_max=0,
				y_vel_min=0,
				y_vel_max=0,
				friction=4,
				count_min=30,
				count_max=50,
				-- area_circle_radius.max="4",
				-- area_circle_radius.min="4",
				velocity_always_away_from_center=80,
				lifetime_min=0.9,
				lifetime_max=3.2,
				render_on_grid=false,
				airflow_force=0.25,
				airflow_time=0.101,
				airflow_scale=2.01,
				fade_based_on_lifetime=true,
				create_real_particles=false,
				emit_cosmetic_particles=true,
				emission_interval_min_frames=3,
				emission_interval_max_frames=3,
				delay_frames=8,
				is_emitting=true,
			} )
			ComponentSetValue2(comp3, "gravity", 0, 0)
			ComponentSetValue2(comp3, "offset", 0, 0)
			ComponentSetValue2(comp3, "area_circle_radius", 9, 9)
			
			-- EntityAddComponent(child_id2, "LuaComponent", {
				-- script_source_file="data/scripts/projectiles/gazer_laser_projectile_spawner.lua",
				-- execute_every_n_frame="1",
			-- } )
			
			EntityAddComponent(child_id3, "LifetimeComponent", {
				lifetime="45",
			} )
			
			function get_direction( x1, y1, x2, y2 )
			  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
			end
			
			function shoot_projectile_at_pos(shooter_entity, projectile_file, origin_x, origin_y, dest_x, dest_y, projectile_speed)	

			  local dir = get_direction(origin_x, origin_y, dest_x, dest_y)
			  local vx = math.cos(dir) * projectile_speed
			  local vy = math.sin(dir) * projectile_speed

			  local ourProjectile = shoot_projectile(shooter_entity, projectile_file, origin_x, origin_y, vx, vy)
			  
			end
			
			for i, sprite_child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
				
				edit_component2( sprite_child_id, "SpriteComponent", function(sprite_comp,vars)
					
					ComponentSetValue2( sprite_comp, "rect_animation", "close")
					
				end)
				
			end
			
			child_x, child_y = EntityGetTransform(child_id)
			
			for i = 1, 25 do
			
				x, y = EntityGetTransform(entity_id)
				
				if ( child_x ~= nil ) and ( child_y ~= nil ) then

					shoot_projectile_at_pos(entity_id, "data/entities/projectiles/gazer_laser_projectile.xml", x, y, child_x , child_y , 1400)
					
				end
				
				wait(1)
			end
			
			wait (25)
			
			for i, sprite_child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
				
				edit_component2( sprite_child_id, "SpriteComponent", function(sprite_comp,vars)
					
					ComponentSetValue2( sprite_comp, "rect_animation", "stand")
					
				end)
				
			end
			
		end
		
	end

end)