--Particle Effects:

dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local parent_id = EntityGetParent( entity_id )

if parent_id > 0 then

	--Area Checker:
	
	local parent_x, parent_y = EntityGetTransform(parent_id)
	local x, y = EntityGetTransform(entity_id)
	local parent_y = parent_y - 65
	local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")

	function get_distance( x1, y1, x2, y2 )
		local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
		return result
	end

	function get_direction( x1, y1, x2, y2 )
		return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
	end

	local distance = get_distance(x, y, parent_x, parent_y)
	local max_distance = 20
	if distance > max_distance then     
	  local direction = get_direction(parent_x, parent_y, x, y)
	  x = parent_x + math.cos(direction) * max_distance
	  y = parent_y + math.sin(direction) * max_distance
	  -- EntitySetComponentIsEnabled( entity_id, physics_body_component, false )
	end

	EntitySetTransform(entity_id, x, y)
	-- EntitySetComponentIsEnabled( entity_id, physics_body_component, true )
	

	--Teleport to parent if inside wall:

	local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, x, y)
	  
	if did_hit then

		-- EntityLoad( "data/entities/particles/teleportation_source.xml", x, y )
		-- EntityLoad( "data/entities/particles/teleportation_target.xml", parent_x, parent_y )
		-- EntitySetComponentIsEnabled( entity_id, physics_body_component, false )
		EntitySetTransform( entity_id, parent_x, parent_y )
		-- EntitySetComponentIsEnabled( entity_id, physics_body_component, true )

	end
	
end