dofile( "data/scripts/lib/utilities.lua" )
 
local entity_id = GetUpdatedEntityID()
local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
local sprite_particle_emitter_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteParticleEmitterComponent")
local hp = ComponentGetValue2(damage_model_component, "hp")
local max_hp = ComponentGetValue2(damage_model_component, "max_hp")
local lua_comps = EntityGetComponentIncludingDisabled(entity_id, "LuaComponent") or {}
local blue_fire_shot_damage = { script_damage_received = "data/scripts/projectiles/blue_fire_shot.lua", execute_every_n_frame = 99999 }
local red_fire_shot = "data/scripts/projectiles/red_fire_shot.lua"
local red_fire_shot_damage = { script_damage_received = "data/scripts/projectiles/red_fire_shot_damage.lua", execute_every_n_frame = 99999 }
local green_fire_shot = "data/scripts/projectiles/green_fire_shot.lua"
local green_fire_shot_damage = { script_damage_received = "data/scripts/projectiles/green_fire_shot_damage.lua", execute_every_n_frame = 99999 }
 
function set_scripts_enabled(entity_id, scripts)
  for i, lua_comp in ipairs(lua_comps) do
    for i, script in ipairs(scripts) do
      if ComponentGetValue2(lua_comp, script[1]) == script[2] then
        EntitySetComponentIsEnabled(entity_id, lua_comp, script[3])
      end  
    end
  end
end

function get_script(script)
  local lua_comps = EntityGetComponentIncludingDisabled(entity_id, "LuaComponent") or {}
  for i, lua_comp in ipairs(lua_comps) do
    local matches = true
    for k, v in pairs(script) do
      if ComponentGetValue2(lua_comp, k) ~= v then
        matches = false
      end
    end
    if matches then return lua_comp end
  end
  return false
end

function remove_scripts(scripts)
  for i, script in ipairs(scripts) do
    local lua_comp = get_script(script)
    if lua_comp then
      EntityRemoveComponent(entity_id, lua_comp)
    end
  end
end
 
if hp > max_hp * 0.5 then
  ComponentSetValue(sprite_particle_emitter_component, "sprite_file", "data/enemies_gfx/small_statue_physics_emissive_particle.xml")
  if not get_script(blue_fire_shot_damage) then
    EntityAddComponent2(entity_id, "LuaComponent", blue_fire_shot_damage)
  end
  set_scripts_enabled(entity_id, {
    { "script_source_file", red_fire_shot, false },
    { "script_source_file", green_fire_shot, false },
  })
  remove_scripts({
    red_fire_shot_damage,
    green_fire_shot_damage
  })
elseif hp > max_hp * 0.25 then
  ComponentSetValue(sprite_particle_emitter_component, "sprite_file", "data/enemies_gfx/small_statue_physics_emissive_particle3.xml")
  if not get_script(red_fire_shot_damage) then
    EntityAddComponent2(entity_id, "LuaComponent", red_fire_shot_damage)
  end
  set_scripts_enabled(entity_id, {
    { "script_source_file", red_fire_shot, true },
    { "script_source_file", green_fire_shot, false },
  })
  remove_scripts({
    blue_fire_shot_damage,
    green_fire_shot_damage
  })
else
  ComponentSetValue(sprite_particle_emitter_component, "sprite_file", "data/enemies_gfx/small_statue_physics_emissive_particle2.xml")
  if not get_script(green_fire_shot_damage) then
    EntityAddComponent2(entity_id, "LuaComponent", green_fire_shot_damage)
  end
  set_scripts_enabled(entity_id, {
    { "script_source_file", red_fire_shot, false },
    { "script_source_file", green_fire_shot, true },
  })
  remove_scripts({
    blue_fire_shot_damage,
    red_fire_shot_damage
  })
end

-- local entity_id = GetUpdatedEntityID()
-- local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
-- local sprite_particle_emitter_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteParticleEmitterComponent")
-- local hp = ComponentGetValue2(damage_model_component, "hp")
-- local max_hp = ComponentGetValue2(damage_model_component, "max_hp")
-- local lua_comps = EntityGetComponentIncludingDisabled(entity_id, "LuaComponent") or {}
-- local blue_fire_shot_damage = { script_damage_received = "data/scripts/projectiles/blue_fire_shot.lua", execute_every_n_frame = 99999 }
-- local red_fire_shot = { script_source_file = "data/scripts/projectiles/red_fire_shot.lua", execute_every_n_frame = 120 }
-- local red_fire_shot_damage = { script_damage_received = "data/scripts/projectiles/red_fire_shot_damage.lua", execute_every_n_frame = 99999 }
-- local green_fire_shot = { script_source_file = "data/scripts/projectiles/green_fire_shot.lua", execute_every_n_frame = 60 }
-- local green_fire_shot_damage = "data/scripts/projectiles/green_fire_shot_damage.lua"

-- function remove_scripts(scripts)
  -- for i, lua_comp in ipairs(lua_comps) do
    -- for i, script in ipairs(scripts) do
      -- local matches = true
      -- for k, v in pairs(script) do
        -- if ComponentGetValue2(lua_comp, k) ~= v then
          -- matches = false
        -- end
      -- end
      -- if matches then
        -- EntityRemoveComponent(entity_id, lua_comp)
      -- end
    -- end
  -- end
-- end

-- if hp > max_hp * 0.5 then
  -- ComponentSetValue(sprite_particle_emitter_component, "sprite_file", "data/enemies_gfx/small_statue_physics_emissive_particle.xml")
  -- EntityAddComponent2(entity_id, "LuaComponent", blue_fire_shot)
  -- remove_scripts({
    -- red_fire_shot,
    -- red_fire_shot_damage,
    -- green_fire_shot,
    -- green_fire_shot_damage
  -- })
-- elseif hp > max_hp * 0.25 then
  -- ComponentSetValue(sprite_particle_emitter_component, "sprite_file", "data/enemies_gfx/small_statue_physics_emissive_particle2.xml")
  -- EntityAddComponent2(entity_id, "LuaComponent", blue_fire_shot)
  -- remove_scripts({
    -- red_fire_shot,
    -- green_fire_shot,
    -- red_fire_shot_damage,
    -- green_fire_shot
  -- })
-- else
	-- ComponentSetValue(sprite_particle_emitter_component, "sprite_file", "data/enemies_gfx/small_statue_physics_emissive_particle2.xml")
  -- ComponentSetValue(sprite_particle_emitter_component, "sprite_file", "data/enemies_gfx/small_statue_physics_emissive_particle2.xml")
  -- EntityAddComponent2(entity_id, "LuaComponent", blue_fire_shot)
  -- remove_scripts({
    -- red_fire_shot,
    -- green_fire_shot,
    -- red_fire_shot_damage,
    -- green_fire_shot
  -- })
-- end