local old_async_loop = async_loop
function async_loop(func)
  local success, err = pcall(function()
    old_async_loop(func)
  end)
  if not success then
    print("ERROR: " .. err)
  end
end

dofile_once("data/scripts/lib/coroutines.lua")
-- dofile( "data/scripts/game_helpers.lua" )
async_loop(function()

	dofile_once("data/scripts/lib/utilities.lua")

	function spawn_portal(which_one, material)
		local entity_id = GetUpdatedEntityID()
		local x,y = EntityGetTransform( entity_id )
		
		-- local opts = { "portal_orb_blue", "portal_orb_green", "portal_orb_pink" }
		
		SetRandomSeed( GameGetFrameNum(), x + entity_id )
		
		local raycasts = 4
		local dir = ( math.pi * 2.0 ) / raycasts
		local length = 8
		
		-- local rnd = Random( 1, #opts )
		local portal = "data/entities/projectiles/" .. which_one .. ".xml"
		
		local p = EntityGetWithTag( "player_unit" )
		
		if ( #p > 0 ) then
			local t = p[1]
			local px, py = EntityGetTransform( t )
			
			local dx = px + Random( -150, 150 )
			local dy = py + Random( -150, 150 )
			
			local dist = math.abs( py - dy ) + math.abs( px - dx )
			local limit = 0
			local wall = true
			
			while ( ( dist < 100 ) or wall ) and ( limit < 20 ) do
				dx = px + Random( -100, 100 )
				dy = py + Random( -100, 100 )
				dist = math.abs( py - dy ) + math.abs( px - dx )
				limit = limit + 1
				
				for j=0,raycasts-1 do
					local ex = dx + math.cos( j * dir ) * length
					local ey = dy - math.sin( j * dir ) * length
					
					wall = RaytraceSurfaces( dx, dy, ex, ey )
					
					if wall then
						break
					end
				end
			end
			if portal == "data/entities/projectiles/portal_orb_blue" then
				EntityLoad( "data/entities/particles/poof_blue.xml", dx, dy )
			end
			if portal == "data/entities/projectiles/portal_orb_green" then
				EntityLoad( "data/entities/particles/poof_blue.xml", dx, dy )
			end
			if portal == "data/entities/projectiles/portal_orb_pink" then
				EntityLoad( "data/entities/particles/poof_pink.xml", dx, dy )
			end
			if portal == "data/entities/projectiles/portal_orb_purple" then
				EntityLoad( "data/entities/particles/poof_pink.xml", dx, dy )
				EntityLoad( "data/entities/particles/poof_blue.xml", dx, dy )
			end
			local portal_id = EntityLoad( portal, dx, dy )
			EntityAddChild(entity_id, portal_id)
			
			-- Add Trail Particles
				
			local particle_comp = EntityAddComponent2(portal_id, "ParticleEmitterComponent", {
					  emitted_material_name=material,
					  x_pos_offset_min=-2,
					  x_pos_offset_max=2,
					  y_pos_offset_min=-2,
					  y_pos_offset_max=2,
					  x_vel_min=-50,
					  x_vel_max=50,
					  y_vel_min=-50,
					  y_vel_max=50,
					  count_min=0,
					  count_max=1,
					  is_trail=true,
					  trail_gap=1,
					  lifetime_min=0.8,
					  lifetime_max=0.8,
					  fade_based_on_lifetime=true,
					  create_real_particles=false,
					  emit_cosmetic_particles=true,
					  collide_with_grid=false,
					  emission_interval_min_frames=0,
					  emission_interval_max_frames=0,
					  airflow_force=0.36,
					  airflow_time=1.20,
					  airflow_scale=0.28,
					  is_emitting=true,
			} )
			ComponentSetValue2(particle_comp, "gravity", 0, 0)
			ComponentSetValue2(particle_comp, "offset", 0, 0)
			
			EntityAddComponent(portal_id, "LuaComponent", {
				script_source_file="data/scripts/animals/head_statue_particles.lua",
				execute_every_n_frame="1",
				execute_on_added="1",
			} )
				
			-- EntityAddComponent(particles_id, "LifetimeComponent", {
				-- lifetime="240",
			-- } )
		end
	end

	wait(60)

	local entity_id = GetUpdatedEntityID()
	
	local x, y = EntityGetTransform(entity_id)
	
	local players = EntityGetInRadiusWithTag(x, y, 250, "player_unit")
	
	local parent_id = EntityGetParent(entity_id)

	if #players > 0 and (EntityGetHerdRelation(parent_id, players[1]) < 40) then
	  
		local player_x, player_y = EntityGetTransform(players[1])
		local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, player_x, player_y)
	  
		if not did_hit then
		
			--Opening finger 1:
		
			edit_component2( entity_id, "SpriteComponent", function(sprite_comp,vars)
					
				ComponentSetValue2( sprite_comp, "rect_animation", "open1")
					
			end)
			
			--Adding Vortex particle Effect:
			
			local vortex_id = EntityLoad( "data/particles/vortex/field1.xml", x, y )
			EntitySetTransform(vortex_id, x, y)
			EntityAddChild(entity_id, vortex_id)
			
			wait(60)
			
			spawn_portal("portal_orb_green","spark_green")
					
			wait(240)
			
			edit_component2( entity_id, "SpriteComponent", function(sprite_comp,vars)
					
				ComponentSetValue2( sprite_comp, "rect_animation", "open2")
					
			end)
			
			--Adding Vortex particle Effect:
			
			local vortex_id = EntityLoad( "data/particles/vortex/field3.xml", x, y )
			EntitySetTransform(vortex_id, x, y)
			EntityAddChild(entity_id, vortex_id)
			
			wait(60)
			
			spawn_portal("portal_orb_pink","spark_red")
			
			wait(240)

			edit_component2( entity_id, "SpriteComponent", function(sprite_comp,vars)
					
				ComponentSetValue2( sprite_comp, "rect_animation", "open3")
					
			end)
			
			--Adding Vortex particle Effect:
			
			local vortex_id = EntityLoad( "data/particles/vortex/field2.xml", x, y )
			EntitySetTransform(vortex_id, x, y)
			EntityAddChild(entity_id, vortex_id)
			
			wait(60)
			
			spawn_portal("portal_orb_blue","spark_blue")
			
			wait(240)

			edit_component2( entity_id, "SpriteComponent", function(sprite_comp,vars)
					
				ComponentSetValue2( sprite_comp, "rect_animation", "open4")
					
			end)
			
			--Adding Vortex particle Effect:
			
			local vortex_id = EntityLoad( "data/particles/vortex/field4.xml", x, y )
			EntitySetTransform(vortex_id, x, y)
			EntityAddChild(entity_id, vortex_id)
			
			wait(60)
			
			spawn_portal("portal_orb_purple","spark_purple")
			
			wait(240)
			
			edit_component2( entity_id, "SpriteComponent", function(sprite_comp,vars)
					
				ComponentSetValue2( sprite_comp, "rect_animation", "close")
					
			end)
			
		end
		
	end

end)