dofile_once("data/scripts/lib/utilities.lua")

--rotating sprite based on velocity
function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x, scale_y = EntityGetTransform(entity_id)

SetRandomSeed(GameGetFrameNum(), x + y + entity_id)

--Set Origin Point
local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "initialised")
local var_comp2 = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")

if ComponentGetValue2(var_comp, "value_bool") == false then
	ComponentSetValue2(var_comp, "value_bool", true)

	local origin_x = ComponentGetValue2(var_comp2, "value_int")
	if origin_x == false or origin_x == 0 then
		ComponentSetValue2(var_comp2, "value_int", x)
	end
	
	local origin_y = tonumber(ComponentGetValue2(var_comp2, "value_string"))
	if origin_y == false or origin_y == 0 then
		ComponentSetValue2(var_comp2, "value_string", y)
	end
	
end

--If origin y is too high, just reset it
local origin_y = tonumber(ComponentGetValue2(var_comp2, "value_string"))

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 60 == 0 then

	if y < origin_y - 150 then

		ComponentSetValue2(var_comp2, "value_string", y)
		
		-- local limb_boss_components = EntityGetComponentIncludingDisabled(entity_id, "LimbBossComponent")
		
		-- if #limb_boss_components > 0 then
		
			-- for k, limb_boss_component in pairs(limb_boss_components)do
				-- EntityRemoveComponent( entity_id, limb_boss_component )
			-- end
			
			-- local component = EntityAddComponent2(entity_id, "LimbBossComponent", {
				-- state=4
			-- })
			-- EntitySetComponentIsEnabled( entity_id, component, true )
			
		-- end
		
		-- local physics_ai_components = EntityGetComponentIncludingDisabled(entity_id, "PhysicsAIComponent")
		
		-- if #physics_ai_components > 0 then
		
			-- for k, physics_ai_component in pairs(physics_ai_components)do
				-- EntityRemoveComponent( entity_id, physics_ai_component )
			-- end
			
			-- local component = EntityAddComponent2(entity_id, "PhysicsAIComponent", {
				-- target_vec_max_len=24.0,
				-- force_coeff=8,
				-- force_max=40,
				-- force_balancing_coeff=0.9,
				-- torque_coeff=50,
				-- torque_balancing_coeff=1,
				-- torque_max=50.0,
				-- free_if_static=true,
				-- damage_deactivation_probability=0,
				-- damage_deactivation_time_min=2,
				-- damage_deactivation_time_max=10
			-- })
			-- EntitySetComponentIsEnabled( entity_id, component, false )
			-- ComponentAddTag( component, "enabled_in_world" )
			-- ComponentAddTag( component, "enable_when_player_seen" )
			
		-- end

	elseif y > origin_y + 150 then

		ComponentSetValue2(var_comp2, "value_string", y)
		
		-- local limb_boss_components = EntityGetComponentIncludingDisabled(entity_id, "LimbBossComponent")
		
		-- if #limb_boss_components > 0 then
		
			-- for k, limb_boss_component in pairs(limb_boss_components)do
				-- EntityRemoveComponent( entity_id, limb_boss_component )
			-- end
			
			-- local component = EntityAddComponent2(entity_id, "LimbBossComponent", {
				-- state=4
			-- })
			-- EntitySetComponentIsEnabled( entity_id, component, true )
			
		-- end
		
		-- local physics_ai_components = EntityGetComponentIncludingDisabled(entity_id, "PhysicsAIComponent")
		
		-- if #physics_ai_components > 0 then
		
			-- for k, physics_ai_component in pairs(physics_ai_components)do
				-- EntityRemoveComponent( entity_id, physics_ai_component )
			-- end
			
			-- local component = EntityAddComponent2(entity_id, "PhysicsAIComponent", {
				-- target_vec_max_len=24.0,
				-- force_coeff=8,
				-- force_max=40,
				-- force_balancing_coeff=0.9,
				-- torque_coeff=50,
				-- torque_balancing_coeff=1,
				-- torque_max=50.0,
				-- free_if_static=true,
				-- damage_deactivation_probability=0,
				-- damage_deactivation_time_min=2,
				-- damage_deactivation_time_max=10
			-- })
			-- EntitySetComponentIsEnabled( entity_id, component, false )
			-- ComponentAddTag( component, "enabled_in_world" )
			-- ComponentAddTag( component, "enable_when_player_seen" )
			
		-- end
		
	end
	
end

-- if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 600 == 0 then

	-- local limb_boss_components = EntityGetComponentIncludingDisabled(entity_id, "LimbBossComponent")
	
	-- if #limb_boss_components > 0 then
	
		-- for k, limb_boss_component in pairs(limb_boss_components)do
			-- EntityRemoveComponent( entity_id, limb_boss_component )
		-- end
		
		-- local component = EntityAddComponent2(entity_id, "LimbBossComponent", {
			-- state=4
		-- })
		-- EntitySetComponentIsEnabled( entity_id, component, true )
		
	-- end
	
	-- local physics_ai_components = EntityGetComponentIncludingDisabled(entity_id, "PhysicsAIComponent")
	
	-- if #physics_ai_components > 0 then
	
		-- for k, physics_ai_component in pairs(physics_ai_components)do
			-- EntityRemoveComponent( entity_id, physics_ai_component )
		-- end
		
		-- local component = EntityAddComponent2(entity_id, "PhysicsAIComponent", {
			-- target_vec_max_len=24.0,
			-- force_coeff=8,
			-- force_max=40,
			-- force_balancing_coeff=0.9,
			-- torque_coeff=50,
			-- torque_balancing_coeff=1,
			-- torque_max=50.0,
			-- free_if_static=true,
			-- damage_deactivation_probability=0,
			-- damage_deactivation_time_min=2,
			-- damage_deactivation_time_max=10
		-- })
		-- EntitySetComponentIsEnabled( entity_id, component, false )
		-- ComponentAddTag( component, "enabled_in_world" )
		-- ComponentAddTag( component, "enable_when_player_seen" )
		
	-- end
	
-- end

--trying to fool system
-- local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
-- ComponentSetValue2( damage_model_component, "mLiquidCount", 0 )
-- ComponentSetValue2( damage_model_component, "mAirAreWeInWater", false )
-- ComponentSetValue2( damage_model_component, "mAirDoWeHave", true )

--Move right to left
local move_right = GetValueBool("move_right", true)

if x > ( ComponentGetValue2(var_comp2, "value_int") + 200 ) then
	SetValueBool("move_right", false)
	SetValueNumber("target_y", Random(-80,80))
elseif x < ( ComponentGetValue2(var_comp2, "value_int") - 200 ) then
	SetValueBool("move_right", true)
	SetValueNumber("target_y", Random(-80,80))
end

local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")

if limb_boss_component ~= nil and limb_boss_component > 0 then

	if move_right == true then

		ComponentSetValue2(limb_boss_component, "state", 4)
		ComponentSetValue2(limb_boss_component, "mMoveToPositionX", ComponentGetValue2(var_comp2, "value_int") + 250)
		ComponentSetValue2(limb_boss_component, "mMoveToPositionY", tonumber(ComponentGetValue2(var_comp2, "value_string")) + GetValueNumber("target_y", 0))
		
	elseif move_right == false then

		ComponentSetValue2(limb_boss_component, "state", 4)
		ComponentSetValue2(limb_boss_component, "mMoveToPositionX", ComponentGetValue2(var_comp2, "value_int") - 250)
		ComponentSetValue2(limb_boss_component, "mMoveToPositionY", tonumber(ComponentGetValue2(var_comp2, "value_string")) + GetValueNumber("target_y", 0))

	end
	
end

--expand the lava converter 
local components = EntityGetComponent(entity_id, "MagicConvertMaterialComponent")
if components then
	for k, component in pairs(components)do
		if ComponentHasTag( component, "enabled_in_hand" ) then
			-- local old_radius = ComponentGetValue2(component, "radius")
			-- if(old_radius < 50)then
				-- ComponentSetValue2(component, "radius", old_radius + 20)
				-- ComponentSetValue2(component, "min_radius", old_radius)
			-- else
				-- ComponentSetValue2(component, "radius", 1)
				-- ComponentSetValue2(component, "min_radius", 0)
			-- end
		else
			local old_radius = ComponentGetValue2(component, "radius")
			if (old_radius < 45)then
				ComponentSetValue2(component, "radius", old_radius + 1)
				ComponentSetValue2(component, "min_radius", old_radius)
			else
				ComponentSetValue2(component, "radius", 1)
				ComponentSetValue2(component, "min_radius", 0)
			end
		end
	end
end


--Adding detection for the surfaces
surface_found = false
surface_found_quantity = 0

for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	local surface_found_var_comp = EntityGetFirstComponentIncludingDisabled(child, "VariableStorageComponent")
	if ( surface_found_var_comp ~= nil ) and ( surface_found_var_comp > 0 ) then
		local surface_check_value = ComponentGetValue2(surface_found_var_comp, "value_bool")
		if surface_check_value == true then
		  surface_found_quantity = surface_found_quantity + 1
		end
	end
end

if surface_found_quantity > 0 then
	surface_found = true
end

if surface_found == true then

	local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
	
	local targetX = ComponentGetValue2(limb_boss_component, "mMoveToPositionX")
	local targetY = ComponentGetValue2(limb_boss_component, "mMoveToPositionY")
	
	local dx = targetX - x
	local dy = targetY - y
	local angle = math.atan2(dy, dx)
	
	local force = 10
	
	PhysicsApplyForce(entity_id, force * math.cos(angle), force * math.sin(angle) )
	
	--Keep the creature elevated. cancel gravity because limbs are grabbing land
	PhysicsApplyForce(entity_id, 0, -19.6 )
	
	-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

-- else

	-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
	
else

	--Make the creature fall, But don't let it fall too quickly, so we just reduce the upward force a little
	PhysicsApplyForce(entity_id, 0, -8.5 )
	
end