dofile_once("data/scripts/lib/utilities.lua")

function damage_received( dmg, msg, source )
	local entity_id = GetUpdatedEntityID()
	local parent_id = EntityGetParent( entity_id )
	for i, child in ipairs(EntityGetAllChildren(parent_id) or {}) do
		if EntityGetName(child) == "neck" then
			neck_id = child
			EntityInflictDamage( child, 0.04, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, entity_id, 0, 0 )
		end
	end
	local root_id = EntityGetRootEntity( entity_id )
	local x,y = EntityGetTransform( root_id )
	
	if ( source ~= nil ) and ( source ~= NULL_ENTITY ) and ( source ~= entity_id ) and ( source ~= root_id ) then
		EntityInflictDamage( root_id, dmg, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, source, 0, 0 )
		EntityInflictDamage( parent_id, 0.04, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, entity_id, 0, 0 )
	else
		EntityInflictDamage( root_id, dmg, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, entity_id, 0, 0 )
		EntityInflictDamage( parent_id, 0.04, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, entity_id, 0, 0 )
	end
	
	local comp = EntityGetFirstComponent( neck_id, "DamageModelComponent" )
	if ( comp ~= nil ) then
		local max_hp = ComponentGetValue2( comp, "max_hp" )
		ComponentSetValue2( comp, "hp", max_hp )
	end
	
	local comp = EntityGetFirstComponent( entity_id, "DamageModelComponent" )
	if ( comp ~= nil ) then
		local max_hp = ComponentGetValue2( comp, "max_hp" )
		ComponentSetValue2( comp, "hp", max_hp )
	end
	
	local comp = EntityGetFirstComponent( parent_id, "DamageModelComponent" )
	if ( comp ~= nil ) then
		local max_hp = ComponentGetValue2( comp, "max_hp" )
		ComponentSetValue2( comp, "hp", max_hp )
	end
end