dofile_once("data/scripts/lib/utilities.lua")

function damage_received( dmg, msg, source, is_fatal)
	if EntityGetName( source ) ~= "sand_worm_segment" then
		local entity_id = GetUpdatedEntityID()
		local root_id = EntityGetRootEntity( entity_id )
		local x,y = EntityGetTransform( root_id )
		
		for i, child_id in ipairs(EntityGetAllChildren(root_id) or {}) do
		
			local var_comp5 = get_variable_storage_component( child_id, "damage_flash_delay" )
			ComponentSetValue2(var_comp5, "value_int", 1)

			local damage_model_component = EntityGetFirstComponentIncludingDisabled(child_id, "DamageModelComponent")
			
			if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) and EntityGetName(child_id) == "sand_worm_segment" then
			
				EntityInflictDamage( child_id, 0.04, "DAMAGE_PROJECTILE", "", "NONE", 0, 0, entity_id, x, y )
				
			end

		end
		
		if ( source ~= nil ) and ( source ~= NULL_ENTITY ) and ( source ~= entity_id ) and ( source ~= root_id ) then
			EntityInflictDamage( root_id, dmg, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, source, x, y )
		else
			EntityInflictDamage( root_id, dmg, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, entity_id, x, y )
		end
		
		local comp = EntityGetFirstComponent( entity_id, "DamageModelComponent" )
		if ( comp ~= nil ) then
			local max_hp = ComponentGetValue2( comp, "max_hp" )
			ComponentSetValue2( comp, "hp", max_hp )
		end
	end
end