dofile_once("data/scripts/lib/utilities.lua")

function damage_received( dmg, msg, source )
	local entity_id = GetUpdatedEntityID()
	local root_id = EntityGetRootEntity( entity_id )
	local parent_id = EntityGetParent( entity_id )
	EntityInflictDamage( parent_id, 0.04, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, parent_id, 0, 0 )
	local comp = EntityGetFirstComponent( parent_id, "DamageModelComponent" )
	if ( comp ~= nil ) then
		local max_hp = ComponentGetValue2( comp, "max_hp" )
		ComponentSetValue2( comp, "hp", max_hp )
	end
	local x,y = EntityGetTransform( root_id )
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	if ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") > Random(1, 3) ) or ( dmg > 2 ) then
		local var_comp = get_variable_storage_component( parent_id, "killed" )
		if ComponentGetValue2(var_comp, "value_bool") == false then
			local sprite_component = EntityGetFirstComponentIncludingDisabled(parent_id, "SpriteComponent")
			if ComponentGetValue2(sprite_component, "image_file") == "data/enemies_gfx/scorpio_eye.png" then
				ComponentSetValue2(sprite_component, "image_file", "data/enemies_gfx/scorpio_eye_dead.png")
			elseif ComponentGetValue2(sprite_component, "image_file") == "data/enemies_gfx/scorpio_eye2.png" then
				ComponentSetValue2(sprite_component, "image_file", "data/enemies_gfx/scorpio_eye2_dead.png")
			end
			EntityRefreshSprite( parent_id, sprite_component )
			ComponentSetValue2(var_comp, "value_bool", true)
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
			GamePlaySound("data/audio/Desktop/animals.bank", "animals/bat/attack_dash", x, y)
		end
	end
	
	value = 0
	
	for i, child in ipairs(EntityGetAllChildren(root_id) or {}) do
	  
	  if EntityGetName(child) == "eyeball" then
		local var_comp2 = get_variable_storage_component( child, "killed" )
		local bool = ComponentGetValue2( var_comp2, "value_bool" )
		if bool == false then
			value = value + 1
		end
		
	  end
	  
	end
	
	if value == 0 then
		local entity_id = GetUpdatedEntityID()
		local damage_model_component = EntityGetFirstComponentIncludingDisabled(root_id, "DamageModelComponent")

		ComponentSetValue2(damage_model_component, "invincibility_frames", 0)
		
		EntitySetComponentsWithTagEnabled(root_id, "enabled_in_hand", true)
		
		-- local game_effect_comp = GetGameEffectLoadTo(root_id, "BLINDNESS", true)
		-- ComponentSetValue2(game_effect_comp, "frames", -1)
		
		LoadGameEffectEntityTo( root_id, "data/entities/misc/effect_blindness_scorpio.xml" )
		
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/slimeshooter/death", x, y)
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/bat/death", x, y)
		
		-- local pathfinding_component = EntityGetFirstComponent(root_id, "PathFindingComponent")
		-- ComponentSetValue2(pathfinding_component, "distance_to_reach_node_x", 60)
		-- ComponentSetValue2(pathfinding_component, "distance_to_reach_node_x", 60)
		
		-- local platforming_component = EntityGetFirstComponent(root_id, "CharacterPlatformingComponent")
		-- ComponentSetValue2(platforming_component, "velocity_min_y", -350)
		-- ComponentSetValue2(platforming_component, "velocity_max_y", 350)
		-- ComponentSetValue2(platforming_component, "fly_velocity_x", 100)
		
		local animal_ai_component = EntityGetFirstComponent(root_id, "AnimalAIComponent")
		
		-- ComponentSetValue2(animal_ai_component, "preferred_job", "TakingFireDamage")
		-- ComponentSetValue2(animal_ai_component, "ai_state", 11)
		ComponentSetValue2(animal_ai_component, "creature_detection_range_x", 0)
		ComponentSetValue2(animal_ai_component, "creature_detection_range_y", 0)
		ComponentSetValue2(animal_ai_component, "creature_detection_check_every_x_frames", 1000)
		ComponentSetValue2(animal_ai_component, "escape_if_damaged_probability", 100)
		
		
		local cpc_id = EntityGetFirstComponentIncludingDisabled(root_id, "CharacterPlatformingComponent")
		ComponentSetValue2( cpc_id, "pixel_gravity", 600 )
	
		EntitySetComponentsWithTagEnabled(root_id, "enabled_in_world", false)
		-- ComponentSetValue2(animal_ai_component, "ai_state_timer", 99999999999999999999999999999999999999)
		
		-- ComponentSetValue2(damage_model_component, "air_needed", true)
		-- ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
		-- EntityInflictDamage( root_id, dmg, "DAMAGE_DROWNING", "", "BLOOD_EXPLOSION", 0, 0, source, x, y )
	end
end