dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 250, "mortal")) do
	-- is target a valid enemy
	if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, entity_x, entity_y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = entity_x
			enemy_y = entity_y
		end
	end
end

if not enemy then return end

local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y - 13 , enemy_x, enemy_y)
		
local did_hit_floor, hit_x_floor, hit_y_floor = RaytraceSurfaces(x, y + 3 , x, y + 4)
		
if not did_hit and did_hit_floor then
	if enemy_x < x and scale_x > 0 then
		EntitySetTransform(entity_id, x, y, rot, -1)
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/throw", x, y)
	elseif enemy_x > x and scale_x < 0 then
		EntitySetTransform(entity_id, x, y, rot, 1)
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/throw", x, y)
	end
	
end
