dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

local enemy, enemy_x, enemy_y
local min_dist = 99999
local enemy = 0
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 300, "mortal")) do
	-- is target a valid enemy
	if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, entity_x, entity_y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = entity_x
			enemy_y = entity_y
		end
	end
end

--do nothing if there's no target
local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
local prey_id = ComponentGetValue2(animal_ai_component, "mGreatestPrey")
local state = ComponentGetValue2(animal_ai_component, "ai_state")

local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
local targ_x, targ_y = ComponentGetValueVector2(pathfinding_component, "path_next_node_vector_to")
local path_is_stuck = ComponentGetValue2(pathfinding_component, "path_is_stuck")
local path_frames_stuck = ComponentGetValue2(pathfinding_component, "path_frames_stuck")


if enemy > 0 then
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

	local did_hit, hit_x, hit_y = RaytracePlatforms(x, y - 3, enemy_x, enemy_y)
	-- if path_is_stuck or ( path_frames_stuck > 200 ) then
		-- shoot_projectile( entity_id, "data/entities/projectiles/grapple_vine.xml", x, y, Random(-60, 60), Random(-60, 60) )
	if did_hit then
		shoot_projectile( entity_id, "data/entities/projectiles/grapple_vine.xml", x, y, targ_x, targ_y )
		-- ComponentSetValue2( animal_ai_component, "preferred_job", "JobDefault" )
		-- ComponentSetValue2( animal_ai_component, "ai_state", 18 )


		-- local cdc_id = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		-- local velocity_x, velocity_y = ComponentGetValue2(cdc_id, "mVelocity")
		-- ComponentSetValueVector2(cdc_id, "mVelocity", velocity_x + Random(-100, 100), velocity_y + Random(-100, 100))
		-- ComponentSetValue2( GetUpdatedComponentID(), "execute_every_n_frame", Random(10, 25) )
	-- else
		-- if state ~= 13 then
			-- -- ComponentSetValue2( pathfinding_component, "frames_between_searches", 0 )
			-- -- ComponentSetValue2( animal_ai_component, "mRangedAttackNextFrame", 0 )
			-- -- ComponentSetValue2( animal_ai_component, "ai_state", 15 )
		-- end
	end
end

if ( state == 0 ) or path_is_stuck or ( path_frames_stuck > 200 ) then
	ComponentSetValue2( animal_ai_component, "ai_state", 1 )
end