dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity( entity_id )
local rx,ry,rangle,rscale_x = EntityGetTransform(root_id)
local x,y,angle,scale_x,scale_y = EntityGetTransform(entity_id)
local r = angle

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
	
	if EntityGetName(child_id) == "hand_2" then
	
		hand_id = child_id
		cx,cy,cangle,cscale_x,cscale_y = EntityGetTransform(child_id)
	end

end

for i, sibling_id in ipairs(EntityGetAllChildren(root_id) or {}) do
	
	if EntityGetName(sibling_id) == "hand_gun" then
	
		gun_id = sibling_id
		sx,sy,sangle,sscale_x,sscale_y = EntityGetTransform(sibling_id)
	end

end

--Check Nearest Enemy
local range = 250
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, range, "mortal")) do
	-- is target a valid enemy
	if root_id ~= id  and (EntityGetHerdRelation(root_id, id) < 40) and EntityGetRootEntity( id ) ~= root_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local ex, ey = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, ex, ey)
		if dist < min_dist then
			enemy = id
			enemy_x = ex
			enemy_y = ey
		end
	end
end

if not enemy then
	if rscale_x < 0 then
		enemy_x = rx - 150
		enemy_y = ry + 250
	elseif rscale_x > 0 then 
		enemy_x = rx + 150
		enemy_y = ry + 250
	end
end

function move_angle_towards(current_angle, target_angle, speed)
  -- Make angle go from 0 to 2pi
  if target_angle < 0 then
	target_angle = target_angle + math.pi * 2
  end
  if current_angle < 0 then
	current_angle = current_angle + math.pi * 2
  end

  local dist_up = math.abs(target_angle - current_angle)
  local dist_down = math.abs((current_angle + math.pi * 2) - target_angle)
  if current_angle > target_angle then
	dist_up = math.abs((target_angle + math.pi * 2) - current_angle)
	dist_down = math.abs(current_angle - target_angle)
  end
  
  local dir
  if math.abs(dist_up) < math.abs(dist_down) then
	dir = 1
  else
	dir = -1
  end
  local dist_smallest = dist_up
  if dist_down < dist_up then
	dist_smallest = dist_down
  end

  local new_angle = current_angle + speed * dir
  if dir > 0 and current_angle < target_angle and new_angle > target_angle then
	new_angle = target_angle
  elseif dir < 0 and current_angle > target_angle and new_angle < target_angle  then
	new_angle = target_angle
  end
  new_angle = new_angle % (math.pi * 2)

  return new_angle
end

local angle_old = GetValueNumber("average_rotation", 0)
local angle_old2 = GetValueNumber("average_rotation2", 0)

local smoothness_factor = 20
local smoothness_factor_gun = 40

-- local looking_at_target = (enemy_x > rx and rscale_x > 0) or (enemy_x < rx and rscale_x < 0)

-- if enemy then

	--Stretching towards target

	function get_direction( x1, y1, x2, y2 )
		local result = math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
		return result
	end

	function get_distance( x1, y1, x2, y2 )
		local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
		return result
	end

	local start_x, start_y = x, y

	local angle2 = get_direction(start_x, start_y, enemy_x, enemy_y)
	
	--check if arm is inside walls
	local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, cx + math.cos(angle2) * 6, cy + math.sin(angle2) * 6)
	
	if did_hit then
	  enemy_x = hit_x
	  enemy_y = hit_y
	end
	
	function approx_rolling_average(avg, target, n)
		avg = avg - avg / n;
		avg = avg + target / n;
		return avg
	end

	local old_enemy_x = GetValueNumber("enemy_x", x)
	local old_enemy_y = GetValueNumber("enemy_y", y)
	enemy_x = approx_rolling_average(old_enemy_x, enemy_x, 10)
	enemy_y = approx_rolling_average(old_enemy_y, enemy_y, 10)
	SetValueNumber("enemy_x", enemy_x)
	SetValueNumber("enemy_y", enemy_y)
	
	--Smoothen Path
	angle_new = move_angle_towards(angle_old, angle2, 1 / smoothness_factor)
	
	local distance = get_distance(start_x, start_y, enemy_x, enemy_y)
	local sprite_width = 67
	local max_distance = 67
	local scale = math.max(0, distance) / sprite_width
	scale = math.min(scale, sprite_width / max_distance)
	
	--get tip of arm
	local tip_x = scale * sprite_width
	local tip_y = 0
	tip_x, tip_y = vec_rotate(tip_x, tip_y, angle_new)
	
	--Sibling
	local sstart_x, sstart_y = sx, sy

	local angle3 = get_direction(sstart_x, sstart_y, enemy_x, enemy_y)
	
	--Smoothen Path
	angle_new2 = move_angle_towards(angle_old2, angle3, 1 / smoothness_factor_gun)
	
	-- local distance2 = get_distance(sstart_x, sstart_y, enemy_x, enemy_y)
	-- local sprite_width2 = 29
	-- local max_distance2 = 29
	-- local scale2 = math.max(0, distance2) / sprite_width2
	-- scale2 = math.min(scale2, sprite_width2 / max_distance2)
	
	if rscale_x < 0 then
		EntitySetTransform(entity_id, start_x, start_y, angle_new - 0.085 , scale, scale_y * -1)
		EntitySetTransform(gun_id, sstart_x, sstart_y, angle_new2 - 0.085 , 1, sscale_y * -1)
		EntitySetTransform(hand_id, start_x + tip_x , start_y + tip_y , angle_new, cscale_x, scale_y )
	elseif rscale_x > 0 then
		EntitySetTransform(entity_id, start_x, start_y, angle_new , scale, scale_y)
		EntitySetTransform(gun_id, sstart_x, sstart_y, angle_new2 , 1, sscale_y)
		EntitySetTransform(hand_id, start_x + tip_x, start_y + tip_y, angle_new)
	end
-- elseif not enemy then

	-- --Stretching towards target

	-- function get_direction( x1, y1, x2, y2 )
		-- local result = math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
		-- return result
	-- end

	-- function get_distance( x1, y1, x2, y2 )
		-- local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
		-- return result
	-- end

	-- local start_x, start_y = x, y

	-- local angle2 = get_direction(start_x, start_y, enemy_x, enemy_y)
	
	-- --Smoothen Path
	-- angle_new = move_angle_towards(angle_old, angle2, 1 / smoothness_factor)
	
	-- local distance = get_distance(start_x, start_y, enemy_x, enemy_y)
	-- local sprite_width = 67
	-- local max_distance = 67
	-- local scale = math.max(0, distance) / sprite_width
	-- scale = math.min(scale, sprite_width / max_distance)
	
	-- local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, cx, cy)
	-- if did_hit then
		-- scale = scale * 0.9
	-- end
	
	-- --get tip of arm
	-- local tip_x = scale * sprite_width
	-- local tip_y = 0
	-- tip_x, tip_y = vec_rotate(tip_x, tip_y, angle_new)
	
	-- --Sibling
	-- local sstart_x, sstart_y = sx, sy

	-- local angle3 = get_direction(sstart_x, sstart_y, enemy_x, enemy_y)
	
	-- --Smoothen Path
	-- angle_new2 = move_angle_towards(angle_old2, angle3, 1 / smoothness_factor_gun)
	
	-- local distance2 = get_distance(sstart_x, sstart_y, enemy_x, enemy_y)
	-- local sprite_width2 = 29
	-- local max_distance2 = 29
	-- local scale2 = math.max(0, distance2) / sprite_width2
	-- scale2 = math.min(scale2, sprite_width2 / max_distance2)
	
	-- if rscale_x < 0 then
		-- EntitySetTransform(entity_id, start_x, start_y, angle_new - 0.085 , scale, scale_y * -1)
		-- EntitySetTransform(gun_id, sstart_x, sstart_y, angle_new2 - 0.085 , scale2, sscale_y * -1)
		-- EntitySetTransform(hand_id, start_x + tip_x , start_y + tip_y , angle_new, cscale_x, scale_y )
	-- elseif rscale_x > 0 then
		-- EntitySetTransform(entity_id, start_x, start_y, angle_new , scale, scale_y)
		-- EntitySetTransform(gun_id, sstart_x, sstart_y, angle_new2 , scale2, sscale_y)
		-- EntitySetTransform(hand_id, start_x + tip_x, start_y + tip_y, angle_new)
	-- end
	
-- end

SetValueNumber("average_rotation",angle_new)
SetValueNumber("average_rotation2",angle_new2)