dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local range = 250
local pos_x, pos_y, rotation = EntityGetTransform(entity_id)
local root_id = EntityGetRootEntity( entity_id )

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, range, "mortal")) do
	-- is target a valid enemy
	if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(root_id, id) < 40 then
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end

if enemy ~= 0 and enemy ~= nil then
  
	local did_hit, hit_x, hit_y = RaytracePlatforms(pos_x, pos_y, enemy_x, enemy_y)
  
	if not did_hit then
		
		rotate_value = 0
		
		rotation = rotation - math.rad(rotate_value)
		local distance_from_center = 29
		local projectile_speed = 100
		-- SetRandomSeed(GameGetFrameNum(), x + y * i)
		-- local random_angle_adjustment = math.rad(Random(-60, 60))
		local target_x = pos_x + math.cos(rotation) * distance_from_center
		local target_y = pos_y + math.sin(rotation) * distance_from_center
		
		local vel_x = math.cos(rotation) * projectile_speed
		local vel_y = math.sin(rotation) * projectile_speed
		
		--animation
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do

			ComponentSetValue2(comp, "rect_animation", "attack")
			ComponentSetValue2(comp, "next_rect_animation", "stand")
			
		end
		
		shoot_projectile(root_id, "data/entities/projectiles/junkbot_orb.xml", target_x, target_y, vel_x, vel_y)
		
	end
	
end

