dofile_once("data/scripts/lib/utilities.lua")

function get_distance(x1,y1,x2,y2)
    return math.sqrt((x1 - x2)^2 + (y1 - y2)^2)
end

function get_direction( x1, y1, x2, y2 )
    return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local var_comp1 = get_variable_storage_component( entity_id, "origin_x" )
local var_comp2 = get_variable_storage_component( entity_id, "origin_y" )

local origin_x = ComponentGetValue2(var_comp1, "value_float")
local origin_y = ComponentGetValue2(var_comp2, "value_float")

local angle = get_direction(x, y, origin_x, origin_y)

local sprite_width = 1
local max_distance = 99999999999999999


local distance = get_distance(x, y, origin_x, origin_y)

local scale = math.min(distance, max_distance) / sprite_width

EntitySetTransform(entity_id, x, y, angle, scale)

