dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

SetRandomSeed(x + GameGetFrameNum(), y)

--Area Checker
local parent_id = EntityGetParent( entity_id )

if parent_id > 0 then

	local parent_x, parent_y = EntityGetTransform(parent_id)

	local x, y = EntityGetTransform(entity_id)
	
	function constrain(entity, x2, y2, max_dist)
		local chardatacomp = EntityGetFirstComponent(entity, "CharacterDataComponent")
		local projcomp = EntityGetFirstComponent(entity, "VelocityComponent")
		local physcomp = EntityGetFirstComponent(entity, "PhysicsBodyComponent") or EntityGetFirstComponent(entity1, "PhysicsBody2Component") or EntityGetFirstComponent(entity1, "SimplePhysicsComponent")
		if ( chardatacomp ~= nil ) and ( chardatacomp > 0 ) then
			local vel_x, vel_y = ComponentGetValue2(chardatacomp, "mVelocity")
		end
		if ( projcomp ~= nil ) and ( projcomp > 0 ) then
			local proj_vel_x, proj_vel_y = ComponentGetValue2(projcomp, "mVelocity")
		end
		local x1, y1 = EntityGetTransform(entity)
		if (not x1) or (not x2) then return nil end
			
		local dist = math.sqrt(((x2-x1)^2) + ((y2-y1)^2))
		local target_x = x2 + (((x1-x2)/dist)*max_dist)
		local target_y = y2 + (((y1-y2)/dist)*max_dist)
		local target_vel_x = target_x - x1
		local target_vel_y = target_y - y1

		if dist > max_dist then
			if ( ( physcomp ~= nil ) and ( physcomp > 0 ) ) or not proj_vel_x then
				PhysicsApplyForce(entity, target_vel_x*100, target_vel_y*100)
			end
			if ( chardatacomp ~= nil ) and ( chardatacomp > 0 ) then
				vel_y = vel_y - 60
				local target_mag = math.sqrt((target_vel_x^2) + (target_vel_y^2))
				local mag = math.sqrt((vel_x^2) + (vel_y^2)) / 40
				local force_x = ((target_vel_x/target_mag)*mag)
				local force_y = ((target_vel_y/target_mag)*mag)

				vel_x = ((vel_x + force_x)*1.025) + (target_vel_x*dist*0.8)
				vel_y = ((vel_y + force_y)*1.025) + (target_vel_y*dist*0.8)
				EntitySetTransform(entity, target_x, target_y)
				if ComponentGetValue2(chardatacomp, "is_on_ground") == false then vel_x = vel_x*1.16 end
				ComponentSetValue2(chardatacomp, "mVelocity", vel_x, vel_y+60)
			elseif ( projcomp ~= nil ) and ( projcomp > 0 ) then
				ComponentSetValue2(projcomp, "mVelocity", proj_vel_x+(target_vel_x*100), proj_vel_y+(target_vel_y*100))
				EntitySetTransform(entity, target_x, target_y)
			end
		end
	end
	
	constrain(entity_id, parent_x, parent_y, 75)
	
end

--

local player_distance = 1000

local player = get_players()[1]

if(player ~= nil)then
	px, py = EntityGetTransform(player)
	local hit_dir_x = px - x
	local hit_dir_y = py - y
	player_distance = math.sqrt((hit_dir_x*hit_dir_x) + (hit_dir_y*hit_dir_y))
end

local players = EntityGetWithTag("player_unit")

if ( BiomeMapGetName() ~= "$biome_holymountain" and #players > 0 and player_distance < 512)then

	-- local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "grabbing")
	
	-- local grabbing = ComponentGetValue2(var_comp, "value_bool")

	-- if grabbing then
	
		-- local range = 150
		-- local target, targetX, targetY
		-- local min_dist = 150
		-- for _,id in pairs(EntityGetInRadiusWithTag(x, y, range, "enemy")) do
			-- -- is target a valid enemy
			-- if entity_id ~= id and EntityGetParent(entity_id) ~= id and EntityGetName( id ) ~= "Manus" and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
				-- local target_x, target_y = EntityGetFirstHitboxCenter( id )
				-- local dist = get_distance(x, y, target_x, target_y)
				-- if dist < min_dist then
					-- min_dist = dist
					-- target = id
					-- targetX = target_x
					-- targetY = target_y
				-- end
			-- end
		-- end
		
	-- else
	
		local range = 150
		local targetX, targetY
		local min_dist = 150
		for _,id in pairs(EntityGetInRadiusWithTag(x, y, range, "mortal")) do
			-- is target a valid enemy
			if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
				local target_x, target_y = EntityGetFirstHitboxCenter( id )
				local dist = get_distance(x, y, target_x, target_y)
				if dist < min_dist then
					min_dist = dist
					target = id
					targetX = target_x
					targetY = target_y
				end
			end
		end
		
	-- end
	
	local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "grabbing")
	
	local grabbing = ComponentGetValue2(var_comp, "value_bool")
	
	local did_hit, hit_x, hit_y = RaytracePlatforms(x, y , targetX, targetY)
	
	if did_hit or not target or ( grabbing == true and not did_hit ) then
		target_id = EntityGetParent( entity_id )
	else
		target_id = target
	end
	
	if grabbing == true then
		for _,id in pairs(EntityGetInRadiusWithTag(x, y, 150, "enemy")) do
			local ex, ey = EntityGetTransform( id )
			local did_hit2, hit_x2, hit_y2 = RaytracePlatforms(x, y , ex, ey)
			-- local parent_id = EntityGetParent( entity_id )
			-- local parent_x, parent_y = EntityGetTransform( parent_id )
			-- local did_hit3, hit_x3, hit_y3 = RaytracePlatforms(x, y , parent_x, parent_y)
			if not did_hit2 and EntityGetParent(entity_id) ~= id then
				target_id = id
			end
		end
	end
	
	if ( target_id ~= 0) and ( target_id ~= nil) then
		tx, ty = EntityGetTransform( target_id )

		angle = 0 - math.atan2( ty - y, tx - x )
		
		local length = Random( 600, 800 )

		vel_x = math.cos( angle ) * length
		vel_y = 0- math.sin( angle ) * length
		
		local velocity_component = EntityGetComponent(entity_id, "VelocityComponent")
		if(velocity_component ~= nil)then
			local velocity_x, velocity_y = ComponentGetValue2( velocity_component, "mVelocity")

			if(velocity_x ~= nil)then
				PhysicsApplyForce(entity_id, -velocity_x * 1, -velocity_y * 1)
			end
		end

		PhysicsApplyForce(entity_id, vel_x * 0.15, vel_y * 0.15)
		
	end
	
	-- local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y , px, py)
	
	-- if not did_hit then
	
		-- local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		-- local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")
		-- local physics_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsAIComponent")		
		-- local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")	
		
	  -- EntitySetComponentIsEnabled( entity_id, physics_ai_component, true )
	  -- EntitySetComponentIsEnabled( entity_id, physics_body_component, true )
	  -- EntitySetComponentIsEnabled( entity_id, animal_ai_component, true )
	  -- EntitySetComponentIsEnabled( entity_id, controls_component, true )
	-- end

	-- local limb_boss_component = EntityGetFirstComponent(entity_id, "LimbBossComponent")

	-- ComponentSetValue2(limb_boss_component, "mMoveToPositionX", px )
	-- ComponentSetValue2(limb_boss_component, "mMoveToPositionY", py )
	
	-- edit_component( entity_id, "PhysicsAIComponent", function(comp,vars)
		-- local pos_x,pos_y = ComponentGetValueVector2( comp, "mLastPositionWhenHadPath")
		-- ComponentSetValueVector2( comp, "mLastPositionWhenHadPath", px, py)
	-- end)
end