dofile_once("data/scripts/lib/utilities.lua")

local range = 15
local projectile_velocity = 20
local scatter = 0

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetFirstHitboxCenter( entity_id )
local root_id = EntityGetRootEntity( entity_id )

--Make the physics body not fall
PhysicsApplyForce(entity_id, 0, -15)

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 15
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, range, "mortal")) do
	-- is target a valid enemy
	if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(root_id, id) < 40 then
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end

-- check los
local can_shoot = false
if enemy then can_shoot = not RaytracePlatforms(pos_x, pos_y, enemy_x, enemy_y) end

-- hand/shooting state & animation control
-- edit_component2( entity_id, "SpriteComponent", function(comp,vars)
	-- -- if enemy is not visible then open hand
	-- local hand_open = ComponentGetValue2(comp, "rect_animation") == "stand"
	-- if not can_shoot then
		-- if not hand_open then
			-- ComponentSetValue2( comp, "rect_animation", "stand")
			-- --EntitySetComponentsWithTagEnabled( entity_id, "enabled_when_attacking", false )
		-- end
		-- return
	-- end

	-- -- prepare to shoot
	-- if hand_open then
		-- ComponentSetValue2( comp, "rect_animation", "attack")
		-- --EntitySetComponentsWithTagEnabled( entity_id, "enabled_when_attacking", true )
		-- can_shoot = false
		-- return
	-- end
-- end)

if not can_shoot then 
	local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
	local animation = ComponentGetValue2( sprite_component, "rect_animation")
	if animation ~= "release" then
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "release")
			ComponentSetValue2(comp, "next_rect_animation", "release")
		end
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/bloom/attack_shoot_buildup", pos_x, pos_y)
		EntityLoad( "data/entities/misc/manus_cell_eater.xml", pos_x , pos_y )
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
	end
	SetValueNumber("times", 0)
	local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "grabbing")
	ComponentSetValue2(var_comp, "value_bool", false)
	return 
end

-- direction
local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

-- scatter
SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
vel_x,vel_y = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

-- apply velocity & shoot
vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)

local distance = get_distance(pos_x, pos_y, enemy_x, enemy_y)

local t = GetValueNumber("times", 0)

if t >= 250 then SetValueNumber("times", 0) end

if distance < range and enemy then
	
	SetValueNumber("times", t + 1)
	
	if t < 150 then
	
		--animation
		local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
		local animation = ComponentGetValue2( sprite_component, "rect_animation")
		if animation ~= "grab" then
			local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do
				ComponentSetValue2(comp, "rect_animation", "grab")
				ComponentSetValue2(comp, "next_rect_animation", "grab")
			end
			GamePlaySound("data/audio/Desktop/animals.bank", "animals/giant/attack_shoot", pos_x, pos_y)
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
		end

		-- pull target closer to anchor
		-- local center_x, center_y = EntityGetTransform(entity_id)
		
		-- local vx = center_x - enemy_x
		-- local vy = center_y - enemy_y

		-- -- prevent pulling into a wall by checking if glue center (parent) is inside platform
		-- local dist = get_magnitude(vx, vy)
		-- if dist < 8 or dist > 130 or RaytracePlatforms(center_x, center_y, center_x + 1, center_y) then
			-- --print("abort pull")
			-- return
		-- end

		-- -- calculate force
		-- local force = 0.08
		-- local age_factor = map(t, 0, 300, 1, 0.25) -- glue pull gets weaker over time
		-- vx, vy = vec_mult(vx, vy, force * age_factor)
		EntityApplyTransform(enemy, pos_x, pos_y)
		
		local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "grabbing")
		ComponentSetValue2(var_comp, "value_bool", true)
	else
		local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
		local animation = ComponentGetValue2( sprite_component, "rect_animation")
		if animation ~= "release" then
			local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do
				ComponentSetValue2(comp, "rect_animation", "release")
				ComponentSetValue2(comp, "next_rect_animation", "release")
			end
			GamePlaySound("data/audio/Desktop/animals.bank", "animals/bloom/attack_shoot_buildup", pos_x, pos_y)
			EntityLoad( "data/entities/misc/manus_cell_eater.xml", pos_x , pos_y )
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
		end
		local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "grabbing")
		ComponentSetValue2(var_comp, "value_bool", false)
	end
else
	local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
	local animation = ComponentGetValue2( sprite_component, "rect_animation")
	if animation ~= "release" then
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "release")
			ComponentSetValue2(comp, "next_rect_animation", "release")
		end
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/bloom/attack_shoot_buildup", pos_x, pos_y)
		EntityLoad( "data/entities/misc/manus_cell_eater.xml", pos_x , pos_y )
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
	end
	SetValueNumber("times", 0)
	local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "grabbing")
	ComponentSetValue2(var_comp, "value_bool", false)
end
