dofile_once("data/scripts/lib/utilities.lua")

local range = 300

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local target = EntityGetClosestWithTag(x, y, "player_unit")
if target > 0 then
	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist > range then
	
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
		  if EntityGetName(child) == "ik_leg" then
		  
			local lua_component = EntityGetFirstComponentIncludingDisabled(child, "LuaComponent")
			EntitySetComponentIsEnabled( child, lua_component, false )
			
			for i, child_of_child in ipairs(EntityGetAllChildren(child)) do
				local sprite_components = EntityGetComponentIncludingDisabled(child_of_child, "SpriteComponent")
				
				for k, sprite_component in pairs(sprite_components)do
					EntitySetComponentIsEnabled( child_of_child, sprite_component, false )
				end
			end
		  end
		  
		  if EntityGetName(child) == "spine" then
		  
			EntityKill(child)
			
		  end
		  
		end
		
	else
	
		local value = GetValueNumber("timeout_frames", 0)
		
		if value >= 1 then
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		end
		
		SetValueNumber("timeout_frames", value + 1)
	
		spines = 0

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
		  if EntityGetName(child) == "ik_leg" then
		  
			local lua_component = EntityGetFirstComponentIncludingDisabled(child, "LuaComponent")
			EntitySetComponentIsEnabled( child, lua_component, true )
			
			for i, child_of_child in ipairs(EntityGetAllChildren(child)) do
				local sprite_components = EntityGetComponentIncludingDisabled(child_of_child, "SpriteComponent")
				
				for k, sprite_component in pairs(sprite_components)do
					EntitySetComponentIsEnabled( child_of_child, sprite_component, true )
				end
			end
			
		  end

		  if EntityGetName(child) == "spine" then
			spines = spines + 1
		  end
		
		end
		
		if spines < 3 then
		
			for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
			  
				if EntityGetName(child) == "spine" then
			  
					EntityKill(child)
					
				end

			end
		
		end
		
		if spines == 0 then
			
		    local ent = EntityLoad("data/entities/verlet_chains/minabomination/verlet.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityAddComponent2(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 5, -3, scale_x, scale_y, rot)
			EntitySetName(ent, "spine")
			EntityAddChild(entity_id, ent)
			
		    local ent = EntityLoad("data/entities/verlet_chains/minabomination/verlet.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityAddComponent2(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", -5, -3, scale_x, scale_y, rot)
			EntitySetName(ent, "spine")
			EntityAddChild(entity_id, ent)
			
		    local ent = EntityLoad("data/entities/verlet_chains/minabomination/verlet.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityAddComponent2(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 0, -6, scale_x, scale_y, rot)
			EntitySetName(ent, "spine")
			EntityAddChild(entity_id, ent)
			
		end

	end
	
end