dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local player = EntityGetInRadiusWithTag(x, y, 900, "player_unit")
local px, py = EntityGetTransform( player[1] )

for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do

	if EntityGetName(child) == "player_dark" or EntityGetName(child) == "darkness" or EntityGetName(child) == "player_eldritch" then
		local sprite_component = EntityGetFirstComponentIncludingDisabled(child, "SpriteComponent")
		if #player > 0 then
			local dist = get_distance(x, y, px, py)
			if EntityGetName(child) ~= "player_eldritch" then
				EntitySetTransform(child, px, py)
			end
			if dist < 200 then
				local max_alpha = 1
				local min_alpha = 0 -- Adjust this value as per your requirement
				local threshold_distance = 100 -- Adjust this value to set the distance where alpha starts to increase more rapidly

				local alpha_change_rate = (max_alpha - min_alpha) / (200 - threshold_distance)
				local adjusted_dist = math.max(0, dist - threshold_distance)
				local alpha = max_alpha - math.min(1, alpha_change_rate * adjusted_dist)
				EntitySetComponentIsEnabled(child, sprite_component, true)
				ComponentSetValue2(sprite_component, "alpha", alpha)
				EntitySetComponentsWithTagEnabled(child, "enabled_in_world", false)
				
				if EntityGetName(child) == "player_eldritch" then
					local ox = GetValueNumber("origin_x", px)
					local oy = GetValueNumber("origin_y", py)

					local cx, cy = GameGetCameraPos()

					local parallaxFactor = 0.9

					local x2 = (cx - ox) * parallaxFactor
					local y2 = (cy - oy) * parallaxFactor

					EntitySetTransform(child, ox + x2, oy + y2)
				end
			else
				if EntityGetName(child) == "player_eldritch" then
					EntitySetTransform(child, px, py)
					SetValueNumber("origin_x", px)
					SetValueNumber("origin_y", py)
					EntitySetComponentsWithTagEnabled(child, "enabled_in_world", false)
				end
				ComponentSetValue2(sprite_component, "alpha", 0)
				EntitySetComponentIsEnabled(child, sprite_component, false)
			end
		else
			EntitySetComponentsWithTagEnabled(child, "enabled_in_world", true)
			ComponentSetValue2(sprite_component, "alpha", 0)
			EntitySetComponentIsEnabled(child, sprite_component, false)
		end
	end
end

local projectiles = EntityGetWithTag( "projectile_player" )
local direction_random = math.rad( Random( -30, 30 ) )
if ( #projectiles > 0 ) then
	for i,projectile_id in ipairs(projectiles) do	
		local px, py = EntityGetTransform( projectile_id )
		
		local distance = math.abs( x - px ) + math.abs( y - py )
		local distance_full = 200
		
		if ( distance < distance_full * 1.25 ) then
			distance = get_distance( px, py, x, y )
			direction = get_direction( px, py, x, y )
	
			if ( distance < distance_full ) then
				local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )
				
				local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.01)
				local gravity_coeff = 60
				
				if ( velocitycomponents ~= nil ) then
					edit_component( projectile_id, "VelocityComponent", function(comp,vars)
						local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
						
						local offset_x = math.cos( direction + direction_random ) * ( gravity_coeff * gravity_percent )
						local offset_y = 0 - math.sin( direction + direction_random ) * ( gravity_coeff * gravity_percent )

						vel_x = vel_x + offset_x
						vel_y = vel_y + offset_y

						ComponentSetValueVector2( comp, "mVelocity", vel_x, vel_y)
					end)
				end
			end
		end
	end
end