dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local goomba_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControllerGoombaAIComponent")
local dir_goomba = ComponentGetValue2(goomba_comp, "mChangingDirectionCounter")

local did_hit_right, _, __ = RaytracePlatforms(x + 16, y, x + 16, y - 51)
local did_hit_left, _, __ = RaytracePlatforms(x - 16, y, x - 16, y - 51)

local is_wall = false
if did_hit_right or did_hit_left then
	is_wall = true
end

local enemy_x = 0
local enemy_y = 0
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 200, "mortal")) do
	-- is target a valid enemy
	if ( entity_id ~= id )  and (EntityGetHerdRelation(entity_id, id) < 40) and (EntityGetParent(id) ~= entity_id) and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, entity_x, entity_y)
		local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y - 25 , entity_x, entity_y)
		
		if ( dist < min_dist ) and ( not did_hit ) then
			min_dist = dist
			enemy = id
			enemy_x = entity_x
			enemy_y = entity_y
		end
		
		-- if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 300 == 0 then
			-- for i=1, Random(1, 4) do

				-- local offsetx = Random(-6,6)
				-- local offsety = Random(-6,6)
				
				-- if Random(1,5) == 1 then
					-- e = EntityLoad( "data/entities/animals/goomonster_mule.xml", x + offsetx, y - 25 + offsety )
				-- elseif Random(1,20) == 1 then
					-- e = EntityLoad( "data/entities/animals/goomonster_giant.xml", x + offsetx, y - 25 + offsety )
				-- end

				-- GenomeSetHerdId( e, "friendly" )
				
				-- local vel_comp = EntityGetFirstComponentIncludingDisabled(e, "CharacterDataComponent")
				-- ComponentSetValue2(vel_comp, "mVelocity", 0, 0)
				
			-- end
		-- end
	end
end

local hunting = GetValueNumber("hunting", 0)

local character_platforming_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")

local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
local state = ComponentGetValue2(animal_ai_component, "ai_state")
local difference = math.abs(15 - state)

local still = false

if ( difference < 0.0001 ) then

    local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
    ComponentSetValue2(controls_comp, "mButtonDownRight", false)
	ComponentSetValue2(controls_comp, "mButtonDownLeft", false)
	
	-- local vel_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
	-- local vel_x, vel_y = ComponentGetValue2(vel_comp, "mVelocity")
	-- ComponentSetValue2(vel_comp, "mVelocity", 0, vel_y)
	
	still = true
	
elseif (enemy_x ~= nil) and (enemy_x ~= 0) and (enemy_x >= x) then

	-- local vel_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
	-- local vel_x, vel_y = ComponentGetValue2(vel_comp, "mVelocity")
	-- ComponentSetValue2(vel_comp, "mVelocity", vel_x + 5, vel_y)
		
	-- ComponentSetValue2(character_platforming_component, "mLookOverrideDirection", 0)
	-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
    local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
    ComponentSetValue2(controls_comp, "mButtonDownRight", true)
	ComponentSetValue2(controls_comp, "mButtonDownLeft", false)
	-- -- GamePrint("right")
	SetValueNumber("hunting", 1)
	-- EntitySetTransform(entity_id, x, y, rot, -1)
elseif (enemy_x ~= nil) and (enemy_x ~= 0) and (enemy_x < x) then
	-- local vel_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
	-- local vel_x, vel_y = ComponentGetValue2(vel_comp, "mVelocity")
	-- ComponentSetValue2(vel_comp, "mVelocity", vel_x - 5, vel_y)
	
	-- ComponentSetValue2(character_platforming_component, "mLookOverrideDirection", 0)
	-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
    local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
	ComponentSetValue2(controls_comp, "mButtonDownRight", false)
	ComponentSetValue2(controls_comp, "mButtonDownLeft", true)
	-- -- GamePrint("left")
	SetValueNumber("hunting", 1)
	-- EntitySetTransform(entity_id, x, y, rot, 1)
elseif hunting == 1 then
    -- -- local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
	-- -- ComponentSetValue2(controls_comp, "mButtonDownRight", false)
	-- -- ComponentSetValue2(controls_comp, "mButtonDownLeft", false)
	-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
	-- GamePrint("reset")
	SetValueNumber("hunting", 0)
-- else
	-- ComponentSetValue2(character_platforming_component, "mLookOverrideDirection", 1)
end

if still == false then
	if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 30 == 0 then
		GameScreenshake(0.05)
	end
end
--This is purely turning animation code
local last_scale_x = GetValueNumber("last_xscale", scale_x)
local last_direction = GetValueNumber("last_goomba_direction", dir_goomba)

local var_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")

if ComponentGetValue2(var_comp, "value_bool") == false then
	local goomba_turning = false
	if ( last_direction ~= dir_goomba ) then
		goomba_turning = true
	end

	if ( ( last_scale_x ~= scale_x ) or goomba_turning ) and ( hunting == 0 ) or (is_wall == true) then
	
		ComponentSetValue2(var_comp, "value_bool", true)
		
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		
		for i, comp in ipairs(sprite_comps) do
		
			ComponentRemoveTag( comp, "character" )
			
			if ( ComponentGetValue2(comp, "rect_animation") == "stand" ) then
				ComponentSetValue2( comp, "rect_animation", "turn_right" )
			end
			
		end
		local scale_x_temp = scale_x
		if goomba_turning == true then
			scale_x_temp = -scale_x
		end
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 20 * -scale_x_temp ), y - 30, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 20 * -scale_x_temp ), y - 40, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 20 * -scale_x_temp ), y - 50, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 20 * -scale_x_temp ), y - 20, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 20 * -scale_x_temp ), y - 10, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 20 * -scale_x_temp ), y - 7, 0, 0, false )

		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 10 * -scale_x_temp ), y - 30, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 10 * -scale_x_temp ), y - 40, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 10 * -scale_x_temp ), y - 50, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 10 * -scale_x_temp ), y - 20, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 10 * -scale_x_temp ), y - 10, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 10 * -scale_x_temp ), y - 7, 0, 0, false )
		
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 0 * -scale_x_temp ), y - 30, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 0 * -scale_x_temp ), y - 40, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 0 * -scale_x_temp ), y - 50, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 0 * -scale_x_temp ), y - 20, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 0 * -scale_x_temp ), y - 10, 0, 0, false )
		shoot_projectile( entity_id, "data/entities/projectiles/mule_explosion.xml", x + ( 0 * -scale_x_temp ), y - 7, 0, 0, false )

		GamePlaySound("mods/new_enemies/data/sound/more_sounds/my_mod_audio.bank", "snd_mod/mule_damage", x, y)
		-- LoadPixelScene( "data/biome_impl/mule_dig.png", "", x + ( 20 * -scale_x ), y - 25, "", true, false, "", 50, true)
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/giant/attack_shoot", x, y)
		
		SetValueNumber("timeout_frames", 0)
		
	end
	
end

if ComponentGetValue2(var_comp, "value_bool") == true then
	SetValueNumber("timeout_frames", GetValueNumber("timeout_frames", 20) + 1)
	if ( GetValueNumber("timeout_frames", 20) > 20 ) then
		ComponentSetValue2(var_comp, "value_bool", false)
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentAddTag( comp, "character" )
		end
	end
end

SetValueNumber("last_xscale", scale_x)
SetValueNumber("last_goomba_direction", dir_goomba)

function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

local old_average = GetValueNumber("average_rotation", 0)

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local entity_id = GetUpdatedEntityID()

--Moving our normal detectors based on entity rotation
local right_corner = { x1 = -10, y1 = 0 }
local right_x, right_y = vec_rotate(right_corner.x1, right_corner.y1, rot)
right_x = x + right_x
right_y = y + right_y

local left_corner = { x2 = 10, y2 = 0 }
local left_x, left_y = vec_rotate(left_corner.x2, left_corner.y2, rot)
left_x = x + left_x
left_y = y + left_y

local right_corner2 = { x1 = -20, y1 = 0 }
local right_x2, right_y2 = vec_rotate(right_corner2.x1, right_corner2.y1, rot)
right_x2 = x + right_x2
right_y2 = y + right_y2

local left_corner2 = { x2 = 20, y2 = 0 }
local left_x2, left_y2 = vec_rotate(left_corner2.x2, left_corner2.y2, rot)
left_x2 = x + left_x2
left_y2 = y + left_y2

function GetSurfaceNormal(pos_x, pos_y, ray_length, ray_count)
	local total_normal_x = 0
	local total_normal_y = 0
	local total_distance = 0
	local found_normal = false

	for i = 1, ray_count do
		local angle = (i - 1) * (2 * math.pi / ray_count)
		local ray_x = pos_x + ray_length * math.cos(angle)
		local ray_y = pos_y + ray_length * math.sin(angle)

		local did_hit, hit_x, hit_y = RaytracePlatforms(pos_x, pos_y, ray_x, ray_y)

		if did_hit then
			found_normal = true
			local normal_x, normal_y = hit_x - pos_x, hit_y - pos_y
			total_normal_x = total_normal_x + normal_x
			total_normal_y = total_normal_y + normal_y
			total_distance = total_distance + math.sqrt(normal_x^2 + normal_y^2)
		end
	end

	if found_normal then
		local average_normal_x = total_normal_x / ray_count
		local average_normal_y = total_normal_y / ray_count
		local average_distance = total_distance / ray_count
		return true, average_normal_x, average_normal_y, average_distance
	else
		return false, 0, 0, 0
	end
end

local found_normal, normal_x, normal_y, approximate_distance_from_surface = GetSurfaceNormal(right_x, right_y, 10, 16)
local found_normal2, normal_x2, normal_y2, approximate_distance_from_surface = GetSurfaceNormal(left_x, left_y, 10, 16)
local found_normal3, normal_x3, normal_y3, approximate_distance_from_surface = GetSurfaceNormal(x, y, 10, 16)

local found_normal4, normal_x4, normal_y4, approximate_distance_from_surface = GetSurfaceNormal(right_x2, right_y2, 10, 16)
local found_normal5, normal_x5, normal_y5, approximate_distance_from_surface = GetSurfaceNormal(left_x2, left_y2, 10, 16)

local normal_in_solid, hit_x, hit_y = RaytracePlatforms( right_x, right_y, right_x, right_y )
local normal_in_solid2, hit_x2, hit_y2 = RaytracePlatforms( left_x, left_y, left_x, left_y )
local normal_in_solid3, hit_x3, hit_y3 = RaytracePlatforms( x, y, x, y )
local normal_in_solid4, hit_x4, hit_y4 = RaytracePlatforms( right_x2, right_y2, right_x2, right_y2 )
local normal_in_solid5, hit_x5, hit_y5 = RaytracePlatforms( left_x2, left_y2, left_x2, left_y2 )

normal_count = 5

if normal_in_solid or not found_normal then
	normal_x = 0
	normal_y = 0
	normal_count = normal_count - 1
end

if normal_in_solid2 or not found_normal2 then
	normal_x2 = 0
	normal_y2 = 0
	normal_count = normal_count - 1
end

if normal_in_solid3 or not found_normal3 then
	normal_x3 = 0
	normal_y3 = 0
	normal_count = normal_count - 1
end

if normal_in_solid4 or not found_normal4 then
	normal_x4 = 0
	normal_y4 = 0
	normal_count = normal_count - 1
end

if normal_in_solid5 or not found_normal5 then
	normal_x5 = 0
	normal_y5 = 0
	normal_count = normal_count - 1
end


if normal_count > 0 then

	local normal_x_average = (normal_x + normal_x2 + normal_x3 + normal_x4 + normal_x5) / normal_count
	local normal_y_average = (normal_y + normal_y2 + normal_y3 + normal_y4 + normal_y5) / normal_count

	local dir = get_direction(0, 0, normal_x_average, normal_y_average)
	local degree_shift = math.rad(-90) + dir -- 90 degree rotation to properly orient the entity
	local new_average = approx_rolling_average(old_average, degree_shift, 5) -- if the number is higher than 5 the turning speed would be smoother and slower, if less it would be more instantaneous
	SetValueNumber("average_rotation", new_average)

	local max_angle = math.rad(45)
	local new_average_capped_angle = math.min(max_angle, math.max(new_average, -max_angle))
	EntitySetTransform(entity_id, x, y, new_average_capped_angle)
end