dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x = EntityGetTransform(entity_id)

local did_hit_right, _, __ = RaytracePlatforms(x + 3, y, x + 3, y - 21)
local did_hit_left, _, __ = RaytracePlatforms(x - 3, y, x - 3, y - 21)

local did_hit_right_floor, _, __ = RaytracePlatforms(x + 3, y, x + 3, y + 30)
local did_hit_left_floor, _, __ = RaytracePlatforms(x - 3, y, x - 3, y + 30)

if did_hit_right or (not did_hit_right_floor) then
	EntitySetTransform(entity_id, x, y, rot, -1)
elseif did_hit_left or (not did_hit_left_floor) then
	EntitySetTransform(entity_id, x, y, rot, 1)
end

local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
local state = ComponentGetValue2(animal_ai_component, "ai_state")

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local goomba_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControllerGoombaAIComponent")
local dir_goomba = ComponentGetValue2(goomba_comp, "mChangingDirectionCounter")

local enemy_x = 0
local enemy_y = 0
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 200, "mortal")) do
	-- is target a valid enemy
	if ( entity_id ~= id )  and (EntityGetHerdRelation(entity_id, id) < 40) and (EntityGetParent(id) ~= entity_id) and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, entity_x, entity_y)
		local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y - 25 , entity_x, entity_y)
		
		if ( dist < min_dist ) and ( not did_hit ) then
			
			-- EntitySetComponentIsEnabled( entity_id, animal_ai_component, true )
			
			ComponentSetValue2(animal_ai_component, "creature_detection_range_x", 250)
			ComponentSetValue2(animal_ai_component, "creature_detection_range_y", 250)
			ComponentSetValue2(animal_ai_component, "preferred_job", "JobDefault")

			min_dist = dist
			enemy = id
			enemy_x = entity_x
			enemy_y = entity_y
		end
	end
end

local difference = math.abs(15 - state)
local difference2 = math.abs(13 - state)

if ( difference < 0.0001 ) or ( difference2 < 0.0001 ) then

    local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
    ComponentSetValue2(controls_comp, "mButtonDownRight", false)
	ComponentSetValue2(controls_comp, "mButtonDownLeft", false)
	
elseif (enemy_x ~= nil) and (enemy_x ~= 0) and (enemy_x >= x) then
    local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
    ComponentSetValue2(controls_comp, "mButtonDownRight", true)
	ComponentSetValue2(controls_comp, "mButtonDownLeft", false)
elseif (enemy_x ~= nil) and (enemy_x ~= 0) and (enemy_x < x) then
    local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
	ComponentSetValue2(controls_comp, "mButtonDownRight", false)
	ComponentSetValue2(controls_comp, "mButtonDownLeft", true)
elseif (enemy_x == 0) then
	ComponentSetValue2(animal_ai_component, "creature_detection_range_x", 0)
	ComponentSetValue2(animal_ai_component, "creature_detection_range_y", 0)
	ComponentSetValue2(animal_ai_component, "preferred_job", "MoveNearTarget")
	ComponentSetValue2(animal_ai_component, "ai_state", 6)
end

if ( enemy_x == 0 ) and ( scale_x > 0 ) then
    local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
    ComponentSetValue2(controls_comp, "mButtonDownRight", true)
	ComponentSetValue2(controls_comp, "mButtonDownLeft", false)
elseif ( enemy_x == 0 ) and ( scale_x <= 0 ) then
    local controls_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
    ComponentSetValue2(controls_comp, "mButtonDownRight", false)
	ComponentSetValue2(controls_comp, "mButtonDownLeft", true)
end