dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/projectiles/overmind.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

-- function distance(dx, dy, dx2, dy2)
    -- return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
-- end

-- GamePrint(GetValueNumber("state_duration", 0))
-- GamePrint(GetValueNumber("state_duration2", 0))
-- GamePrint(GetValueNumber("state", 0))
-- GamePrint(tostring(GetValueNumber("tentacle_laying_done", 0)))

local players = EntityGetWithTag("player_unit")
if #players > 0 then
else
	players = EntityGetWithTag("polymorphed_player")
end

--Getting the arena checker
local children = EntityGetAllChildren( entity_id, "pitcheck_b" )
local arena_center_id = children[1]
local acx, acy = EntityGetTransform( arena_center_id )

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

-- local state_duration = GetValueNumber("state_duration", 0)
-- local state_duration2 = GetValueNumber("state_duration2", 0)

local components = EntityGetComponent( entity_id, "VariableStorageComponent" )
if ( components ~= nil ) then
	for _,comp_id in pairs(components) do 
		local var_name = ComponentGetValue( comp_id, "name" )
		if ( var_name == "state") then
			state_var_comp = comp_id
		end
		if ( var_name == "state_previous") then
			state_previous_var_comp = comp_id
		end
		if ( var_name == "state_duration") then
			state_duration_var_comp = comp_id
		end
		if ( var_name == "position") then
			position_var_comp = comp_id
		end
		if ( var_name == "tentacle_direction") then
			tentacle_direction_var_comp = comp_id
		end
		if ( var_name == "parallax_factor") then
			parallax_factor_var_comp = comp_id
		end
		if ( var_name == "init_origin") then
			init_origin_var_comp = comp_id
		end
		if ( var_name == "origin") then
			origin_var_comp = comp_id
		end
	end
end

local components = EntityGetComponent( arena_center_id, "VariableStorageComponent" )
if ( components ~= nil ) then
	for _,comp_id in pairs(components) do 
		local var_name = ComponentGetValue( comp_id, "name" )
		if ( var_name == "is_clearing_terrain") then
			arena_terrain_handler_var_comp = comp_id
		end
		if ( var_name == "is_laser") then
			is_laser_var_comp = comp_id
		end
		if ( var_name == "direction_laser") then
			direction_laser_var_comp = comp_id
		end
	end
end

local tentacle_direction = ComponentGetValue2(tentacle_direction_var_comp, "value_int")
local state_duration = ComponentGetValue2(state_duration_var_comp, "value_int")

local delay = ComponentGetValue2(position_var_comp, "value_int")

--Parallax

if ComponentGetValue2(init_origin_var_comp, "value_bool") == false then
	ComponentSetValue2(init_origin_var_comp, "value_bool", true)
	
	ComponentSetValue2(direction_laser_var_comp, "value_int", Random(0,1))
	
	ComponentSetValue2(origin_var_comp, "value_float", x)
	ComponentSetValue2(origin_var_comp, "value_string", y)
	
	ox_raw = x
	oy_raw = y
end

local ox_raw = ComponentGetValue2(origin_var_comp, "value_float")
local oy_raw = ComponentGetValue2(origin_var_comp, "value_string")

local ox = ox_raw
local oy = tonumber(oy_raw)

local cx, cy = GameGetCameraPos()

local parallaxFactor = ComponentGetValue2(parallax_factor_var_comp, "value_float")
-- if parallaxFactor < 0.4 then
	-- ComponentSetValue2(parallax_factor_var_comp, "value_float", parallaxFactor + 0.001)
	-- -- GamePrint(parallaxFactor)
-- end

local x2 = (cx - ox) * parallaxFactor
local y2 = (cy - oy) * parallaxFactor

EntitySetTransform(entity_id, ox + x2, oy + y2)

--Attack Logic
local state = ComponentGetValue2(state_var_comp, "value_int")

local previous_active_state = ComponentGetValue2(state_previous_var_comp, "value_int")

if ( #players > 0 ) then

	local player_id = players[1]
	if ( times_executed > 300 ) and ( times_executed % ( 600 + delay ) == 0 ) and ( times_executed > 1 ) then
		local eid = EntityLoad( "data/entities/misc/unseen_spawner.xml", x, y )
		EntityAddChild( player_id, eid )
	end
	
end

if state == 0 then
	local children = EntityGetAllChildren( entity_id, "prop" )
	local eye_socket1 = children[1]
	local eye_socket1_children = EntityGetAllChildren( eye_socket1, "prop" )
	local eye_pupil1 = eye_socket1_children[1]
	local epx1, epy1 = EntityGetTransform( eye_pupil1 )

	local eye_socket2 = children[2]
	local eye_socket2_children = EntityGetAllChildren( eye_socket2, "prop" )
	local eye_pupil2 = eye_socket2_children[1]
	local epx2, epy2 = EntityGetTransform( eye_pupil2 )
	
	GamePlayAnimation( eye_pupil1, "default", 100, "default", 100 )
	GamePlayAnimation( eye_pupil2, "default", 100, "default", 100 )
	
	--Bubble spawner
	if times_executed > 300 and times_executed % 150 == 0 and times_executed > 1 then
	
		local head_number = 0

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
			if EntityGetName(child) == "bubble" then
				head_number = head_number + 1
			end
		end

		if head_number < 1 then
			local ent = shoot_projectile( entity_id, "data/entities/animals/mwyah_bubble_pink.xml", x, y, 0, 50, false )
			EntitySetName(ent, "bubble")

			EntityAddChild(entity_id, ent)
		end
	end
	
	if ( times_executed % 400 == 0 ) and ( times_executed > 1 ) then
		
		if previous_active_state == 0 then
			ComponentSetValue2(state_var_comp, "value_int", Random(1,2))
		elseif previous_active_state == 1 then
			ComponentSetValue2(state_var_comp, "value_int", 2)
		elseif previous_active_state == 2 then
			ComponentSetValue2(state_var_comp, "value_int", 1)
		end
	end
	
elseif state == 1 then
	ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
	
	if state_duration == 150 then
		ComponentSetValue2(is_laser_var_comp, "value_int", 1)
	elseif state_duration > 800 then
		ComponentSetValue2(is_laser_var_comp, "value_int", 0)
		ComponentSetValue2(state_var_comp, "value_int", 0)
		ComponentSetValue2(state_duration_var_comp, "value_int", 0)
		ComponentSetValue2(state_previous_var_comp, "value_int", 1)
		ComponentSetValue2(position_var_comp, "value_int", Random(0, 150))
		ComponentSetValue2(direction_laser_var_comp, "value_int", Random(0,1))
	end
elseif state == 2 then
	ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
	
	local children = EntityGetAllChildren( entity_id, "prop" )
	local eye_socket1 = children[1]
	local eye_socket1_children = EntityGetAllChildren( eye_socket1, "prop" )
	local eye_pupil1 = eye_socket1_children[1]
	local epx1, epy1 = EntityGetTransform( eye_pupil1 )
	
	local children = EntityGetAllChildren( entity_id, "prop" )
	local eye_socket2 = children[2]
	local eye_socket2_children = EntityGetAllChildren( eye_socket2, "prop" )
	local eye_pupil2 = eye_socket2_children[1]
	local epx2, epy2 = EntityGetTransform( eye_pupil2 )
	
	GamePlaySound("data/audio/Desktop/projectiles.bank", "player_projectiles/megalaser/create", epx1, epy1)
	GamePlaySound("data/audio/Desktop/projectiles.bank", "player_projectiles/megalaser/create", epx2, epy2)
	
	GamePlayAnimation( eye_pupil1, "attacking", 100, "attacking", 100 )
	GamePlayAnimation( eye_pupil2, "attacking", 100, "attacking", 100 )
	
	if ( times_executed % 30 == 0 ) then
		if ( #players > 0 ) then

			local player_id = players[1]
			
			if tentacle_direction == 0 then
				ComponentSetValue2(tentacle_direction_var_comp, "value_int", 1)
				
				shoot_at_entity(eye_pupil1, player_id, 0, 0, 0, 60, "data/entities/projectiles/hoop_projectile.xml", 999, 99999999)
			elseif tentacle_direction == 1 then
				ComponentSetValue2(tentacle_direction_var_comp, "value_int", 0)
				
				shoot_at_entity(eye_pupil2, player_id, 0, 0, 0, 60, "data/entities/projectiles/hoop_projectile.xml", 999, 99999999)
			end
		end
	end
	
	if state_duration > 150 then
		ComponentSetValue2(state_var_comp, "value_int", 0)
		ComponentSetValue2(state_duration_var_comp, "value_int", 0)
		ComponentSetValue2(state_previous_var_comp, "value_int", 2)
		ComponentSetValue2(position_var_comp, "value_int", Random(0, 150))
	end
end