local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

local phys2 = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBody2Component")

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

	local game_effect_component = EntityGetFirstComponentIncludingDisabled(child_id, "GameEffectComponent")
	
	if game_effect_component and EntityGetName(child_id) ~= "important" then
	
		EntityKill(child_id)
		
	end

end

if ( phys2 ~= nil ) and ( phys2 > 0 ) then
	local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
	local targ_x, targ_y = ComponentGetValueVector2(pathfinding_component, "path_next_node_vector_to")
	local pixcount = ComponentGetValue2(phys2, "mPixelCount")
	PhysicsApplyForce( entity_id, targ_x * pixcount/100, targ_y * pixcount/100)
end

local players = EntityGetWithTag("player_unit")

if #players > 0 then
	local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
	if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
		ComponentSetValue2( animal_ai_component, "mGreatestPrey", players[1] )
		ComponentSetValue2( animal_ai_component, "mHasFoundPrey", true )
	end
end