dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

-- function distance(dx, dy, dx2, dy2)
    -- return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
-- end

-- GamePrint(GetValueNumber("state_duration", 0))
-- GamePrint(GetValueNumber("state_duration2", 0))
-- GamePrint(GetValueNumber("state", 0))
-- GamePrint(tostring(GetValueNumber("tentacle_laying_done", 0)))

local players = EntityGetWithTag("player_unit")
if #players > 0 then
else
	players = EntityGetWithTag("polymorphed_player")
end

--Getting the arena checker
local children = EntityGetAllChildren( entity_id, "pitcheck_b" )
local arena_center_id = children[1]
local acx, acy = EntityGetTransform( arena_center_id )

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

-- local state_duration = GetValueNumber("state_duration", 0)
-- local state_duration2 = GetValueNumber("state_duration2", 0)

local components = EntityGetComponent( entity_id, "VariableStorageComponent" )
if ( components ~= nil ) then
	for _,comp_id in pairs(components) do 
		local var_name = ComponentGetValue( comp_id, "name" )
		if ( var_name == "state") then
			state_var_comp = comp_id
		end
		if ( var_name == "state_previous") then
			state_previous_var_comp = comp_id
		end
		if ( var_name == "state_duration") then
			state_duration_var_comp = comp_id
		end
		if ( var_name == "state_duration2") then
			state_duration2_var_comp = comp_id
		end
		if ( var_name == "position") then
			position_var_comp = comp_id
		end
		if ( var_name == "tentacle_laying") then
			tentacle_laying_var_comp = comp_id
		end
		if ( var_name == "tentacle_direction") then
			tentacle_direction_var_comp = comp_id
		end
		if ( var_name == "parallax_factor") then
			parallax_factor_var_comp = comp_id
		end
		if ( var_name == "init_origin") then
			init_origin_var_comp = comp_id
		end
		if ( var_name == "origin") then
			origin_var_comp = comp_id
		end
	end
end

local state_duration = ComponentGetValue2(state_duration_var_comp, "value_int")
local state_duration2 = ComponentGetValue2(state_duration2_var_comp, "value_int")

--Parallax

if ComponentGetValue2(init_origin_var_comp, "value_bool") == false then
	ComponentSetValue2(init_origin_var_comp, "value_bool", true)
	
	ComponentSetValue2(tentacle_direction_var_comp, "value_int", Random(0,1))
	
	ComponentSetValue2(origin_var_comp, "value_float", x)
	ComponentSetValue2(origin_var_comp, "value_string", y)
	
	ox_raw = x
	oy_raw = y
end

local ox_raw = ComponentGetValue2(origin_var_comp, "value_float")
local oy_raw = ComponentGetValue2(origin_var_comp, "value_string")

local ox = ox_raw
local oy = tonumber(oy_raw)

local cx, cy = GameGetCameraPos()

local parallaxFactor = ComponentGetValue2(parallax_factor_var_comp, "value_float")
if parallaxFactor < 0.2 then
	ComponentSetValue2(parallax_factor_var_comp, "value_float", parallaxFactor + 0.001)
	-- GamePrint(parallaxFactor)
end

local x2 = (cx - ox) * parallaxFactor
local y2 = (cy - oy) * parallaxFactor

EntitySetTransform(entity_id, ox + x2, oy + y2)

--Attack Logic
local state = ComponentGetValue2(state_var_comp, "value_int")

local previous_active_state = ComponentGetValue2(state_previous_var_comp, "value_int")

local arena_terrain_handler_var_comp = get_variable_storage_component( arena_center_id, "is_clearing_terrain" )

local tentacle_laying = ComponentGetValue2(tentacle_laying_var_comp, "value_int")

if state == 0 then

	--Bubble spawner
	if times_executed > 300 and times_executed % 150 == 0 and times_executed > 1 then
		ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 1)
		head_number = 0

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
			if EntityGetName(child) == "bubble" then
				head_number = head_number + 1
			end
		end

		if head_number < 1 then
			local ent = shoot_projectile( entity_id, "data/entities/animals/mwyah_bubble.xml", x, y - 130 , 0, 50, false )
			EntitySetName(ent, "bubble")

			EntityAddChild(entity_id, ent)
		end
	end
	
	if ( times_executed % 200 == 0 ) and ( times_executed > 1 ) then
		
		if previous_active_state == 0 then

			ComponentSetValue2(state_var_comp, "value_int", Random(1,4))
			
		elseif previous_active_state == 1 then
		
			local states = {2, 3, 4, 5}
			local random_index = Random(1, #states)
			local state_new = states[random_index]
			
			ComponentSetValue2(state_var_comp, "value_int", state_new)
			
		elseif previous_active_state == 2 then
		
			local states = {1, 3, 4, 5}
			local random_index = Random(1, #states)
			local state_new = states[random_index]

			ComponentSetValue2(state_var_comp, "value_int", state_new)
			
		elseif previous_active_state == 3 then
		
			local states = {1, 2, 4, 5}
			local random_index = Random(1, #states)
			local state_new = states[random_index]
			
			ComponentSetValue2(state_var_comp, "value_int", state_new)
			
		elseif previous_active_state == 4 then
		
			local states = {1, 2, 3, 5}
			local random_index = Random(1, #states)
			local state_new = states[random_index]
			
			ComponentSetValue2(state_var_comp, "value_int", state_new)
			
		elseif previous_active_state == 5 then
		
			local states = {1, 2, 3, 4}
			local random_index = Random(1, #states)
			local state_new = states[random_index]
			
			ComponentSetValue2(state_var_comp, "value_int", state_new)
		
		end
	end
	
elseif state == 1 then
	ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 0)

	local position = ComponentGetValue2(position_var_comp, "value_int")
	local tentacle_direction = ComponentGetValue2(tentacle_direction_var_comp, "value_int") -- Introduce a new variable
	
	if ( times_executed % 50 == 0 ) and ( times_executed > 1 ) and ( tentacle_laying < 2 ) then
	
		if tentacle_direction == 0 then -- Tentacles start from the left
			local tentacle = EntityLoad( "data/entities/animals/mwyah_tentacle_physics.xml", acx - 226 , acy - 200 + ( 80 * position ) )
			EntityAddChild(entity_id, tentacle)
		else -- Tentacles start from the right
			local tentacle = EntityLoad( "data/entities/animals/mwyah_tentacle_physics_right.xml", acx + 200 , acy - 200 + ( 80 * position ) )
			EntityAddChild(entity_id, tentacle)
		end
		
		ComponentSetValue2(position_var_comp, "value_int", position + 1)
	end

	ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
	
	position = ComponentGetValue2(position_var_comp, "value_int")
	
	if ( position > 5 ) and ( tentacle_laying < 2 ) then
		ComponentSetValue2(position_var_comp, "value_int", 0)
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", tentacle_laying + 1)
		ComponentSetValue2(tentacle_direction_var_comp, "value_int", 1 - tentacle_direction) -- Toggle the direction after finishing one set of tentacles
	end
	if state_duration > 1000 then
		ComponentSetValue2(state_var_comp, "value_int", 0)
		ComponentSetValue2(state_duration_var_comp, "value_int", 0)
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
		ComponentSetValue2(tentacle_direction_var_comp, "value_int", Random(0,1))
		ComponentSetValue2(state_previous_var_comp, "value_int", 1)
		ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 2)
	end
elseif state == 2 then

	if ( times_executed % 10 == 0 ) and ( times_executed > 1 ) then
		if tentacle_laying == 0 then
			EntityLoad( "data/entities/projectiles/mwyah_slicer.xml", cx , acy + 200 )
		end
	end

	ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
	
	if ( state_duration > 300 ) and ( tentacle_laying == 0 ) then
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
	end

	if state_duration > 300 then
		ComponentSetValue2(state_var_comp, "value_int", 0)
		ComponentSetValue2(state_duration_var_comp, "value_int", 0)
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
		ComponentSetValue2(state_previous_var_comp, "value_int", 2)
	end
	
elseif state == 3 then
	
	ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
	
	if tentacle_laying == 0 then
		EntitySetComponentsWithTagEnabled(entity_id, "character", false)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
		shoot_projectile( entity_id, "data/entities/projectiles/mwyah_face_spiral.xml", x, y - 150 , -1, 1, false )
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
	end

	if state_duration > 200 then
		ComponentSetValue2(state_var_comp, "value_int", 0)
		ComponentSetValue2(state_duration_var_comp, "value_int", 0)
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
		ComponentSetValue2(state_previous_var_comp, "value_int", 3)
		EntitySetComponentsWithTagEnabled(entity_id, "character", true)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	end
	
elseif state == 4 then
	
	ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
	
	if tentacle_laying == 0 then
	
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
		
		EntitySetComponentsWithTagEnabled(entity_id, "character", false)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
		
		local how_many = 15
		local angle_inc = ( 2 * 3.14159 ) / how_many
		local theta = 0
		local length = 100

		for i=1,how_many do
			local vel_x = math.cos( theta ) * length
			local vel_y = math.sin( theta ) * length
			theta = theta + angle_inc
			shoot_projectile( entity_id, "data/entities/projectiles/mwyah_black.xml", x, y - 140, vel_x, vel_y )
			shoot_projectile( entity_id, "data/entities/projectiles/mwyah_black2.xml", x, y - 140, vel_x, vel_y )
		end
	end

	if state_duration > 200 then
		ComponentSetValue2(state_var_comp, "value_int", 0)
		ComponentSetValue2(state_duration_var_comp, "value_int", 0)
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
		ComponentSetValue2(state_previous_var_comp, "value_int", 4)
		EntitySetComponentsWithTagEnabled(entity_id, "character", true)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	end
	
elseif state == 5 then
	
	ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
	
	if tentacle_laying == 0 then
	
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
		
		EntitySetComponentsWithTagEnabled(entity_id, "character", false)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
		
		shoot_projectile( entity_id, "data/entities/projectiles/mwyah_logo.xml", x, y - 140, 0, 50 )

	end

	if state_duration > 200 then
		ComponentSetValue2(state_var_comp, "value_int", 0)
		ComponentSetValue2(state_duration_var_comp, "value_int", 0)
		ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
		ComponentSetValue2(state_previous_var_comp, "value_int", 5)
		EntitySetComponentsWithTagEnabled(entity_id, "character", true)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	end
	
elseif state == 6 then
	if oy > acy + 20 then
		GameScreenshake(20)
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", true)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand2")
			ComponentSetValue2(comp, "next_rect_animation", "stand2")
		end
		ComponentSetValue2(origin_var_comp, "value_string", tostring(oy - 0.5))
	else
		ComponentSetValue2(state_duration2_var_comp, "value_int", state_duration2 + 1)
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", false)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand3")
			ComponentSetValue2(comp, "next_rect_animation", "stand3")
		end
	end
	-- local tentacle_laying = GetValueNumber("tentacle_laying_done", 0)
	if ( #players > 0 ) then

		local player_id = players[1]
		local px, py = EntityGetTransform( player_id )
		
		local player_counts = EntityGetInRadiusWithTag(x, y - 160, 40, "player_unit")
		
		if ( tentacle_laying == 0 ) then
		
			if ( times_executed % 100 == 0 ) and ( times_executed > 1 )  and ( state_duration2 > 150 ) then
				shoot_projectile( entity_id, "data/entities/projectiles/hands2.xml", px, py, 0, 0 )
				GamePlaySound("data/audio/Desktop/animals.bank", "animals/giant/attack_shoot", px, py)
			end

			if ( #player_counts > 0 ) and ( state_duration2 > 305 ) then

				ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 4)
				
				ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
				local character_platforming_component = EntityGetFirstComponentIncludingDisabled(player_id, "CharacterPlatformingComponent")

				if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
					ComponentSetValue2(character_platforming_component, "mIsPrecisionJumping", true)
				end
				
				local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					local max_hp = ComponentGetValue2( comp, "max_hp" )
					local hp = ComponentGetValue2( comp, "hp" )
					EntityLoad( "data/entities/projectiles/mwyah_explode.xml", x , y - 160 )
					EntityInflictDamage( entity_id, ( max_hp / 2 ) / 5, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, player_id, x, y )
					ComponentSetValue2( comp, "invincibility_frames", 300 )
					GameScreenshake(20)
				end
				for _,id in pairs(EntityGetInRadiusWithTag(x, y, 999999, "cloned")) do
					EntityKill(id)
				end
			end
		else
			ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
		end
		
		if state_duration2 == 160 then
			ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 3)
		end
		
		if state_duration > 150 then
			ComponentSetValue2(state_var_comp, "value_int", 7)
			ComponentSetValue2(state_duration_var_comp, "value_int", 0)
			ComponentSetValue2(state_duration2_var_comp, "value_int", 0)
			ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
			ComponentSetValue2(state_previous_var_comp, "value_int", 6)
		end
	end
elseif state == 7 then
	if oy > acy + 20 then
		GameScreenshake(20)
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", true)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand2")
			ComponentSetValue2(comp, "next_rect_animation", "stand2")
		end
		ComponentSetValue2(origin_var_comp, "value_string", tostring(oy - 0.5))
	else
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", false)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand3")
			ComponentSetValue2(comp, "next_rect_animation", "stand3")
		end
	end

	ComponentSetValue2(state_duration2_var_comp, "value_int", state_duration2 + 1)
	-- local tentacle_laying = GetValueNumber("tentacle_laying_done", 0)
	if #players > 0 then
	
		local player_id = players[1]
		local px, py = EntityGetTransform( player_id )
		
		local player_counts = EntityGetInRadiusWithTag(x, y - 160, 40, "player_unit")
		
		if ( tentacle_laying == 0 ) then

			if ( #player_counts > 0 ) and ( state_duration2 > 305 ) then
				ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 4)
				ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
				local character_platforming_component = EntityGetFirstComponentIncludingDisabled(player_id, "CharacterPlatformingComponent")

				if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
					ComponentSetValue2(character_platforming_component, "mIsPrecisionJumping", true)
				end
				
				local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					local max_hp = ComponentGetValue2( comp, "max_hp" )
					local hp = ComponentGetValue2( comp, "hp" )
					EntityLoad( "data/entities/projectiles/mwyah_explode.xml", x , y - 160 )
					EntityInflictDamage( entity_id, ( max_hp / 2 ) / 5, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, player_id, x, y )
					ComponentSetValue2( comp, "invincibility_frames", 300 )
					GameScreenshake(20)
				end
				for _,id in pairs(EntityGetInRadiusWithTag(x, y, 999999, "cloned")) do
					EntityKill(id)
				end
			end
		else
			ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 4)
			ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
		end
		
		if state_duration2 == 150 then
			ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 5)
			local bubble = EntityLoad("data/entities/animals/mwyah_bubble_green.xml", px , py)
			EntityAddChild(player_id, bubble)
		elseif state_duration2 == 300 then
			EntityLoad( "data/entities/projectiles/mwyah_wall.xml", acx , acy )
		end
		if state_duration > 150 then
			ComponentSetValue2(state_var_comp, "value_int", 8)
			ComponentSetValue2(state_duration_var_comp, "value_int", 0)
			ComponentSetValue2(state_duration2_var_comp, "value_int", 0)
			ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
			ComponentSetValue2(state_previous_var_comp, "value_int", 7)
		end
	end
elseif state == 8 then
	if oy > acy + 20 then
		GameScreenshake(20)
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", true)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand2")
			ComponentSetValue2(comp, "next_rect_animation", "stand2")
		end
		ComponentSetValue2(origin_var_comp, "value_string", tostring(oy - 0.5))
	else
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", false)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand3")
			ComponentSetValue2(comp, "next_rect_animation", "stand3")
		end
	end

	ComponentSetValue2(state_duration2_var_comp, "value_int", state_duration2 + 1)
	-- local tentacle_laying = GetValueNumber("tentacle_laying_done", 0)
	if #players > 0 then
	
		local player_id = players[1]
		local px, py = EntityGetTransform( player_id )
		
		local player_counts = EntityGetInRadiusWithTag(x, y - 160, 40, "player_unit")
		
		if ( tentacle_laying == 0 ) then

			if ( #player_counts > 0 ) and ( state_duration2 > 305 ) then
				ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 4)
				ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
				local character_platforming_component = EntityGetFirstComponentIncludingDisabled(player_id, "CharacterPlatformingComponent")

				if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
					ComponentSetValue2(character_platforming_component, "mIsPrecisionJumping", true)
				end
				
				local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					local max_hp = ComponentGetValue2( comp, "max_hp" )
					local hp = ComponentGetValue2( comp, "hp" )
					EntityLoad( "data/entities/projectiles/mwyah_explode.xml", x , y - 160 )
					EntityInflictDamage( entity_id, ( max_hp / 2 ) / 5, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, player_id, x, y )
					ComponentSetValue2( comp, "invincibility_frames", 300 )
					GameScreenshake(20)
				end
				for _,id in pairs(EntityGetInRadiusWithTag(x, y, 999999, "cloned")) do
					EntityKill(id)
				end
			end
		else
			ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
		end
		
		if state_duration2 == 150 then
			ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 6)
			local bubble = EntityLoad("data/entities/animals/mwyah_bubble_green.xml", px , py)
			EntityAddChild(player_id, bubble)
		elseif state_duration2 == 300 then
			EntityLoad( "data/entities/projectiles/mwyah_wall.xml", acx , acy )
			EntityLoad( "data/entities/projectiles/mwyah_wall_inverted.xml", acx , acy )
		end
		if state_duration > 150 then
			ComponentSetValue2(state_var_comp, "value_int", 9)
			ComponentSetValue2(state_duration_var_comp, "value_int", 0)
			ComponentSetValue2(state_duration2_var_comp, "value_int", 0)
			ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
			ComponentSetValue2(state_previous_var_comp, "value_int", 8)
		end
	end
elseif state == 9 then
	if oy > acy + 20 then
		GameScreenshake(20)
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", true)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand2")
			ComponentSetValue2(comp, "next_rect_animation", "stand2")
		end
		ComponentSetValue2(origin_var_comp, "value_string", tostring(oy - 0.5))
	else
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", false)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand3")
			ComponentSetValue2(comp, "next_rect_animation", "stand3")
		end
	end

	ComponentSetValue2(state_duration2_var_comp, "value_int", state_duration2 + 1)
	-- local tentacle_laying = GetValueNumber("tentacle_laying_done", 0)
	if #players > 0 then
	
		local player_id = players[1]
		local px, py = EntityGetTransform( player_id )
		
		local player_counts = EntityGetInRadiusWithTag(x, y - 160, 40, "player_unit")
		
		if ( tentacle_laying == 0 ) then
		
			if ( times_executed % 100 == 0 ) and ( times_executed > 1 ) and ( state_duration2 > 150 ) then
				shoot_projectile( entity_id, "data/entities/projectiles/hands2.xml", px, py, 0, 0 )
				GamePlaySound("data/audio/Desktop/animals.bank", "animals/giant/attack_shoot", px, py)
			end
			
			if ( #player_counts > 0 ) and ( state_duration2 > 305 ) then
				ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 4)
				ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
				local character_platforming_component = EntityGetFirstComponentIncludingDisabled(player_id, "CharacterPlatformingComponent")

				if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
					ComponentSetValue2(character_platforming_component, "mIsPrecisionJumping", true)
				end
				
				local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					local max_hp = ComponentGetValue2( comp, "max_hp" )
					local hp = ComponentGetValue2( comp, "hp" )
					EntityLoad( "data/entities/projectiles/mwyah_explode.xml", x , y - 160 )
					EntityInflictDamage( entity_id, ( max_hp / 2 ) / 5, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, player_id, x, y )
					ComponentSetValue2( comp, "invincibility_frames", 300 )
					GameScreenshake(20)
				end
				for _,id in pairs(EntityGetInRadiusWithTag(x, y, 999999, "cloned")) do
					EntityKill(id)
				end
			end
		else
			ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
		end
		
		if state_duration2 == 150 then
			ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 7)
			local bubble = EntityLoad("data/entities/animals/mwyah_bubble_green.xml", px , py)
			EntityAddChild(player_id, bubble)
		elseif state_duration2 == 300 then
			EntityLoad( "data/entities/animals/doom_bringer_weak.xml", acx - 150 , acy - 150 )
		end
		if state_duration > 150 then
			ComponentSetValue2(state_var_comp, "value_int", 10)
			ComponentSetValue2(state_duration_var_comp, "value_int", 0)
			ComponentSetValue2(state_duration2_var_comp, "value_int", 0)
			ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
			ComponentSetValue2(state_previous_var_comp, "value_int", 9)
		end
	end
elseif state == 10 then
	if oy > acy + 20 then
		GameScreenshake(20)
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", true)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand2")
			ComponentSetValue2(comp, "next_rect_animation", "stand2")
		end
		ComponentSetValue2(origin_var_comp, "value_string", tostring(oy - 0.5))
	else
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", false)
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "rect_animation", "stand3")
			ComponentSetValue2(comp, "next_rect_animation", "stand3")
		end
	end

	ComponentSetValue2(state_duration2_var_comp, "value_int", state_duration2 + 1)
	-- local tentacle_laying = GetValueNumber("tentacle_laying_done", 0)
	if #players > 0 then
	
		local player_id = players[1]
		local px, py = EntityGetTransform( player_id )
		
		local player_counts = EntityGetInRadiusWithTag(x, y - 160, 40, "player_unit")
		
		if ( tentacle_laying == 0 ) then

			if ( #player_counts > 0 ) and ( state_duration2 > 305 ) then
				ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 4)
				ComponentSetValue2(tentacle_laying_var_comp, "value_int", 1)
				local character_platforming_component = EntityGetFirstComponentIncludingDisabled(player_id, "CharacterPlatformingComponent")

				if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
					ComponentSetValue2(character_platforming_component, "mIsPrecisionJumping", true)
				end
				
				local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					local max_hp = ComponentGetValue2( comp, "max_hp" )
					local hp = ComponentGetValue2( comp, "hp" )
					EntityLoad( "data/entities/projectiles/mwyah_explode.xml", x , y - 160 )
					EntityInflictDamage( entity_id, ( max_hp / 2 ) / 5, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, player_id, x, y )
					ComponentSetValue2( comp, "invincibility_frames", 300 )
					GameScreenshake(20)
				end
				for _,id in pairs(EntityGetInRadiusWithTag(x, y, 999999, "cloned")) do
					EntityKill(id)
				end
			end
		else
			ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 4)
			ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
		end
		
		if state_duration2 == 150 then
			ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 8)
			local bubble = EntityLoad("data/entities/animals/mwyah_bubble_green.xml", px , py)
			EntityAddChild(player_id, bubble)
		elseif state_duration2 == 300 then
			EntityLoad( "data/entities/projectiles/mwyah_wall.xml", acx , acy )
		end
		if state_duration > 150 then
			ComponentSetValue2(state_var_comp, "value_int", 12)
			ComponentSetValue2(state_duration_var_comp, "value_int", 0)
			ComponentSetValue2(state_duration2_var_comp, "value_int", 0)
			ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
			ComponentSetValue2(state_previous_var_comp, "value_int", 10)
		end
	end
elseif state == 12 then
	if oy < acy + 512 then
		GameScreenshake(20)
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", true)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
		ComponentSetValue2(origin_var_comp, "value_string", tostring(oy + 0.5))
	else
		for i, child in ipairs(EntityGetAllChildren(arena_center_id) or {}) do
			if EntityGetName(child) == "pipes" then
				EntitySetComponentsWithTagEnabled(child, "enabled_in_world", false)
			end
		end
		for _,id in pairs(EntityGetInRadiusWithTag(x, y, 999999, "cloned")) do
			EntityKill(id)
		end
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
		if ( comp ~= nil ) then
			ComponentSetValue2(comp, "kill_now", true)
		end
	end

	ComponentSetValue2(state_duration_var_comp, "value_int", state_duration + 1)
	
end

--Change phase when half health

function damage_received( dmg, msg, source, is_fatal)
	local entity_id = GetUpdatedEntityID()
	local children = EntityGetAllChildren( entity_id, "pitcheck_b" )
	local arena_center_id = children[1]
	
	local arena_terrain_handler_var_comp = get_variable_storage_component( arena_center_id, "is_clearing_terrain" )
	
	local components = EntityGetComponent( entity_id, "VariableStorageComponent" )
	if ( components ~= nil ) then
		for _,comp_id in pairs(components) do 
			local var_name = ComponentGetValue( comp_id, "name" )
			if ( var_name == "state") then
				state_var_comp = comp_id
			end
			if ( var_name == "state_previous") then
				state_previous_var_comp = comp_id
			end
			if ( var_name == "state_duration") then
				state_duration_var_comp = comp_id
			end
			if ( var_name == "state_duration2") then
				state_duration2_var_comp = comp_id
			end
			if ( var_name == "position") then
				position_var_comp = comp_id
			end
			if ( var_name == "tentacle_laying") then
				tentacle_laying_var_comp = comp_id
			end
			if ( var_name == "tentacle_direction") then
				tentacle_direction_var_comp = comp_id
			end
			if ( var_name == "parallax_factor") then
				parallax_factor_var_comp = comp_id
			end
			if ( var_name == "init_origin") then
				init_origin_var_comp = comp_id
			end
			if ( var_name == "origin") then
				origin_var_comp = comp_id
			end
		end
	end
	
	local state_current = ComponentGetValue2(state_var_comp, "value_int")
	
	if state_current < 6 then
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
		if ( comp ~= nil ) then
			local max_hp = ComponentGetValue2( comp, "max_hp" )
			local hp = ComponentGetValue2( comp, "hp" )
			if hp < max_hp / 2 then
				ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 13)
				EntitySetComponentsWithTagEnabled(entity_id, "character", false)
				EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
				local comp2 = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent", "enabled_in_hand" )
				if ( comp2 ~= nil ) then
					ComponentSetValue2(comp2, "rect_animation", "stand2")
					ComponentSetValue2(comp2, "next_rect_animation", "stand2")
				end
				
				ComponentSetValue2(state_var_comp, "value_int", 6)
				ComponentSetValue2(state_duration_var_comp, "value_int", 0)
				ComponentSetValue2(state_duration2_var_comp, "value_int", 0)
				ComponentSetValue2(tentacle_laying_var_comp, "value_int", 0)
				ComponentSetValue2(state_previous_var_comp, "value_int", 5)
				
				ComponentSetValue2( comp, "hp", max_hp / 2 )
				ComponentSetValue2( comp, "invincibility_frames", 300 )
				for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
					if EntityGetName(child) == "bubble" then
						EntityKill(child)
					end
				end
				
				for i, child in ipairs(EntityGetAllChildren(arena_center_id) or {}) do
					if EntityGetName(child) == "pipes" then
						local var_comp = get_variable_storage_component( child, "offset" )
						ComponentSetValue2(var_comp, "value_float", -10)
					end
				end
				
				if #players > 0 then
					local player_id = players[1]
					local px, py = EntityGetTransform( player_id )
					GlobalsSetValue("new_enemies_global_no_recoil", "1")
					
					local hook_converter = EntityAddComponent2(player_id, "LuaComponent", {
						script_shot="data/scripts/projectiles/all_projectiles_to_hooks.lua", 
						execute_every_n_frame=-1
					})
						
					local character_platforming_component = EntityGetFirstComponentIncludingDisabled(player_id, "CharacterPlatformingComponent")

					if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
						ComponentSetValue2(character_platforming_component, "mIsPrecisionJumping", true)
					end
					
					local properties_to_change = {
						jump_velocity_y = -200,
						jump_velocity_x = 150,
						jump_velocity_x = 150,
						swim_up_buoyancy_coeff = 2,
						velocity_min_x=-100,
						velocity_max_x=100,
						velocity_min_y=-200,
						fly_velocity_x = 60,
						fly_speed_max_up = 0,
						fly_speed_mult = 0,
						fly_speed_change_spd = 0
					}

					if character_platforming_component then
						local old_values = ""
						for k, v in pairs(properties_to_change) do
							local value = ComponentGetValue2(character_platforming_component, k)
							local string_value = tostring(value)
							if type(value) == "boolean" then
								string_value = value and "1" or "0"
							end
							old_values = old_values .. k .. ":" .. type(value) .. "=" .. string_value
							if next(properties_to_change, k) then
								old_values = old_values .. ","
							end
							ComponentSetValue2(character_platforming_component, k, v)
						end

						EntityAddComponent2(player_id, "VariableStorageComponent", {
							name = "new_enemies_player_mwyah_phase2_old_values",
							value_string = old_values,
						})
					end
					
					local bubble = EntityLoad("data/entities/animals/mwyah_bubble_green.xml", px , py)
					EntityAddChild(player_id, bubble)
				end
			end
		end
	elseif state_current > 5 then
		if is_fatal then
			ComponentSetValue2(state_var_comp, "value_int", 12)
			ComponentSetValue2(arena_terrain_handler_var_comp, "value_int", 2)
			
			for i, child in ipairs(EntityGetAllChildren(arena_center_id) or {}) do
				if EntityGetName(child) == "pipes" then
					local var_comp = get_variable_storage_component( child, "offset" )
					ComponentSetValue2(var_comp, "value_float", 512)
				end
			end
		end
	end
end