dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/game_helpers.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform( entity_id )

local player = EntityGetInRadiusWithTag(x, y, 150, "player_unit")

--Giving ooion moon hovering movement
local float_range = 200
local float_force = 3
local float_sensor_sector = math.pi * 0.3

local dir_x = 0
local dir_y = float_range
dir_x, dir_y = vec_rotate(dir_x, dir_y, ProceduralRandomf(x, y + GameGetFrameNum(), -float_sensor_sector, float_sensor_sector))

local did_hit,hit_x,hit_y = RaytracePlatforms( x, y, x + dir_x, y + dir_y )
if did_hit then
	local dist = get_distance(x, y, hit_x, hit_y)
	dist = math.max(6, dist) -- tame a bit on close encounters
	dir_x = -dir_x / dist * float_force
	dir_y = -dir_y / dist * float_force
	PhysicsApplyForce(entity_id, dir_x, dir_y)
end


--Setting low gravity on surrounding creatures and player
if #player > 0 and (EntityGetHerdRelation(entity_id, player[1]) < 40) then
  
	local player_x, player_y = EntityGetTransform(player[1])
	
	
	play_animation( entity_id, "wake")
	
	-- GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/treble_eye/create", x, y )
	
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
	
	local entities = EntityGetInRadiusWithTag(x, y, 150, "enemy")
	for i, player2 in ipairs(player) do
	  table.insert(entities, player2)
	end

	for i, entity in ipairs(entities) do
	
		local x2, y2 = EntityGetTransform(entity)
		local platforming_component = EntityGetFirstComponent(entity, "CharacterPlatformingComponent")
		  
		local has_gravity_effect = false
		local var_store_comps = EntityGetComponent(entity, "VariableStorageComponent") or {}
		
		for i, comp in ipairs(var_store_comps) do
		
			if ComponentGetValue2(comp, "name") == "ooion_gravity" then
				has_gravity_effect = true
				break
			end
			
		end
			
		if not EntityHasTag(entity, "standard_gravity") and platforming_component and not has_gravity_effect then
			
			local gravity = ComponentGetValue(platforming_component, "pixel_gravity")
		   
			EntityAddComponent(entity, "VariableStorageComponent", {
				name="ooion_gravity",
			})
				
			EntityAddComponent(entity, "LuaComponent", {
				script_source_file="data/scripts/animals/ooion_gravity_checker.lua",
				execute_every_n_frame=20,
				execute_on_added=0,
			}) 
			
			gravity = gravity/5
			  
			ComponentSetValue(platforming_component, "pixel_gravity", gravity)
			
		end
		
	end

else

	--close eye
	play_animation( entity_id, "sleep")
	
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)

end

function damage_received(damage, message,entity_thats_responsible, is_fatal)

	local entity_id = GetUpdatedEntityID()
	
	--open eye
	
	play_animation( entity_id, "wake")
	
	GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/treble_eye/create", x, y )
	
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

end