dofile_once("data/scripts/lib/utilities.lua")

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

function shoot_projectile_at_pos(shooter_entity, projectile_file, origin_x, origin_y, dest_x, dest_y, projectile_speed)	

  local projectile_speed = projectile_speed / 2

  local dir = get_direction(origin_x, origin_y, dest_x, dest_y)
  local vx = math.cos(dir) * projectile_speed
  local vy = math.sin(dir) * projectile_speed

  local ourProjectile = shoot_projectile(shooter_entity, projectile_file, origin_x, origin_y, vx, vy)
  
end

function damage_received( damage, desc, entity_who_caused, is_fatal )
	local entity_id    = GetUpdatedEntityID()
	local x, y = EntityGetTransform( entity_id )

	if( entity_who_caused == entity_id ) then return end
	if script_wait_frames( entity_id, 2 ) then  return  end
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	local angle_inc = 0
	local angle_inc_set = false
	
	local length = 400
	
	if ( entity_who_caused ~= nil ) and ( entity_who_caused ~= NULL_ENTITY ) then
	
		local ex, ey = EntityGetTransform( entity_who_caused )
		
		if ( ex ~= nil ) and ( ey ~= nil ) then
		
			shoot_projectile_at_pos(entity_id, "data/entities/projectiles/ooion_projectile.xml", x, y, ex, ey, 300)
			
		end
		
	end

end
