dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x,y = EntityGetTransform( entity_id )

local multiplier = 1

local function getDistance(x1, y1, x2, y2)
	return math.sqrt(math.pow((y2-y1),2)+math.pow((x2-x1),2))
end

local angle_old = GetValueNumber("average_rotation", 0)
local angle = 0

--Check Nearest Enemy
local enemy = 0
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 200, "mortal")) do
	-- is target a valid enemy
	if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local hx, hy = EntityGetFirstHitboxCenter( id )
		-- local did_hit_enemy, hit_x,hit_y = RaytracePlatforms( x, y, hx, hy )
		-- if not did_hit_enemy then
			enemy = id
			px = hx
			py = hy
			
		-- end
	end
end

if enemy > 0 then
	angle = math.atan2( y - py, px - x )
	local enemy_to_entity_distance = getDistance(x,y, px,py)
	if enemy_to_entity_distance < 15 then
		multiplier = enemy_to_entity_distance * 1/15
	end
end

function move_angle_towards(current_angle, target_angle, speed)

  -- Make angle go from 0 to 2pi
  if target_angle < 0 then
    target_angle = target_angle + math.pi * 2
  end
  if current_angle < 0 then
    current_angle = current_angle + math.pi * 2
  end

  local dist_up = math.abs(target_angle - current_angle)
  local dist_down = math.abs((current_angle + math.pi * 2) - target_angle)
  if current_angle > target_angle then
    dist_up = math.abs((target_angle + math.pi * 2) - current_angle)
    dist_down = math.abs(current_angle - target_angle)
  end
  
  local dir
  if math.abs(dist_up) < math.abs(dist_down) then
    dir = 1
  else
    dir = -1
  end
  local dist_smallest = dist_up
  if dist_down < dist_up then
    dist_smallest = dist_down
  end

  local new_angle = current_angle + speed * dir
  if dir > 0 and current_angle < target_angle and new_angle > target_angle then
    new_angle = target_angle
  elseif dir < 0 and current_angle > target_angle and new_angle < target_angle  then
    new_angle = target_angle
  end
  new_angle = new_angle % (math.pi * 2)

  return new_angle
end

x = x + 2

y = y + 2

angle = move_angle_towards(angle_old, angle, 1/40)
SetValueNumber("average_rotation", angle)

for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	-- if EntityGetName(child) == "eye2" then
		-- EntitySetTransform( child, x + math.cos( angle ) * 1, y - math.sin( angle ) * 1  )
	-- end
	if EntityGetName(child) == "eye3" then
		EntitySetTransform( child, x - 2 + math.cos( angle ) * 3.8 * multiplier, y - 2 - math.sin( angle ) * 3.8 * multiplier )
	end
	if EntityGetName(child) == "eye4" then
		EntitySetTransform( child, x - 2 + math.cos( angle ) * 4 * multiplier, y - 2 - math.sin( angle ) * 4 * multiplier )
	end
	if EntityGetName(child) == "eye5" then
		EntitySetTransform( child, x - 2 + math.cos( angle ) * 5.5 * multiplier, y - 2 - math.sin( angle ) * 5.5 * multiplier )
	end
	if EntityGetName(child) == "eye6" then
		EntitySetTransform( child, x - 1 + math.cos( angle ) * 4.3 * multiplier, y - 1 - math.sin( angle ) * 4.3 * multiplier )
	end
	if EntityGetName(child) == "eye6_light" then
		local x2 = x - 1 + math.cos( angle ) * 150
		local y2 = y - 1 - math.sin( angle ) * 150
		local did_hit, hit_x,hit_y = RaytraceSurfaces( x, y, x2, y2 )
		local x_scale = 1
		local distance
		if did_hit then
			distance= getDistance(x,y,hit_x,hit_y)
			local sprite_width = 75
			local max_distance = 75
			local scale = math.max(0, distance) / sprite_width
			x_scale = math.min(scale, sprite_width / max_distance)
		end
		EntitySetTransform( child, x - 1 + math.cos( angle ) * 4.3 * multiplier, y - 1 - math.sin( angle ) * 4.3 * multiplier, -angle, x_scale, x_scale  )
	end
	if EntityGetName(child) == "eye7" then
		EntitySetTransform( child, x + math.cos( angle ) * 3 * multiplier, y - math.sin( angle ) * 3 * multiplier )
	end
end