dofile_once("data/scripts/lib/utilities.lua")

function damage_received( damage, message, entity_thats_responsible, is_fatal, projectile_thats_responsible )

	function split_string(inputstr, sep)
	  sep = sep or "%s"
	  local t= {}
	  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		table.insert(t, str)
	  end
	  return t
	end

	function toboolean(str)
		return str == "1"
	end

	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform( entity_id )
	local px, py = EntityGetTransform( projectile_thats_responsible )
	
	local projectile_comp = EntityGetFirstComponentIncludingDisabled( projectile_thats_responsible, "ProjectileComponent" )
	if ( projectile_comp ~= nil ) and ( projectile_comp > 0 ) then
		local bounces_left = ComponentGetValue2(projectile_comp, "bounces_left") 
	-- if bounces_left > 0 then
		distance = get_distance( px, py, x, y )
		direction = get_direction( px, py, x, y )
		
		local distance_full = 15
			
		local velocitycomponents = EntityGetComponent( projectile_thats_responsible, "VelocityComponent" )
		
		local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.01)
		local gravity_coeff = 10000000
	
		local var_comp = get_variable_storage_component( projectile_thats_responsible, "new_enemies_hitbox_bounce_old_values" )
		
		local stored_values = ComponentGetValue2(projectile_comp, "bounce_fx_file")

		if stored_values then
			local properties = split_string(stored_values, ",")
			for i, v in ipairs(properties) do
				local bounce_fx_contents = shoot_projectile_from_projectile( entity_id, v, px, py, 0, 0 )
			end
		end

		component_write( projectile_comp,
		{
			bounces_left = bounces_left - 1
		} )
				
		local properties_to_change = {
			on_collision_remove_projectile = false,
			penetrate_entities = true
		}
		
		if projectile_comp and not var_comp then
			local old_values = ""
			for k, v in pairs(properties_to_change) do
				local value = ComponentGetValue2(projectile_comp, k)
				local string_value = tostring(value)
				if type(value) == "boolean" then
					string_value = value and "1" or "0"
				end
				old_values = old_values .. k .. ":" .. type(value) .. "=" .. string_value
				if next(properties_to_change, k) then
					old_values = old_values .. ","
				end
				ComponentSetValue2(projectile_comp, k, v)
			end

			EntityAddComponent2(projectile_thats_responsible, "VariableStorageComponent", {
				name = "new_enemies_hitbox_bounce_old_values",
				value_string = old_values,
			})
			EntityAddComponent2(projectile_thats_responsible, "LuaComponent", {
				script_source_file="data/scripts/animals/oruai_reflect_restore.lua",
				remove_after_executed=true,
				execute_every_n_frame=2,
				execute_on_added=false
			})
		end
		
		if ( velocitycomponents ~= nil ) then
			edit_component( projectile_thats_responsible, "VelocityComponent", function(comp,vars)
			
				local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
				
				SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
				local direction_random = math.rad( Random( -30, 30 ) )
				
				local offset_x = math.cos( direction + direction_random ) * ( gravity_coeff * gravity_percent )
				local offset_y = 0 - math.sin( direction + direction_random ) * ( gravity_coeff * gravity_percent )

				vel_x = offset_x
				vel_y = offset_y

				ComponentSetValueVector2( comp, "mVelocity", vel_x, vel_y)
			end)
		end
		
	end

end