dofile_once("data/scripts/lib/utilities.lua")

function split_string(inputstr, sep)
  sep = sep or "%s"
  local t= {}
  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
    table.insert(t, str)
  end
  return t
end

function toboolean(str)
	return str == "1"
end

local entity_id = GetUpdatedEntityID()
local projectile_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ProjectileComponent")
local var_store = get_variable_storage_component(entity_id, "new_enemies_hitbox_bounce_old_values")
local stored_values = ComponentGetValue2(var_store, "value_string")

if stored_values then
	local properties = split_string(stored_values, ",")
	
	for i, v in ipairs(properties) do
		local name, prop_type, value = string.match(v, "(.+):(.+)=(.+)")
		value = _G["to"..prop_type](value)
		ComponentSetValue2(projectile_component, name, value)
	end
	
	EntityRemoveComponent(entity_id, var_store)
end
