dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local ghost_component = EntityGetFirstComponent(entity_id, "GhostComponent")

local cam_x, cam_y = GameGetCameraPos()

-- Calculate the difference between the ghost's position and the camera position
local diff_x = cam_x - x
local diff_y = cam_y - y

-- Calculate the magnitude of the difference vector
local magnitude = math.sqrt(diff_x^2 + diff_y^2)

-- Normalize the difference vector
local normalized_diff_x = diff_x / magnitude
local normalized_diff_y = diff_y / magnitude

-- Set the repelling force strength
local repel_force = 100

-- Calculate the repelling force vector
local repel_x = normalized_diff_x * repel_force
local repel_y = normalized_diff_y * repel_force

-- Calculate the new velocity by subtracting the repelling force vector
local vel_x, vel_y = ComponentGetValue2(ghost_component, "velocity")
vel_x2 = vel_x - repel_x
vel_y2 = vel_y - repel_y

-- Update the velocity in the ghost component
ComponentSetValue2(ghost_component, "velocity", vel_x + vel_x2 * 0.5, vel_y + vel_y2 * 0.5)

if ( BiomeMapGetName( cam_x, cam_y ) ~= "$biome_wandcave" 
and BiomeMapGetName( cam_x - 512, cam_y ) ~= "$biome_wandcave" 
and BiomeMapGetName( cam_x + 512, cam_y ) ~= "$biome_wandcave"
and BiomeMapGetName( cam_x, cam_y - 512 ) ~= "$biome_wandcave" 
and BiomeMapGetName( cam_x, cam_y + 512 ) ~= "$biome_wandcave"
and BiomeMapGetName( cam_x - 512, cam_y - 512 ) ~= "$biome_wandcave" 
and BiomeMapGetName( cam_x + 512, cam_y - 512 ) ~= "$biome_wandcave"
and BiomeMapGetName( cam_x - 512, cam_y + 512 ) ~= "$biome_wandcave" 
and BiomeMapGetName( cam_x + 512, cam_y + 512 ) ~= "$biome_wandcave" )
and	( BiomeMapGetName( cam_x, cam_y ) ~= "$biome_pyramid" 
and BiomeMapGetName( cam_x - 512, cam_y ) ~= "$biome_pyramid" 
and BiomeMapGetName( cam_x + 512, cam_y ) ~= "$biome_pyramid"
and BiomeMapGetName( cam_x, cam_y - 512 ) ~= "$biome_pyramid" 
and BiomeMapGetName( cam_x, cam_y + 512 ) ~= "$biome_pyramid"
and BiomeMapGetName( cam_x - 512, cam_y - 512 ) ~= "$biome_pyramid" 
and BiomeMapGetName( cam_x + 512, cam_y - 512 ) ~= "$biome_pyramid"
and BiomeMapGetName( cam_x - 512, cam_y + 512 ) ~= "$biome_pyramid" 
and BiomeMapGetName( cam_x + 512, cam_y + 512 ) ~= "$biome_pyramid" ) 
and	( BiomeMapGetName( cam_x, cam_y ) ~= "$biome_crypt" 
and BiomeMapGetName( cam_x - 512, cam_y ) ~= "$biome_crypt" 
and BiomeMapGetName( cam_x + 512, cam_y ) ~= "$biome_crypt"
and BiomeMapGetName( cam_x, cam_y - 512 ) ~= "$biome_crypt" 
and BiomeMapGetName( cam_x, cam_y + 512 ) ~= "$biome_crypt"
and BiomeMapGetName( cam_x - 512, cam_y - 512 ) ~= "$biome_crypt" 
and BiomeMapGetName( cam_x + 512, cam_y - 512 ) ~= "$biome_crypt"
and BiomeMapGetName( cam_x - 512, cam_y + 512 ) ~= "$biome_crypt" 
and BiomeMapGetName( cam_x + 512, cam_y + 512 ) ~= "$biome_crypt" )then

	-- StatsLogPlayerKill( GetUpdatedEntityID() )
	
	EntityKill(entity_id)
end

local dist = get_distance(x, y, cam_x, cam_y)
if dist > 250 then
	EntityKill(entity_id)
end