dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

local found, nx, ny, apd = GetSurfaceNormal(x, y, 13, 13)

local player = get_players()[1]

if(player ~= nil)then
	px, py = EntityGetTransform(player)
	local hit_dir_x = px - x
	local hit_dir_y = py - y
	player_distance = math.sqrt((hit_dir_x*hit_dir_x) + (hit_dir_y*hit_dir_y))
end

local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, px, py)

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 2 == 0 then
	if not found and BiomeMapGetName() ~= "$biome_holymountain" and player ~= nil and player_distance < 200 and not did_hit then
	  nx = nx * (math.abs(apd) + 2)
	  ny = ny * (math.abs(apd) + 2)
	  
		local new_ent = EntityLoad("data/entities/animals/phantom_boss.xml", x - nx, y - ny)
		EntityLoad( "data/entities/particles/phantom_boss_particles.xml", x - nx, y - ny)
		
		local who_shot_damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		local who_spawned_damage_model_component = EntityGetFirstComponentIncludingDisabled( new_ent, "DamageModelComponent" )

		local hp = ComponentGetValue2(who_shot_damage_model_component, "hp")
		local max_hp = ComponentGetValue2(who_shot_damage_model_component, "max_hp")

		if max_hp and hp then
			if hp <= 0 then
				EntityKill(new_ent)
				return
			end
			ComponentSetValue2( who_spawned_damage_model_component, "max_hp", max_hp )
			ComponentSetValue2( who_spawned_damage_model_component, "hp", hp )
		end
		
		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")

		if damage_model_component then
			
			EntityAddComponent(entity_id, "VariableStorageComponent", {
				_tags="no_gold_drop",
			  })
			
			ComponentSetValue2(damage_model_component, "hp", 0)
			ComponentSetValue2(damage_model_component, "air_needed", true)
			ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
		else
			EntityKill(entity_id)
		end
	else
	  nx = 0
	  ny = 0
	end
end

shoot_projectile( entity_id, "data/entities/projectiles/phantom_boss_wave_projectile2.xml", x, y, 0, 2000 )
