dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "mods/new_enemies/files/object_poly_cororoutines.lua" )

async(function()

	wait(1)
	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform( entity_id )
	
	local projectile_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "ProjectileComponent" )
	local shooter_id = ComponentGetValue2( projectile_comp, "mWhoShot")

		
	local new_ent = EntityLoad("data/entities/animals/phantom_boss_tiny.xml", x, y - 32)
	
	EntityAddComponent(new_ent, "VariableStorageComponent", {
		name = "oldpath",
		value_string = serialize_entity(shooter_id)
	})

	EntityAddComponent(new_ent, "LuaComponent", {
		enable_coroutines="1",
		script_source_file="data/scripts/animals/phantom_boss_transform_return.lua",
		execute_on_added="1",
		execute_every_n_frame="-1",
		execute_times="1"
	})
	
	EntityKill(entity_id)

end)

function serialize_entity(entity)
    if not coroutine.running() then
        error("serialize_entity() must be called from inside an async function", 2)
    end
	local polytools = dofile_once("mods/new_enemies/files/polytools/polytools.lua")
    EntityRemoveFromParent(entity)
    EntityApplyTransform(entity, 6666666, 6666666)
    local serialized = polytools.save(entity)
    wait(0)
    entity = EntityGetInRadius(6666666, 6666666, 5)[1]
    EntityKill(entity)
    return serialized
end