dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "mods/new_enemies/files/object_poly_cororoutines.lua" )

async(function()

    wait(1200)
	
    local entity_id = GetUpdatedEntityID()

    local x, y = EntityGetTransform( entity_id )
	
	local found, nx, ny, apd = GetSurfaceNormal(x, y, 20, 20)
	if found then
	  nx = nx * (math.abs(apd) + 2)
	  ny = ny * (math.abs(apd) + 2)
	  
		local components = EntityGetComponent( entity_id, "VariableStorageComponent" )

		for i,comp_id in ipairs(components) do 
			local var_name = ComponentGetValue( comp_id, "name" )
			if( var_name == "oldpath") then
				local load_me = ComponentGetValue( comp_id, "value_string" )
				local new_entity = deserialize_entity(load_me)
				EntitySetTransform(new_entity, x - nx, y - ny)
				-- EntityLoad( load_me, x, y )
			end
		end
		
		EntityKill(entity_id)
	else
	  nx = 0
	  ny = 0
	end
    
end)

function deserialize_entity(str)
    if not coroutine.running() then
        error("deserialize_entity() must be called from inside an async function", 2)
    end
	local polytools = dofile_once("mods/new_enemies/files/polytools/polytools.lua")
    -- Move the entity to a unique location so that we can get a reference to the entity with EntityGetInRadius once polymorph wears off
    -- Apply polymorph which, when it runs out after 1 frame will turn the entity back into it's original form, which we provide
    polytools.spawn(666666, 666666, str)
    -- Wait 1 frame for the polymorph to wear off
    wait(0)
    local all_entities = EntityGetInRadius(666666, 666666, 3)
	print(#all_entities)
    return EntityGetRootEntity(all_entities[1])
end