dofile_once("data/scripts/animals/player_ai_movement_utilities.lua")
-- dofile( "data/scripts/lib/coroutines.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )

local ourEntity = GetUpdatedEntityID()
local entity_id = GetUpdatedEntityID()

local component_id = GetUpdatedComponentID()

local player = get_players()[1]

local x, y = EntityGetTransform(ourEntity)

if ( BiomeMapGetName() == "$biome_holymountain" and player > 0 ) then
	return
end
	
local ourVelocityComponent = EntityGetComponent(ourEntity, "VelocityComponent")
local ourProjectileComponent = EntityGetFirstComponent(ourEntity, "ProjectileComponent")


--Finding Target

local range = 9999
local target, targetX, targetY
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, range, "player_unit")) do
	-- is target a valid enemy
	if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local target_x, target_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, target_x, target_y)
		if dist < min_dist then
			min_dist = dist
			target = id
			targetX = target_x
			targetY = target_y
		end
	end
end

if GetValueBool("initialized", false) == false then

	SetValueBool("initialized", true)

	function node_func ( node, neighbor, goal, node_density )
		--print(table.dump(neighbor))
		--print(table.dump(node))

		--print("hella_rawr")

		local MAX_DIST = node_density

		local distance_from_walls = 5
			
		if get_distance( node.x, node.y, neighbor.x, neighbor.y ) > MAX_DIST then
			return false
		end

		--GamePrint("hellaa")

		
		if (neighbor ~= goal and
			(RaytracePlatforms( neighbor.x, neighbor.y, node.x, node.y ) or 
			RaytracePlatforms( neighbor.x, neighbor.y, neighbor.x + distance_from_walls, neighbor.y ) or 
			RaytracePlatforms( neighbor.x, neighbor.y, neighbor.x, neighbor.y + distance_from_walls) or 
			RaytracePlatforms( neighbor.x, neighbor.y, neighbor.x - distance_from_walls, neighbor.y ) or 
			RaytracePlatforms( neighbor.x, neighbor.y, neighbor.x, neighbor.y - distance_from_walls) or 
			RaytracePlatforms( neighbor.x, neighbor.y, neighbor.x + distance_from_walls, neighbor.y + distance_from_walls ) or 
			RaytracePlatforms( neighbor.x, neighbor.y, neighbor.x - distance_from_walls, neighbor.y + distance_from_walls) or 
			RaytracePlatforms( neighbor.x, neighbor.y, neighbor.x + distance_from_walls, neighbor.y - distance_from_walls ) or 
			RaytracePlatforms( neighbor.x, neighbor.y, neighbor.x - distance_from_walls, neighbor.y - distance_from_walls)))then
			return false
		end

		return not RaytracePlatforms( neighbor.x, neighbor.y, node.x, node.y )
	end

	gui = GuiCreate()
	GuiStartFrame(gui)

	GuiOptionsAdd(gui, GUI_OPTION.NonInteractive)

	--time_start = GameGetRealWorldTimeSinceStarted()

	path_true, node_grid = FindPath( x, y, targetX, targetY, true, node_func )
	if(path_true == nil) or (target == nil) then
		local found2 = false
		local lua_comps = EntityGetComponent(entity_id, "LuaComponent") or {}
		for i, comp in ipairs(lua_comps) do
		  if ComponentGetValue2(comp, "script_source_file") == "data/scripts/animals/player_ai_movement.lua" then
			found2 = true
			break
		  end
		end
		if not found2 then
			EntityAddComponent(entity_id, "LuaComponent", {
				script_source_file="data/scripts/animals/player_ai_movement.lua",
				execute_every_n_frame=10
			})
			EntityRemoveComponent(entity_id, GetUpdatedComponentID())
			return
		end
		return
	end

	path = path_true--SmoothPath(path_true)


	--print("Pathfinding took: "..tostring((GameGetRealWorldTimeSinceStarted() - time_start) * 1000).."ms")

	local virt_x = MagicNumbersGetValue("VIRTUAL_RESOLUTION_X")
	local virt_y = MagicNumbersGetValue("VIRTUAL_RESOLUTION_Y")
	local screen_width, screen_height = GuiGetScreenDimensions(gui)
	local scale_x = virt_x / screen_width
	local scale_y = virt_y / screen_height
	local cx, cy = GameGetCameraPos()

	previous_time = GameGetFrameNum()

	DEBUGGING = false

	current_index = 1

	-- async_loop(function()

else

	local lua_comps = EntityGetComponent(entity_id, "LuaComponent") or {}
	for i, comp in ipairs(lua_comps) do
	  if ( ComponentGetValue2(comp, "script_source_file") == "data/scripts/animals/player_ai_movement.lua" ) then
		EntityRemoveComponent( entity_id, comp )
	  end
	end
	-- if GlobalsGetValue("stop_please", "0") == "1" then
	  -- GlobalsSetValue("stop_please", "0")
	  -- coroutine.yield()
	-- end

    time_start = GameGetRealWorldTimeSinceStarted()
    x, y = EntityGetTransform(ourEntity)
	
	if not path then
		return
	end
    
	if target then
		targetPointX = path[current_index].x
		targetPointY = path[current_index].y
	end
	
    local directionX = (targetPointX) - x
    
    local directionY = (targetPointY) - y

    virt_x = MagicNumbersGetValue("VIRTUAL_RESOLUTION_X")
    virt_y = MagicNumbersGetValue("VIRTUAL_RESOLUTION_Y")
    screen_width, screen_height = GuiGetScreenDimensions(gui)
    scale_x = virt_x / screen_width
    scale_y = virt_y / screen_height
    cx, cy = GameGetCameraPos()

    -- if(DEBUGGING)then
        -- for k, v in pairs(node_grid)do
            -- sx, sy = (v.x - cx) / scale_x + screen_width / 2 + 1.5, (v.y - cy) / scale_y + screen_height / 2

            -- GuiImage( gui, 125210 + k, sx, sy, "data/projectiles_gfx/marker2.png", 1, 1, 0 )
        -- end
    -- end
    
    for k, v in pairs(path_true)do
        sx, sy = (v.x - cx) / scale_x + screen_width / 2 + 1.5, (v.y - cy) / scale_y + screen_height / 2
		
		if(DEBUGGING)then
			GuiImage( gui, k, sx, sy, "data/projectiles_gfx/marker.png", 1, 1, 0 )
		end
    end

    local Speed = 200

    
    if target ~= nil and (ourVelocityComponent ~= nil)then
    
        targetX, targetY = EntityGetTransform(target)

        if(get_distance(targetX, targetY, x, y) < 20)then
            
            directionX = (targetX) - x
    
            directionY = (targetY) - y
        end

            -- local velocityX, velocityY = ComponentGetValue2( comp, "mVelocity")
    
            -- local vel_x = directionX
    
            -- local vel_y = directionY
            
            -- local len = math.sqrt((vel_x*vel_x) + (vel_y*vel_y))
    
            -- local dir_x = vel_x / len + x
            -- local dir_y = vel_y / len + y
			
			local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
			local character_data_component = EntityGetFirstComponent(entity_id, "CharacterDataComponent")
            
			if targetPointX > x and targetPointY < y  - 3 then
				ComponentSetValue2( controls_component, "mButtonDownRight", true )
				ComponentSetValue2( controls_component, "mButtonDownLeft", false )
				
				GamePlayAnimation(entity_id, "fly_idle", 1)
				EntitySetComponentsWithTagEnabled(entity_id, "jetpack", true)
				
				-- ComponentSetValueVector2(character_data_component, "mVelocity", velocity_x, -78)
				-- ComponentSetValue2( controls_component, "mButtonDownUp", true )
				-- GamePrint("Going Right Up")
			elseif targetPointX >= x and targetPointY >= y - 3 then
				ComponentSetValue2( controls_component, "mButtonDownRight", true )
				ComponentSetValue2( controls_component, "mButtonDownLeft", false )
				
				EntitySetComponentsWithTagEnabled(entity_id, "jetpack", false)
				-- ComponentSetValue2( controls_component, "mButtonDownUp", false )
				-- GamePrint("Going Right")
			elseif targetPointX <= x and targetPointY >= y  - 3 then
				ComponentSetValue2( controls_component, "mButtonDownRight", false )
				ComponentSetValue2( controls_component, "mButtonDownLeft", true )
				EntitySetComponentsWithTagEnabled(entity_id, "jetpack", false)
				-- ComponentSetValue2( controls_component, "mButtonDownUp", false )
				-- GamePrint("Going Left")
			elseif targetPointX < x and targetPointY < y  - 3 then
				ComponentSetValue2( controls_component, "mButtonDownRight", false )
				ComponentSetValue2( controls_component, "mButtonDownLeft", true )
				-- ComponentSetValue2( controls_component, "mButtonDownUp", true )
				
				GamePlayAnimation(entity_id, "fly_idle", 1)
				EntitySetComponentsWithTagEnabled(entity_id, "jetpack", true)
				
				-- ComponentSetValueVector2(character_data_component, "mVelocity", velocity_x, -78)
				-- GamePrint("Going left Up")
			end
    
    end
	
	function movement1()
		local found2 = false
		local lua_comps = EntityGetComponent(entity_id, "LuaComponent") or {}
		for i, comp in ipairs(lua_comps) do
		  if ComponentGetValue2(comp, "script_source_file") == "data/scripts/animals/player_ai_movement.lua" then
			found2 = true
			break
		  end
		end
		if not found2 then

			EntityAddComponent(entity_id, "LuaComponent", {
				script_source_file="data/scripts/animals/player_ai_movement.lua",
				execute_every_n_frame=10
			})
			EntityRemoveComponent(entity_id, GetUpdatedComponentID())
			-- coroutine.yield()
			return
		end
	end

	-- if(targetPointX == nil) then

		-- EntityAddComponent2(entity_id, "LuaComponent", {
			-- script_source_file="data/scripts/animals/player_ai_movement2.lua",
			-- vm_type="ONE_PER_COMPONENT_INSTANCE",
			-- enable_coroutines=true,
			-- execute_on_added=true,
			-- execute_every_n_frame=-1,
			-- execute_times=1
		-- })
		-- EntityRemoveComponent(entity_id, GetUpdatedComponentID())
		-- coroutine.yield()
		-- return
	-- end
	
	local player = get_players()[1]

	if ( BiomeMapGetName() == "$biome_holymountain" and player > 0 ) then
		-- coroutine.yield()
		EntityRemoveComponent(entity_id, GetUpdatedComponentID())
		return
	end
	if target ~= nil then
		if(get_distance(targetX, targetY, x, y) >= 20)then
			if(get_distance(x, y - 3, targetPointX, targetPointY) < 5)then
				current_index = current_index + 1
				last_time_current_index_changed = GameGetFrameNum()
			end

			if last_time_current_index_changed and last_time_current_index_changed < GameGetFrameNum() - 180 then
				last_time_current_index_changed = GameGetFrameNum()
				-- -- local found = false
				-- -- local lua_comps = EntityGetComponent(entity_id, "LuaComponent") or {}
				
				-- -- for i, comp in ipairs(lua_comps) do
				  -- -- if ComponentGetValue2(comp, "script_source_file") == "data/scripts/animals/player_ai_movement2.lua" then
					-- -- found = true
					-- -- break
				  -- -- end
				-- -- end
				-- -- if not found then

					EntityAddComponent2(entity_id, "LuaComponent", {
						script_source_file="data/scripts/animals/player_ai_movement2.lua",
						-- vm_type="ONE_PER_COMPONENT_INSTANCE",
						-- enable_coroutines=true,
						execute_on_added=true,
						execute_every_n_frame=1,
						-- execute_times=1
					})
					-- EntitySetComponentIsEnabled( entity_id, GetUpdatedComponentID(), false )
					EntityRemoveComponent( entity_id, component_id )
					-- coroutine.yield()
					return
				-- -- end
				-- movement1()
				-- return
			end
			
			-- print(tostring(coroutine.running()))
		
			if(current_index > #path)then
			

				-- local range = 9999
				-- local target, targetX, targetY
				-- local min_dist = 9999
				-- for _,id in pairs(EntityGetInRadiusWithTag(x, y, range, "player_unit")) do
					-- -- is target a valid enemy
					-- if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
						-- local target_x, target_y = EntityGetFirstHitboxCenter( id )
						-- local dist = get_distance(x, y, target_x, target_y)
						-- if dist < min_dist then
							-- min_dist = dist
							-- target = id
							-- targetX = target_x
							-- targetY = target_y
						-- end
					-- end
				-- end

				path_true = FindPath( x, y, targetX, targetY, true, node_func, node_grid )
				if(path_true == nil)then
					movement1()
					return
				end
				
				path = path_true --SmoothPath(path_true)


				current_index = 1
			end

		end
	end
end
   -- GamePrint("Loop finished in "..tostring((GameGetRealWorldTimeSinceStarted() - time_start) * 1000).."ms")
    -- wait(0.01)
-- end)
--[[



]]