dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
	if EntityGetName(child_id) == "inventory_quick" then
		for i, child_id2 in ipairs(EntityGetAllChildren(child_id) or {}) do
			if EntityGetName(child_id2) == "wandage" then
				local EZWand = dofile("mods/new_enemies/files/EZWand.lua")
				local wand = EZWand(child_id2)

				if BiomeMapGetName( x, y ) == "$biome_excavationsite" then
					spells_to_choose_from = {
					"BUBBLESHOT",
					"SLOW_BULLET",
					"LIGHT_BULLET",
					"BOUNCY_ORB",
					"RUBBER_BALL",
					"SPITTER",
					"ARROW",
					"LASER",
					"BULLET",
					"SLIMEBALL",
					"FIREBOMB",
					"DISC_BULLET"
					}
				elseif BiomeMapGetName( x, y ) == "$biome_snowcave" then
					wand.castDelay = 20
					wand.rechargeTime = 21
					wand.manaMax = 200
					wand.mana = 200
					wand.manaChargeSpeed = 60
					spells_to_choose_from = {
					"LANCE",
					"HEAVY_BULLET_TRIGGER",
					"SPITTER_TIMER",
					"SPITTER_TIER_2",
					"SPITTER_TIER_2_TIMER",
					"BUBBLESHOT_TRIGGER",
					"BULLET_TRIGGER",
					"LIGHT_BULLET_TRIGGER",
					"ARROW",
					"LASER",
					"BULLET",
					"HEAVY_BULLET",
					"ROCKET",
					"GRENADE_TRIGGER",
					"BALL_LIGHTNING",
					"ROCKET",
					"BUCKSHOT",
					"DISC_BULLET"
					}
				elseif BiomeMapGetName( x, y ) == "$biome_rainforest" then
					wand.castDelay = 20
					wand.rechargeTime = 21
					wand.manaMax = 200
					wand.mana = 200
					wand.manaChargeSpeed = 60
					spells_to_choose_from = {
					-- "METEOR",
					"LANCE",
					"HEAVY_BULLET_TRIGGER",
					"LIGHTNING",
					"MEGALASER",
					"GRENADE_TIER_3",
					"GRENADE_TIER_2",
					"ROCKET_TIER_3",
					"ROCKET_TIER_2",
					"ROCKET",
					"FIREWORK",
					"SPITTER_TIER_3_TIMER",
					"SPITTER_TIER_2_TIMER"
					}
				elseif BiomeMapGetName( x, y ) == "$biome_vault" then
					wand.castDelay = 20
					wand.rechargeTime = 21
					wand.manaMax = 200
					wand.mana = 200
					wand.manaChargeSpeed = 60
					spells_to_choose_from = {
					-- "METEOR",
					"TENTACLE_TIMER",
					"LIGHTNING",
					"MEGALASER",
					-- "WORM_SHOT",
					"GRENADE_TIER_3",
					"GRENADE_TIER_2",
					"ROCKET_TIER_3",
					"ROCKET_TIER_2",
					"ROCKET",
					-- "DISC_BULLET_BIG",
					"SPITTER_TIER_3_TIMER",
					"SPITTER_TIER_2_TIMER",
					"LIGHT_BULLET_TRIGGER_2"
					}
				elseif BiomeMapGetName( x, y ) == "$biome_tower" or BiomeMapGetName( x, y ) == "$biome_crypt" then
					wand.castDelay = 5
					wand.rechargeTime = 21
					wand.manaMax = 500
					wand.mana = 500
					wand.manaChargeSpeed = 250
					spells_to_choose_from = {
					"METEOR",
					"TENTACLE_TIMER",
					"LIGHTNING",
					"MEGALASER",
					"ROCKET_TIER_3",
					"ROCKET_TIER_2",
					"DISC_BULLET_BIG",
					"SPITTER_TIER_3_TIMER",
					"SPITTER_TIER_2_TIMER",
					"LIGHT_BULLET_TRIGGER_2"
					}
				else
					spells_to_choose_from = {
					"BUBBLESHOT",
					"SLIMEBALL",
					"FIREBOMB",
					}
				end
				local random_index = Random(1, #spells_to_choose_from)
				wand:AddSpells(spells_to_choose_from[random_index], Random(1, 3))

				local number = Random(1, 300)

				if number < 25 then
					wand:SetSprite("data/items_gfx/flamethrower.xml", 2, 4, 10, 0)
				elseif number > 25 and number < 50 then
					wand:SetSprite("data/items_gfx/dronelauncher.xml", 1, 5, 9, 0)
				elseif number > 50 and number < 75 then
					wand:SetSprite("data/items_gfx/disc_gun.xml", 2, 4, 8, 0)
				elseif number > 75 and number < 100 then
					wand:SetSprite("data/items_gfx/rifle.xml", 2, 4, 10, 0)
				elseif number > 100 and number < 125 then
					wand:SetSprite("data/items_gfx/wand_3.xml", 2, 4, 11, 0)
				elseif number > 125 and number < 150 then
					wand:SetSprite("data/items_gfx/submachinegun.xml", 2, 4, 8, 0)
				elseif number > 150 and number < 175 then
					wand:SetSprite("data/items_gfx/shotgun.xml", 2, 4, 10, 0)
				elseif number > 175 and number < 200 then
					wand:SetSprite("data/items_gfx/wand_16.xml", 2, 4, 14, 0)
				elseif number > 200 and number < 225 then
					wand:SetSprite("data/items_gfx/cement_thrower.xml", 2, 4, 10, 0)
				elseif number > 225 and number < 250 then
					wand:SetSprite("data/items_gfx/desert_eagle.xml", 2, 4, 8, 0)
				elseif number > 250 and number < 275 then
					wand:SetSprite("data/items_gfx/building_gun.xml", 2, 4, 10, 0)
				elseif number > 275 and number < 300 then
					wand:SetSprite("data/items_gfx/digger.xml", 2, 4, 7, 0)
				end
				
				if BiomeMapGetName( x, y ) == "$biome_vault" or BiomeMapGetName( x, y ) == "$biome_rainforest" or BiomeMapGetName( x, y ) == "$biome_tower" then
					local number2 = Random(1, 7)
					if number2 == 1 then
						wand:SetSprite("data/items_gfx/grenadelauncher.xml", 2, 4, 15, 0)
					elseif number2 == 2 then
						wand:SetSprite("data/items_gfx/nukelauncher.xml", 2, 4, 16, 0)
					elseif number2 == 3 then
						wand:SetSprite("data/items_gfx/opgun.xml", 2, 4, 16, 0)
					elseif number2 == 4 then
						wand:SetSprite("data/items_gfx/pipe_launcher.xml", 2, 4, 14, 0)
					elseif number2 == 5 then
						wand:SetSprite("data/items_gfx/poisonwand.xml", 2, 4, 16, 0)
					elseif number2 == 6 then
						wand:SetSprite("data/items_gfx/pulserifle.xml", 1, 4, 16, 0)
					elseif number2 == 7 then
						wand:SetSprite("data/items_gfx/rocketlauncher.xml", 2, 4, 15, 0)
					end
				end
				
				if BiomeMapGetName( x, y ) == "$biome_crypt" then
				
					local number2 = Random(1, 100)
					
					if number2 > 0 and number2 < 50 then
						wand:SetSprite("data/items_gfx/decoy_wand.xml", 1, 4, 8, 0)
					elseif number2 > 50 and number2 < 100 then
						wand:SetSprite("data/items_gfx/decoy_wand2.xml", 2, 4, 7, 0)
					end
				end	
			end	
		end		
	end
end