dofile_once("data/scripts/lib/utilities.lua")

function collision_trigger(colliding_entity)

	local range = 15
	local projectile_velocity = 20
	local scatter = 0

	local entity_id = GetUpdatedEntityID()
	local pos_x, pos_y, rot, scale_x = EntityGetTransform(entity_id)

	local root_id = EntityGetRootEntity( entity_id )

	if scale_x == 1 then
		mandible_position = { x1 = 11, y1 = 5 }
	elseif scale_x == -1 then
		mandible_position = { x1 = -11, y1 = 5 }
	end

	local mandible_x, mandible_y = vec_rotate(mandible_position.x1, mandible_position.y1, rot)
	pos_x = pos_x + mandible_x
	pos_y = pos_y + mandible_y

	local old_scale_x = GetValueNumber("old_scale_x", scale_x)

	local turning = false
	
	local var_comp = get_variable_storage_component( entity_id, "grabbing" )
	local var_comp2 = get_variable_storage_component( entity_id, "damaging" )
	
	local grabbing = ComponentGetValue2(var_comp, "value_bool")

	if old_scale_x ~= scale_x then
		turning = true
		local found_normal = GetSurfaceNormal(pos_x, pos_y, 5, 16)
		if not found_normal and grabbing then
			EntitySetTransform(GetValueNumber("enemy_id", 0), pos_x, pos_y)
			SetValueNumber("enemy_id", 0)
		end
	end

	SetValueNumber("old_scale_x", scale_x)

	-- locate nearest enemy
	local enemy, enemy_x, enemy_y
	local min_dist = 15
	for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, range, "mortal")) do
		-- is target a valid enemy
		if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(root_id, id) < 40 then
			local x, y = EntityGetFirstHitboxCenter( id )
			local dist = get_distance(pos_x, pos_y, x, y)
			if dist < min_dist then
				min_dist = dist
				enemy = id
				enemy_x = x
				enemy_y = y
				SetValueNumber("enemy_id", enemy)
			end
		end
	end

	local found_normal2 = GetSurfaceNormal(pos_x, pos_y, 5, 16)

	-- check los
	local can_shoot = false
	if enemy then can_shoot = not found_normal2 end

	-- hand/shooting state & animation control
	-- edit_component2( entity_id, "SpriteComponent", function(comp,vars)
		-- -- if enemy is not visible then open hand
		-- local hand_open = ComponentGetValue2(comp, "rect_animation") == "stand"
		-- if not can_shoot then
			-- if not hand_open then
				-- ComponentSetValue2( comp, "rect_animation", "stand")
				-- --EntitySetComponentsWithTagEnabled( entity_id, "enabled_when_attacking", false )
			-- end
			-- return
		-- end

		-- -- prepare to shoot
		-- if hand_open then
			-- ComponentSetValue2( comp, "rect_animation", "attack")
			-- --EntitySetComponentsWithTagEnabled( entity_id, "enabled_when_attacking", true )
			-- can_shoot = false
			-- return
		-- end
	-- end)

	if ( not can_shoot ) then 
		local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
		local animation = ComponentGetValue2( sprite_component, "rect_animation")
		if animation ~= "release" then
			local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do
				ComponentSetValue2(comp, "rect_animation", "release")
				ComponentSetValue2(comp, "next_rect_animation", "release")
			end
			
			GamePlaySound("data/audio/Desktop/animals.bank", "animals/bloom/attack_shoot_buildup", pos_x, pos_y)
			-- EntityLoad( "data/entities/misc/manus_cell_eater.xml", pos_x , pos_y )
			ComponentSetValue2(var_comp2, "value_bool", true)
		end
		SetValueNumber("times", 0)
		ComponentSetValue2(var_comp, "value_bool", false)
		return 
	end

	-- direction
	local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
	vel_x,vel_y = vec_normalize(vel_x, vel_y)

	-- scatter
	SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
	vel_x,vel_y = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

	-- apply velocity & shoot
	vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)

	local distance = get_distance(pos_x, pos_y, enemy_x, enemy_y)

	local t = GetValueNumber("times", 0)

	if t >= 250 then SetValueNumber("times", 0) end

	if ( distance < range and enemy ) then
		
		SetValueNumber("times", t + 1)
		
		if t < 150 then
		
			--animation
			local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
			local animation = ComponentGetValue2( sprite_component, "rect_animation")
			if animation ~= "grab" then
				if ComponentGetValue2(var_comp2, "value_bool") == true then
					local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
					for i, comp in ipairs(sprite_comps) do
						ComponentSetValue2(comp, "rect_animation", "grab")
						ComponentSetValue2(comp, "next_rect_animation", "grab")
					end
				
					GamePlaySound("data/audio/Desktop/animals.bank", "animals/giant/attack_shoot", pos_x, pos_y)
					EntityInflictDamage( enemy, 0.5, "DAMAGE_SLICE", "", "BLOOD_EXPLOSION", 0, 0, root_id, pos_x, pos_y )
					ComponentSetValue2(var_comp2, "value_bool", false)
				end
				-- SetValueNumber("enemy_id", enemy)
				
			end

			-- pull target closer to anchor
			-- local center_x, center_y = EntityGetTransform(entity_id)
			
			-- local vx = center_x - enemy_x
			-- local vy = center_y - enemy_y

			-- -- prevent pulling into a wall by checking if glue center (parent) is inside platform
			-- local dist = get_magnitude(vx, vy)
			-- if dist < 8 or dist > 130 or RaytracePlatforms(center_x, center_y, center_x + 1, center_y) then
				-- --print("abort pull")
				-- return
			-- end

			-- -- calculate force
			-- local force = 0.08
			-- local age_factor = map(t, 0, 300, 1, 0.25) -- glue pull gets weaker over time
			-- vx, vy = vec_mult(vx, vy, force * age_factor)
			
			EntitySetTransform(enemy, pos_x, pos_y)
			ComponentSetValue2(var_comp, "value_bool", true)
		else
			local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
			local animation = ComponentGetValue2( sprite_component, "rect_animation")
			if animation ~= "release" then
				local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
				for i, comp in ipairs(sprite_comps) do
					ComponentSetValue2(comp, "rect_animation", "release")
					ComponentSetValue2(comp, "next_rect_animation", "release")
				end
				GamePlaySound("data/audio/Desktop/animals.bank", "animals/bloom/attack_shoot_buildup", pos_x, pos_y)
				ComponentSetValue2(var_comp2, "value_bool", true)
				
			end
			ComponentSetValue2(var_comp, "value_bool", false)
		end
	else
		local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
		local animation = ComponentGetValue2( sprite_component, "rect_animation")
		if animation ~= "release" then
			local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do
				ComponentSetValue2(comp, "rect_animation", "release")
				ComponentSetValue2(comp, "next_rect_animation", "release")
			end
			GamePlaySound("data/audio/Desktop/animals.bank", "animals/bloom/attack_shoot_buildup", pos_x, pos_y)
			ComponentSetValue2(var_comp2, "value_bool", true)
		end
		SetValueNumber("times", 0)
		ComponentSetValue2(var_comp, "value_bool", false)
	end

end