dofile_once( "data/scripts/lib/utilities.lua" )
-- dofile( "data/scripts/game_helpers.lua" )

local dash_velocity = 300

local entity_id = GetUpdatedEntityID()
local parent_id = EntityGetParent(entity_id)
local x, y, rot, scale_x  = EntityGetTransform(parent_id)

local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 300, "mortal")) do
    -- is target a valid enemy
    if parent_id ~= id  and (EntityGetHerdRelation(parent_id, id) < 40) and EntityGetParent(id) ~= parent_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)    then
        local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
        local dist = get_distance(x, y, entity_x, entity_y)
        if dist < min_dist then
            min_dist = dist
            enemy = id
            enemy_x = entity_x
            enemy_y = entity_y
        end
    end
end

--do nothing if there's no target

if not enemy then return end

if ( ( enemy_x < x and scale_x < 0 ) or ( enemy_x > x and scale_x > 0 ) ) then

	local force_decay = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
    --getting the direction to go to
    local var_comp = get_variable_storage_component( entity_id, "direction" )
    local dir = tonumber(ComponentGetValue2(var_comp, "value_float"))
    local force = 200 / ( force_decay + 1 )
    local force_x = math.cos(dir) * ( force )
    local dist_x = math.abs(enemy_x - x)
    local dist_y = math.abs(enemy_y - y)
    local force_y = math.sin(dir) * force * (dist_y / dist_x) * 1000
    
    local cdc_id = EntityGetFirstComponentIncludingDisabled(parent_id, "CharacterDataComponent")
    local velocity_x, velocity_y = ComponentGetValue2(cdc_id, "mVelocity")
    
    ComponentSetValueVector2(cdc_id, "mVelocity", velocity_x - force_x, velocity_y + force_y)
end