dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( GetUpdatedEntityID() )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local players = EntityGetInRadiusWithTag(x, y, 300, "player_unit")
local closestEntity = get_players()[1]

local ikcomp = EntityGetFirstComponent(entity_id, "IKLimbsAnimatorComponent")

local is_physics_ai_off = 0

if not ComponentGetValue2( ikcomp, "mHasGroundAttachmentOnAnyLeg" ) then
	EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", false)
	-- ComponentSetValue2(ikcomp, "no_ground_attachment_penalty_coeff", 0.75)
	is_physics_ai_off = 1
else
	-- ComponentSetValue2(ikcomp, "no_ground_attachment_penalty_coeff", 0.000000000000001)
	EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
end

--toggle cell eater
if is_physics_ai_off == 0 then
	if BiomeMapGetName() ~= "$biome_holymountain" and #players > 0 then
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
	else
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	end
else
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
end

local it_is_attack_frame = false

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 12 == 0 then
	it_is_attack_frame = true
end

--actual attacks
if #players > 0 and (EntityGetHerdRelation(entity_id, closestEntity) < 40) and it_is_attack_frame then

	local number = GetValueNumber("number", 0)
	SetValueNumber("number", number + 1)

	local player_x, player_y = EntityGetTransform(players[1])
	local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y, player_x, player_y)
	
	--Skull rain attack toggle
	-- if player_x > x - 200 and player_y < y + 300 and player_y > y and player_x < x + 200  and not did_hit then
	if number >= 2 then
		SetValueNumber("number", 0)
		if not did_hit then
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
			return
		end
	else
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		--animation
		local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do

			ComponentSetValue2(comp, "rect_animation", "stand")
			
		end
	end
	
	--Spawn skeleton or skull rat
	if not did_hit then
	
		for i=1, Random(1, 4) do

			local offsetx = Random(-6,6)
			local offsety = Random(-6,6)
			
			if Random(1,5) == 1 then
				e = EntityLoad( "data/entities/animals/skullrat.xml", x + offsetx, y + offsety )
			elseif Random(1,20) == 1 then
				e = EntityLoad( "data/entities/animals/skullfly.xml", x + offsetx, y + offsety )
			else
				e = EntityLoad( "data/entities/animals/skeleton.xml", x + offsetx, y + offsety )	
			end

			GenomeSetHerdId( e, "friendly" )
			
			-- local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
			-- EntityRemoveComponent(theEntity, animal_ai_component)
			
			-- EntityAddComponent2(player_id, "LuaComponent", {
				-- script_source_file="data/scripts/animals/desulitor_fly_ai_activator.lua",
				-- execute_every_n_frame=20,
				-- execute_on_added=false,
				-- remove_after_executed=true,
			-- }) 
			
			local vel_comp = EntityGetFirstComponentIncludingDisabled(e, "CharacterDataComponent")
			ComponentSetValue2(vel_comp, "mVelocity", Random(-400, 400), Random(0, 200))
			
		end
		
	end

end