function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

local old_average = GetValueNumber("average_rotation", 0)

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local found_normal, normal_x, normal_y, approximate_distance_from_surface = GetSurfaceNormal(x, y, 60, 16)
local dir = get_direction(0, 0, normal_x, normal_y)
local degree_shift = math.rad(-90) + dir -- 90 degree rotation to properly orient the entity
local new_average = approx_rolling_average(old_average, degree_shift, 5) -- if the number is higher than 5 the turning speed would be smoother and slower, if less it would be more instantaneous
SetValueNumber("average_rotation", new_average)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

if found_normal then
 EntitySetTransform(entity_id, x, y, new_average)
end

local parent_id = EntityGetParent( entity_id )
local crawler_component = EntityGetFirstComponentIncludingDisabled(parent_id, "CrawlerAnimalComponent")
local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")

if ( ComponentGetValue2( crawler_component, "speed" ) == 0 ) or ( ComponentGetValue2( crawler_component, "mPrevFalling" ) == 1 ) then
	ComponentSetValue2(sprite_component, "rect_animation", "stand")
	ComponentSetValue2(sprite_component, "next_rect_animation", "stand")
else
	ComponentSetValue2(sprite_component, "rect_animation", "walk")
	ComponentSetValue2(sprite_component, "next_rect_animation", "walk")
end
	
if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 60 == 0 then
	
	local random_number = Random(1,6)
	if random_number > 4 then
		-- if Random(1,2) ==  1 then

			-- ComponentSetValue2(crawler_component, "mDir", false)
			
		-- else
		
			-- ComponentSetValue2(crawler_component, "mDir", true)
			
		-- end
	elseif random_number == 1 then
		ComponentSetValue2(crawler_component, "speed", 0)
	elseif random_number == 2 then
		ComponentSetValue2(crawler_component, "speed", 1)
	elseif random_number == 3 then
		ComponentSetValue2(crawler_component, "speed", 2)
	elseif random_number == 4 then
		ComponentSetValue2(crawler_component, "speed", 3)
	end
end
