local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local found, nx, ny, apd = GetSurfaceNormal(x, y, 6, 6)
if found then
  nx = nx * (math.abs(apd) + 2)
  ny = ny * (math.abs(apd) + 2)
else
  nx = 0
  ny = 0
end

--Explode when there's more slimes than limit
local roller_count = 0

local nearby = EntityGetInRadiusWithTag(x, y, 300, "mortal")

for i, entity in ipairs(nearby) do

	if EntityGetName(entity) == "$slime_roller" then
	
		roller_count = roller_count + 1
		
	end
	
end

if roller_count > 7 then

	local slime_roller = EntityLoad("data/entities/animals/slime_roller.xml", x, y)
	
	EntityAddComponent(slime_roller, "VariableStorageComponent", {
		_tags="no_gold_drop",
    })

	local damage_model_component = EntityGetFirstComponentIncludingDisabled(slime_roller, "DamageModelComponent")

	if damage_model_component then
		
		ComponentSetValue2(damage_model_component, "hp", 0)
		ComponentSetValue2(damage_model_component, "air_needed", true)
		ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
		
	end
else
	EntityLoad("data/entities/animals/slime_roller.xml", x - nx, y - ny)
end

EntityKill(entity_id)

