dofile("data/scripts/lib/utilities.lua")

local MIN_ALPHA = 0.03
local MAX_ALPHA = 0.671429

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local sprite_comps = EntityGetComponentIncludingDisabled(entity_id,"SpriteComponent")
for i,comp_id in pairs(sprite_comps) do
	local path = ComponentGetValue2( comp_id, "image_file")
	if path == "data/enemies_gfx/spooky_ghost.xml" then
		sprite_comp_id = comp_id
	end
	if path == "data/enemies_gfx/spooky_ghost_emissive.xml" then
		emissive_comp_id = comp_id
	end
end

function set_alpha(sprite_id, player_distance, alpha_change_speed)

	local player_nearby = EntityGetInRadiusWithTag(x, y, player_distance, "player_unit")

	local alpha = ComponentGetValue2(sprite_id, "alpha")

	--Note: The invisibility game effect does not make certain creatures invisible, one of which is this Spooky Ghost. So we adjust the sprite's alpha instead.
	if #player_nearby == 0 and alpha > MIN_ALPHA then
		alpha = math.max(alpha-alpha_change_speed, MIN_ALPHA)
		ComponentSetValue2(sprite_id, "alpha", alpha)
	elseif #player_nearby > 0 and alpha < MAX_ALPHA then
		alpha = math.min(alpha+alpha_change_speed, MAX_ALPHA)
		ComponentSetValue2(sprite_id, "alpha", alpha)
	end
	
end

set_alpha(sprite_comp_id, 70, 0.045)
set_alpha(emissive_comp_id, 11, 0.09)