dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)
local x, y = EntityGetFirstHitboxCenter( entity_id )

local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 100, "mortal")) do
	-- is target a valid enemy
	if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, entity_x, entity_y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = entity_x
			enemy_y = entity_y
		end
	end
end

local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")

if not enemy then 
	return 
end

local did_hit, hit_x, hit_y = RaytracePlatforms(x, y , enemy_x, enemy_y)

local character_data_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")

--Make sure to not interrupt a ranged attack (state 15)
local state = ComponentGetValue2(animal_ai_component, "ai_state")
local difference = math.abs(15 - state)

if not did_hit and ( ComponentGetValue2(character_data_comp, "is_on_ground") or ComponentGetValue2(character_data_comp, "is_on_slippery_ground") ) and not ( difference < 0.0001 ) then
	ComponentSetValue2( animal_ai_component, "ai_state", 5 ) --set ai state to prepare a jump
	distance = get_distance(x, y, enemy_x, enemy_y)
	max_distance = 3
	if distance > max_distance then
	  local direction = get_direction(x, y, enemy_x, enemy_y)
	  enemy_x = enemy_x + math.cos(direction) * max_distance
	  enemy_y = enemy_y + math.sin(direction) * max_distance
	end
	ComponentSetValue2( animal_ai_component, "mNextJumpTarget", enemy_x, enemy_y ) --set jump target
	ComponentSetValue2( animal_ai_component, "mNextJumpHasVelocity", false ) --prevent enemy from jumping 40 meters into the sky (no idea why it happens)
else
	ComponentSetValue2( animal_ai_component, "ai_state", 18 ) -- set ai state to normal
end

-- SetRandomSeed(x + GameGetFrameNum(), y)
-- ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 10 + Random(140))
