dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/game_helpers.lua" )

local theEntity = GetUpdatedEntityID()
local players = get_players()
local player_x, player_y, player_scale_x = 0, 0, 1

local animal_ai_component = EntityGetFirstComponentIncludingDisabled(theEntity, "AnimalAIComponent")
local physics_body_component = EntityGetFirstComponentIncludingDisabled(theEntity, "PhysicsBodyComponent")
local sprite_component = EntityGetFirstComponentIncludingDisabled(theEntity, "SpriteComponent")
local hitbox_component = EntityGetFirstComponentIncludingDisabled(theEntity, "HitboxComponent")

local character_data_component = EntityGetFirstComponent(theEntity, "CharacterDataComponent")
local vel_x, vel_y = ComponentGetValueVector2(character_data_component, "mVelocity")

local physics_vel_x, physics_vel_y = PhysicsGetComponentVelocity( theEntity, physics_body_component )

function disable()
    EntityRemoveComponent(theEntity, animal_ai_component)
    EntitySetComponentIsEnabled( theEntity, sprite_component, false )
    EntitySetComponentIsEnabled( theEntity, hitbox_component, false )
    EntitySetComponentIsEnabled( theEntity, physics_body_component, true )
    PhysicsApplyForce(theEntity, vel_x * 4 , vel_y * 4 )
end

function reenable()
  if not animal_ai_component then
    EntityAddComponent(theEntity, "AnimalAIComponent", {
            preferred_job="JobDefault",
            escape_if_damaged_probability="0",
            attack_melee_damage_min="0.4",
            attack_melee_damage_max="0.8",
            attack_melee_action_frame="2",
            attack_dash_enabled="1",
            attack_dash_distance="200",
            creature_detection_range_x="250",
            creature_detection_range_y="250",
            food_material="meat",
            needs_food="0",
            sense_creatures="1",
            attack_ranged_enabled="0",
            can_fly="0",
            defecates_and_pees="0",
    })
	
	EntitySetComponentIsEnabled( theEntity, sprite_component, true )
	EntitySetComponentIsEnabled( theEntity, hitbox_component, true )
	EntitySetComponentIsEnabled( theEntity, physics_body_component, false )
	
	ComponentSetValue2(character_data_component, "mVelocity", physics_vel_x * 20, physics_vel_y * 20 )
	
  end
end

if #players > 0 then
  player_x, player_y, succ, player_scale_x = EntityGetTransform(players[1])
end

local x, y = EntityGetTransform( theEntity )
local looking_at_crab = (player_x > x and player_scale_x < 0) or (player_x < x and player_scale_x > 0)

if looking_at_crab and animal_ai_component then
  if math.abs(vel_x) <= 16 and math.abs(vel_y) <= 16 then
    disable()
  end
elseif not looking_at_crab and not animal_ai_component then
  reenable()
end
