dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x,y,rot = EntityGetTransform( entity_id )

function get_direction( x1, y1, x2, y2 )
    return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local old_x = GetValueNumber("old_x", x)
local old_y = GetValueNumber("old_y", y)

local angle = get_direction(x, y, old_x, old_y)

SetValueNumber("old_x",x)
SetValueNumber("old_y",y)

GamePlaySound("data/audio/Desktop/materials.bank", "materials/electric_spark", x, y)

for i=1, 3 do
	
	SetRandomSeed( x , y + GameGetFrameNum() )
	
	dir = angle + math.rad( Random( -20, 20 ) ) + 180

	local length = 400
	local vel_x = math.cos( dir ) * length
	local vel_y = math.sin( dir ) * length

	local target_x = x + math.cos(dir) * 20
	local target_y = y + math.sin(dir) * 20

	local projectile
	local rng = Random(1, 35)
	if rng < 15 then
	  projectile = "data/entities/projectiles/tardigrade_water.xml"
	elseif rng < 25 then
	  projectile = "data/entities/projectiles/tardigrade_slime.xml"
	elseif rng < 30 then
	  projectile = "data/entities/projectiles/tardigrade_sand.xml"
	else
	  projectile = "data/entities/projectiles/tardigrade_glue_shot.xml"
	end

	shoot_projectile( entity_id, projectile, target_x, target_y, vel_x, vel_y )
end