local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

local phys2 = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBody2Component")

local is_offscreen = false

local cbx, cby, cbw, cbh = GameGetCameraBounds()
if ( ( x < cbx ) or ( x > cbx + cbw ) or ( y < cby ) or ( y > cby + cbh ) ) then
	is_offscreen = true
	if ( phys2 ~= nil ) and ( phys2 > 0 ) then
		ComponentSetValue2( phys2, "kill_entity_if_body_destroyed", false )
	end
else
	if ( phys2 ~= nil ) and ( phys2 > 0 ) then
		ComponentSetValue2( phys2, "kill_entity_if_body_destroyed", true )
	end
end

if ( not ( ( phys2 ~= nil ) and ( phys2 > 0 ) ) ) and is_offscreen then
	local new_ent = EntityLoad( EntityGetFilename( entity_id ), x, y )
	
	local who_shot_damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
	local who_spawned_damage_model_component = EntityGetFirstComponentIncludingDisabled( new_ent, "DamageModelComponent" )

	local hp = ComponentGetValue2(who_shot_damage_model_component, "hp")
	local max_hp = ComponentGetValue2(who_shot_damage_model_component, "max_hp")
	local minimum_knockback_force = ComponentGetValue2(who_shot_damage_model_component, "minimum_knockback_force")

	if max_hp and hp then
		if hp <= 0 then
			EntityKill(new_ent)
			return
		end
		ComponentSetValue2( who_spawned_damage_model_component, "minimum_knockback_force", minimum_knockback_force )
		ComponentSetValue2( who_spawned_damage_model_component, "max_hp", max_hp )
		ComponentSetValue2( who_spawned_damage_model_component, "hp", hp )
		
	end
	
	EntityKill(entity_id)
	return
end

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

	local game_effect_component = EntityGetFirstComponentIncludingDisabled(child_id, "GameEffectComponent")
	
	if game_effect_component and EntityGetName(child_id) ~= "important" then
	
		EntityKill(child_id)
		
	end
	
	

end

local comp_ids  = EntityGetComponent( entity_id, "PhysicsJoint2MutatorComponent" )

-- local pers = GetValueNumber( "a", 1.0 )
-- SetValueNumber( "a", pers + 1.0 )
-- print( tostring( pers ) )

local dir    = 1.0
local offset = 0.5
local i      = 0
if( comp_ids ~= nil ) then
	for index,joint in ipairs(comp_ids) do
	if index % 2 == 0 then
		local time = GameGetFrameNum() / 60.0
		ComponentSetValue2( joint, "motor_speed", ( math.sin(offset + time * 1.0) * 5.0 * dir ) * -1)
		ComponentSetValue2( joint, "motor_max_torque", 1.0 )

		dir = dir * -1.0
		i = i + 1
		if i == 4 then
			offset = offset + 0.5
			i = 0
		end
	else
		local time = GameGetFrameNum() / 60.0
		ComponentSetValue2( joint, "motor_speed", math.sin(offset + time * 1.0) * 5.0 * dir )
		ComponentSetValue2( joint, "motor_max_torque", 1.0 )

		dir = dir * -1.0
		i = i + 1
		if i == 4 then
			offset = offset + 0.5
			i = 0
		end
	end
	end
end

if ( phys2 ~= nil ) and ( phys2 > 0 ) then
	local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
	local targ_x, targ_y = ComponentGetValueVector2(pathfinding_component, "path_next_node_vector_to")
	local pixcount = ComponentGetValue2(phys2, "mPixelCount")
	PhysicsApplyForce( entity_id, targ_x * pixcount/100, targ_y * pixcount/100)

	dofile_once("data/scripts/lib/utilities.lua")
	if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 4 == 0 then
		local physics_bodies = PhysicsBodyIDGetFromEntity( entity_id, phys2 )
		for i, body_id in ipairs(physics_bodies or {}) do
			if i == #physics_bodies and ( #physics_bodies > 2 ) then
				bx, by, bangle, bvel_x, bvel_y, bangular_vel = PhysicsBodyIDGetTransform( body_id )
				bx, by = PhysicsPosToGamePos( bx, by )
				local wanted_x, wanted_y = vec_rotate(2, 5, bangle)
				wanted_x = bx + wanted_x
				wanted_y = by + wanted_y
				EntityLoad( "data/entities/particles/tentacle_boss_portal.xml", wanted_x, wanted_y )
			end
		end
	end
end