dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

EntityAddComponent2(entity_id, "PhysicsBody2Component", { 
	is_static=false,
	allow_sleep=true,
	angular_damping=0.01,
	linear_damping=0.5,
	fixed_rotation=false,
	is_bullet=false,
	init_offset_y=0,
	-- manual_init=true
})

EntityAddComponent2(entity_id, "PhysicsImageShapeComponent", { 
	body_id=100,
	offset_x=-12,
	offset_y=-7,
	image_file="data/enemies_gfx/slimeboss_tentacle__0.png",
	material=CellFactory_GetType("gold_box2d_boss"),
	z=-1
})

EntityAddComponent2(entity_id, "PhysicsImageShapeComponent", { 
	body_id=101,
	offset_x=-12,
	offset_y=-4,
	image_file="data/enemies_gfx/slimeboss_tentacle_0.png",
	material=CellFactory_GetType("gold_box2d_boss"),
	z=-0.9
})

EntityAddComponent2(entity_id, "PhysicsJoint2Component", { 
	type="REVOLUTE_JOINT",
	joint_id=1,
	offset_x=13,
	offset_y=0,
	body1_id=100,
	body2_id=101,
	break_force=0,
	break_distance=0
})

EntityAddComponent2(entity_id, "PhysicsJoint2MutatorComponent", { 
	joint_id=1,
	motor_speed=0,
	motor_max_torque=10
})

EntityAddComponent2(entity_id, "PhysicsImageShapeComponent", { 
	body_id=102,
	offset_x=-12,
	offset_y=-4,
	image_file="data/enemies_gfx/slimeboss_tentacle_1.png",
	material=CellFactory_GetType("gold_box2d_boss"),
	z=-0.8
})

EntityAddComponent2(entity_id, "PhysicsJoint2Component", { 
	type="REVOLUTE_JOINT",
	joint_id=2,
	offset_x=-11,
	offset_y=0,
	body1_id=101,
	body2_id=102,
	break_force=0,
	break_distance=0
})

EntityAddComponent2(entity_id, "PhysicsJoint2MutatorComponent", { 
	joint_id=2,
	motor_speed=0,
	motor_max_torque=10
})

EntityAddComponent2(entity_id, "PhysicsImageShapeComponent", { 
	body_id=103,
	offset_x=-12,
	offset_y=-4,
	image_file="data/enemies_gfx/slimeboss_tentacle_2.png",
	material=CellFactory_GetType("gold_box2d_boss"),
	z=-0.7
})

EntityAddComponent2(entity_id, "PhysicsJoint2Component", { 
	type="REVOLUTE_JOINT",
	joint_id=3,
	offset_x=13,
	offset_y=0,
	body1_id=102,
	body2_id=103,
	break_force=0,
	break_distance=0
})

EntityAddComponent2(entity_id, "PhysicsJoint2MutatorComponent", { 
	joint_id=3,
	motor_speed=0,
	motor_max_torque=10
})

-----TENTACLE LAID NOW TO ADD PORTAL CHILD----------------


local portal = EntityLoad( "data/entities/particles/tentacle_boss_portal.xml", pos_x, pos_y )
local dummy_body = PhysicsAddBodyImage( portal, "data/enemies_gfx/slimeboss_tentacle_dummy.png", "gold_box2d_boss", - 2, - 2 )
-- local boss_body = PhysicsAddBodyImage( entity_id, "data/enemies_gfx/slimeboss_tentacle_dummy.png", "gold_box2d_boss", - 2, - 2 )
PhysicsAddJoint( portal, 1, -1, 0, 0, "WELD_JOINT" )
-- PhysicsAddJoint( entity_id, 100, dummy_body, 0, 0, "WELD_JOINT" )

-- EntityAddChild(entity_id, portal)
-- local phys_body2 = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBody2Component")
-- physicsbody_val = ComponentGetValue(phys_body2, "mBodyId")
-- GamePrint(physicsbody_val)
-- physicsbody_val2 = ComponentGetValue(phys_body2, "mBody")
-- GamePrint(physicsbody_val2)
-- local image_shape = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsImageShapeComponent")
-- local physicsbodyimage_alt = EntityGetFirstComponentIncludingDisabled( entity_id, "PhysicsImageShapeComponent", "enabled_in_world" )
-- GamePrint(image_shape)
-- GamePrint(physicsbodyimage_alt)
-- ComponentSetValue2(image_shape, "is_root", false)
-- ComponentSetValue2(physicsbodyimage_alt, "is_root", true)

-- physicsbody_val3 = ComponentGetValue(image_shape, "mBody")
-- GamePrint(physicsbody_val3)
-- local joint_val = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsJoint2Component")
-- physicsbody_val4 = ComponentGetValue(joint_val, "joint_id")
-- GamePrint(physicsbody_val4)

-- local joint_val2 = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsJoint2MutatorComponent")
-- physicsbody_val5 = ComponentGetValue(joint_val2, "mBox2DJointId")
-- GamePrint(physicsbody_val5)

-- EntityAddComponent2(portal, "PhysicsBody2Component", {
	-- is_static=false,
	-- allow_sleep=true,
	-- angular_damping=0.01,
	-- linear_damping=0.5,
	-- fixed_rotation=false,
	-- is_bullet=false,
	-- init_offset_y=0,
	-- -- manual_init=true,
	-- kill_entity_after_initialized=false,
	-- kill_entity_if_body_destroyed=true,
	-- mBodyId=tonumber(physicsbody_val),
	-- mBody=tonumber(physicsbody_val2)
-- })

-- EntityAddComponent(portal, "PhysicsBody2Component", {
	-- is_static="0",
	-- allow_sleep="0",
	-- angular_damping="0.01",
	-- linear_damping="0.5",
	-- fixed_rotation="0",
	-- is_bullet="0",
	-- init_offset_y="0",
	-- kill_entity_after_initialized="0",
	-- kill_entity_if_body_destroyed="1",
	-- mBodyId=physicsbody_val,
	-- mBody=physicsbody_val2
-- })

-- EntityAddComponent2(portal, "PhysicsImageShapeComponent", {
	-- z=1,
	-- body_id=99,
	-- centered=false,
	-- is_root=true,
	-- image_file="data/enemies_gfx/slimeboss_tentacle_dummy.png",
	-- material=CellFactory_GetType("gold_box2d_boss"),
	-- mBody=tonumber(physicsbody_val3)
-- })

-- EntityAddComponent(portal, "PhysicsImageShapeComponent", {
	-- z="1",
	-- body_id="105",
	-- centered="0",
	-- is_root="1",
	-- image_file="data/enemies_gfx/slimeboss_tentacle_dummy.png",
	-- material="gold_box2d_boss",
	-- mBody=physicsbody_val3
-- })

-- EntityAddComponent2(portal, "PhysicsJoint2Component", {
	-- type="WELD_JOINT",
	-- break_force=0,
	-- break_distance=0,
	-- body1_id=99,
	-- body2_id=100,
	-- offset_x=0,
	-- offset_y=0,
	-- joint_id=tonumber(physicsbody_val4)
-- })

-- EntityAddComponent(portal, "PhysicsJoint2Component", {
	-- type="WELD_JOINT",
	-- break_force="0",
	-- break_distance="0",
	-- body1_id="100",
	-- body2_id="105",
	-- offset_x="0",
	-- offset_y="0",
	-- joint_id=physicsbody_val4
-- })

-- EntityAddComponent2(portal, "PhysicsJoint2MutatorComponent", {
	-- mBox2DJointId=tonumber(physicsbody_val5),
	-- joint_id=1,
	-- motor_speed=0,
	-- motor_max_torque=0
-- })

-- EntityAddComponent(portal, "PhysicsJoint2MutatorComponent", {
	-- mBox2DJointId=physicsbody_val5,
	-- joint_id="1",
	-- motor_speed="0",
	-- motor_max_torque="0"
-- })


----------TO CONTINUE LAYING THE REST OF THE TENTACLE. Attempt to fool the system-----------
EntityAddComponent2(entity_id, "PhysicsImageShapeComponent", {
	is_root=true,
	centered=true,
	body_id=104,
	offset_x=-10,
	offset_y=-1,
	image_file="data/enemies_gfx/slimeboss_tentacle_3.png",
	material=CellFactory_GetType("gold_box2d_boss"),
	z=-0.6
})

EntityAddComponent2(entity_id, "PhysicsJoint2Component", {
	type="REVOLUTE_JOINT",
	joint_id=4,
	offset_x=-11,
	offset_y=0,
	body1_id=103,
	body2_id=104,
	break_force=0,
	break_distance=0
})

EntityAddComponent2(entity_id, "PhysicsJoint2MutatorComponent", {
	joint_id=4,
	motor_speed=0,
	motor_max_torque=10
})