--Rotation

dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local x, y, r = EntityGetTransform(entity_id)

local variable_storage = EntityGetComponent(entity_id, "VariableStorageComponent")

local aim_direction = {x = 0, y = 0}

local players = EntityGetWithTag("player_unit")

if #players > 0 then

	local player_x, player_y = EntityGetTransform(players[1])

	local direction_x, direction_y = player_x - x, player_y - y

	local len = math.sqrt((direction_x*direction_x) + (direction_y*direction_y))

	aim_direction.x, aim_direction.y = direction_x / len, direction_y / len

	local phys_body = EntityGetFirstComponent(entity_id, "PhysicsBodyComponent")

	local ang_vel = PhysicsGetComponentAngularVelocity( entity_id, phys_body )

	function angle_rad(direction)
		return math.atan2(direction.y,direction.x)
	end

	function get_torque(current_angle, target_angle, speed)
		-- Make angle go from 0 to 2pi
		if target_angle < 0 then
		  target_angle = target_angle + math.pi * 2
		end
		if current_angle < 0 then
		  current_angle = current_angle + math.pi * 2
		end
	  
		local dist_up = math.abs(target_angle - current_angle)
		local dist_down = math.abs((current_angle + math.pi * 2) - target_angle)
		
		if current_angle > target_angle then
		  dist_up = math.abs((target_angle + math.pi * 2) - current_angle)
		  dist_down = math.abs(current_angle - target_angle)
		end
		
		local dir
		if math.abs(dist_up) < math.abs(dist_down) then
		  dir = 1
		else
		  dir = -1
		end
		local dist_smallest = dist_up
		if dist_down < dist_up then
		  dist_smallest = dist_down
		end
	  
		local new_angle = speed * dir

		return new_angle
	end

	PhysicsApplyTorque( entity_id, -ang_vel * 10 )

	PhysicsApplyTorque( entity_id, get_torque(r, angle_rad(aim_direction), 5) * 10 )

end

--Move out of Wall:

-- local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")

-- local inside_wall, hit_x, hit_y = RaytracePlatforms(x, y, x, y )

-- local found, nx, ny, apd = GetSurfaceNormal(x, y, 16, 16)
-- if found then
  -- nx = nx * (math.abs(apd) + 2)
  -- ny = ny * (math.abs(apd) + 2)
-- else
  -- nx = 0
  -- ny = 0
-- end

-- if inside_wall then
	-- EntitySetComponentIsEnabled( entity_id, physics_body_component, false )
	-- EntitySetTransform(entity_id, x - nx, y - ny)
-- end

-- EntitySetComponentIsEnabled( entity_id, physics_body_component, true )