dofile_once( "data/scripts/lib/utilities.lua" )

function collision_trigger( colliding_entity_id  )

	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- position reseter
	
	if EntityHasTag( colliding_entity_id, "pitcheck_b" ) then
	
		local lua_comps = EntityGetComponent(entity_id, "LuaComponent") or {}

		EntityAddComponent( entity_id, "LuaComponent", 
		{ 
			script_source_file="data/scripts/animals/train_start_long.lua",
			execute_every_n_frame = "400"
		} )
		
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		EntitySetComponentsWithTagEnabled(entity_id, "character", false)
		
		EntitySetTransform( entity_id, x - 735, y )

		for i, comp in ipairs(lua_comps) do
				
			if ComponentGetValue2(comp, "script_source_file") == "data/scripts/animals/train_move.lua" then
			
				EntityRemoveComponent( entity_id, comp )
				
			end
			
		end

	end
	
	--Impact
	
	if EntityHasTag( colliding_entity_id, "mortal" ) then
	
		for i, child_id in ipairs(EntityGetAllChildren(colliding_entity_id) or {}) do
		
			local effect_comps = EntityGetComponent(child_id, "GameEffectComponent") or {}
			
			for i, comp in ipairs(effect_comps) do
					
				if ComponentGetValue2(comp, "effect") == "PROTECTION_EXPLOSION" then
				
					EntitySetComponentIsEnabled( child_id, comp, false )
					
					explosion_checker_found = false
					
					local lua_comps = EntityGetComponent(child_id, "LuaComponent") or {}
					
					for i, lua_comp in ipairs(lua_comps) do
							
						if ComponentGetValue2(lua_comp, "script_source_file") == "data/scripts/animals/train_explosion_immunity_checker.lua" then
						
							explosion_checker_found = true
							break
							
						end
						
					end
					
					if explosion_checker_found == false then

						EntityAddComponent(child_id, "LuaComponent", {
							script_source_file="data/scripts/animals/train_explosion_immunity_checker.lua",
							execute_every_n_frame=5,
							execute_on_added=0,
						}) 
					
					end
					
				end
				
			end

		end

		EntityLoad( "data/entities/misc/train_impact.xml", x, y )
		
		local cdc_id = EntityGetFirstComponentIncludingDisabled(colliding_entity_id, "CharacterDataComponent")
		
		if ( cdc_id ~= nil ) and ( cdc_id > 0 ) then
			local velocity_x, velocity_y = ComponentGetValue2(cdc_id, "mVelocity")
			ComponentSetValueVector2(cdc_id, "mVelocity", 1600, velocity_y)
		end
	end
	
end