dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/status_effects/status_list_custom.lua")

function kill_child(entity)
	EntityRemoveFromParent( entity )
	local root_children = EntityGetAllChildren(entity)
	if ( root_children ~= nil ) and ( #root_children > 0 ) then
		root_child = root_children[1]
	end
	if ( root_child ~= nil ) and ( root_child > 0 ) then
		EntityRemoveFromParent( root_child )
		update_statuses(entity, root_child)		
			
		kill_entity(root_child)
	end
end

function kill_entity(entity)
	EntityAddComponent(entity, "VariableStorageComponent", {
		_tags="no_gold_drop",
	})
	
	EntityAddComponent( entity, "LuaComponent", 
	{ 
		script_source_file="data/scripts/animals/twig_death.lua",
		execute_every_n_frame = "10",
	} )
end

-- function get_root_child(entity)
    -- local children = EntityGetAllChildren(entity)
    -- for i, child_id in ipairs(children or {}) do
        -- if EntityGetName(child_id) == "$twig" then
            -- return get_root_child(child_id)
        -- end
    -- end
    -- if EntityGetName(entity) == "$twig" then
        -- return entity
    -- end
-- end

-- function apply_statuses_to_all_parents(entity1, entity2)
    -- local parent = EntityGetParent(entity2)
    -- if ( parent ~= nil ) and ( parent > 0 ) then
		-- update_statuses(entity1, entity2)
		-- return apply_statuses_to_all_parents(parent)
    -- end
-- end

function update_statuses(entity1, entity2)
	if ( ( entity1 ~= nil ) and ( entity1 > 0 ) ) and ( ( entity2 ~= nil ) and ( entity2 > 0 ) ) then
		-- local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity1, "DamageModelComponent")
		-- if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
			-- local ragdollfx = ComponentGetValue2(damage_model_component, "ragdoll_fx_forced")
			-- local damage_model_component2 = EntityGetFirstComponentIncludingDisabled(entity2, "DamageModelComponent")
			-- if ( damage_model_component2 ~= nil ) and ( damage_model_component2 > 0 ) then
				-- ComponentSetValue2(damage_model_component2, "ragdoll_fx_forced", ragdollfx)
				-- GamePrint(ragdollfx)
			-- end
		-- end
		for _, effect in pairs(status_effects) do
			-- GamePrint(tostring(GameGetGameEffectCount(entity_id, effect.id)))
			
			if GameGetGameEffectCount(entity1, effect.id) > 0 then
				-- GamePrint(tostring(entity_id).. " "..tostring(parent_id).. " "..tostring(effect.id).. " "..tostring(GameGetGameEffectCount(entity_id, effect.id)))
				if GameGetGameEffectCount(entity2, effect.id) <= 1 then
					local effect_id = LoadGameEffectEntityTo( entity2, effect.effect_entity )
					local game_effect_component = EntityGetFirstComponentIncludingDisabled(effect_id, "GameEffectComponent")
					ComponentSetValue2(game_effect_component, "ragdoll_effect_custom_entity_file", effect.ragdoll_entity)
					-- GamePrint("yes")
					if effect.ragdoll_material ~= "" then
						ComponentSetValue2(game_effect_component, "ragdoll_material", CellFactory_GetType( effect.ragdoll_material ) )
					end
				end
			end
			
		end
		
		local do_procedure = true
		for i, child_id in ipairs(EntityGetAllChildren(entity1) or {}) do

			local game_effect_components = EntityGetComponentIncludingDisabled(child_id, "GameEffectComponent")
			
			for i, game_effect_component in ipairs(game_effect_components or {}) do
				if ComponentGetValue2(game_effect_component, "effect") == "CUSTOM" then 
					if GameGetGameEffectCount(entity2, "CUSTOM") <= 1 then
					-- local effect_id_val = ComponentGetValue2(game_effect_component, "custom_effect_id")
					-- for i, child_id2 in ipairs(EntityGetAllChildren(entity1) or {}) do

						-- local game_effect_components2 = EntityGetComponentIncludingDisabled(child_id2, "GameEffectComponent")

						-- for i, game_effect_component2 in ipairs(game_effect_components2 or {}) do
							-- if ComponentGetValue2(game_effect_component2, "custom_effect_id") == effect_id_val then
								-- do_procedure = false
							-- end
						-- end
					-- end
					-- if do_procedure == true then
						local effect_id = LoadGameEffectEntityTo( entity2, "data/entities/misc/effect_template.xml" )
						local game_effect_component2 = EntityGetFirstComponentIncludingDisabled(effect_id, "GameEffectComponent")
						ComponentSetValue2(game_effect_component2, "custom_effect_id", ComponentGetValue2(game_effect_component, "custom_effect_id") )
						ComponentSetValue2(game_effect_component2, "ragdoll_effect_custom_entity_file", ComponentGetValue2(game_effect_component, "ragdoll_effect_custom_entity_file") )
						ComponentSetValue2(game_effect_component2, "ragdoll_effect", ComponentGetValue2(game_effect_component, "ragdoll_effect") )
						ComponentSetValue2(game_effect_component2, "ragdoll_material", ComponentGetValue2(game_effect_component, "ragdoll_material") )
					-- end
					end
				end
				if ComponentGetValue2(game_effect_component, "effect") == "NONE" then 
					if GameGetGameEffectCount(entity2, "NONE") <= 1 then
					-- local effect_id_val = ComponentGetValue2(game_effect_component, "custom_effect_id")
					-- for i, child_id2 in ipairs(EntityGetAllChildren(entity1) or {}) do

						-- local game_effect_components2 = EntityGetComponentIncludingDisabled(child_id2, "GameEffectComponent")

						-- for i, game_effect_component2 in ipairs(game_effect_components2 or {}) do
							-- if ComponentGetValue2(game_effect_component2, "custom_effect_id") == effect_id_val then
								-- do_procedure = false
							-- end
						-- end
					-- end
					-- if do_procedure == true then
						local effect_id = LoadGameEffectEntityTo( entity2, "data/entities/misc/effect_template.xml" )
						local game_effect_component2 = EntityGetFirstComponentIncludingDisabled(effect_id, "GameEffectComponent")
						ComponentSetValue2(game_effect_component2, "custom_effect_id", ComponentGetValue2(game_effect_component, "custom_effect_id") )
						ComponentSetValue2(game_effect_component2, "ragdoll_effect_custom_entity_file", ComponentGetValue2(game_effect_component, "ragdoll_effect_custom_entity_file") )
						ComponentSetValue2(game_effect_component2, "ragdoll_effect", ComponentGetValue2(game_effect_component, "ragdoll_effect") )
						ComponentSetValue2(game_effect_component2, "ragdoll_material", ComponentGetValue2(game_effect_component, "ragdoll_material") )
					-- end
					end
				end
			end
			
		end
	end
end

function damage_received( damage, message, entity_thats_responsible, is_fatal  )

	if(is_fatal == true)then
		local entity_id = GetUpdatedEntityID()
		local parent_id = EntityGetParent(entity_id)
		-- local root_id = EntityGetRootEntity( parent_id )
		-- update_statuses(entity_id, root_id)
		update_statuses(entity_id, parent_id)
		-- apply_statuses_to_all_parents(entity_id, parent_id)
		kill_child(entity_id)

		
		if ( parent_id ~= nil ) and ( parent_id > 0 ) then
			-- local root_parent = get_root_child(root_id)
			
			-- local rx2, ry2 = EntityGetTransform(root_parent)
			-- GameCreateSpriteForXFrames("data/debug/sui_close_button.png", rx2, ry2, true, 0, 0, 200, true)
			
			-- if ( root_parent ~= nil ) and ( root_parent > 0 ) then
				update_statuses(entity_id, parent_id)
				-- GamePrint(tostring(entity_id) .. " " .. tostring(root_parent))
				kill_entity(parent_id)
			-- end
		end
	end
end