dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity( entity_id )
local x,y = EntityGetTransform( root_id )
local trueangle = 0
local angle = 0

--Check Nearest Enemy
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 200, "mortal")) do
	-- is target a valid enemy
	if root_id ~= id  and (EntityGetHerdRelation(root_id, id) < 40) and EntityGetParent(id) ~= root_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local hx, hy = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, hx, hy)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = hx
			enemy_y = hy
		end
	end
end

function move_angle_towards(current_angle, target_angle, speed)
  -- Make angle go from 0 to 2pi
  if target_angle < 0 then
    target_angle = target_angle + math.pi * 2
  end
  if current_angle < 0 then
    current_angle = current_angle + math.pi * 2
  end

  local dist_up = math.abs(target_angle - current_angle)
  local dist_down = math.abs((current_angle + math.pi * 2) - target_angle)
  if current_angle > target_angle then
    dist_up = math.abs((target_angle + math.pi * 2) - current_angle)
    dist_down = math.abs(current_angle - target_angle)
  end
  
  local dir
  if math.abs(dist_up) < math.abs(dist_down) then
    dir = 1
  else
    dir = -1
  end
  local dist_smallest = dist_up
  if dist_down < dist_up then
    dist_smallest = dist_down
  end

  local new_angle = current_angle + speed * dir
  if dir > 0 and current_angle < target_angle and new_angle > target_angle then
    new_angle = target_angle
  elseif dir < 0 and current_angle > target_angle and new_angle < target_angle  then
    new_angle = target_angle
  end
  new_angle = new_angle % (math.pi * 2)

  return new_angle
end

trueangle_old = GetValueNumber("average_rotation", 0)

if ( enemy ~= 0 ) and ( enemy ~= nil ) then
	-- angle_old = GetValueNumber("average_rotation2", 0)
	-- angle = get_direction( x, y, enemy_x, enemy_y )
	-- angle = math.pi + angle
	
	trueangle = math.atan2( enemy_y - y, enemy_x - x )

end

-- function approx_rolling_average(avg, new_sample, n)
  -- avg = avg - avg / n;
  -- avg = avg + new_sample / n;
  -- return avg
-- end

local smoothness_factor = 40

-- local trueangle_new = approx_rolling_average(trueangle_old, trueangle, smoothness_factor)
-- local angle_new = approx_rolling_average(angle_old, angle, smoothness_factor)

trueangle_new = move_angle_towards(trueangle_old, trueangle, 1 / smoothness_factor)
-- angle_new = move_angle_towards(angle_old, angle, 1 / smoothness_factor)

SetValueNumber("average_rotation", trueangle_new)
-- SetValueNumber("average_rotation2", angle_new)

EntitySetTransform( entity_id, x + math.cos( trueangle_new * -1 ) * 2.5, y - math.sin( trueangle_new * -1 ) * 2.5 , trueangle_new)