dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity( entity_id )
local rx,ry,rangle,rscale_x = EntityGetTransform(root_id)
local x,y,angle,scale_x,scale_y = EntityGetTransform(entity_id)
local r = angle

--Check Nearest Enemy
local range = 250
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(x, y, range, "player_unit")) do
	-- is target a valid enemy
	-- if root_id ~= id  and (EntityGetHerdRelation(root_id, id) < 40) and EntityGetRootEntity( id ) ~= root_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local ex, ey = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, ex, ey)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = ex
			enemy_y = ey
		end
	-- end
end

if not enemy then
	return
end

function move_angle_towards(current_angle, target_angle, speed)
  -- Make angle go from 0 to 2pi
  if target_angle < 0 then
	target_angle = target_angle + math.pi * 2
  end
  if current_angle < 0 then
	current_angle = current_angle + math.pi * 2
  end

  local dist_up = math.abs(target_angle - current_angle)
  local dist_down = math.abs((current_angle + math.pi * 2) - target_angle)
  if current_angle > target_angle then
	dist_up = math.abs((target_angle + math.pi * 2) - current_angle)
	dist_down = math.abs(current_angle - target_angle)
  end
  
  local dir
  if math.abs(dist_up) < math.abs(dist_down) then
	dir = 1
  else
	dir = -1
  end
  local dist_smallest = dist_up
  if dist_down < dist_up then
	dist_smallest = dist_down
  end

  local new_angle = current_angle + speed * dir
  if dir > 0 and current_angle < target_angle and new_angle > target_angle then
	new_angle = target_angle
  elseif dir < 0 and current_angle > target_angle and new_angle < target_angle  then
	new_angle = target_angle
  end
  new_angle = new_angle % (math.pi * 2)

  return new_angle
end

local angle_old2 = GetValueNumber("average_rotation2", 0)

local smoothness_factor_gun = 40

function get_direction( x1, y1, x2, y2 )
	local result = math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
	return result
end

function get_distance( x1, y1, x2, y2 )
	local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
	return result
end


function approx_rolling_average(avg, target, n)
	avg = avg - avg / n;
	avg = avg + target / n;
	return avg
end

local old_enemy_x = GetValueNumber("enemy_x", x)
local old_enemy_y = GetValueNumber("enemy_y", y)
enemy_x = approx_rolling_average(old_enemy_x, enemy_x, 10)
enemy_y = approx_rolling_average(old_enemy_y, enemy_y, 10)
SetValueNumber("enemy_x", enemy_x)
SetValueNumber("enemy_y", enemy_y)

--Gun
local sstart_x, sstart_y = x, y

local angle3 = get_direction(sstart_x, sstart_y, enemy_x, enemy_y)

--Smoothen Path
angle_new2 = move_angle_towards(angle_old2, angle3, 1 / smoothness_factor_gun)

EntitySetTransform(entity_id, sstart_x, sstart_y, angle_new2)

SetValueNumber("average_rotation2",angle_new2)