dofile_once("data/scripts/lib/utilities.lua")

--GameEffect Immunity
local entity_id = GetUpdatedEntityID()
local x, y, rot, sx, sy = EntityGetTransform( entity_id )

for i, projectile_id in ipairs(EntityGetInRadiusWithTag(x + 114, y + 114, 200, "projectile") or {}) do
	for i, comp in ipairs(EntityGetComponentIncludingDisabled( projectile_id, "HitEffectComponent" ) or {}) do
		EntityRemoveComponent( entity_id, comp )
	end
end

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

	local game_effect_component = EntityGetFirstComponentIncludingDisabled(child_id, "GameEffectComponent")
	
	if game_effect_component  and EntityGetName(child_id) ~= "important" then
	
		EntityKill(child_id)
		
	end

end

--Setting x scale of entity always to 1 
EntitySetTransform(entity_id, x, y, 0, 1)

--Always go towards player
local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
local player = EntityGetInRadiusWithTag(x + 114, y + 114, 99999999, "player_unit")
if #player > 0 then
	local px, py = EntityGetTransform(player[1])
	ComponentSetValueVector2( animal_ai_component, "mHomePosition", px - 114, py - 114 )
end

-- local home_x, home_y = ComponentGetValue2(animal_ai_component, "mHomePosition")
-- print(px)
-- print(py)
-- print(home_x)
-- print(home_y)

--Check if fan joints are still functional 

local player = EntityGetInRadiusWithTag(x + 114, y + 114, 200, "player_unit")

local did_hit = RaytraceSurfaces(x + 114, y + 40 , x + 114, y + 40)
local did_hit2 = RaytraceSurfaces(x + 189, y + 114 , x + 189, y + 114)
local did_hit3 = RaytraceSurfaces(x + 115, y + 189 , x + 115, y + 189)
local did_hit4 = RaytraceSurfaces(x + 40, y + 114 , x + 40, y + 114)

fans = 4

if #player > 0 then
	if not did_hit then
		fans = fans - 1
	end
	if not did_hit2 then
		fans = fans - 1
	end
	if not did_hit3 then
		fans = fans - 1
	end
	if not did_hit4 then
		fans = fans - 1
	end
end

local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
local hp = ComponentGetValue2( damage_model_component, "hp" )

if fans < 1 then

	if damage_model_component then

		-- ComponentSetValue2(damage_model_component, "hp", 0)
		-- ComponentSetValue2(damage_model_component, "air_needed", true)
		-- ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
		
		-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
		
		-- ComponentSetValue2( damage_model_component, "hp", 1 )
		
		local players = EntityGetInRadiusWithTag(x + 114, y + 114, 250, "player_unit")
		
		if #players > 0 then
			EntityInflictDamage( entity_id, 1500, "DAMAGE_PROJECTILE", "", "NORMAL", 0, 0, players[1], x, y )
		end
		
	end
	
end

--Make smoke particles if low health

if damage_model_component then
	-- local hp = ComponentGetValue2( damage_model_component, "hp" )
	if ( hp < 750 or fans < 3 ) and sx ~= -1 then
		EntitySetComponentsWithTagEnabled(entity_id, "disabled", true)
	else
		EntitySetComponentsWithTagEnabled(entity_id, "disabled", false)
	end
end