dofile_once("data/scripts/new_enemies_utils.lua")
dofile_once( "data/scripts/lib/utilities.lua" )

-- Check if player is in range, and if they are, add the tracking script to them

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local players = EntityGetInRadiusWithTag(x, y, 500, "player_unit")
local enemies = EntityGetInRadiusWithTag(x, y, 500, "mortal")
if #players > 0 then
	local player = players[1]
	local var_store = get_component_with_values(player, "VariableStorageComponent", { name = "position_tracker" })
	if not var_store then
			EntityAddComponent(player, "VariableStorageComponent", {
				name="position_tracker",
				value_string=""
		})
			EntityAddComponent(player, "LuaComponent", {
				script_source_file="data/scripts/misc/position_tracker.lua",
				execute_every_n_frame=2,
				execute_on_added=0
		}) 
		-- This will check whether a time wizard is still in range, and if not, remove the scripts again
			EntityAddComponent(player, "LuaComponent", {
				script_source_file="data/scripts/animals/position_tracker_checker.lua",
				execute_every_n_frame=20,
				execute_on_added=0
		})
	end
end

for i, enemy in ipairs(enemies) do

  if EntityGetComponent(enemy, "GenomeDataComponent") ~= nil then

	local enemy_var_store = get_component_with_values(enemy, "VariableStorageComponent", { name = "position_tracker2" })
	if not enemy_var_store and enemy ~= entity_id then
			EntityAddComponent(enemy, "VariableStorageComponent", {
				name="position_tracker2",
				value_string=""
		})
			EntityAddComponent(enemy, "LuaComponent", {
				script_source_file="data/scripts/misc/position_tracker_enemies.lua",
				execute_every_n_frame=1,
				execute_on_added=0,
				remove_after_executed=1,
		}) 
		-- This will check whether a time wizard is still in range, and if not, remove the scripts again
			-- EntityAddComponent(enemy, "LuaComponent", {
				-- script_source_file="data/scripts/animals/position_tracker_checker_enemies.lua",
				-- execute_every_n_frame=20,
				-- execute_on_added=0,
		-- })
	end
  end
end