dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/status_effects/status_list_custom.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

local frames = GetValueNumber("frames", 0)
SetValueNumber("frames", frames + 1)

local worm_component = EntityGetFirstComponentIncludingDisabled(entity_id, "BossDragonComponent")

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

function update_statuses(entity1, entity2)
	if ( ( entity1 ~= nil ) and ( entity1 > 0 ) ) and ( ( entity2 ~= nil ) and ( entity2 > 0 ) ) then
		-- local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity1, "DamageModelComponent")
		-- if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
			-- local ragdollfx = ComponentGetValue2(damage_model_component, "ragdoll_fx_forced")
			-- local damage_model_component2 = EntityGetFirstComponentIncludingDisabled(entity2, "DamageModelComponent")
			-- if ( damage_model_component2 ~= nil ) and ( damage_model_component2 > 0 ) then
				-- ComponentSetValue2(damage_model_component2, "ragdoll_fx_forced", ragdollfx)
				-- GamePrint(ragdollfx)
			-- end
		-- end
		for _, effect in pairs(status_effects) do
			-- GamePrint(tostring(GameGetGameEffectCount(entity_id, effect.id)))
			
			if GameGetGameEffectCount(entity1, effect.id) > 0 then
				-- GamePrint(tostring(entity_id).. " "..tostring(parent_id).. " "..tostring(effect.id).. " "..tostring(GameGetGameEffectCount(entity_id, effect.id)))
				if GameGetGameEffectCount(entity2, effect.id) <= 1 then
					local effect_id = LoadGameEffectEntityTo( entity2, effect.effect_entity )
					local game_effect_component = EntityGetFirstComponentIncludingDisabled(effect_id, "GameEffectComponent")
					ComponentSetValue2(game_effect_component, "ragdoll_effect_custom_entity_file", effect.ragdoll_entity)
					-- GamePrint("yes")
					if effect.ragdoll_material ~= "" then
						ComponentSetValue2(game_effect_component, "ragdoll_material", CellFactory_GetType( effect.ragdoll_material ) )
					end
				end
			end
			
		end
		
		local do_procedure = true

		local game_effect_components = EntityGetComponentIncludingDisabled(entity2, "GameEffectComponent")
		
		for i, game_effect_component in ipairs(game_effect_components or {}) do
			if ComponentGetValue2(game_effect_component, "effect") == "CUSTOM" then 
				if GameGetGameEffectCount(entity2, "CUSTOM") <= 1 then
				-- local effect_id_val = ComponentGetValue2(game_effect_component, "custom_effect_id")
				-- for i, child_id2 in ipairs(EntityGetAllChildren(entity1) or {}) do

					-- local game_effect_components2 = EntityGetComponentIncludingDisabled(child_id2, "GameEffectComponent")

					-- for i, game_effect_component2 in ipairs(game_effect_components2 or {}) do
						-- if ComponentGetValue2(game_effect_component2, "custom_effect_id") == effect_id_val then
							-- do_procedure = false
						-- end
					-- end
				-- end
				-- if do_procedure == true then
					local effect_id = LoadGameEffectEntityTo( entity2, "data/entities/misc/effect_template.xml" )
					local game_effect_component2 = EntityGetFirstComponentIncludingDisabled(effect_id, "GameEffectComponent")
					ComponentSetValue2(game_effect_component2, "custom_effect_id", ComponentGetValue2(game_effect_component, "custom_effect_id") )
					ComponentSetValue2(game_effect_component2, "ragdoll_effect_custom_entity_file", ComponentGetValue2(game_effect_component, "ragdoll_effect_custom_entity_file") )
					ComponentSetValue2(game_effect_component2, "ragdoll_effect", ComponentGetValue2(game_effect_component, "ragdoll_effect") )
					ComponentSetValue2(game_effect_component2, "ragdoll_material", ComponentGetValue2(game_effect_component, "ragdoll_material") )
				-- end
				end
			end
			if ComponentGetValue2(game_effect_component, "effect") == "NONE" then 
				if GameGetGameEffectCount(entity2, "NONE") <= 1 then
				-- local effect_id_val = ComponentGetValue2(game_effect_component, "custom_effect_id")
				-- for i, child_id2 in ipairs(EntityGetAllChildren(entity1) or {}) do

					-- local game_effect_components2 = EntityGetComponentIncludingDisabled(child_id2, "GameEffectComponent")

					-- for i, game_effect_component2 in ipairs(game_effect_components2 or {}) do
						-- if ComponentGetValue2(game_effect_component2, "custom_effect_id") == effect_id_val then
							-- do_procedure = false
						-- end
					-- end
				-- end
				-- if do_procedure == true then
					local effect_id = LoadGameEffectEntityTo( entity2, "data/entities/misc/effect_template.xml" )
					local game_effect_component2 = EntityGetFirstComponentIncludingDisabled(effect_id, "GameEffectComponent")
					ComponentSetValue2(game_effect_component2, "custom_effect_id", ComponentGetValue2(game_effect_component, "custom_effect_id") )
					ComponentSetValue2(game_effect_component2, "ragdoll_effect_custom_entity_file", ComponentGetValue2(game_effect_component, "ragdoll_effect_custom_entity_file") )
					ComponentSetValue2(game_effect_component2, "ragdoll_effect", ComponentGetValue2(game_effect_component, "ragdoll_effect") )
					ComponentSetValue2(game_effect_component2, "ragdoll_material", ComponentGetValue2(game_effect_component, "ragdoll_material") )
				-- end
				end
			end
		end
	end
end

function spawn_portal()
	
	local raycasts = 4
	local dir = ( math.pi * 2.0 ) / raycasts
	local length = 8

	local p = EntityGetInRadiusWithTag(x, y, 400, "player_unit")
	
	if ( #p > 0 ) then
		local t = p[1]
		local px, py = EntityGetTransform( t )
		
		local dx = px + Random( -150, 150 )
		local dy = py + Random( -150, 150 )
		
		local dist = math.abs( py - dy ) + math.abs( px - dx )
		local limit = 0
		local wall = true
		
		while ( ( dist < 100 ) or wall ) and ( limit < 20 ) do
			dx = px + Random( -150, 150 )
			dy = py + Random( -150, 150 )
			dist = math.abs( py - dy ) + math.abs( px - dx )
			limit = limit + 1
			
			for j=0,raycasts-1 do
				local ex = dx + math.cos( j * dir ) * length
				local ey = dy - math.sin( j * dir ) * length
				
				wall = RaytraceSurfaces( dx, dy, ex, ey )
				
				if wall then
					break
				end
			end
		end
		
		local vx, vy = ComponentGetValue2(worm_component, "mTargetVec")
		local old_portal = EntityLoad( "data/entities/particles/portal_worm.xml", x + vx * 200, y + vy * 200)
		EntitySetName( old_portal, "portal_a" )
		EntityAddChild(entity_id, old_portal)
		local portal_orientation = math.atan2(vy, vx)
		EntitySetTransform(old_portal, x + vx * 200, y + vy * 200, portal_orientation)

		ComponentSetValue2(worm_component, "direction_adjust_speed", 0)
		ComponentSetValue2(worm_component, "direction_adjust_speed_hunt", 0)
		ComponentSetValue2(worm_component, "mSpeed", 5)
		
		EntityLoad( "data/entities/particles/poof_blue.xml", dx, dy )
		local new_portal = EntityLoad( "data/entities/particles/portal_worm.xml", dx, dy )
		EntitySetName( new_portal, "portal_b" )
		EntitySetTransform(new_portal, dx, dy, portal_orientation + math.pi)
		EntityAddChild(entity_id, new_portal)
		return false
	else
		return true
	end
end

if ( worm_component ~= nil ) and ( worm_component > 0 ) then
	
	-- local phase = GetValueNumber("phase", 0)
	-- local frames_test = GetValueNumber("frames2", 0)
	-- SetValueNumber("frames2", frames_test + 1)
	-- if frames_test > 300 then
		-- GamePrint(frames_test)
		-- GamePrint(phase)
		-- SetValueNumber("phase", phase + 1)
		-- SetValueNumber("frames2", 0)
	-- end
	
	-- GamePrint(ComponentGetValue2(worm_component, "mPhase"))
	
	-- local phase = ComponentGetValue2(worm_component, "mPhase")
	-- ComponentSetValue2(worm_component, "mPhase", phase + 1)
	if frames == 170 then
		ComponentSetValue2(worm_component, "direction_adjust_speed", 0.003)
		ComponentSetValue2(worm_component, "direction_adjust_speed_hunt", 0.04)
	end
		
	if frames > 300 then
		SetValueNumber("frames", Random (0, 40))
		is_far = spawn_portal()
	end

	for _, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

		if EntityGetName(child_id) == "controls" then
			controls_id = child_id
		end
		
		if EntityGetName(child_id) == "controls_target" then
			controls_target_id = child_id
		end
		
		worm_ai_component_controls = EntityGetFirstComponentIncludingDisabled(controls_id, "WormAIComponent")
		worm_component_controls = EntityGetFirstComponentIncludingDisabled(controls_id, "WormComponent")
		

		if EntityGetName(child_id) == "portal_a" then
			local dx, dy = EntityGetTransform(child_id)
			
			local distance = get_distance(x, y, dx, dy)
			
			if distance < 9 then
				GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/teleport/tick", dx, dy)
				EntitySetComponentsWithTagEnabled(child_id, "enabled_in_world", false)
				
				EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
				EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", false)
				
				local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					ComponentSetValue2( comp, "wait_for_kill_flag_on_death", true )
				end
				
				EntityAddComponent(entity_id, "LuaComponent", {
					script_source_file="data/scripts/animals/worm_portal_shorten.lua",
					execute_every_n_frame=1,
					execute_on_added=0,
				})
				
				EntityAddComponent(entity_id, "LuaComponent", {
					script_damage_received="data/scripts/animals/hitbox_damage.lua",
					execute_every_n_frame=-1
				})
				
				for _, child_id2 in ipairs(EntityGetAllChildren(entity_id) or {}) do
					if EntityGetName(child_id2) == "portal_particles" then
						EntityKill(child_id2)
					end
					
					if EntityGetName(child_id2) == "portal_b" then
						EntitySetComponentsWithTagEnabled(child_id2, "enabled_in_world", false)
						dx, dy = EntityGetTransform(child_id2)
						
						GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/teleport/tick", dx, dy)
						
						local new_worm = EntityLoad( "data/entities/animals/worm_portal.xml", dx, dy )
						
						--Syncing worm controls
						for _, child_id in ipairs(EntityGetAllChildren(new_worm) or {}) do

							if EntityGetName(child_id) == "controls" then
							
								local worm_component3 = EntityGetFirstComponentIncludingDisabled(child_id, "WormComponent")
								if ( worm_component3 ~= nil ) and ( worm_component3 > 0 ) then
									for k, v in pairs(ComponentGetMembers( worm_component_controls )) do
										if ( k ~= "mPrevPositions" ) then
											ComponentSetValue2(worm_component3, k, ComponentGetValue2(worm_component_controls, k))
										end
									end
								end
								
								local worm_component4 = EntityGetFirstComponentIncludingDisabled(child_id, "WormAIComponent")
								if ( worm_component4 ~= nil ) and ( worm_component4 > 0 ) then
									for k, v in pairs(ComponentGetMembers( worm_ai_component_controls )) do
										ComponentSetValue2(worm_component4, k, ComponentGetValue2(worm_ai_component_controls, k))
									end
								end
							end
						end
						
						--Sync Health
						local who_shot_damage_model_component = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
						local who_spawned_damage_model_component = EntityGetFirstComponentIncludingDisabled( new_worm, "DamageModelComponent" )

						local hp = ComponentGetValue2(who_shot_damage_model_component, "hp")
						local max_hp = ComponentGetValue2(who_shot_damage_model_component, "max_hp")

						if max_hp and hp then

							ComponentSetValue2( who_spawned_damage_model_component, "max_hp", max_hp )
							ComponentSetValue2( who_spawned_damage_model_component, "hp", hp )
							
						end
						
						--Sync game effects
						update_statuses(entity_id, new_worm)
						
						EntitySetComponentsWithTagEnabled(new_worm, "pitcheck_b", false)
						local worm_component2 = EntityGetFirstComponentIncludingDisabled(new_worm, "BossDragonComponent")
						if ( worm_component2 ~= nil ) and ( worm_component2 > 0 ) then
							for k, v in pairs(ComponentGetMembers( worm_component )) do
								if ( k ~= "speed" ) and
								( k ~= "speed_hunt" ) and
								( k ~= "hunt_box_radius" ) and
								( k ~= "random_target_box_radius" ) and
								( k ~= "mPartDistance" ) and
								( k ~= "mIsInitialized" ) then
									ComponentSetValue2(worm_component2, k, ComponentGetValue2(worm_component, k))
								end
							end
							ComponentSetValue2(worm_component, "bite_damage", 0)
							ComponentSetValue2(worm_component, "speed", 0)
							ComponentSetValue2(worm_component, "speed_hunt", 0)
							ComponentSetValue2(worm_component, "direction_adjust_speed", 0)
							ComponentSetValue2(worm_component, "direction_adjust_speed_hunt", 0)
							ComponentSetValue2(worm_component, "hunt_box_radius", 0)
							ComponentSetValue2(worm_component, "random_target_box_radius", 0)
							
							ComponentSetValue2(worm_component, "acceleration", 0)
							ComponentSetValue2(worm_component, "speed", 0)
							ComponentSetValue2(worm_component, "max_speed", 0)
							ComponentSetValue2(worm_component, "mSpeed", 0)
						end
						
						EntityAddChild(new_worm, entity_id)
					
					end
				end
			end	
		end
	end

	if ( worm_component_controls ~= nil ) and ( worm_component_controls > 0 ) then
		-- local cvx, cvy = ComponentGetValue2(worm_component_controls, "mTargetVec")
		-- ComponentSetValue2(worm_component, "mTargetVec", cvx, cvy)
		tx, ty = ComponentGetValue2(worm_component_controls, "mTargetPosition")

	end
	
	EntitySetTransform(controls_target_id, tx, ty)
	
	local enemy = 0
	local enemy_x = 0
	local enemy_y = 0
	for _,id in pairs(EntityGetInRadiusWithTag(x, y, 300, "mortal")) do
		-- is target a valid enemy
		if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(entity_id, id) < 40 then
			local x, y = EntityGetFirstHitboxCenter( id )
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
	if is_far == false then
		if enemy > 0 then
			ComponentSetValue2(worm_component, "mTargetEntityId", enemy)
			ComponentSetValue2(worm_component, "mLastLivingTargetPos", enemy_x, enemy_y)
		else
			ComponentSetValue2(worm_component, "mTargetEntityId", controls_target_id)
			ComponentSetValue2(worm_component, "mLastLivingTargetPos", tx, ty)
		end
		ComponentSetValue2(worm_component, "mRandomTarget", tx, ty)
	-- else
		-- local p = EntityGetInRadiusWithTag(x, y, 9999999, "player_unit")
		-- local px, py = EntityGetTransform(p[1])
		-- ComponentSetValue2(worm_component, "mTargetEntityId", p[1])
		-- ComponentSetValue2(worm_component, "mLastLivingTargetPos", px, py)
		-- ComponentSetValue2(worm_component, "mRandomTarget", px, py)
	end
	-- ComponentSetValue2(worm_component, "mPhase", 2)
	
	-- local tx2, ty2 = EntityGetTransform(controls_target_id)
	-- GamePrint(tostring(tx2) .. " " .. tostring(ty2))
	-- GameCreateSpriteForXFrames( "data/debug/sui_close_button.png", tx, ty, true, 0, 0, 1, true )
end
