dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local sprite_components = EntityGetComponentIncludingDisabled(entity_id, "SpriteComponent", "enabled_in_hand") or {}

local sprite_found = false
local sprite_count = 0

-- Find the first disabled sprite component and enable it
for i, sprite_component in ipairs(sprite_components) do
    if not ComponentGetIsEnabled( sprite_component ) then
        -- Enable the first disabled sprite component found
        EntitySetComponentIsEnabled(entity_id, sprite_component, true)
        sprite_found = true
        break  -- Stop after enabling the first disabled sprite component
    end
	
	sprite_count = #sprite_component
end

-- If no disabled sprite components were found, disable them all
if not sprite_found then
    EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
end
