dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot, sx, sy = EntityGetTransform(entity_id)

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local increment = 0.2

local lifetimecomp = EntityGetFirstComponentIncludingDisabled( entity_id, "LifetimeComponent" )
if ( lifetimecomp ~= nil ) and ( lifetimecomp > 0 ) then
	local lifetime = ComponentGetValue2( lifetimecomp, "lifetime" )
	increment = 1 / lifetime
end

local increment2 = 0.2

local var_comp = get_variable_storage_component( entity_id, "particle_acceleration" )
if ( var_comp ~= nil ) and ( var_comp > 0 ) then
	increment2 = ComponentGetValue2( var_comp, "value_float" )
end

local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent" )

if ( comp ~= nil ) and ( comp > 0 ) then
	local alpha = ComponentGetValue2(comp, "alpha")
	if alpha > 0 then
		ComponentSetValue2(comp, "alpha", alpha - increment)
		EntitySetTransform(entity_id, x, y, rot, sx + increment2, sy + increment2)
	else
		EntityKill(entity_id)
	end
	
	EntityRefreshSprite( entity_id, comp )
end