dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local particle_id = EntityCreateNew()
EntitySetTransform(particle_id, x, y, rot)

local var_comp = get_variable_storage_component( entity_id, "particle_lifetime" )
local lifetime = 0
if ( var_comp ~= nil ) and ( var_comp > 0 ) then
	lifetime = ComponentGetValue2( var_comp, "value_int" )
end

local var_comp2 = get_variable_storage_component( entity_id, "particle_sprite" )
local sprite = "data/enemies_gfx/worm_portal_body_emissive.xml"
if ( var_comp2 ~= nil ) and ( var_comp2 > 0 ) then
	sprite = ComponentGetValue2( var_comp2, "value_string" )
end

local z = -0.491
local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent" )

if ( comp ~= nil ) and ( comp > 0 ) then
	z = ComponentGetValue2( comp, "z_index" )
end

EntityAddComponent2(particle_id, "SpriteComponent", {
	alpha=1,
	image_file=sprite,
	rect_animation="eat",
	next_rect_animation="eat",
	offset_x=20,
	offset_y=12,
	update_transform=true,
	update_transform_rotation=true,
	never_ragdollify_on_death=true,
	z_index= z + 0.001
} )

EntityAddComponent2(particle_id, "LuaComponent", {
	script_source_file="data/scripts/animals/worm_portal_particle_fade.lua",
	execute_every_n_frame=1
})

EntityAddComponent2(particle_id, "LifetimeComponent", {
	lifetime=lifetime + Random(-lifetime/2, lifetime/2)
} )

local var_comp4 = get_variable_storage_component( entity_id, "particle_acceleration" )
local acceleration = 0.2
if ( var_comp4 ~= nil ) and ( var_comp4 > 0 ) then
	acceleration = ComponentGetValue2( var_comp4, "value_float" )
end

EntityAddComponent2(particle_id, "VariableStorageComponent", {
	name = "particle_acceleration",
	value_float = acceleration
} )

local var_comp3 = get_variable_storage_component( entity_id, "particle_sprite_delay" )
local delay = 1
if ( var_comp3 ~= nil ) and ( var_comp3 > 0 ) then
	delay = ComponentGetValue2( var_comp3, "value_int" )
end

ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", Random(1,delay))