function get_distance( x1, y1, x2, y2 )
	local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
	return result
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
if times == 1 then
	SetValueNumber("origin_x", x)
	SetValueNumber("origin_y", y)
end

local origin_x = GetValueNumber("origin_x", x)
local origin_y = GetValueNumber("origin_y", y)

EntitySetTransform(entity_id, origin_x, origin_y)

local parent_id = EntityGetParent( entity_id )

local px, py = EntityGetTransform(parent_id)

local worm_component = EntityGetFirstComponentIncludingDisabled(parent_id, "BossDragonComponent")

if ( worm_component ~= nil ) and ( worm_component > 0 ) then

	ComponentSetValue2(worm_component, "mSpeed", 5)

end

-- local worm_component_dummy = EntityGetFirstComponentIncludingDisabled(entity_id, "BossDragonComponent")
-- if ( worm_component_dummy ~= nil ) and ( worm_component_dummy > 0 ) then
	-- local vx, vy = ComponentGetValue2(worm_component_dummy, "mTargetVec")
	-- SetValueNumber("origin_x", x + vx)
	-- SetValueNumber("origin_y", y + vy)
-- end

local old_x = GetValueNumber("old_x", px)
local old_y = GetValueNumber("old_y", py)

local dist = get_distance(old_x, old_y, px, py)

if dist > 16 then
	if ( worm_component ~= nil ) and ( worm_component > 0 ) then
		local full_dist = ComponentGetValue2(worm_component, "part_distance")
		local cur_dist = ComponentGetValue2(worm_component, "mPartDistance")
		if cur_dist < 16 then
			ComponentSetValue2(worm_component, "mPartDistance", cur_dist + 1 )
		end
	end

	SetValueNumber("old_x", px)
	SetValueNumber("old_y", py)

	-- local sprite_components = EntityGetComponent(entity_id, "SpriteComponent", "enabled_in_hand") or {}
	local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent", "enabled_in_hand")
	
	local first_sprite_found = false

	-- Disable the first sprite component found that is enabled
	-- for i, sprite_component in ipairs(sprite_components) do
		-- Disable the first enabled sprite component found
	if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
		EntitySetComponentIsEnabled(entity_id, sprite_component, false)
		first_sprite_found = true
		ComponentSetValue(sprite_component, "alpha", 0.5)
	end
		-- break  -- Stop after disabling the first enabled sprite component
	-- end

	-- local sprite_components = EntityGetComponent(entity_id, "SpriteComponent", "enabled_in_hand") or {}

	-- for i, sprite_component in ipairs(sprite_components) do
		-- -- Disable the first enabled sprite component found
		-- -- if i == 1 then
			-- ComponentSetValue(sprite_component, "alpha", 0.5)
		-- -- elseif i == 2 then
			-- -- ComponentSetValue(sprite_component, "alpha", 0.5)
			-- break  -- Stop after disabling the first enabled sprite component
		-- -- end
	-- end

	-- If no second sprite component was found, kill the entity
	if first_sprite_found == false then
		if ( worm_component ~= nil ) and ( worm_component > 0 ) then
			ComponentSetValue2(worm_component, "direction_adjust_speed", 0.003)
			ComponentSetValue2(worm_component, "direction_adjust_speed_hunt", 0.04)
		end
		if ( parent_id ~= nil ) and ( parent_id > 0 ) then
			EntitySetComponentsWithTagEnabled(parent_id, "pitcheck_b", true)
		end
		EntityKill(entity_id)
	end
end