dofile( "data/scripts/lib/utilities.lua" )
dofile( "data/scripts/game_helpers.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local player = EntityGetInRadiusWithTag(x, y, 1000, "player_unit")

local player_id = player[1]

if #player > 0 then

	local has_worm_attractor = false
	local worm_attractor_component = EntityGetFirstComponent(player_id, "WormAttractorComponent")
			
	if worm_attractor_component then
		has_worm_attractor = true
	end
	
	local this_lua_component = GetUpdatedComponentID()
			
	local worm_attractor_lifetime = ComponentGetValue2(this_lua_component, "execute_every_n_frame")
	
	if not has_worm_attractor then
	
		-- EntityAddComponent(player_id, "VariableStorageComponent", {
			-- name = "has_worm_attractor",
		-- })
		
		-- EntityAddComponent(player_id, "GameEffectComponent", {
			-- effect = "WORM_ATTRACTOR",
			-- frames = worm_attractor_lifetime,
		-- })
		
		-- GetGameEffectLoadTo(player_id, "WORM_ATTRACTOR", true)
		
		local game_effect_comp = GetGameEffectLoadTo(player_id, "WORM_ATTRACTOR", true)
		ComponentSetValue2(game_effect_comp, "frames", tonumber(worm_attractor_lifetime))
		
		GamePrint("Added Worm Attractor")
		
		EntityAddComponent(player_id, "WormAttractorComponent", {
			direction = "1",
			radius = 3000,
		})
		
		EntityAddComponent(player_id, "LuaComponent", {
			script_source_file = "data/scripts/animals/worm_target_player_checker.lua",
			execute_every_n_frame = 20,
			execute_on_added = 0,
		}) 
				
	end
end