dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x,y = EntityGetTransform( entity_id )

local players = EntityGetInRadiusWithTag( x, y, 400, "player_unit" )

if #players > 0 then

	if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 30 == 0 then
		local r = 300
		
		local targets = EntityGetInRadiusWithTag( x, y, r, "mortal" )

		for i,v in ipairs( targets ) do
			if ( v ~= entity_id ) and ( EntityHasTag( v, "enemy" ) or EntityHasTag( v, "player_unit" )) then
				local vx,vy = EntityGetTransform( v )
				local child_id = EntityCreateNew()
				EntitySetTransform(child_id, vx, vy)
				if not EntityHasTag( v, "player_unit" ) then
					EntityAddChild(v, child_id)
				
					particle_comp = EntityAddComponent2(child_id, "ParticleEmitterComponent", {
						  emitted_material_name="slime_yellow",
						  x_pos_offset_min=-5,
						  x_pos_offset_max=5,
						  y_pos_offset_min=-5,
						  y_pos_offset_max=5,
						  x_vel_min=0,
						  x_vel_max=0,
						  y_vel_min=0,
						  y_vel_max=0,
						  count_min=0,
						  count_max=1,
						  is_trail=true,
						  trail_gap=1,
						  lifetime_min=0.1,
						  lifetime_max=0.1,
						  fade_based_on_lifetime=true,
						  create_real_particles=false,
						  emit_cosmetic_particles=true,
						  collide_with_grid=false,
						  emission_interval_min_frames=0,
						  emission_interval_max_frames=0,
						  velocity_always_away_from_center=220,
						  airflow_force=0.36,
						  airflow_time=1.20,
						  airflow_scale=0.28,
						  is_emitting=true
					} )
					ComponentSetValue2(particle_comp, "gravity", 0, 0)
					ComponentSetValue2(particle_comp, "offset", 0, 0)

					EntityAddComponent2(child_id, "LuaComponent", {
						script_source_file="data/scripts/animals/xopon_particles.lua",
						execute_every_n_frame=1,
						execute_on_added=true
					} )
					
					EntityAddComponent2(child_id, "LifetimeComponent", {
						lifetime=30
					} )
					EntityAddComponent2(child_id, "InheritTransformComponent", {} )
				else
					particle_comp = EntityAddComponent2(child_id, "ParticleEmitterComponent", {
						  emitted_material_name="slime_yellow",
						  x_pos_offset_min=-5,
						  x_pos_offset_max=5,
						  y_pos_offset_min=-5,
						  y_pos_offset_max=5,
						  x_vel_min=0,
						  x_vel_max=0,
						  y_vel_min=0,
						  y_vel_max=0,
						  count_min=0,
						  count_max=1,
						  is_trail=true,
						  trail_gap=1,
						  lifetime_min=0.1,
						  lifetime_max=0.1,
						  fade_based_on_lifetime=true,
						  create_real_particles=false,
						  emit_cosmetic_particles=true,
						  collide_with_grid=false,
						  emission_interval_min_frames=0,
						  emission_interval_max_frames=0,
						  velocity_always_away_from_center=220,
						  airflow_force=0.36,
						  airflow_time=1.20,
						  airflow_scale=0.28,
						  is_emitting=true
					} )
					ComponentSetValue2(particle_comp, "gravity", 0, 0)
					ComponentSetValue2(particle_comp, "offset", 0, 0)

					EntityAddComponent2(child_id, "LuaComponent", {
						script_source_file="data/scripts/animals/xopon_particles_player.lua",
						execute_every_n_frame=1,
						execute_on_added=true
					} )
					
					EntityAddComponent2(child_id, "LifetimeComponent", {
						lifetime=30
					} )
				end
				
				local frozenTest = GameGetGameEffectCount( entity_id, "FROZEN" )
				if frozenTest <= 0 then
					local eid = EntityLoad( "data/entities/misc/effect_mana_eater.xml", x, y )
					EntityAddChild( v, eid )
				end
			end
		end
	end
end