dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/game_helpers.lua" )

function collision_trigger()
	local entity_id    = GetUpdatedEntityID()
	local x,y = EntityGetTransform( entity_id )
	
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
	GamePlayAnimation( entity_id, "attack", 100)
	
	EntityAddComponent(entity_id, "AudioLoopComponent", {
		file="data/audio/Desktop/fx.bank",
		event_name="fx/fx_concentration",
		calculate_material_lowpass="0",
		auto_play="1"
	})
	
	GameTriggerMusicFadeOutAndDequeueAll( 3.0 )
	GameTriggerMusicEvent( "music/oneshot/dark_02", true, x, y )
end

function damage_received(damage, message,entity_thats_responsible, is_fatal)
	if EntityGetName(entity_thats_responsible) == "DEBUG_NAME:player" then
		local entity_id    = GetUpdatedEntityID()
		local x,y = EntityGetTransform( entity_id )
		
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		GamePlayAnimation( entity_id, "attack", 100)
		
		EntityAddComponent(entity_id, "AudioLoopComponent", {
			file="data/audio/Desktop/fx.bank",
			event_name="fx/fx_concentration",
			calculate_material_lowpass="0",
			auto_play="1"
		})
		
		GameTriggerMusicFadeOutAndDequeueAll( 3.0 )
		GameTriggerMusicEvent( "music/oneshot/dark_02", true, x, y )
		EntityRemoveComponent(entity_id, GetUpdatedComponentID())
	end
end