dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
-- locate nearest enemy
local enemy, enemy_x, enemy_y
local detection_range = 200

local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")
local physics_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsAIComponent")

for _,id in pairs(EntityGetInRadiusWithTag(x, y, detection_range, "player_unit") or {}) do
	-- is target a valid enemy
	if ( id > 0 ) and ( id ~= nil ) then
		local ex, ey = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, ex, ey)
		if ( dist < detection_range ) then
			enemy = id
			enemy_x = ex
			enemy_y = ey
			SetValueBool("is_attacking", true)
		end
	end
end

local number = GetValueNumber("number", 0)
local is_attacking = GetValueBool("is_attacking", false)
		
if ( is_attacking == true ) then

	SetValueNumber("number", number + 1)

	if ( number <= 3 ) and ( enemy > 0 ) and ( enemy ~= nil ) then
	
		ComponentSetValue2(limb_boss_component, "state", 4)
		ComponentSetValue2(limb_boss_component, "mMoveToPositionX", enemy_x)
		ComponentSetValue2(limb_boss_component, "mMoveToPositionY", enemy_y)
		ComponentSetValue2(physics_ai_component, "force_max", 10000)
		ComponentSetValue2(physics_ai_component, "force_coeff", 250)


	else
		
		SetValueBool("is_attacking", false)
		SetValueNumber("number", 0)
		
		ComponentSetValue2(limb_boss_component, "state", 5)
		ComponentSetValue2(physics_ai_component, "force_max", 100)
		ComponentSetValue2(physics_ai_component, "force_coeff", 20)
		
	end
	
end