dofile_once( "data/scripts/lib/utilities.lua" )

function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

--Area Checker
local entity_id    = GetUpdatedEntityID()
local parent_id = EntityGetParent( entity_id )

if parent_id > 0 then

	local parent_x, parent_y = EntityGetTransform(parent_id)
	--Area Checker:

	local x, y = EntityGetTransform(entity_id)
	
	local old_average_x = GetValueNumber("average_x", x)
	local old_average_y = GetValueNumber("average_y", y)

	-- local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")

	function get_distance( x1, y1, x2, y2 )
		local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
		return result
	end

	function get_direction( x1, y1, x2, y2 )
		return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
	end

	local distance = get_distance(x, y, parent_x, parent_y)
	local max_distance = 30
	if distance > max_distance then     
	  local direction = get_direction(parent_x, parent_y, x, y)
	  x = parent_x + math.cos(direction) * max_distance
	  y = parent_y + math.sin(direction) * max_distance
	  -- EntitySetComponentIsEnabled( entity_id, physics_body_component, false )
	end

	if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") >= 5 then
		new_average_x = approx_rolling_average(old_average_x, x, 20)
		new_average_y = approx_rolling_average(old_average_y, y, 20)
	else
		new_average_x = x
		new_average_y = y
	end

	EntitySetTransform(entity_id, new_average_x, new_average_y)
	-- EntitySetComponentIsEnabled( entity_id, physics_body_component, true )
	
	SetValueNumber("average_x", new_average_x)
	SetValueNumber("average_y", new_average_y)
	
	--Find the child
	for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
		if EntityGetName( child ) == "body" then
			body_id = child
		end
	end

	--Elongate body based on distance

	local angle = get_direction(new_average_x, new_average_y, parent_x, parent_y)
	local distance = get_distance(new_average_x, new_average_y, parent_x, parent_y)

	local sprite_width = 60
	local max_distance = 200
	local scale = distance / sprite_width
	scale = scale, sprite_width / distance

	EntitySetTransform(body_id, new_average_x, new_average_y, angle, scale )
end
