dofile_once("data/scripts/empty_enemy_helper_start.lua")

function insert_enemy(into_what, prob, min_count, max_count, entity, key)
	if not HasFlagPersistent("ned_"..key) then
		table.insert(into_what, {
			prob = prob,
			min_count	= min_count,
			max_count = max_count,
			entity = entity,
		})
	end
end

local year, month, day = GameGetDateAndTimeLocal()

if ( ( month == 10 ) and ( day >= 15 ) and ( day <= 21 ) ) then
	if not HasFlagPersistent("ned_gonha") then
		table.insert(g_small_enemies, {
			prob           = 0.1 * global_prob,
			min_count    = 1,
			max_count    = 2,  
		  entity     = "data/entities/animals/gonha.xml",
		  delete = function()
			for i,enemy in ipairs(g_small_enemies) do
			  if enemy.entity == "data/entities/animals/gonha.xml" then
				table.remove(g_small_enemies, i)
				g_small_enemies.total_prob = 0 --this will cause the probabilities to be recalculated
				for i, v in ipairs(g_small_enemies) do 
				  if v.entity == "" then
					v.prob = v.prob - enemy.prob * vanilla_small_enemies_empty_percentage
				  end
				end
				break
			  end
			end
		  end
		})
	end
end

	insert_enemy(g_big_enemies, 0.15 * global_prob, 1, 1, "data/entities/animals/skullmage.xml", "skullmage")

	insert_enemy(g_big_enemies, 0.18 * global_prob, 1, 1, "data/entities/animals/toxicmage2.xml", "toxicmage2")

	insert_enemy(g_big_enemies, 0.15 * global_prob, 1, 1, "data/entities/animals/summoner.xml", "summoner")
	
	insert_enemy(g_big_enemies, 0.15 * global_prob, 1, 1, "data/entities/animals/wizard_tiny.xml", "wizard_tiny")
	
	insert_enemy(g_big_enemies, 0.15 * global_prob, 1, 1, "data/entities/animals/beehive.xml", "beehive")
	
	insert_enemy(g_big_enemies, 0.15 * global_prob, 1, 1, "data/entities/animals/slime_ghoul.xml", "slime_ghoul")
	
	insert_enemy(g_big_enemies, 0.15 * global_prob, 1, 1, "data/entities/animals/beanpodupine.xml", "beanpodupine")
	
	insert_enemy(g_big_enemies, 0.15 * global_prob, 1, 1, "data/entities/animals/irtokki.xml", "irtokki")
	
	insert_enemy(g_big_enemies, 0.15 * global_prob, 1, 1, "data/entities/animals/mexxi.xml", "mexxi")
	
	-- insert_enemy(g_big_enemies, 0.15, 1, 2, "data/entities/animals/frog_bot.xml", "frog_bot")
	
	insert_enemy(g_big_enemies, 0.05 * global_prob, 1, 1, "data/entities/animals/ooion.xml", "ooion")
	
	insert_enemy(g_small_enemies, 0.01 * global_prob, 1, 1, "data/entities/animals/player_ai.xml", "player_ai")
	
	insert_enemy(g_small_enemies, 0.1 * global_prob, 2, 4, "data/entities/animals/crawlers/larva_crawler_spawner.xml", "larva_crawler")
	
	insert_enemy(g_small_enemies, 0.006 * global_prob, 1, 1, "data/entities/animals/slimeshooter_mega_sleep.xml", "slimeshooter_mega")
	insert_enemy(g_small_enemies, 0.003 * global_prob, 1, 1, "data/entities/animals/mule_sleep.xml", "mule")
	
	if not HasFlagPersistent("ned_snowman") then
	table.insert(g_big_enemies,
	{
		prob   		= 0.1 * global_prob,
		min_count	= 1,
		max_count	= 1,    
		entities 	= {
			"data/entities/animals/snowman.xml",
		}
	})
	end
	
	-- if not HasFlagPersistent("ned_worm_eel") then
	-- table.insert(g_big_enemies,
	-- {
		-- prob   		= 0.1,
		-- min_count	= 1,
		-- max_count	= 1,    
		-- entities 	= {
			-- "data/entities/animals/worm_eel.xml",
		-- }
	-- })
	-- end
	
	function spawn_eye_bat_check()
		local year, month, day = GameGetDateAndTimeLocal()
		--Noita's Birthday and My Birthday:
		if ( ( month == 9 ) and ( day >= 24 ) and ( day <= 26 ) ) or ( ( month == 1 ) and ( day >= 16 ) and ( day <= 18 ) ) then
			return false
		--Halloween:
		elseif ( month == 10 ) and ( day == 31 ) then
			return false
		elseif ( month == 11 ) and ( day >= 1 ) and ( day <= 2 ) then
			return false
		--Valentines:
		elseif ( month == 2 ) and ( day >= 14 ) and ( day <= 14 ) then
			return false
		--Easter:
		-- Easter (Changes Date Each Year)
		-- Easter may occur between 22nd march and 25th april
		elseif ( month == 3 ) and ( day >= 28 ) and ( day <= 31 ) then
			return false
		else
			return true
		end
	end
	
	if spawn_eye_bat_check() then
		insert_enemy(g_small_enemies, 0.1 * global_prob, 3, 8, "data/entities/animals/eye_bat.xml", "eye_bat")
	end
	--Noita's Birthday and My Birthday:
	if ( ( month == 9 ) and ( day >= 24 ) and ( day <= 26 ) ) or ( ( month == 1 ) and ( day >= 16 ) and ( day <= 18 ) ) then
		insert_enemy(g_small_enemies, 0.1 * global_prob, 3, 8, "data/entities/animals/eye_bat_birthday.xml", "eye_bat")
	end
	--Halloween:
	if ( ( month == 10 ) and ( day == 31 ) ) or ( ( month == 11 ) and ( day >= 1 ) and ( day <= 2 ) ) then
		insert_enemy(g_small_enemies, 0.1 * global_prob, 3, 8, "data/entities/animals/eye_bat_pumpkin.xml", "eye_bat")
	end
	
	--Valentines:
	if  (month == 2 ) and ( day >= 14 ) and ( day <= 16 ) then
		insert_enemy(g_small_enemies, 0.1 * global_prob, 3, 8, "data/entities/animals/eye_bat_valentines.xml", "eye_bat")
	end
	
	--Easter
	if ( month == 4 ) and ( day >= 9 ) and ( day <= 11 ) then
		insert_enemy(g_small_enemies, 0.1 * global_prob, 3, 8, "data/entities/animals/eye_bat_easter.xml", "skeleton")
	end

	function spawn_skeleton_check()
		local year, month, day = GameGetDateAndTimeLocal()
		--April Fools:
		if ( month == 4 ) and ( day >= 1 ) and ( day <= 3 ) then
			return false
		--Christmas:
		elseif ( month == 12 ) and ( day >= 24 ) and ( day <= 26 ) then
			return false 
		--Saint Patrick's:
		elseif ( month == 3 ) and ( day >= 17 ) and ( day <= 19 ) then
			return false 
		--New Year:
		elseif ( month == 1 ) and ( day >= 1 ) and ( day <= 3 ) then
			return false 
		--My Birthday:
		elseif ( month == 1 ) and ( day >= 16 ) and ( day <= 18 ) then
			return false 
		--Valentines Day:
		elseif ( month == 2 ) and ( day >= 14 ) and ( day <= 14 ) then
			return false
		--Noita's Birthday:
		elseif ( month == 9 ) and ( day >= 24 ) and ( day <= 26 ) then
			return false
		--Lunar New Year:
		elseif ( month == 2 ) and ( day >= 12 ) and ( day <= 13 ) then
			return false
		--Halloween:
		elseif ( month == 10 ) and ( day == 31 ) then
			return false
		elseif ( month == 11 ) and ( day >= 1 ) and ( day <= 2 ) then
			return false
		--Day Of The Dead:
		elseif ( month == 11 ) and ( day >= 3 ) and ( day <= 8 ) then
			return false
		--Oriental Feast:
		elseif ( month == 10 ) and ( day >= 1 ) and ( day <= 3 ) then
			return false
		--Thanksgiving:
		elseif ( month == 11 ) and ( day >= 26 ) and ( day <= 28 ) then
			return false
		--Pride Month:
		elseif ( month == 6 ) and ( day >= 1 ) and ( day <= 3 ) then
			return false
		--4th Of July:
		elseif ( month == 7 ) and ( day >= 4 ) and ( day <= 6 ) then
			return false
		--Easter:
		-- Easter (Changes Date Each Year)
		-- Easter may occur between 22nd march and 25th april
		elseif ( month == 3 ) and ( day >= 28 ) and ( day <= 31 ) then
			return false
		--Carnival:
		--(Changes date each year)
		elseif ( month == 3 ) and ( day >= 1 ) and ( day <= 5 ) then
			return false
		--Diwali:
		--Diwali, Changes Date Each Year:
		elseif ( month == 11 ) and ( day >= 1 ) and ( day <= 1 ) then
			return false
		else
			return true
		end
	end

	if spawn_skeleton_check() then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/skeleton.xml", "skeleton")
	end
	
	if ( month == 3 ) and ( day >= 17 ) and ( day <= 19 ) then
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_green.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_beer.xml", "skeleton")
	end


	if ( month == 11 ) and ( day >= 3 ) and ( day <= 8 ) then
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_guitar.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_guitar2.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_guitarron.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_guitarron2.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_harp.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_harp2.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_maraca.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_maraca2.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_trumpet.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_trumpet2.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_violin.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.04166666666 * global_prob, 1, 2, "data/entities/animals/skeleton_mariachi_violin2.xml", "skeleton")
	end

	if ( month == 10 ) and ( day >= 31 ) and ( day <= 31 ) then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/skeleton_diwalli.xml", "skeleton")
	end

	if ( month == 2 ) and ( day >= 14 ) and ( day <= 14 ) then
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_carnevale.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_carnival.xml", "skeleton")
	end

	if ( month == 4 ) and ( day >= 9 ) and ( day <= 11 ) then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/skeleton_easter_bunny.xml", "skeleton")
	end
	
	if ( month == 6 ) and ( day >= 1 ) and ( day <= 3 ) then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/skeleton_pride.xml", "skeleton")
	end

	if ( month == 7 ) and ( day >= 4 ) and ( day <= 6 ) then
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_4th_july_firework.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_4th_july.xml", "skeleton")
	end

	if ( month == 11 ) and ( day >= 26 ) and ( day <= 28 ) then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/skeleton_thanksgiving.xml", "skeleton")
	end

	if (( month == 10 ) and ( day == 31 )) or (( month == 11 ) and ( day >= 1 ) and ( day <= 2 )) then
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_vampire.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_pumpkin.xml", "skeleton")
	end

	if (( month == 2 ) and ( day >= 12 ) and ( day <= 13 )) or (( month == 10 ) and ( day >= 1 ) and ( day <= 3 )) then
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_lunar_new_year.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.25 * global_prob, 1, 2, "data/entities/animals/skeleton_oriental.xml", "skeleton")
	end

	if (( month == 9 ) and ( day >= 24 ) and ( day <= 26 )) or (( month == 1 ) and ( day >= 16 ) and ( day <= 18 )) then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/skeleton_birthday.xml", "skeleton")
	end

	if ( month == 2 ) and ( day >= 14 ) and ( day <= 16 ) then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/skeleton_valentines.xml", "skeleton")
	end

	if ( month == 4 ) and ( day >= 1 ) and ( day <= 3 ) then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/trumpet.xml", "skeleton")
	end

	if ( month == 1 ) and ( day >= 1 ) and ( day <= 3 ) then
		insert_enemy(g_small_enemies, 0.5 * global_prob, 1, 2, "data/entities/animals/skeleton_champagne.xml", "skeleton")
	end

	if ( month == 12 ) and ( day >= 24 ) and ( day <= 26 ) then
		insert_enemy(g_small_enemies, 0.125 * global_prob, 1, 2, "data/entities/animals/skeleton_christmas.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.125 * global_prob, 1, 2, "data/entities/animals/skeleton_present.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.125 * global_prob, 1, 2, "data/entities/animals/skeleton_candy.xml", "skeleton")
		insert_enemy(g_small_enemies, 0.125 * global_prob, 1, 2, "data/entities/animals/skeleton_antlorz.xml", "skeleton")
	end

	-- insert_enemy(g_big_enemies, 0.03, 1, 1, "data/entities/animals/bloodskull.xml", "bloodskull")
	
	-- insert_enemy(g_big_enemies, 0.1, 1, 1, "data/entities/animals/desulitor.xml", "desulitor")
	
	-- insert_enemy(g_big_enemies, 0.02, 1, 1, "data/entities/animals/driller.xml", "driller")

	-- insert_enemy(g_big_enemies, 0.015, 1, 1, "data/entities/animals/earthskull.xml", "earthskull")
	
	insert_enemy(g_big_enemies, 0.015 * global_prob, 1, 1, "data/entities/animals/menace.xml", "menace")
	
	-- insert_enemy(g_big_enemies, 0.015, 1, 1, "data/entities/animals/flesh_wall.xml", "flesh_wall")
	
	-- insert_enemy(g_big_enemies, 0.09, 1, 1, "data/entities/animals/longleg_big.xml", "longleg_big")
	
	if not HasFlagPersistent("ned_longleg_big") then
		local entities_to_spawn = {"data/entities/animals/longleg_big.xml" }
		
		table.insert(entities_to_spawn, "data/entities/animals/longleg.xml")
		table.insert(entities_to_spawn, "data/entities/animals/longleg.xml")
		
		table.insert(g_big_enemies,
		{
			prob   		= 0.09 * global_prob,
			min_count	= 1,
			max_count	= 1,    
			entities    = entities_to_spawn
		})
	end
	
	insert_enemy(g_small_enemies, 0.1 * global_prob, 1, 2, "data/entities/animals/hybrid.xml", "hybrid")
	
	insert_enemy(g_small_enemies, 0.1 * global_prob, 1, 2, "data/entities/animals/hazmat.xml", "hazmat")
	
	insert_enemy(g_small_enemies, 0.1 * global_prob, 1, 2, "data/entities/animals/conduit.xml", "conduit")

	insert_enemy(g_small_enemies, 0.05 * global_prob, 1, 2, "data/entities/animals/fallen_alchemist.xml", "fallen_alchemist")
	
	insert_enemy(g_big_enemies, 0.0125 * global_prob, 1, 1, "data/entities/animals/sneeker.xml", "sneeker")
	
	insert_enemy(g_big_enemies, 0.001 * global_prob, 1, 1, "data/entities/animals/slimeshooter_golden.xml", "slimeshooter_golden")
	
	insert_enemy(g_big_enemies, 0.001 * global_prob, 1, 1, "data/entities/animals/gonha.xml", "gonha")
	
	insert_enemy(g_big_enemies, 0.01 * global_prob, 1, 1, "data/entities/animals/ground_terror.xml", "ground_terror")

	insert_enemy(g_big_enemies, 0.2 * global_prob, 1, 1, "data/entities/animals/axeman.xml", "axeman")
	
	insert_enemy(g_big_enemies, 0.1 * global_prob, 1, 1, "data/entities/animals/goomonster.xml", "goomonster")

	insert_enemy(g_big_enemies, 0.1 * global_prob, 1, 1, "data/entities/animals/archer.xml", "archer")

	insert_enemy(g_big_enemies, 0.1 * global_prob, 1, 1, "data/entities/animals/stone_crab.xml", "stone_crab")
	
	-- insert_enemy(g_big_enemies, 0.1, 1, 1, "data/entities/animals/mutant_blob.xml", "mutant_blob")
	
	insert_enemy(g_big_enemies, 0.1 * global_prob, 1, 1, "data/entities/animals/invisiman.xml", "invisiman")
	
	insert_enemy(g_big_enemies, 0.08 * global_prob, 1, 1, "data/entities/animals/stalker.xml", "stalker")
	
	insert_enemy(g_big_enemies, 0.08 * global_prob, 1, 1, "data/entities/animals/stalker_ceiling.xml", "stalker_ceiling")
	
	insert_enemy(g_big_enemies, 0.08 * global_prob, 1, 1, "data/entities/animals/monkey.xml", "monkey")
	
	insert_enemy(g_small_enemies, 0.125 * global_prob, 1, 2, "data/entities/animals/dripper.xml", "dripper")
	
	-- insert_enemy(g_small_enemies, 0.04, 1, 1, "data/entities/animals/enigma_delayed_spawner.xml", "enigma")
	
dofile_once("data/scripts/empty_enemy_helper_end.lua")
