function init( x, y, w, h )
	
	local _, _, day, hour, minute, second = GameGetDateAndTimeLocal()
	SetRandomSeed(day + hour + second, minute + second)

	local function loadRandomEntity(entities, xMin, xMax, yMin, yMax, UseY)
	  -- for i = 1, #entities do
		local randomIndex = Random(1, #entities)
		local entity = entities[randomIndex]
		if entity ~= "" then
		  if UseY then
			yvalue = math.random(yMin, yMax)
		  else
			yvalue = y + 203
		  end
		  LoadPixelScene(entity, "", math.random(xMin, xMax), yvalue, "", true)
		end
	  -- end
	end
	
	if not HasFlagPersistent("ned_boids") then
		for i=1, 20 do
		  loadRandomEntity({ "data/biome_impl/hill_pixels/boid.png", "" }, -260, -773, -1000, 203, true)
		end
		for i=1, 40 do
		  loadRandomEntity({ "data/biome_impl/hill_pixels/boid.png", "" }, 1647, 4690, -1000, 203, true)
		end
	end

	if not HasFlagPersistent("ned_peasants") then
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
		loadRandomEntity({ "data/biome_impl/hill_pixels/peasant.png", "data/biome_impl/hill_pixels/peasant_red.png", "data/biome_impl/hill_pixels/peasant_blue.png", "" }, -260, -773)
	end

	if not HasFlagPersistent("ned_huts") then
	  loadRandomEntity({ "data/biome_impl/hill_pixels/hut.png", "" }, -260, -773)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/hut.png", "" }, -260, -773)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/hut.png", "" }, -260, -773)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/hut.png", "" }, -260, -773)
	end

	if not HasFlagPersistent("ned_mammoths") then
	  loadRandomEntity({ "data/biome_impl/hill_pixels/mammoth.png", "data/biome_impl/hill_pixels/mammoth_baby.png","data/biome_impl/hill_pixels/mammoth_baby.png" }, -2150, -5000)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/mammoth.png", "data/biome_impl/hill_pixels/mammoth_baby.png","data/biome_impl/hill_pixels/mammoth_baby.png" }, -2150, -5000)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/mammoth.png", "data/biome_impl/hill_pixels/mammoth_baby.png","data/biome_impl/hill_pixels/mammoth_baby.png" }, -2150, -5000)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/mammoth.png", "data/biome_impl/hill_pixels/mammoth_baby.png","data/biome_impl/hill_pixels/mammoth_baby.png" }, -2150, -5000)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/mammoth.png", "data/biome_impl/hill_pixels/mammoth_baby.png","data/biome_impl/hill_pixels/mammoth_baby.png" }, -2150, -5000)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/mammoth.png", "data/biome_impl/hill_pixels/mammoth_baby.png","data/biome_impl/hill_pixels/mammoth_baby.png" }, -2150, -5000)
	end

	if not HasFlagPersistent("ned_camels") then
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 5460, 7140)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 5460, 7140)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 5460, 7140)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 5460, 7140)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 5460, 7140)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 5460, 7140)
	  
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 11430, 13290)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 11430, 13290)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 11430, 13290)
	  
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 15020, 15916)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 15020, 15916)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/camel.png", "data/biome_impl/hill_pixels/scorpion.png", "data/biome_impl/hill_pixels/locust.png" }, 15020, 15916)
	end

	if not HasFlagPersistent("ned_llama") then
	  loadRandomEntity({ "data/biome_impl/hill_pixels/frog_tiny.png", "data/biome_impl/hill_pixels/llama.png" }, 1647, 2480)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/frog_tiny.png", "data/biome_impl/hill_pixels/llama.png" }, 1647, 2480)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/frog_tiny.png", "data/biome_impl/hill_pixels/llama.png" }, 1647, 2480)
	  
	  loadRandomEntity({ "data/biome_impl/hill_pixels/frog_tiny.png", "data/biome_impl/hill_pixels/llama.png" }, 3132, 4690)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/frog_tiny.png", "data/biome_impl/hill_pixels/llama.png" }, 3132, 4690)
	  loadRandomEntity({ "data/biome_impl/hill_pixels/frog_tiny.png", "data/biome_impl/hill_pixels/llama.png" }, 3132, 4690)
	end
	
	
	if not HasFlagPersistent("ned_ritualists") then
		EntityLoad("data/entities/buildings/ritualist_a.xml", x - 61,y + 397)
		EntityLoad("data/entities/buildings/ritualist_b.xml", x - 83,y + 399)
		EntityLoad("data/entities/buildings/altar_skull.xml", x -111,y + 399)
		EntityLoad("data/entities/buildings/ritualist_c.xml", x - 138,y + 400)
		EntityLoad("data/entities/buildings/ritualist_d.xml", x - 159,y + 400)
		
		EntityLoad("data/entities/props/physics_torch_stand_intro_old.xml", x - 182,y + 404)
		EntityLoad("data/entities/props/physics_torch_stand_intro_old.xml", x - 32,y + 400)

		LoadBackgroundSprite( "data/vegetation/lush_bush_04.xml", x - 172, y + 409, 40.0, false )
		LoadBackgroundSprite( "data/vegetation/lush_bush_05.xml", x - 47, y + 408, 40.0, false )
	end
	
	if GameGetIsGamepadConnected() then
		LoadPixelScene( "data/biome_impl/mountain/hall.png", "data/biome_impl/mountain/hall_visual.png", x, y, "data/biome_impl/mountain/hall_background_gamepad_updated.png", true )
	else
		LoadPixelScene( "data/biome_impl/mountain/hall.png", "data/biome_impl/mountain/hall_visual.png", x, y, "data/biome_impl/mountain/hall_background.png", true )
	end
	
	LoadPixelScene( "data/biome_impl/mountain/hall_instructions.png", "", x, y, "", true )
	
	LoadPixelScene( "data/biome_impl/mountain/hall_b.png", "data/biome_impl/mountain/hall_b_visual.png", x, y+512, "", true )
	LoadPixelScene( "data/biome_impl/mountain/hall_br.png", "data/biome_impl/mountain/hall_br_visual.png", x+512, y+512, "", true )
	LoadPixelScene( "data/biome_impl/mountain/hall_r.png", "data/biome_impl/mountain/hall_r_visual.png", x+512, y, "", true )
	LoadPixelScene( "data/biome_impl/mountain/hall_bottom.png", "", x-512, y+512, "", true )
	LoadPixelScene( "data/biome_impl/mountain/hall_bottom_2.png", "", x+552, y+512, "", true )
	
	load_verlet_rope_with_two_joints("data/entities/verlet_chains/vines/verlet_vine_pixelscene.xml", x+139, y+300, x+175, y+281)
	load_verlet_rope_with_two_joints("data/entities/verlet_chains/vines/verlet_vine_pixelscene.xml", x+302, y+341, x+348, y+345)
	load_verlet_rope_with_two_joints("data/entities/verlet_chains/vines/verlet_vine_pixelscene.xml", x+325, y+342, x+374, y+371)
	load_verlet_rope_with_two_joints("data/entities/verlet_chains/vines/verlet_vine_long_pixelscene.xml", x+216, y+278, x+272, y+314)
	
	load_verlet_rope_with_one_joint("data/entities/verlet_chains/vines/verlet_vine_short_pixelscene.xml", x+243, y+285)
	load_verlet_rope_with_one_joint("data/entities/verlet_chains/vines/verlet_vine_short_pixelscene.xml", x+281, y+325)
	load_verlet_rope_with_one_joint("data/entities/verlet_chains/vines/verlet_vine_short_pixelscene.xml", x+356, y+354)
	load_verlet_rope_with_one_joint("data/entities/verlet_chains/vines/verlet_vine_shorter_pixelscene.xml", x+184, y+276)
	load_verlet_rope_with_one_joint("data/entities/verlet_chains/vines/verlet_vine_shorter_pixelscene.xml", x+286, y+331)
end