dofile_once("data/scripts/empty_enemy_helper_start.lua")

if ( not HasFlagPersistent("ned_crawler_bug") ) or ( not HasFlagPersistent("ned_larva_crawler") ) then
	function spawn_crawlers( x, y )
	
		if Randomf() < (1 * global_prob) then

			if ( not HasFlagPersistent("ned_crawler_bug") ) and ( not HasFlagPersistent("ned_larva_crawler") ) then
				SetRandomSeed( GameGetFrameNum(), x + y )
				local random_val = Random(1, 2)
				if random_val == 1 then
					EntityLoad("data/entities/animals/larva_crawler.xml", x, y )
				elseif random_val == 2 then
					EntityLoad("data/entities/animals/crawler_bug.xml", x, y )
				end
			elseif ( not HasFlagPersistent("ned_crawler_bug") ) then
				EntityLoad("data/entities/animals/crawler_bug.xml", x, y )
			elseif ( not HasFlagPersistent("ned_larva_crawler") ) then
				EntityLoad("data/entities/animals/larva_crawler.xml", x, y )
			end
		end
	end
end

if not HasFlagPersistent("ned_spider_crawler") then
	function spawn_scorpions(x, y)
		spawn(g_scorpions,x,y)
		SetRandomSeed( GameGetFrameNum(), x + y )
		local random_val = Random(1, 8)
		if Randomf() < ((1/6) * global_prob) then
			for i=1, random_val do
				SetRandomSeed( GameGetFrameNum() + Random(-150, 150), x + y )
				local random_x = x + Random(-50, 50)
				local random_y = y - 50 + Random(-50, 50)
				local did_hit,hit_x,hit_y = RaytraceSurfaces(random_x, random_y, random_x, random_y)
				local entities = EntityGetInRadiusWithTag( random_x, random_y, 10, "monk_hand" )
				if ( #entities > 1 ) then
				else
					if not did_hit then
						EntityLoad("data/entities/animals/spider_crawler.xml", random_x, random_y )
					end
				end
			end
		end
	end
end

if not HasFlagPersistent("ned_mummy") then
table.insert(g_statues,
{
    prob   		= 0.5 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/coffin_mummy.xml"
})
end

-- if not HasFlagPersistent("ned_spider_crawler") then
-- table.insert(g_small_enemies,
-- {
    -- prob   		= 0.07,
    -- min_count	= 1,
    -- max_count	= 2,    
    -- entity 	= "mods/new_enemies/data/entities/animals/spider_crawler.xml"
-- })
-- end

if not HasFlagPersistent("ned_darkghost") then
table.insert(g_small_enemies,
{
    prob   		= 0.05 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/darkghost2.xml"
})
end
if not HasFlagPersistent("ned_potionmaster2") then
table.insert(g_small_enemies,
{
    prob   		= 0.05 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/liquidcave/potionmaster2.xml"
})
end
if not HasFlagPersistent("ned_phantom_trapper") then
table.insert(g_small_enemies,
{
    prob   		= 0.05 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/phantom_trapper.xml"
})
end
if not HasFlagPersistent("ned_shield_physics") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/shield_physics.xml"
})
end
if not HasFlagPersistent("ned_ghostling") then
table.insert(g_small_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 2,    
    entity 	= "mods/new_enemies/data/entities/animals/ghostling.xml"
})
end
if not HasFlagPersistent("ned_flopper_mother") then
table.insert(g_small_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 2,    
    entity 	= "mods/new_enemies/data/entities/animals/flopper_mother.xml"
})
end
if not HasFlagPersistent("ned_drake_snake") then
table.insert(g_small_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 2,    
    entity 	= "mods/new_enemies/data/entities/animals/drake_snake.xml"
})
end
if not HasFlagPersistent("ned_shapeshifter") then
table.insert(g_small_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 2,    
    entity 	= "mods/new_enemies/data/entities/animals/shapeshifter.xml"
})
end
if not HasFlagPersistent("ned_scarab") then
table.insert(g_small_enemies,
{
    prob   		= 0.2 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/scarab.xml"
})
end
if not HasFlagPersistent("ned_scorpio") then
table.insert(g_small_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/scorpio.xml"
})
end
if not HasFlagPersistent("ned_gigashooter") then
table.insert(g_small_enemies,
{
    prob   		= 0.07 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/gigashooter.xml"
})
end
if not HasFlagPersistent("ned_hairling") then
table.insert(g_small_enemies,
{
    prob   		= 0.07 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/hairling.xml"
})
end
if not HasFlagPersistent("ned_ground_terror") then
table.insert(g_small_enemies,
{
    prob   		= 0.07 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/ground_terror.xml"
})
end
if not HasFlagPersistent("ned_polyshooter") then
table.insert(g_small_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/polyshooter.xml"
})
end
if not HasFlagPersistent("ned_chaoticpolyshooter") then
table.insert(g_small_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/chaoticpolyshooter.xml"
})
end
if not HasFlagPersistent("ned_mirror_physics") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/mirror_physics.xml"
})
end
if not HasFlagPersistent("ned_phantom_boss") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/phantom_boss.xml"
})
end
if not HasFlagPersistent("ned_hurpa") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/hurpa.xml"
})
end
if not HasFlagPersistent("ned_manus") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/manus.xml"
})
end
if not HasFlagPersistent("ned_gold_face_physics") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/gold_face_physics.xml"
})
end
if not HasFlagPersistent("ned_acidmonster") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/acidmonster.xml"
})
end
if not HasFlagPersistent("ned_watermonster") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/watermonster.xml"
})
end
if not HasFlagPersistent("ned_bloodmonster") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/bloodmonster.xml"
})
end
if not HasFlagPersistent("ned_spooky_ghost") then
table.insert(g_small_enemies,
{
    prob   		= 0.023 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/spooky_ghost.xml"
})
end
-- if not HasFlagPersistent("ned_draghoul") then
-- table.insert(g_small_enemies,
-- {
    -- prob   		= 0.07,
    -- min_count	= 1,
    -- max_count	= 1,    
    -- entity 	= "mods/new_enemies/data/entities/animals/draghoul.xml"
-- })
-- end
if not HasFlagPersistent("ned_moal") then
table.insert(g_small_enemies,
{
    prob   		= 0.035 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/moal.xml"
})
end
if not HasFlagPersistent("ned_slimeshooter_mega") then
table.insert(g_small_enemies,
{
    prob   		= 0.035 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/slimeshooter_mega.xml"
})
end
if not HasFlagPersistent("ned_skull_abomination") then
table.insert(g_small_enemies,
{
    prob   		= 0.02 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/skull_abomination.xml"
})
end
if not HasFlagPersistent("ned_imp") then
table.insert(g_small_enemies,
{
    prob   		= 0.07 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/imp.xml"
})
end
-- if not HasFlagPersistent("ned_wyrm") then
-- table.insert(g_small_enemies,
-- {
    -- prob   		= 0.07,
    -- min_count	= 1,
    -- max_count	= 1,    
    -- entity 	= "mods/new_enemies/data/entities/animals/wyrm.xml"
-- })
-- end
if not HasFlagPersistent("ned_lukki_blue") then
table.insert(g_small_enemies,
{
    prob   		= 0.05 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/lukki_blue.xml"
})
end
if not HasFlagPersistent("ned_lukki_red") then
table.insert(g_small_enemies,
{
    prob   		= 0.05 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/lukki_red.xml"
})
end
if not HasFlagPersistent("ned_lukki_white") then
table.insert(g_small_enemies,
{
    prob   		= 0.05 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/lukki_white.xml"
})
end

dofile_once("data/scripts/empty_enemy_helper_end.lua")