--dofile_once( "data/scripts/lib/utilities.lua" )

GameSetPostFxParameter("bossroom_lighting", 1, 0, 0, 0)

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
local orbcount = 0

local cam_x, cam_y = GameGetCameraPos()

-- local old_cam_x = GetValueNumber("oldcamx", cam_x)
-- SetValueNumber("oldcamx", cam_x)

local theEntity = GetUpdatedEntityID()
local x, y = EntityGetTransform(theEntity)

local players = EntityGetWithTag("player_unit")
if #players > 0 then
else
	players = EntityGetWithTag("polymorphed_player")
end

for i, child_id in ipairs(EntityGetAllChildren(theEntity) or {}) do
	
	if EntityGetName(child_id) == "sprite" then
		local sprite_comps = EntityGetComponentIncludingDisabled(child_id,"SpriteComponent")
		for i,comp_id in pairs(sprite_comps) do
			local alpha = ComponentGetValue2(comp_id, "alpha")
			if alpha < 1 then
				ComponentSetValue2(comp_id, "alpha", alpha + 0.01)
			end
		end
	end

end

local state = GetValueNumber("state", 0)
if times_executed % 300 == 0 then
	if state == 0 then
		SetValueNumber("state", 1)
	elseif state == 1 then
		SetValueNumber("state", 0)
	end
end

orbcount = GameGetOrbCountThisRun()
if orbcount > 34 then
	orbcount = 34
end

if orbcount > 12 then
	state=1
end

local is_in_corridor = true

if #players > 0 then
    local player_x, player_y = EntityGetTransform(players[1])
	
	local old_player_x = GetValueNumber("oldx", player_x)
	SetValueNumber("oldx", player_x)
	
	-- local pvelx, pvely = GameGetVelocityCompVelocity( players[1] )
	-- if ( pvelx ~= nil ) and ( pvelx > 0 ) then
		-- player_x = player_x + pvelx
	-- end
	
	if (player_y < y - 280) or (player_y > y + 50) then 
		is_in_corridor = false
	end
		
	if (is_in_corridor == false) and (times_executed % 60 == 0) then
		EntityApplyTransform(players[1], player_x, y)
	end
	
	local cam_move_x = x - cam_x
	local player_move_x = x - player_x
	
    if cam_x < x - 512 then
		EntitySetComponentsWithTagEnabled(players[1], "fast_movement_particles", false)
		EntityApplyTransform(players[1], x - (player_move_x - cam_move_x), player_y)
		
		function check_with_tag(tag_str)
			local enemies = EntityGetInRadius( x, y, 2000 )
			if ( #enemies > 0 ) then
				for _,enemy_id in ipairs(enemies) do
					if ( EntityHasTag( enemy_id, "player_unit" ) == false ) and ( EntityHasTag( enemy_id, "polymorphed_player" ) == false ) and ( EntityHasTag( enemy_id, "ear_boss_boss" ) == false ) then
						local ex, ey = EntityGetTransform( enemy_id )
						if (ex < cam_x + 2000) or
							(ex > cam_x - 2000) or
							(ey > cam_y - 150) or
							(ey < cam_y + 150) then
							EntityApplyTransform(enemy_id, ex + cam_move_x, ey)
						end
					end
				end
			end
		end
		
		check_with_tag("mortal")
		
		local shooter_comp = EntityGetFirstComponent(players[1], "PlatformShooterPlayerComponent")
		local cpox, cpoy = ComponentGetValue2(shooter_comp, "mSmoothedCameraPosition")
		-- local camerrorx, ccamerrory = ComponentGetValue2(shooter_comp, "mCamErrorAveraged")
		ComponentSetValue2( shooter_comp, "mSmoothedCameraPosition", cpox + cam_move_x, cpoy )
		cpox, cpoy = ComponentGetValue2(shooter_comp, "mDesiredCameraPos")
		ComponentSetValue2( shooter_comp, "mDesiredCameraPos", cpox + cam_move_x, cpoy )
		GameSetCameraPos(cam_x + cam_move_x, cam_y)
		
		-- cpox, cpoy = ComponentGetValue2(shooter_comp, "mCamCorrectionGainSmoothed")
		-- ComponentSetValue2( shooter_comp, "mCamCorrectionGainSmoothed", -cpox, cpoy )
		-- GamePrint("mCamCorrectionGainSmoothed:" .. tostring(cpox) .. " " .. tostring(cpoy))
		
		cpox, cpoy = ComponentGetValue2(shooter_comp, "mCamErrorAveraged")
		ComponentSetValue2( shooter_comp, "mCamErrorAveraged", -cpox, cpoy )
		
		-- local recoil = ComponentGetValue2(shooter_comp, "mCameraRecoil")
		-- ComponentSetValue2( shooter_comp, "mCameraRecoil", 0 )

		-- recoil = ComponentGetValue2(shooter_comp, "mCamCorrectionTeleSmoothed")
		-- ComponentSetValue2( shooter_comp, "mCamCorrectionTeleSmoothed", -recoil )
		-- GamePrint("mCamCorrectionTeleSmoothed:" .. tostring(recoil))

		-- RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256 - 1024, y - 337 )
		RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256 - 512, y - 337 )
		RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256, y - 337 )	
		RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256 + 512, y - 337 )
		-- RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256 + 1024, y - 337 )
		
		-- LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256 - 1024, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256 - 512, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256 + 512, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		-- LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256 + 1024, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		
	elseif cam_x > x + 512 then
		EntitySetComponentsWithTagEnabled(players[1], "fast_movement_particles", false)
		EntityApplyTransform(players[1], x - (player_move_x - cam_move_x) , player_y)

		function check_with_tag(tag_str)
			local enemies = EntityGetInRadius( x, y, 2000 )
			if ( #enemies > 0 ) then
				for _,enemy_id in ipairs(enemies) do
					if ( EntityHasTag( enemy_id, "player_unit" ) == false ) and ( EntityHasTag( enemy_id, "polymorphed_player" ) == false ) and ( EntityHasTag( enemy_id, "ear_boss_boss" ) == false ) then
						local ex, ey = EntityGetTransform( enemy_id )
						if (ex < cam_x + 2000) or
							(ex > cam_x - 2000) or
							(ey > cam_y - 150) or
							(ey < cam_y + 150) then
							EntityApplyTransform(enemy_id, ex + cam_move_x, ey)
						end
					end
				end
			end
		end
		
		check_with_tag("mortal")
		
		local shooter_comp = EntityGetFirstComponent(players[1], "PlatformShooterPlayerComponent")
		local cpox, cpoy = ComponentGetValue2(shooter_comp, "mSmoothedCameraPosition")
		-- local camerrorx, ccamerrory = ComponentGetValue2(shooter_comp, "mCamErrorAveraged")
		ComponentSetValue2( shooter_comp, "mSmoothedCameraPosition", cpox + cam_move_x, cpoy )
		cpox, cpoy = ComponentGetValue2(shooter_comp, "mDesiredCameraPos")
		ComponentSetValue2( shooter_comp, "mDesiredCameraPos", cpox + cam_move_x, cpoy )
		
		GameSetCameraPos(cam_x + cam_move_x, cam_y)
		
		-- cpox, cpoy = ComponentGetValue2(shooter_comp, "mCamCorrectionGainSmoothed")
		-- ComponentSetValue2( shooter_comp, "mCamCorrectionGainSmoothed", -cpox, cpoy )
		-- GamePrint("mCamCorrectionGainSmoothed:" .. tostring(cpox) .. " " .. tostring(cpoy))
		
		cpox, cpoy = ComponentGetValue2(shooter_comp, "mCamErrorAveraged")
		ComponentSetValue2( shooter_comp, "mCamErrorAveraged", -cpox, cpoy )
		
		-- local recoil = ComponentGetValue2(shooter_comp, "mCameraRecoil")
		-- ComponentSetValue2( shooter_comp, "mCameraRecoil", 0 )

		-- recoil = ComponentGetValue2(shooter_comp, "mCamCorrectionTeleSmoothed")
		-- ComponentSetValue2( shooter_comp, "mCamCorrectionTeleSmoothed", -recoil )
		-- GamePrint("mCamCorrectionTeleSmoothed:" .. tostring(recoil))

		
		-- RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256 - 1024, y - 337 )
		RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256 - 512, y - 337 )
		RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256, y - 337 )	
		RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256 + 512, y - 337 )
		-- RemovePixelSceneBackgroundSprite( "data/biome_impl/apotheosis/orbroom_background.png", x - 256 + 1024, y - 337 )
		
		-- LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256 - 1024, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256 - 512, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256 + 512, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
		-- LoadPixelScene( "data/biome_impl/apotheosis/orbroom.png", "data/biome_impl/apotheosis/orbroom_visual_pixel.png", x - 256 + 1024, y - 337, "data/biome_impl/apotheosis/orbroom_background.png", true, false, "", 5, true )
    end
	
	if (is_in_corridor == true) and (times_executed ~= nil ) then
		if state == 1 and (ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 90 == 0) and (ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") > 300) then
			local handx = player_x
			local handy = y + 50
			-- local entities = EntityGetInRadiusWithTag( handx, handy, 40, "ear_boss" )

			-- if ( #entities > 1 ) then
			-- else
				local child = EntityLoad( "data/entities/projectiles/ear_boss_hand.xml", handx , handy )
				EntityAddChild(theEntity, child)
			-- end
		end
		
		SetRandomSeed( GameGetFrameNum(), x + y + theEntity )
		local valval = 240 - (4 * orbcount)

		if ( times_executed % valval == 0 ) and (times_executed > 500) then
		
			local randomx = player_x + Random(-150, 150)
			
			-- local entities = EntityGetInRadiusWithTag( randomx, player_y, 40, "ear_boss" )
			
			-- if ( #entities > 1 ) then
			-- else
				local child = EntityLoad( "data/entities/projectiles/ear_boss_eye_right.xml", randomx , player_y )
				local cx, cy, rot = EntityGetTransform(child)
				if player_x < cx then
					EntitySetTransform( child, cx, cy, rot, -1 )
				end
				EntityAddChild(theEntity, child)
			-- end
		end
		
		if times_executed % 20 == 0 then
			local randomx = player_x + Random(-150, 150)
			local randomy = player_y + Random(-100, 100)
			local entities = EntityGetInRadiusWithTag( randomx, randomy, 40, "ear_boss" )

			if ( #entities > 1 ) then
			else
				local child = EntityLoad( "data/entities/projectiles/ear_boss_eye_small.xml", randomx , randomy )
				EntityAddChild(theEntity, child)
			end
		end
		
		if (times_executed % (200 - 4 * orbcount) == 0 ) and (times_executed > 600) then
			local randval = Random(1, 2)
			if randval == 1 then
				phan_x = player_x + 250
			else
				phan_x = player_x - 250
			end
			local randval2 = Random(1, 3)
			if randval2 == 1 then
				estr = "data/entities/animals/ear_boss/phan.xml"
			elseif randval2 == 2 then
				estr = "data/entities/animals/ear_boss/phantom_a.xml"
			elseif randval2 == 3 then
				estr = "data/entities/animals/ear_boss/phantom_b.xml"
			end
			local child = EntityLoad( estr, phan_x , player_y )
			EntityAddTag( child, "ear_boss" )
			if orbcount > 5 then
				LoadGameEffectEntityTo( child, "data/entities/misc/effect_protection_explosion.xml" )
			end
			EntityAddChild(theEntity, child)
		end
	end
end

function kill_entities_with_tag(tag, bx, by)
	local entities = EntityGetWithTag(tag)
	for i,entity in ipairs(entities) do
		local ex, ey = EntityGetTransform(entity)
		if EntityHasTag( entity, "ear_boss" ) or EntityHasTag( entity, "boss_tag" ) or EntityHasTag( entity, "player_unit" ) or EntityHasTag( entity, "boss" ) then
		elseif (ex < bx + 2000) and
			(ex > bx - 2000) and
			(ey > by - 256) and
			(ey < by + 205) then
			EntityKill(entity)
		end
	end
end

if times_executed % 60 == 0 then
	kill_entities_with_tag("enemy", x, y)
	kill_entities_with_tag("homing_target", x, y)
end
