dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local players = EntityGetWithTag("player_unit")

local components = EntityGetComponent( entity_id, "VariableStorageComponent" )
if ( components ~= nil ) then
	for _,comp_id in pairs(components) do 
		local var_name = ComponentGetValue( comp_id, "name" )
		if ( var_name == "is_clearing_terrain") then
			var_comp_terrain = comp_id
		end
		if ( var_name == "is_laser") then
			var_comp_lasers = comp_id
		end
		if ( var_name == "direction_laser") then
			direction_laser_var_comp = comp_id
		end
	end
end

local direction = ComponentGetValue2( direction_laser_var_comp, "value_int" )
local laser_state = ComponentGetValue2( var_comp_lasers, "value_int" )

local velocity = 0.01
local enabled = false

for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	if EntityGetName(child) == "mwyah_wall" then
		local wx, wy = EntityGetTransform(child)
		
		if wx < ( x - 384 ) then
			EntitySetTransform(child, wx + 768, wy)
		end
		if laser_state == 1 then
			if wx < ( x - 285 ) then
				enabled = false
			elseif direction == 0 then
				enabled = true
			else
				enabled = false
			end
			local sprite_comps = EntityGetComponent(child, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do
				local alpha = ComponentGetValue2(comp, "alpha")
				if enabled == true then
					if alpha < 1 then
						ComponentSetValue2(comp, "alpha", alpha + 0.01)
					else
						EntitySetComponentsWithTagEnabled( child, "enabled_in_world", enabled )
					end
				else
					if alpha > 0 then
						ComponentSetValue2(comp, "alpha", alpha - 0.01)
					else
						EntitySetComponentsWithTagEnabled( child, "enabled_in_world", enabled )
					end
				end
			end
		elseif laser_state == 0 then
			EntitySetComponentsWithTagEnabled( child, "enabled_in_world", false )
			local sprite_comps = EntityGetComponent(child, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do
				local alpha = ComponentGetValue2(comp, "alpha")
				if alpha > 0 then
					ComponentSetValue2(comp, "alpha", alpha - 0.01)
				end
			end
		end
	end
	
	if EntityGetName(child) == "mwyah_wall2" then
		local wx, wy = EntityGetTransform(child)
		
		if wx > ( x + 384 ) then
			EntitySetTransform(child, wx - 768, wy)
		end
		if laser_state == 1 then
			if wx > ( x + 285 ) then
				enabled = false
			elseif direction == 1 then
				enabled = true
			else
				enabled = false
			end
			local sprite_comps = EntityGetComponent(child, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do
				local alpha = ComponentGetValue2(comp, "alpha")
				if enabled == true then
					if alpha < 1 then
						ComponentSetValue2(comp, "alpha", alpha + 0.01)
					else
						EntitySetComponentsWithTagEnabled( child, "enabled_in_world", enabled )
					end
				else
					if alpha > 0 then
						ComponentSetValue2(comp, "alpha", alpha - 0.01)
					else
						EntitySetComponentsWithTagEnabled( child, "enabled_in_world", enabled )
					end
				end
			end
		elseif laser_state == 0 then
			EntitySetComponentsWithTagEnabled( child, "enabled_in_world", false )
			local sprite_comps = EntityGetComponent(child, "SpriteComponent") or {}
			for i, comp in ipairs(sprite_comps) do
				local alpha = ComponentGetValue2(comp, "alpha")
				if alpha > 0 then
					ComponentSetValue2(comp, "alpha", alpha - 0.01)
				end
			end
		end
	end
end
local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
if times_executed % 30 == 0 then
	if #players > 0 then
		local player_x, player_y = EntityGetTransform(players[1])
		if player_x > x + 236 or player_x < x - 236 or player_y > y + 256 or player_y < y - 256 then     
			EntitySetTransform(players[1], x, y + 200)
		end
	end
end

local current_state = ComponentGetValue2( var_comp_terrain, "value_int" )
local old_state = GetValueNumber("old_state", 0)
SetValueNumber("old_state", current_state)

local bypass = false
if current_state ~= old_state then
	bypass = true
end

if current_state == 1 then
	if times_executed % 4 == 0 then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
elseif current_state == 2 then
	if times_executed % 15 == 0 then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
elseif current_state == 3 then
	if ( times_executed % 15 == 0 )  or ( bypass == true ) then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_level1.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
elseif current_state == 4 then
	if ( times_executed % 15 == 0 ) or ( bypass == true ) then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_clear.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
elseif current_state == 5 then
	if ( times_executed % 15 == 0 ) or ( bypass == true ) then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_level2.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
elseif current_state == 6 then
	if ( times_executed % 15 == 0 ) or ( bypass == true ) then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_level3.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
elseif current_state == 7 then
	if ( times_executed % 15 == 0 ) or ( bypass == true ) then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_level4.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
elseif current_state == 8 then
	if ( times_executed % 15 == 0 ) or ( bypass == true ) then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_level5.png", "", x-256, y-256, "", true, false, "", 50, true)
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_level5_swappers.png", "", x-256, y-256, "", true, false, "", 50, false)
	end
elseif current_state == 13 then
	if ( times_executed % 15 == 0 ) or ( bypass == true ) then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_clear.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
elseif current_state == 14 then
	if times_executed % 15 == 0 then
		LoadPixelScene( "data/biome_impl/orbroommwyahclosed_mwyah_refresh_final.png", "", x-256, y-256, "", true, false, "", 50, true)
	end
end