dofile_once( "data/scripts/lib/coroutines.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )

local orbcount = 0

function init_boss()
	local entity = GetUpdatedEntityID()
	
	local orbcount = GameGetOrbCountThisRun()
	
	local init_comp = get_variable_storage_component(entity, "initialized")

	-- look for stored initialization data
	--if get_variable_storage_component(entity, "initialized") == nil then
	if init_comp and ComponentGetValueBool(init_comp, "value_bool") == false then
		ComponentSetValue(init_comp, "value_bool", "1")
		
		-- Get the amount of orbs to adjust boss difficulty
		orbcount = GameGetOrbCountThisRun()
		
		-- Set boss HP based on orbs
		-- local boss_hp = 46.0 + orbcount * 15.0
		-- local boss_hp = 23.0 + ( 2.0 ^ (orbcount+1.5) ) + orbcount
		local boss_hp = 30 + ( ( 2.0 ^ (orbcount + 1.3) ) + (orbcount*15.5)) * 0.00005

		local comp = EntityGetFirstComponentIncludingDisabled( entity, "DamageModelComponent" )
		if( comp ~= nil ) then
			ComponentSetValue( comp, "max_hp", tostring(boss_hp) )
			ComponentSetValue( comp, "hp", tostring(boss_hp) )
		end
		
		if orbcount > 25 then
			local comp = EntityGetFirstComponentIncludingDisabled( entity, "AnimalAIComponent" )
			if( comp ~= nil ) then
				ComponentSetValue( comp, "attack_ranged_entity_file", "data/entities/projectiles/fireball_bird_stream2.xml" )
				ComponentSetValue( comp, "attack_ranged_offset_x", 0 )
				ComponentSetValue( comp, "attack_ranged_entity_count_min", 1 )
				ComponentSetValue( comp, "attack_ranged_entity_count_max", 3 )
			end
		elseif orbcount > 10 then
			local comp = EntityGetFirstComponentIncludingDisabled( entity, "AnimalAIComponent" )
			if( comp ~= nil ) then
				ComponentSetValue( comp, "attack_ranged_entity_file", "data/entities/projectiles/fireball_bird_stream.xml" )
				ComponentSetValue( comp, "attack_ranged_offset_x", 0 )
			end
		end
	end
end

init_boss()