dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
-- local parent_id = EntityGetParent( entity_id )
local players = EntityGetInRadiusWithTag( x, y, 800, "player_unit" )

if #players > 0 then

	
	-- EntitySetTransform( entity_id, player_x, player_y )

	local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
	local parent_damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		
	local parent_max_health = ComponentGetValue2(parent_damage_model_component, "max_hp")
	local parent_health = ComponentGetValue2(parent_damage_model_component, "hp")
	
	
	--Cool Boss Health Gui Script
	gui = gui or GuiCreate()
	GuiStartFrame(gui)
	local screen_width, screen_height = GuiGetScreenDimensions(gui)
	local healthbar_width = (87 / 2)
	local healthbar_height = 8
	local healthbar_offset_y = screen_height * 0.213889 - 25
	local hp_max = math.floor( ( parent_max_health * 25 ) + 0.5)
	local hp = math.floor( ( parent_health * 25 ) + 0.5) -- SET YOUR HP HEEEEEEEEEEEEEREEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
	if hp < 0 then
	  return
	end

	local percent_filled = hp / hp_max
	local inner_healthbar_width = (healthbar_width - 2) * percent_filled
	-- Outline / Background
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiColorSetForNextWidget(gui, 0.412, 0.243, 0.200, 1)
	GuiZSetForNextWidget(gui, -100)
	GuiImage(gui, 2, (screen_width - healthbar_width) / 2, screen_height - healthbar_offset_y, "data/debug/whitebox.png", 1, healthbar_width / 20, healthbar_height / 20) -- 20x20
	-- Actual inner bar
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiColorSetForNextWidget(gui, 0.529, 0.749, 0.110, 1)
	GuiZSetForNextWidget(gui, -101)
	GuiImage(gui, 3, (screen_width - healthbar_width) / 2 + 1, screen_height - healthbar_offset_y + 1, "data/debug/whitebox.png", 1, inner_healthbar_width / 20, (healthbar_height - 2) / 20) -- 20x20
	-- Health icon
	GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
	GuiZSetForNextWidget(gui, -102)
	GuiImage(gui, 4, (screen_width - healthbar_width) / 2 + healthbar_width + 2.5, screen_height - healthbar_offset_y - 1, "data/ui_gfx/hud/health.png", 1, 1, 1) -- 20x20
	-- Text
	local text_width = GuiGetTextDimensions(gui, hp, 1)
	GuiColorSetForNextWidget(gui, 0, 0, 0, 1)
	GuiZSetForNextWidget(gui, -103)
	GuiText(gui, (screen_width - text_width) / 2, screen_height - healthbar_offset_y - 1, hp)
	-- "Player" string
	local player_string = GameTextGetTranslatedOrNot(EntityGetName( entity_id ))
	local text_width = GuiGetTextDimensions(gui, player_string, 1)
	GuiColorSetForNextWidget(gui, 0.8, 0.8, 0.8, 1)
	GuiZSetForNextWidget(gui, -103)
	GuiText(gui, (screen_width - text_width) / 2, screen_height - healthbar_offset_y - 13, player_string)
end

-- else

	-- EntityKill(entity_id)
	
-- end