dofile_once( "data/scripts/lib/coroutines.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )

local orbcount = 0

local entity = GetUpdatedEntityID()
	
-- Get the amount of orbs to adjust boss difficulty
orbcount = GameGetOrbCountThisRun()

-- Set boss HP based on orbs
-- local boss_hp = 46.0 + orbcount * 15.0
-- local boss_hp = 23.0 + ( 2.0 ^ (orbcount+1.5) ) + orbcount
if orbcount > 15 then
	local value = ( ( ( 2.0 ^ (15 + 1.3) ) + (15*15.5) ) * 0.0001 ) * 0.5
	boss_hp = value * ( orbcount - 15 )
else
	boss_hp = ( ( ( 2.0 ^ (orbcount + 1.3) ) + (orbcount*15.5) ) * 0.0001 ) * 0.5
end

if boss_hp > 1000 then
	boss_hp = 1000
end

if orbcount > 8 then
	local comp = EntityGetFirstComponent( entity, "VelocityComponent" )
	if( comp ~= nil ) then
		ComponentSetValue2( comp, "liquid_drag", 0 )
	end
end

local comp = EntityGetFirstComponent( entity, "ProjectileComponent" )
if( comp ~= nil ) then

	EntityRemoveTag( entity, "projectile" )
	
	if orbcount > 5 then
		ComponentSetValue2( comp, "die_on_liquid_collision", false )
	end
	local d = ComponentGetValue2( comp, "damage" )
	if d > 0 then
		ComponentSetValue2( comp, "damage", d + boss_hp )
	end
	
	local ed = ComponentObjectGetValue2( comp, "config_explosion", "damage" )
	if ed > 0 then
		ComponentObjectSetValue2( comp, "config_explosion", "damage", ed + boss_hp )
	end
	
	local damage_fire = ComponentObjectGetValue2( comp, "damage_by_type", "fire" )
	if damage_fire > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "fire", damage_fire + boss_hp )
	end
	
	local damage_melee = ComponentObjectGetValue2( comp, "damage_by_type", "melee" )
	if damage_melee > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "melee", damage_melee + boss_hp )
	end
	
	local damage_drill = ComponentObjectGetValue2( comp, "damage_by_type", "drill" )
	if damage_drill > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "drill", damage_drill + boss_hp )
	end
	
	local damage_slice = ComponentObjectGetValue2( comp, "damage_by_type", "slice" )
	if damage_slice > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "slice", damage_slice + boss_hp )
	end
	
	local damage_radioactive = ComponentObjectGetValue2( comp, "damage_by_type", "radioactive" )
	if damage_radioactive > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "radioactive", damage_radioactive + boss_hp )
	end
	
	local damage_explosion = ComponentObjectGetValue2( comp, "damage_by_type", "explosion" )
	if damage_explosion > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "explosion", damage_explosion + boss_hp )
	end
	
	local damage_electricity = ComponentObjectGetValue2( comp, "damage_by_type", "electricity" )
	if damage_electricity > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "electricity", damage_electricity + boss_hp )
	end
	
	local damage_poison = ComponentObjectGetValue2( comp, "damage_by_type", "poison" )
	if damage_poison > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "poison", damage_poison + boss_hp )
	end
	
	local damage_physics_hit = ComponentObjectGetValue2( comp, "damage_by_type", "physics_hit" )
	if damage_physics_hit > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "physics_hit", damage_physics_hit + boss_hp )
	end
	
	local damage_ice = ComponentObjectGetValue2( comp, "damage_by_type", "ice" )
	if damage_ice > 0 then
		ComponentObjectSetValue2( comp, "damage_by_type", "ice", damage_ice + boss_hp )
	end
end

local comp = EntityGetFirstComponent( entity, "VerletWeaponComponent" )
if( comp ~= nil ) then
	local vdmax = ComponentGetValue2( comp, "damage_max" )
	if vdmax > 0 then
		ComponentSetValue2( comp, "damage_max", vdmax + boss_hp )
	end
end

local laser_comps = EntityGetComponent(entity, "LaserEmitterComponent") or {}
if ( #laser_comps > 0 ) then
	for i, comp in ipairs(laser_comps) do

		local damage = ComponentObjectGetValue2( comp, "laser", "damage_to_entities" )
		if damage > 0 then
			ComponentObjectSetValue2( comp, "laser", "damage_to_entities", damage + ( boss_hp * 0.2 ) )
		end
	end
end

local comp = EntityGetFirstComponent( entity, "AnimalAIComponent" )
if( comp ~= nil ) and ( comp > 0 )then

	local dmin = ComponentGetValue2( comp, "attack_melee_damage_min" )
	if dmin > 0 then
		ComponentSetValue2( comp, "attack_melee_damage_min", dmin + boss_hp )
	end
	
	local dmax = ComponentGetValue2( comp, "attack_melee_damage_max" )
	if dmax > 0 then
		ComponentSetValue2( comp, "attack_melee_damage_max", dmax + boss_hp )
	end
	
end

local comp = EntityGetComponent( entity, "DamageNearbyEntitiesComponent" )
for i, comp in ipairs(comp or {}) do
	if( comp ~= nil ) then
		local dmin = ComponentGetValue2( comp, "damage_min" )
		if dmin > 0 then
			ComponentSetValue2( comp, "damage_min", dmin + boss_hp )
		end
		
		local dmax = ComponentGetValue2( comp, "damage_max" )
		if dmax > 0 then
			ComponentSetValue2( comp, "damage_max", dmax + boss_hp )
		end
	end
end

local comp = EntityGetComponent( entity, "AreaDamageComponent" )

for i, comp in ipairs(comp or {}) do
	if( comp ~= nil ) then
		local damage_per_frame = ComponentGetValue2( comp, "damage_per_frame" )
		if damage_per_frame > 0 then
			ComponentSetValue2( comp, "damage_per_frame", damage_per_frame + boss_hp )
		end
	end
end