dofile_once( "data/scripts/lib/coroutines.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )

local orbcount = 0

function init_boss()
	local entity = GetUpdatedEntityID()
	
	local init_comp = get_variable_storage_component(entity, "initialized")

	-- look for stored initialization data
	--if get_variable_storage_component(entity, "initialized") == nil then
	if init_comp and ComponentGetValueBool(init_comp, "value_bool") == false then
		ComponentSetValue(init_comp, "value_bool", "1")

		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity, "DamageModelComponent")
		local max_health = ComponentGetValue2(damage_model_component, "max_hp")
		local var_comp2 = get_variable_storage_component( entity, "max_health" )
		ComponentSetValue2(var_comp2, "value_float", max_health)
		
		-- Get the amount of orbs to adjust boss difficulty
		orbcount = GameGetOrbCountThisRun()
		
		-- Set boss HP based on orbs
		-- local boss_hp = 46.0 + orbcount * 15.0
		-- local boss_hp = 23.0 + ( 2.0 ^ (orbcount+1.5) ) + orbcount
		local boss_hp = 120 + (( 2.0 ^ (orbcount + 1.3) ) + (orbcount*15.5)) * 0.00005

		local comp = EntityGetFirstComponentIncludingDisabled( entity, "DamageModelComponent" )
		if( comp ~= nil ) then
			ComponentSetValue( comp, "max_hp", tostring(boss_hp) )
			ComponentSetValue( comp, "hp", tostring(boss_hp) )
		end
	end
end

init_boss()