dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )
local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
local animation = ComponentGetValue2( sprite_component, "rect_animation")

if times_executed == 60 then
	ComponentSetValue2(sprite_component, "rect_animation", "open")
	ComponentSetValue2(sprite_component, "next_rect_animation", "summon")
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
	EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", true)
elseif times_executed == 100 then
	ComponentSetValue2(sprite_component, "rect_animation", "summon")
	ComponentSetValue2(sprite_component, "next_rect_animation", "summon")
	EntityLoad("data/entities/projectiles/random_summonshine_hell_door.xml", x, y - 16)
elseif times_executed == 300 then
	ComponentSetValue2(sprite_component, "rect_animation", "close")
	ComponentSetValue2(sprite_component, "next_rect_animation", "close")
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
elseif times_executed == 350 then
	EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", false)
	ComponentSetValue2(sprite_component, "rect_animation", "teleport")
	ComponentSetValue2(sprite_component, "rect_animation", "teleport")
elseif times_executed == 395 then
	LoadGameEffectEntityTo( entity_id, "data/entities/misc/effect_teleport_hell_door.xml" )
elseif times_executed == 700 then
	ComponentSetValue2(sprite_component, "rect_animation", "teleport_reverse")
	ComponentSetValue2(sprite_component, "next_rect_animation", "close")
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
	EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
	
	local var_comp = get_variable_storage_component( entity_id, "sequence" )
	
	if ComponentGetValue2(var_comp, "value_bool") == true then
		ComponentSetValue2(var_comp, "value_bool", false)
	end
end