local tags = { "erasable", "seamine", "worm", "tablet", "rock", "blackhole", "black_hole" }

function spawn_worm_killer(x, y)
  local entity_id = EntityCreateNew()
  EntitySetTransform(entity_id, x, y)
  EntityAddTag(entity_id, "worm_killer")
  EntityAddComponent(entity_id, "LuaComponent", {
        script_collision_trigger_hit="data/scripts/buildings/killer.lua",
        execute_every_n_frame="-1"
  })
  for i, tag in ipairs(tags) do
    EntityAddComponent(entity_id, "CollisionTriggerComponent", {
      width="2000",
      height="2000",
      radius="2000",
      required_tag=tag,
      destroy_this_entity_when_triggered="0"
    })
  end
  return entity_id
end

function collision_trigger(colliding_entity_id)
  if EntityGetParent(colliding_entity_id) == 0 then
    local physics_body_component = EntityGetFirstComponentIncludingDisabled(colliding_entity_id, "PhysicsBody2Component")
	if physics_body2_component then
		EntitySetComponentIsEnabled( colliding_entity_id, physics_body2_component, false )
	end
    EntityKill(colliding_entity_id)
  else
    -- if EntityHasTag(colliding_entity_id, "blackhole") then
      -- local x, y = EntityGetTransform(colliding_entity_id)  
		-- GamePrintImportant( "You Have Angered The God Of Gods!", "" )
		-- GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/sampo_pick/create", x, y )
		-- GameScreenshake( 300 )	  
		-- EntityLoad("data/entities/animals/doom_bringer_deadly.xml", x, y - 300)
    -- end
    for i, tag in ipairs(tags) do
      if EntityHasTag(colliding_entity_id, tag) then
        EntityRemoveTag(colliding_entity_id, tag)
        local new_entity = EntityCreateNew()
        EntityAddComponent(new_entity, "VariableStorageComponent", {
          name="entity_id",
          value_int=colliding_entity_id
        })
        EntityAddComponent(new_entity, "VariableStorageComponent", {
          name="tag_to_apply",
          value_string=tag
        })
        EntityAddComponent(new_entity, "LuaComponent", {
          script_source_file="data/scripts/buildings/reapply_tag.lua",
          execute_on_added="0",
          execute_every_n_frame="30",
          remove_after_executed="1"
        })
      end
    end
  end
end