dofile_once( "data/scripts/lib/utilities.lua" )

local range = 200
local projectile_velocity = 20
local scatter = 0.2

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetRootEntity(entity_id)
local pos_x, pos_y = EntityGetFirstHitboxCenter( entity_id )

local enemy, enemy_x, enemy_y
-- locate nearest enemy
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, range, "mortal")) do
	-- is target a valid enemy
	if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(root_id, id) < 40 then
		local x, y = EntityGetFirstHitboxCenter( id )
		enemy = id
		enemy_x = x
		enemy_y = y
	end
end

if not enemy or enemy == 0 then return end

-- direction
local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

-- scatter
SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
vel_x,vel_y = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

-- apply velocity & shoot
vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)
shoot_projectile( root_id, "data/entities/projectiles/orb_green_accelerating_mountain.xml", pos_x, pos_y, vel_x, vel_y)
--EntityLoad("data/entities/particles/particle_explosion/main_swirly_green.xml", pos_x, pos_y)
