local entity_id = GetUpdatedEntityID()
local x,y,angle,scale_x,scale_y = EntityGetTransform(entity_id)

for _,id in pairs(EntityGetInRadius(x, y, 750)) do

	local shield_components = EntityGetComponentIncludingDisabled(id, "EnergyShieldComponent") or {}
	for i, comp in ipairs(shield_components) do
		ComponentSetValue2(comp, "energy", 0)
	end

	if EntityHasTag( id, "player_unit" ) then
	
		for i, child_id in ipairs(EntityGetAllChildren(id) or {}) do

			local game_effect_components = EntityGetComponentIncludingDisabled(child_id, "GameEffectComponent")
			
			for i, game_effect_component in ipairs(game_effect_components or {}) do
				
				if ComponentGetValue2(game_effect_component, "effect") == "PROTECTION_ALL" then 
				
					-- ComponentSetValue2( game_effect_component, "effect", 0 )
					ComponentSetValue2( game_effect_component, "effect", "CUSTOM" )
					ComponentSetValue2( game_effect_component, "custom_effect_id", "NEW_ENEMIES_PROTECTION_REMOVED" )
					
					EntityAddComponent(child_id, "UIIconComponent", {
						icon_sprite_file="data/ui_gfx/status_indicators/protection_all_blocked.png",
						name="$no_protection_status_name",
						description="$no_protection_status_desc",
						display_above_head="1",
						display_in_hud="1",
						is_perk="0"
					})
					-- ComponentSetValue2( game_effect_component, "causing_status_effect", "CUSTOM" )
					-- GamePrint("Yes")
					-- EntityKill(child_id)
					
				end
				
			end
			
			-- local UI_components = EntityGetComponentIncludingDisabled(child_id, "UIIconComponent")
			
			-- for i, ui_component in ipairs(UI_components or {}) do
				-- GamePrint("yes")
				-- if ComponentGetValue2(ui_component, "icon_sprite_file") ~= "data/ui_gfx/status_indicators/protection_all_blocked.png" then 
					-- ComponentSetValue2( ui_component, "icon_sprite_file", "data/ui_gfx/status_indicators/protection_all_blocked.png" )
					-- GamePrint("yes")
				-- end
			-- end
			
		end
		
	end
end