--This script is used in conjunction with end, attached to the start and the end of the biome scripts, just so that we balance out the added enemies with the empty chance
--this will allow us to add more variety of enemies, while keeping the same quantity/amount of enemies that can spawn.
function calc_total_prob( value )
	local total_prob = 0
	for i,v in ipairs(value) do
		if( v.prob ~= nil and ( v.spawn_check == nil or v.spawn_check() ) ) then
			total_prob = total_prob + v.prob
		end
	end
	return total_prob
end

if g_small_enemies then
	small_enemies_total_prob_with_vanilla_enemies = calc_total_prob( g_small_enemies )
end

if g_big_enemies then
	big_enemies_total_prob_with_vanilla_enemies = calc_total_prob( g_big_enemies )
end

if g_large_enemies then
	large_enemies_total_prob_with_vanilla_enemies = calc_total_prob( g_large_enemies )
end

if g_robots then
	robots_total_prob_with_vanilla_enemies = calc_total_prob( g_robots )
end

if g_unique_enemy then
	unique_enemy_total_prob_with_vanilla_enemies = calc_total_prob( g_unique_enemy )
end

if g_small_enemies_sky then
	small_enemies_sky_total_prob_with_vanilla_enemies = calc_total_prob( g_small_enemies_sky )
end

if g_big_enemies_sky then
	big_enemies_sky_total_prob_with_vanilla_enemies = calc_total_prob( g_big_enemies_sky )
end

setting_cache = setting_cache or {}
local function get_setting(name)
    setting_cache[name] = setting_cache[name] or ModSettingGet(name)
    return setting_cache[name]
end

--This gets the global spawn probability rate from the settings
global_prob = get_setting("new_enemies.global_enemy_multiplier")
global_prob = global_prob / 100