dofile( "data/scripts/game_helpers.lua" )
dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/buildings/material_immunity.lua")


function item_pickup( entity_item, entity_who_picked, item_name )

give_material_immunity(entity_who_picked, {"radioactive_gas", "rock_static_radioactive", "ice_radioactive_static", "ice_radioactive_glass", "ice_acid_static", "ice_acid_glass"})

	local effect_metadatas = 
	{
		protection_radioactivity =
		{
			entity_file = "data/entities/misc/effect_protection_radioactivity2.xml",
			cloth_color = 0xFF546d7f,
			cloth_color_edge = 0xFF70899c,
		},
	}

	---
	local kind = "protection_radioactivity"
	edit_component( entity_item, "VariableStorageComponent", function(comp,vars)
		kind = ComponentGetValue( comp, "value_string" )
	end)

	---
	local effect_metadata = effect_metadatas[kind]

	---
	local game_effect_entity = LoadGameEffectEntityTo( entity_who_picked, effect_metadata.entity_file )

	-- change cape color
	local children = EntityGetAllChildren( entity_who_picked )
	for i,child in ipairs( children ) do
		if EntityGetName( child ) == "cape" then
			edit_component( child, "VerletPhysicsComponent", function(comp,vars) 
				vars.cloth_color = effect_metadata.cloth_color
				vars.cloth_color_edge = effect_metadata.cloth_color_edge
			end)
		end
	end
	
    local entity_ui = EntityCreateNew()
    EntityAddComponent(entity_ui, "UIIconComponent", 
    { 
      name = "Radioactive Cape",
      description = "You are immune to Several Radioactive Materials",
      icon_sprite_file = "data/items_gfx/cape/protection_radioactivity.png"
    })
    EntityAddChild(entity_who_picked, entity_ui)

	---
	EntityKill( entity_item )
end
