function material_area_checker_success(x, y)
  local entity_id = GetUpdatedEntityID()
  SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
  
  local chunks_loaded = tonumber(GlobalsGetValue("new_enemies_lake_chunks_loaded", "0"))
  chunks_loaded = chunks_loaded + 1
  GlobalsSetValue("new_enemies_lake_chunks_loaded", chunks_loaded)
  
  if not HasFlagPersistent("ned_aquatitan") and chunks_loaded == 1 and Random(1, 1) == 1 then
    -- Omegafish will spawn, determine in which chunk
    GlobalsSetValue("new_enemies_aquatitan_spawn_in_chunk", Random(50, 2385))
  end
  if not HasFlagPersistent("ned_devourer") and chunks_loaded == 1 and Random(1, 1) == 1 then
    -- Omegafish will spawn, determine in which chunk
    GlobalsSetValue("new_enemies_devourer_spawn_in_chunk", Random(50, 2385))
  end
  if not HasFlagPersistent("ned_whale") and chunks_loaded == 1 and Random(1, 1) == 1 then
    -- Omegafish will spawn, determine in which chunk
    GlobalsSetValue("new_enemies_omegafish_spawn_in_chunk", Random(50, 2385))
  end
  if not HasFlagPersistent("ned_piranha") and chunks_loaded == 1 and Random(1, 1) == 1 then
    -- Anglerfish will spawn, determine in which chunk
    GlobalsSetValue("new_enemies_piranha_spawn_in_chunk", Random(50, 2000))
  end

  local omegafish_spawn_in_chunk = tonumber(GlobalsGetValue("new_enemies_omegafish_spawn_in_chunk", "-1"))
  local piranha_spawn_in_chunk = tonumber(GlobalsGetValue("new_enemies_piranha_spawn_in_chunk", "-1"))
  local aquatitan_spawn_in_chunk = tonumber(GlobalsGetValue("new_enemies_aquatitan_spawn_in_chunk", "-1"))
  local devourer_spawn_in_chunk = tonumber(GlobalsGetValue("new_enemies_devourer_spawn_in_chunk", "-1"))
  
  local creatures = {}
  
  for i=1, 35 do
	table.insert(creatures, "data/entities/animals/fish.xml")
	table.insert(creatures, "data/entities/animals/fish_large.xml")
	table.insert(creatures, "data/entities/animals/fish_03.xml")
	table.insert(creatures, "data/entities/animals/fish_04.xml")
  end
  
	if not HasFlagPersistent("ned_sea_sharks") then
		table.insert(creatures, "data/entities/animals/shark.xml")
	end
	
	if not HasFlagPersistent("ned_alligator_small") then

		table.insert(creatures, "data/entities/animals/alligator_temple_small.xml")
	end
	
	if not HasFlagPersistent("ned_alligator") and Random(1, 2) == 1 then
		table.insert(creatures, "data/entities/animals/alligator_temple.xml")
	end
	
	if not HasFlagPersistent("ned_sea_angler") then
		table.insert(creatures, "data/entities/animals/angler.xml")
	end
	
	if not HasFlagPersistent("ned_giant_squid") then
		table.insert(creatures, "data/entities/animals/giant_squid.xml")
	end
	
	if not HasFlagPersistent("ned_sea_angler2") then
		table.insert(creatures, "data/entities/animals/fish_angler2.xml")
	end
	
	if not HasFlagPersistent("ned_zap_eel2") then
		table.insert(creatures, "data/entities/animals/zap_eel2.xml")
	end
  
  local random_index = Random(1, #creatures)
  local creature = creatures[random_index]

  if chunks_loaded == piranha_spawn_in_chunk then
    EntityLoad("data/entities/animals/piranha.xml", x, y)
  elseif chunks_loaded == aquatitan_spawn_in_chunk then
    EntityLoad("data/entities/animals/aquatitan.xml", x, y)
  elseif chunks_loaded == devourer_spawn_in_chunk then
    EntityLoad("data/entities/animals/devourer.xml", x, y)
  elseif chunks_loaded == omegafish_spawn_in_chunk then
    EntityLoad("data/entities/animals/whale.xml", x, y)
  else
    local creature = EntityLoad(creature, x, y)
	local damage_model_component = EntityGetFirstComponentIncludingDisabled(creature, "DamageModelComponent")
	ComponentSetValue2(damage_model_component, "ragdoll_fx_forced", "DISINTEGRATED")
	ComponentSetValue2(damage_model_component, "ragdoll_material", "rock_static_glow")
	ComponentSetValue2(damage_model_component, "ragdoll_filenames_file", "")
	ComponentSetValue2(damage_model_component, "blood_material", "")
	ComponentSetValue2(damage_model_component, "blood_spray_material", "")
  end

  EntityKill(entity_id)
end
