dofile_once( "data/scripts/lib/utilities.lua" )

function serialize_entity(entity_id)
  local game_effect_entity = LoadGameEffectEntityTo(entity_id, "data/entities/misc/effect_silent_poly.xml")
  local game_effect_comp = EntityGetFirstComponentIncludingDisabled(game_effect_entity, "GameEffectComponent")
  local mSerializedData = ComponentGetValue2(game_effect_comp, "mSerializedData")
  return mSerializedData
end

function deserialize_entity(str, x, y)
  local entity_id = EntityCreateNew()
  EntitySetTransform(entity_id, x, y)
  local game_effect_entity = LoadGameEffectEntityTo(entity_id, "data/entities/misc/effect_silent_poly.xml")
  local game_effect_comp = EntityGetFirstComponentIncludingDisabled(game_effect_entity, "GameEffectComponent")
  ComponentSetValue2(game_effect_comp, "mSerializedData", str)
end

local entity_id = GetUpdatedEntityID()
local creature_id = EntityGetRootEntity(entity_id)
local x, y = EntityGetTransform( creature_id )

local physics_image_shape_component = EntityGetFirstComponentIncludingDisabled(creature_id, "PhysicsImageShapeComponent")
	
if creature_id > 0 and not physics_image_shape_component and not EntityHasTag( creature_id, "cloned" ) and not EntityHasTag( creature_id, "boss" ) and not EntityHasTag( creature_id, "boss_tag" ) and not EntityHasTag( creature_id, "wand_ghost" ) then
	if EntityHasTag( creature_id, "player_unit" ) then
		local clone = EntityLoad("data/entities/animals/player_clone.xml", x, y)
		EntityAddTag( clone, "cloned" )
		EntityLoad("data/entities/particles/image_emitters/transmutation_effect.xml", x, y)
	else
		local serialized = serialize_entity(creature_id)
		deserialize_entity(serialized, x, y)

		-- EntityAddTag( clone, "cloned" )
		EntityLoad("data/entities/particles/image_emitters/transmutation_effect.xml", x, y)
	end
end


-- THIS IS THE RUDIMENTARY FILE PATH VERSION:
-- local entity_id = GetUpdatedEntityID()
-- local creature_id = EntityGetRootEntity(entity_id)
-- local x, y = EntityGetTransform( creature_id )
-- if not EntityHasTag( creature_id, "cloned" ) then
	-- if EntityHasTag( creature_id, "player_unit" ) then
		-- local clone = EntityLoad("data/entities/animals/player_clone.xml", x, y)
		-- EntityAddTag( clone, "cloned" )
		-- EntityLoad("data/entities/particles/image_emitters/transmutation_effect.xml", x, y)
	-- else
		-- local creature_filepath = EntityGetFilename( creature_id )
		-- print(creature_filepath)
		-- local clone = EntityLoad(creature_filepath, x, y)
		-- EntityAddTag( clone, "cloned" )
		-- EntityLoad("data/entities/particles/image_emitters/transmutation_effect.xml", x, y)
	-- end
-- end

--THIS IS THE ASYNC POLY TOOLS VERSION
-- dofile_once("data/scripts/lib/coroutines.lua")

-- async(function()
	-- wait(1)
	-- local entity_id = GetUpdatedEntityID()
	-- local creature_id = EntityGetRootEntity(entity_id)
	-- local x, y = EntityGetTransform( creature_id )
	-- if not EntityHasTag( creature_id, "cloned" ) and not EntityHasTag( creature_id, "boss" ) and not EntityHasTag( creature_id, "boss_tag" ) then
		-- if EntityHasTag( creature_id, "player_unit" ) then
			-- local clone = EntityLoad("data/entities/animals/player_clone.xml", x, y)
			-- EntityAddTag( clone, "cloned" )
		-- else
			-- local serialized = serialize_entity(entity_id)
			-- EntitySetTransform(old_entity, x, y)
			-- print(old_entity)
			-- local clone = deserialize_entity(serialized)
			-- -- EntityAddTag( clone, "cloned" )
			-- -- if EntityGetComponent(clone, "GenomeDataComponent") ~= nil then
				-- -- GenomeSetHerdId( clone, "friendly" )
			-- -- end
			-- print(clone)
			-- EntitySetTransform(clone, x, y)
			-- EntityLoad("data/entities/particles/image_emitters/transmutation_effect.xml", x, y)
		-- end
	-- end
	-- wait(99999999999999999999999999999999999999999999)
-- end)