dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local player_id = EntityGetParent( entity_id )

local x, y, r = EntityGetTransform(player_id)

SetRandomSeed( GameGetFrameNum(), x + y + player_id )

local dataComp = EntityGetFirstComponent(player_id, "CharacterDataComponent")
if dataComp then
	local vel_x, vel_y = ComponentGetValue2( dataComp, "mVelocity" )
	ComponentSetValueVector2(dataComp, "mVelocity", vel_x + Random(-50, 50), vel_y + Random(-50, 50))
end

-- ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 5 + Random(95))

if GameGetFrameNum() % 50 == 0 then

	local raycasts = 4
	local dir = ( math.pi * 2.0 ) / raycasts
	local length = 8
	
	local p = EntityGetWithTag( "player_unit" )
	
	if ( #p > 0 ) then
		local t = p[1]
		
		if player_id == t then
			local px, py = EntityGetTransform( t )
			
			local dx = px + Random( -150, 150 )
			local dy = py + Random( -150, 150 )
			
			local dist = math.abs( py - dy ) + math.abs( px - dx )
			local limit = 0
			local wall = true
			
			while ( ( dist < 100 ) or wall ) and ( limit < 20 ) do
				dx = px + Random( -100, 100 )
				dy = py + Random( -100, 100 )
				dist = math.abs( py - dy ) + math.abs( px - dx )
				limit = limit + 1
				
				for j=0,raycasts-1 do
					local ex = dx + math.cos( j * dir ) * length
					local ey = dy - math.sin( j * dir ) * length
					
					wall = RaytraceSurfaces( dx, dy, ex, ey )
					
					if wall then
						break
					end
				end
			end
			
			local hallucination_id = EntityCreateNew()
			EntitySetTransform(hallucination_id, dx, dy)
			EntityAddChild(player_id, hallucination_id)
			
			sprites = {
				"tentacler",
				"enlightened_alchemist",
				"failed_alchemist",
				"fungus_giga",
				"gazer",
				"spitmonster",
				"giantshooter",
				"greed_ghost",
				"giant",
				"necrobot",
				"necrobot_super",
				"necromancer",
				"necromancer_shop",
				"necromancer_super",
				"thundermage_big",
				"thundermage",
				"wizard_poly",
			}
			
			local random_index = Random(1, #sprites)
			local sprite = sprites[random_index]
			local sprite_path = "data/enemies_gfx/" .. sprite .. ".xml"
			
			local sprite_comp = EntityAddComponent2(hallucination_id, "SpriteComponent", {
				alpha=0,
				z_index=-1,
				image_file=sprite_path,
			} )
			
			EntityAddComponent(hallucination_id, "LuaComponent", {
				script_source_file="data/scripts/misc/hallucination.lua",
				execute_every_n_frame="1",
				execute_on_added="1",
			} )
			
		end
		
	end

end
