dofile_once("data/scripts/lib/utilities.lua")

function split_string(inputstr, sep)
  sep = sep or "%s"
  local t= {}
  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
    table.insert(t, str)
  end
  return t
end

function toboolean(str)
	return str == "1"
end

local entity_id = GetUpdatedEntityID()
local owner = EntityGetParent(entity_id)
local character_platforming_component = EntityGetFirstComponentIncludingDisabled(owner, "CharacterPlatformingComponent")
local var_store = get_variable_storage_component(owner, "levitation_slower_effect_old_values")
if ( var_store ~= nil ) and ( var_store > 0 ) then
	stored_values = ComponentGetValue2(var_store, "value_string")
	local properties = split_string(stored_values, ",")
	
	for i, v in ipairs(properties) do
		local name, prop_type, value = string.match(v, "(.+):(.+)=(.+)")
		value = _G["to"..prop_type](value)
		ComponentSetValue2(character_platforming_component, name, value)
	end
	
	EntityRemoveComponent(owner, var_store)
end
