local entity_id = GetUpdatedEntityID()
local owner = EntityGetParent(entity_id)
local damage_model_component = EntityGetFirstComponentIncludingDisabled(owner, "DamageModelComponent")

if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
	ComponentSetValue2(damage_model_component, "materials_damage_proportional_to_maxhp", true)
end

local c = EntityGetAllChildren( owner )

if ( c ~= nil ) then
	for i,v in ipairs( c ) do
		if EntityHasTag( v, "effect_protection" ) then
			EntitySetComponentsWithTagEnabled( v, "effect_protection", false )
		end
	end
end

EntityAddComponent2( owner, "LuaComponent", 
{ 
	script_source_file="data/scripts/status_effects/weaken_end_elephant.lua",
	execute_every_n_frame=150
} )

EntityAddComponent2( owner, "LuaComponent", 
{ 
	script_source_file="data/scripts/misc/material_weakness_effect_off.lua",
	execute_every_n_frame=150
} )