dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local particle_id = EntityCreateNew()

local player_id = EntityGetParent( entity_id )

local px, py, prot, psx, psy = EntityGetTransform(player_id)

EntitySetTransform(particle_id, px, py, prot, psx, psy)

local rect_animation = "stand"
local next_rect_animation = "stand"

local ssprite_comps = EntityGetComponent(player_id, "SpriteComponent") or {}

for i, scomp in ipairs(ssprite_comps) do

	if ComponentGetValue2(scomp, "image_file") == "data/enemies_gfx/player.xml" then
		rect_animation = ComponentGetValue2(scomp, "rect_animation")
		next_rect_animation = ComponentGetValue2(scomp, "next_rect_animation")
	end
end

EntityAddComponent2(particle_id, "SpriteComponent", {
	alpha=0.5,
	image_file="data/particles/player_trail.xml",
	rect_animation=rect_animation,
	next_rect_animation=next_rect_animation,
    offset_x=6,
    offset_y=14,
	update_transform=true,
	update_transform_rotation=true,
	z_index= 0.7
} )

EntityAddComponent2(particle_id, "LuaComponent", {
	script_source_file="data/scripts/misc/player_trail_particles_fade.lua",
	execute_every_n_frame=1
})

EntityAddComponent2(particle_id, "LifetimeComponent", {
	lifetime=60
} )

-- local var_comp4 = get_variable_storage_component( entity_id, "particle_acceleration" )
-- local acceleration = 0.2
-- if ( var_comp4 ~= nil ) and ( var_comp4 > 0 ) then
	-- acceleration = ComponentGetValue2( var_comp4, "value_float" )
-- end

-- EntityAddComponent2(particle_id, "VariableStorageComponent", {
	-- name = "particle_acceleration",
	-- value_float = acceleration
-- } )

-- local var_comp5 = get_variable_storage_component( entity_id, "particle_rotation" )
-- local rotation = 0.5
-- if ( var_comp5 ~= nil ) and ( var_comp5 > 0 ) then
	-- rotation = ComponentGetValue2( var_comp5, "value_float" )
-- end

-- EntityAddComponent2(particle_id, "VariableStorageComponent", {
	-- name = "particle_rotation",
	-- value_float = Random(-rotation, rotation)
-- } )

-- local var_comp3 = get_variable_storage_component( entity_id, "particle_sprite_delay" )
-- local delay = 1
-- if ( var_comp3 ~= nil ) and ( var_comp3 > 0 ) then
	-- delay = ComponentGetValue2( var_comp3, "value_int" )
-- end

-- ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", Random(1,delay))