dofile_once("data/scripts/lib/utilities.lua")

function split_string(inputstr, sep)
  sep = sep or "%s"
  local t= {}
  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
    table.insert(t, str)
  end
  return t
end

function toboolean(str)
	return str == "1"
end

function get_material_damage(entity)
  local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity, "DamageModelComponent")
  if damage_model_component then
    local materials_that_damage = ComponentGetValue2(damage_model_component, "materials_that_damage") --"water,acid,blood,whatever"
    local materials_how_much_damage = ComponentGetValue2(damage_model_component, "materials_how_much_damage")--"1,-1,0.03,0.2"
    materials_that_damage = split_string(materials_that_damage, ",")
    materials_how_much_damage = split_string(materials_how_much_damage, ",")
    local material_damages = {}
    for i, v in ipairs(materials_that_damage) do
      material_damages[v] = tonumber(materials_how_much_damage[i])
    end
    return material_damages
  end
end

local entity_id = GetUpdatedEntityID()
local owner = EntityGetParent(entity_id)
local damage_model_component = EntityGetFirstComponentIncludingDisabled(owner, "DamageModelComponent")
local var_store = get_variable_storage_component(owner, "new_enemies_poison_immunity_shot_values")

local entity_damage_model_component = EntityGetFirstComponentIncludingDisabled(owner, "DamageModelComponent")

if ( var_store ~= nil ) and ( var_store > 0 ) then

	local stored_value = ComponentGetValue2(var_store, "value_string")

	local material_damages = get_material_damage(owner)

	if material_damages and material_damages.poison then
		
		if entity_damage_model_component then
		
			EntitySetDamageFromMaterial( owner, "poison", stored_value )
			
			EntityRemoveComponent(owner, var_store)
			
		end
		
	end
	
end

-- local var_store2 = get_variable_storage_component(owner, "new_enemies_poison_immunity_shot_values2")
-- local stored_value2 = ComponentGetValue2(var_store, "value_string")

-- if stored_value2 then

	-- local poison_multiplier = ComponentObjectGetValue2( entity_damage_model_component, "damage_multipliers", "poison" )

	-- if poison_multiplier then

		-- if entity_damage_model_component then
		
			-- ComponentObjectSetValue2( entity_damage_model_component, "damage_multipliers", "poison", tonumber(stored_value2) )
			
			-- EntityRemoveComponent(owner, var_store2)
			
		-- end

	-- end
	
-- end