dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local owner = EntityGetParent(entity_id)
local character_platforming_component = EntityGetFirstComponentIncludingDisabled(owner, "DamageModelComponent")

function split_string(inputstr, sep)
  sep = sep or "%s"
  local t= {}
  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
    table.insert(t, str)
  end
  return t
end

function get_material_damage(entity)
  local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity, "DamageModelComponent")
  if damage_model_component then
    local materials_that_damage = ComponentGetValue2(damage_model_component, "materials_that_damage") --"water,acid,blood,whatever"
    local materials_how_much_damage = ComponentGetValue2(damage_model_component, "materials_how_much_damage")--"1,-1,0.03,0.2"
    materials_that_damage = split_string(materials_that_damage, ",")
    materials_how_much_damage = split_string(materials_how_much_damage, ",")
    local material_damages = {}
    for i, v in ipairs(materials_that_damage) do
      material_damages[v] = tonumber(materials_how_much_damage[i])
    end
    return material_damages
  end
end

local material_damages = get_material_damage(owner)

local entity_damage_model_component = EntityGetFirstComponent(owner, "DamageModelComponent")

if material_damages and material_damages.poison and material_damages.poison > 0 then
	
	if entity_damage_model_component then
	
		EntitySetDamageFromMaterial( owner, "poison", 0 )
		
		EntityAddComponent2(owner, "VariableStorageComponent", {
			name = "new_enemies_poison_immunity_shot_values",
			value_string = material_damages.poison,
		})
		
	end
	
end

-- local poison_multiplier = ComponentObjectGetValue2( entity_damage_model_component, "damage_multipliers", "poison" )

-- if poison_multiplier and poison_multiplier > 0 then

	-- if entity_damage_model_component then
	
		-- ComponentObjectSetValue2( entity_damage_model_component, "damage_multipliers", "poison", 0 )
		
		-- EntityAddComponent2(owner, "VariableStorageComponent", {
			-- name = "new_enemies_poison_immunity_shot_values2",
			-- value_string = poison_multiplier,
		-- })
		
	-- end

-- end
