dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/misc/coordinate_loader.lua" )

local max_amount_to_store = 200

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

if not var_store then
  local var_store_comps = EntityGetComponent(entity_id, "VariableStorageComponent") or {}
  for i, comp in ipairs(var_store_comps) do     
    if ComponentGetValue2(comp, "name") == "position_tracker" then
      var_store = comp
      break
    end
  end
end

if old_position and (x ~= old_position.x or y ~= old_position.y) then
  local val = ComponentGetValue2(var_store, "value_string")
  local stored_coords = decode_stored_coords(val)
  table.insert(stored_coords, x)
  table.insert(stored_coords, y)
  
  if #stored_coords > max_amount_to_store then
    table.remove(stored_coords, 1)
    table.remove(stored_coords, 1)
  end
  
  local encode_string = encode_coords_to_store(stored_coords)
  
  ComponentSetValue2(var_store, "value_string", encode_string)
end
old_position = {x=x, y=y};