dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/new_enemies/files/resize_entity_lib/shrink_lib.lua")

local entity_id = GetUpdatedEntityID()
local value = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
local ex, ey = EntityGetTransform( entity_id )
-- local game_effect_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GameEffectComponent")
-- ComponentSetValue2(game_effect_component, "mCooldown", value)

function toggle_all_emissive(bool)

	local all_entities = EntityGetInRadius(ex, ey, 9999999999999999 )

	--Turn off all emissive sprites D:
	for i, entity in ipairs(all_entities) do
	
		local ex, ey = EntityGetTransform( entity )

		local sprite_comps = EntityGetComponent(entity, "SpriteComponent") or {}
		
		for i, comp in ipairs(sprite_comps) do
		
			if bool == true then
			
				local cx, cy = GameGetCameraPos()
			
				
				if (ex < cx + 256) or
					(ex > cx - 256) or
					(ey > cy - 150) or
					(ey < cy + 150) then

					
				
					if ComponentGetValue2(comp, "emissive") == true then
					
						ComponentSetValue2(comp, "emissive", false)
						ComponentSetValue2(comp, "z_index", -50)
						EntityRefreshSprite(entity, comp)
						
						if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
							ComponentAddTag( comp, "has_emissive_sprite" )
						end
					
					end
				else
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentGetValue2(comp, "emissive") == false then
						
							ComponentSetValue2(comp, "emissive", true)
							EntityRefreshSprite(entity, comp)
							
						end
					end
				end
				
			elseif bool == false then
			
				if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
				
					if ComponentGetValue2(comp, "emissive") == false then
					
						ComponentSetValue2(comp, "emissive", true)
						EntityRefreshSprite(entity, comp)
						
					end
				end
				
			end
		end
		
		local sprite_particle_comps = EntityGetComponent(entity, "SpriteParticleEmitterComponent") or {}
		
		for i, comp in ipairs(sprite_particle_comps) do
		
			if bool == true then
			
				local cx, cy = GameGetCameraPos()
				
				if (ex < cx + 256) or
					(ex > cx - 256) or
					(ey > cy - 150) or
					(ey < cy + 150) then
				
					if ComponentGetValue2(comp, "emissive") == true then
					
						ComponentSetValue2(comp, "emissive", false)
						ComponentSetValue2(comp, "z_index", -50)
						-- EntityRefreshSprite(entity, comp)
						if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
							ComponentAddTag( comp, "has_emissive_sprite" )
						end
					
					end
				else
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentGetValue2(comp, "emissive") == false then
							ComponentSetValue2(comp, "emissive", true)					
						end
					end
				end
				
			elseif bool == false then
			
				if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
				
					if ComponentGetValue2(comp, "emissive") == false then
						ComponentSetValue2(comp, "emissive", true)	
					end
				end
			end
		end
		
		local projectile_comps = EntityGetComponent(entity, "ProjectileComponent") or {}
		
		for i, comp in ipairs(projectile_comps) do
		
			if bool == true then
			
				local cx, cy = GameGetCameraPos()
				
				if (ex < cx + 256) or
					(ex > cx - 256) or
					(ey > cy - 150) or
					(ey < cy + 150) then
				
					if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == true then
					
						ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", false )
						-- EntityRefreshSprite(entity, comp)
						if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
							ComponentAddTag( comp, "has_emissive_sprite" )
						end
					
					end
				else
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == false then
						
							ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", true )
							
						end
					end
				end
				
			elseif bool == false then
			
				if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
				
					if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == false then
						ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", true )	
					end
				end
			end
		end
		
		
		local explosion_comps = EntityGetComponent(entity, "ExplosionComponent") or {}
		
		for i, comp in ipairs(explosion_comps) do
		
			if bool == true then
			
				local cx, cy = GameGetCameraPos()
				
				if (ex < cx + 256) or
					(ex > cx - 256) or
					(ey > cy - 150) or
					(ey < cy + 150) then
				
					if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == true then
					
						ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", false )
						-- EntityRefreshSprite(entity, comp)
						if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
							ComponentAddTag( comp, "has_emissive_sprite" )
						end
					
					end
				else
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == false then
						
							ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", true )	
							
						end
					end
				end
				
			elseif bool == false then
			
				if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
				
					if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == false then
						ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", true )	
					end
				end
			end
		end
	end
end
if value > 2 then
	local polymorphed_player = EntityGetClosestWithTag(0, 0, "polymorphed_player")
	if polymorphed_player > 0 then
		local ppx, ppy = EntityGetTransform( polymorphed_player )
		EntitySetTransform(entity_id, ppx, ppy)
		toggle_all_emissive(false)
		GameSetPostFxParameter("zoom_in_amount", 1, 0, 0, 0)
	else
		EntityKill(entity_id)
	end
end