dofile_once("data/scripts/lib/coroutines.lua")
-- dofile( "data/scripts/game_helpers.lua" )
async_loop(function()

	wait(100)

	dofile_once("data/scripts/lib/utilities.lua")

	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform(entity_id)
	local players = EntityGetInRadiusWithTag(x, y, 250, "player_unit")

	if #players > 0 then
	  
		local player_x, player_y = EntityGetTransform(players[1])
		local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, player_x, player_y)
	  
		if not did_hit then
			
			local child_id = EntityCreateNew()
			EntitySetTransform(child_id, x, y)
			EntityAddComponent(child_id, "InheritTransformComponent", {} )
			EntityAddChild(entity_id, child_id)
			local comp = EntityAddComponent2(child_id, "ParticleEmitterComponent", {
				emitted_material_name="spark_green_bright",
				-- gravity.y="0.0",
				lifetime_min=0.5,
				lifetime_max=1.5,
				count_min=1,
				count_max=3,
				render_on_grid=true,
				fade_based_on_lifetime=true,
				-- area_circle_radius.max="40",
				cosmetic_force_create=false,
				airflow_force=0.5,
				airflow_time=0.01,
				airflow_scale=0.05,
				emission_interval_min_frames=1,
				emission_interval_max_frames=1,
				emit_cosmetic_particles=true,
				is_emitting=true,
				draw_as_long=true,
				attractor_force=100,
			} )
			ComponentSetValue2(comp, "gravity", 0, 0)
			ComponentSetValue2(comp, "area_circle_radius", 0, 20)
			EntityAddComponent(child_id, "AudioComponent", {
				file="data/audio/Desktop/projectiles.bank",
				event_root="player_projectiles/megalaser",
			} )
			-- GamePlaySound("data/audio/Desktop/explosion.bank", "explosion_small", x, y)
			EntityAddComponent(child_id, "LifetimeComponent", {
				lifetime="60",
			} )
			
			wait(60)
			
			local child_id2 = EntityCreateNew()
			EntitySetTransform(child_id2, x, y)
			EntityAddComponent(child_id2, "InheritTransformComponent", {} )
			EntityAddChild(entity_id, child_id2)
			local comp2 = EntityAddComponent2(child_id2, "ParticleEmitterComponent", {
				emitted_material_name="spark_green_bright",
				-- gravity.y="0",
				-- offset.x="0",
				-- offset.y="0",
				x_pos_offset_min=0,
				y_pos_offset_min=0,
				x_pos_offset_max=0,
				y_pos_offset_max=0,
				x_vel_min=0,
				x_vel_max=0,
				y_vel_min=0,
				y_vel_max=0,
				friction=4,
				count_min=30,
				count_max=50,
				-- area_circle_radius.max="4",
				-- area_circle_radius.min="4",
				velocity_always_away_from_center=80,
				lifetime_min=0.9,
				lifetime_max=3.2,
				render_on_grid=false,
				airflow_force=0.25,
				airflow_time=0.101,
				airflow_scale=2.01,
				fade_based_on_lifetime=true,
				create_real_particles=false,
				emit_cosmetic_particles=true,
				emission_interval_min_frames=5,
				emission_interval_max_frames=5,
				delay_frames=8,
				is_emitting=true,
			} )
			ComponentSetValue2(comp2, "gravity", 0, 0)
			ComponentSetValue2(comp2, "offset", 0, 0)
			ComponentSetValue2(comp2, "area_circle_radius", 4, 4)
			EntityAddComponent(child_id2, "LuaComponent", {
				script_source_file="data/scripts/projectiles/thou_laser_projectile_spawner.lua",
				execute_every_n_frame="5",
			} )
			-- EntityAddComponent(child_id2, "AudioLoopComponent", {
				-- file="data/audio/Desktop/animals.bank",
				-- event_name="animals/wraith/vortex_loop",
				-- auto_play="1",
			-- } )
			-- GamePlaySound("data/audio/Desktop/projectiles.bank", "player_projectiles/wall/create", x, y)
			EntityAddComponent(child_id2, "LifetimeComponent", {
				lifetime="20",
			} )
			
		end
		
	end

end)