dofile_once("data/scripts/new_enemies_utils.lua")
dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/misc/coordinate_loader.lua" )

--evaisa's effect
dofile_once("data/scripts/animals/player_ai_movement_utilities.lua")

local effect_entity_id = GetUpdatedEntityID()
local player_id = EntityGetParent( effect_entity_id )
local x, y = EntityGetTransform( player_id )

-- Time travel effect only works for the player, so if another entity is affected, just kill the effect
if not EntityHasTag(player_id, "player_unit") then 
  if EntityGetComponent(player_id, "GenomeDataComponent") == nil then
	EntityKill(effect_entity_id) 
	return
  end
end

-- This is because globals somehow don't get cleared when the script gets removed...

if EntityHasTag(player_id, "player_unit") == true then

	local tick = GetValueInteger("tick", 0)
	if tick == 0 then
		stored_coords = nil
	end
	SetValueInteger("tick", tick + 1)
	
	if not stored_coords then
	  local var_store = get_component_with_values(player_id, "VariableStorageComponent", { name = "position_tracker" })
	  if var_store then
		local val = ComponentGetValue2(var_store, "value_string")
		stored_coords = decode_stored_coords(val)
	  else
		return
	  end
	end

	EntitySetComponentsWithTagEnabled(effect_entity_id, "enabled_in_world", true)
	if #stored_coords > 0 then
	  EntitySetTransform(player_id, stored_coords[#stored_coords-1], stored_coords[#stored_coords])
	  table.remove(stored_coords , #stored_coords)
	  table.remove(stored_coords , #stored_coords)
	else
	  local var_store = get_component_with_values(player_id, "VariableStorageComponent", { name = "position_tracker" })
	  if var_store ~= nil and var_store > 0 then
		ComponentSetValue2(var_store, "value_string", "")
	  end
	  EntityKill(effect_entity_id)
	end
	
else

	local tick2 = GetValueInteger("tick2", 0)
	if tick2 == 0 then
		stored_coords2 = nil
	end
	SetValueInteger("tick2", tick2 + 1)

	if not stored_coords2 then
	  local var_store3 = get_component_with_values(player_id, "VariableStorageComponent", { name = "position_tracker2" })
	  if var_store3 ~= nil and var_store3 > 0 then
		local val = ComponentGetValue2(var_store3, "value_string")
		stored_coords2 = decode_stored_coords(val)
	  else
		return
	  end
	end
	
	if #stored_coords2 > 0 then
		EntitySetTransform(player_id, stored_coords2[#stored_coords2-1], stored_coords2[#stored_coords2])
	  
	  -- Evaisa's Junk

		function node_func ( node, neighbor, goal, node_density )
			--print(table.dump(neighbor))
			--print(table.dump(node))

			--print("hella_rawr")

			local MAX_DIST = node_density

			local distance_from_walls = 5
				
			if get_distance( node.x, node.y, neighbor.x, neighbor.y ) > MAX_DIST then
				return false
			end

			--GamePrint("hellaa")

			
			if (neighbor ~= goal and
				(RaytraceSurfaces( neighbor.x, neighbor.y, node.x, node.y ) or 
				RaytraceSurfaces( neighbor.x, neighbor.y, neighbor.x + distance_from_walls, neighbor.y ) or 
				RaytraceSurfaces( neighbor.x, neighbor.y, neighbor.x, neighbor.y + distance_from_walls) or 
				RaytraceSurfaces( neighbor.x, neighbor.y, neighbor.x - distance_from_walls, neighbor.y ) or 
				RaytraceSurfaces( neighbor.x, neighbor.y, neighbor.x, neighbor.y - distance_from_walls) or 
				RaytraceSurfaces( neighbor.x, neighbor.y, neighbor.x + distance_from_walls, neighbor.y + distance_from_walls ) or 
				RaytraceSurfaces( neighbor.x, neighbor.y, neighbor.x - distance_from_walls, neighbor.y + distance_from_walls) or 
				RaytraceSurfaces( neighbor.x, neighbor.y, neighbor.x + distance_from_walls, neighbor.y - distance_from_walls ) or 
				RaytraceSurfaces( neighbor.x, neighbor.y, neighbor.x - distance_from_walls, neighbor.y - distance_from_walls)))then
				return false
			end

			return not RaytraceSurfaces( neighbor.x, neighbor.y, node.x, node.y )
		end
	  
		path_true, node_grid = FindPath( x, y, stored_coords2[#stored_coords2-1], stored_coords2[#stored_coords2], true, node_func )
		if(path_true == nil)then
			return
		end

		path = path_true
		
	  value = -1
	  
	  for k, v in pairs(path_true)do
		sx, sy = v.x, v.y
	  	local marker = EntityLoad( "data/entities/misc/time_marker.xml", sx, sy )
		
		value = value + ( -1 * 0.5 )
		
		local sprite_particle_emitter_component = EntityGetFirstComponentIncludingDisabled(marker, "SpriteParticleEmitterComponent")
		ComponentSetValue2(sprite_particle_emitter_component, "color_change", 0, 0, 0, value)
	  end
	  
	  EntityKill(effect_entity_id)
	end
end
