dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/misc/coordinate_loader.lua" )

local entity_id = GetUpdatedEntityID()
local player_id = EntityGetParent( entity_id )

if EntityGetName(player_id) ~= "DEBUG_NAME:player" then 
	EntityKill(entity_id) 
	return
end

local x, y = EntityGetTransform( entity_id )
    
local var_store_comps = EntityGetComponent(player_id, "VariableStorageComponent") or {}
local lua_comps = EntityGetComponent(player_id, "LuaComponent") or {}

for i, comp in ipairs(lua_comps) do
                        
    if ComponentGetValue2(comp, "script_source_file") == "data/scripts/misc/position_tracker.lua" then
            
        EntitySetComponentIsEnabled( player_id, comp, false )
                 
        EntityAddComponent(entity_id, "LuaComponent", {
            script_source_file="data/scripts/misc/position_tracker_enabler.lua",
            execute_on_removed=1,
            execute_every_n_frame=-1,
        }) 
            
    end
            
end

-- This is because globals somehow don't get cleared when the script gets removed...
local tick = GetValueInteger("tick", 0)
if tick == 0 then
    stored_coords = nil
end
SetValueInteger("tick", tick + 1)

if not stored_coords then

  for i, var_comp in ipairs(var_store_comps) do
  
      if ComponentGetValue2(var_comp, "name") == "position_tracker" then
      
          local val = ComponentGetValue2(var_comp, "value_string")
          stored_coords = decode_stored_coords(val)
          
      end
      
  end
  
end

if #stored_coords > 0 then
  EntitySetTransform(player_id, stored_coords[#stored_coords-1], stored_coords[#stored_coords])
  table.remove(stored_coords , #stored_coords)
  table.remove(stored_coords , #stored_coords)
else
    EntityKill(entity_id)
end