dofile_once("data/scripts/new_enemies_utils.lua")
dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/misc/coordinate_loader.lua" )

local effect_entity_id = GetUpdatedEntityID()
local player_id = EntityGetParent( effect_entity_id )

-- Time travel effect only works for the player, so if another entity is affected, just kill the effect
if EntityGetName(player_id) ~= "DEBUG_NAME:player" then 
	EntityKill(effect_entity_id) 
	return
end

-- This is because globals somehow don't get cleared when the script gets removed...
local tick = GetValueInteger("tick", 0)
if tick == 0 then
  stored_coords = nil
end
SetValueInteger("tick", tick + 1)

if not stored_coords then
  local var_store = get_component_with_values(player_id, "VariableStorageComponent", { name = "position_tracker" })
  if var_store then
    local val = ComponentGetValue2(var_store, "value_string")
    stored_coords = decode_stored_coords(val)
  else
    return
  end
end

if #stored_coords > 0 then
  EntityLoad("data/entities/misc/toxic_converter.xml", stored_coords[#stored_coords-1], stored_coords[#stored_coords])
  table.remove(stored_coords , #stored_coords)
  table.remove(stored_coords , #stored_coords)
else
  local var_store = get_component_with_values(player_id, "VariableStorageComponent", { name = "position_tracker" })
  if var_store then
    ComponentSetValue2(var_store, "value_string", "")
  end
  EntityKill(effect_entity_id)
end
