local entity_id = GetUpdatedEntityID()
local owner = EntityGetParent(entity_id)
local character_platforming_component = EntityGetFirstComponentIncludingDisabled(owner, "CharacterPlatformingComponent")

local properties_to_change = {
	run_velocity = 0,
	jump_velocity_y = 0,
	jump_velocity_x = 0,
	fly_velocity_x = 0,
	fly_speed_max_up = 0,
	fly_speed_mult = 0,
	fly_speed_change_spd = 0
}

if character_platforming_component then
	local old_values = ""
	for k, v in pairs(properties_to_change) do
		local value = ComponentGetValue2(character_platforming_component, k)
		local string_value = tostring(value)
		if type(value) == "boolean" then
			string_value = value and "1" or "0"
		end
		old_values = old_values .. k .. ":" .. type(value) .. "=" .. string_value
		if next(properties_to_change, k) then
			old_values = old_values .. ","
		end
		ComponentSetValue2(character_platforming_component, k, v)
	end

	EntityAddComponent2(owner, "VariableStorageComponent", {
		name = "new_enemies_web_effect_old_values",
		value_string = old_values,
	})
end
