dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local projectiles = EntityGetInRadiusWithTag( x, y, 192, "projectile" )
if ( #projectiles > 0 ) then
	for i,projectile_id in ipairs( projectiles ) do
		local tags = EntityGetTags( projectile_id )
		
		if ( tags == nil ) or ( string.find( tags, "disc_bullet" ) == nil ) then
			local px, py = EntityGetTransform( projectile_id )
			local vel_x, vel_y = 0,0
			
			local projectilecomponents = EntityGetComponent( projectile_id, "ProjectileComponent" )
			local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )
			
			if ( projectilecomponents ~= nil ) then
				for j,comp_id in ipairs( projectilecomponents ) do
					ComponentSetValue( comp_id, "on_death_explode", "0" )
					ComponentSetValue( comp_id, "on_lifetime_out_explode", "0" )
				end
			end
			
			if ( velocitycomponents ~= nil ) then
				edit_component( projectile_id, "VelocityComponent", function(comp,vars)
					vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
				end)
			end
			
			local projectile_component = EntityGetFirstComponent(projectile_id, "ProjectileComponent")
			mWhoShot = ComponentGetValue2(projectile_component, "mWhoShot")
			
			local lua_comps = EntityGetComponent(mWhoShot, "LuaComponent") or {}
			
			local found = false
			
			for i, comp in ipairs(lua_comps) do
				if ComponentGetValue2(comp, "script_shot") ~= "" and ComponentGetValue2(comp, "script_shot") ~= "mods/raksa/files/powers/correct_friendly_fire.lua" then
					found = true
					break
				end		
			end
			
			if found then
				shoot_projectile( projectile_id, "data/entities/projectiles/deck/disc_bullet.xml", px, py, vel_x, vel_y )
			else
				shoot_projectile_from_projectile( projectile_id, "data/entities/projectiles/deck/disc_bullet.xml", px, py, vel_x, vel_y )
			end
			
			EntityKill( projectile_id )
		end
	end
end