dofile_once("data/scripts/lib/utilities.lua")

function shot( projectile_id )

	local range = 300
	local projectile_velocity = 20
	local scatter = 0.2

	local entity_id = GetUpdatedEntityID()
	local x, y, succ, scale_x = EntityGetTransform(entity_id)

	-- locate nearest enemy
	local enemy, enemy_x, enemy_y
	local min_dist = 9999
	for _,id in pairs(EntityGetInRadiusWithTag(x, y, range, "mortal")) do
		-- is target a valid enemy
		if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(entity_id, id) < 40 then
			local tx, ty = EntityGetFirstHitboxCenter( id )
			local dist = get_distance(x, y, tx, ty)
			if dist < min_dist then
				min_dist = dist
				enemy = id
				enemy_x = tx
				enemy_y = ty
			end
		end
	end
	
	function attack(origin_x, origin_y)
		if ( enemy ~= 0 ) and ( enemy ~= nil ) then
			-- direction
			local vel_x, vel_y = vec_sub(enemy_x, enemy_y, origin_x, origin_y)
			vel_x,vel_y = vec_normalize(vel_x, vel_y)

			-- apply velocity & shoot
			vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)
			shoot_projectile( entity_id, "data/entities/projectiles/alien_shot.xml", origin_x, origin_y, vel_x, vel_y, false)
			GamePlaySound( "data/audio/Desktop/animals.bank", "animals/statue/appear", origin_x, origin_y )
		end
	end
	
	if scale_x < 0 then
	
		attack(x - 10, y - 21)
		attack(x - 10, y - 9)
		attack(x + 9, y - 23)
		attack(x + 11, y - 14)
		
	elseif scale_x > 0 then
	
		attack(x + 10, y - 21)
		attack(x + 10, y - 9)
		attack(x - 9, y - 23)
		attack(x - 11, y - 14)
		
	end
	
end