dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/new_enemies/files/wiring_utilities.lua")

local this = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(this)
local power = EntityGetVariable(this, "power", "value_bool") 
local particles = EntityGetFirstComponent(this, "ParticleEmitterComponent")
local sprite_component = EntityGetFirstComponent(this, "SpriteComponent")

local dist = 100
local xAdd = 9.5
local force = EntityGetVariable(this, "float:force", "value_float")
local rotation = rot

local corrected = rot-degToRad(90)
local dirX, dirY = math.cos(corrected), math.sin(corrected)

--DebugSquare(LocalToGlobal(x, y, xAdd, -dist, rot))
--DebugSquare(LocalToGlobal(x, y, -xAdd, -dist, rot))
--DebugSquare(LocalToGlobal(x, y, xAdd, 0, rot))
--DebugSquare(LocalToGlobal(x, y, -xAdd, 0, rot))

function inRange(posX, posY)
	local lx, ly = GlobalToLocal(x, y, posX, posY, rot)
	return (lx < xAdd and lx > -xAdd and ly < 0 and ly > -dist)
end

function calculate_force_at(body_x, body_y)
	if not inRange(body_x, body_y) then return 0, 0 end
	local distance = Distance(x+(dirX*dist), y+(dirY*dist), body_x, body_y)
	local f = force * distance 
	
	local forceX, forceY = f *dirX, f *dirY
	return forceX,forceY
end
function calculate_force_for_body( entity, body_mass, body_x, body_y, body_vel_x, body_vel_y, body_vel_angular )
	local fx, fy = calculate_force_at(body_x, body_y)
return body_x,body_y,fx,fy,0 
end

local entities = EntityGetInRadius(x, y, dist)
for _,id in ipairs(entities) do	
	local physicscomp = EntityGetFirstComponent(id, "PhysicsBody2Component") or EntityGetFirstComponent(id, "PhysicsBodyComponent")
	local px, py = EntityGetTransform(id)
	if EntityGetIsAlive(id) and not physicscomp and inRange(px, py) then		
		local fx, fy = calculate_force_at(px, py)		
		ApplyForcePlus(id, fx/4, fy/4)
	end
end	
PhysicsApplyForceOnArea( calculate_force_for_body, this, x-dist, y-dist, x+dist, y+dist)

