dofile_once( "data/scripts/game_helpers.lua" )
dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/projectiles/overmind.lua" )

function spawn_portal(which_one, material)
	local entity_id = GetUpdatedEntityID()
	local x,y = EntityGetTransform( entity_id )
	
	-- local opts = { "portal_orb_blue", "portal_orb_green", "portal_orb_pink" }
	
	SetRandomSeed( GameGetFrameNum(), x + entity_id )
	
	local raycasts = 4
	local dir = ( math.pi * 2.0 ) / raycasts
	local length = 8
	
	-- local rnd = Random( 1, #opts )
	local portal = "data/entities/projectiles/" .. which_one .. ".xml"
	
	local p = EntityGetWithTag( "player_unit" )
	
	if ( #p > 0 ) then
		local t = p[1]
		local px, py = EntityGetTransform( t )
		
		local dx = px + Random( -150, 150 )
		local dy = py + Random( -150, 150 )
		
		local dist = math.abs( py - dy ) + math.abs( px - dx )
		local limit = 0
		local wall = true
		
		while ( ( dist < 100 ) or wall ) and ( limit < 20 ) do
			dx = px + Random( -100, 100 )
			dy = py + Random( -100, 100 )
			dist = math.abs( py - dy ) + math.abs( px - dx )
			limit = limit + 1
			
			for j=0,raycasts-1 do
				local ex = dx + math.cos( j * dir ) * length
				local ey = dy - math.sin( j * dir ) * length
				
				wall = RaytraceSurfaces( dx, dy, ex, ey )
				
				if wall then
					break
				end
			end
		end
		if portal == "data/entities/projectiles/portal_sand" then
			EntityLoad( "data/entities/particles/poof_blue.xml", dx, dy )
		end
		local portal_id = EntityLoad( portal, dx, dy )
		EntityAddChild(entity_id, portal_id)
		
		-- Add Trail Particles
			
		local particle_comp = EntityAddComponent2(portal_id, "ParticleEmitterComponent", {
				  emitted_material_name=material,
				  x_pos_offset_min=-2,
				  x_pos_offset_max=2,
				  y_pos_offset_min=-2,
				  y_pos_offset_max=2,
				  x_vel_min=-50,
				  x_vel_max=50,
				  y_vel_min=-50,
				  y_vel_max=50,
				  count_min=0,
				  count_max=1,
				  is_trail=true,
				  trail_gap=1,
				  lifetime_min=0.8,
				  lifetime_max=0.8,
				  fade_based_on_lifetime=true,
				  create_real_particles=false,
				  emit_cosmetic_particles=true,
				  collide_with_grid=false,
				  emission_interval_min_frames=0,
				  emission_interval_max_frames=0,
				  airflow_force=0.36,
				  airflow_time=1.20,
				  airflow_scale=0.28,
				  is_emitting=true,
		} )
		ComponentSetValue2(particle_comp, "gravity", 0, 0)
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
		EntityAddComponent(portal_id, "LuaComponent", {
			script_source_file="data/scripts/animals/head_statue_particles.lua",
			execute_every_n_frame="1",
			execute_on_added="1",
		} )
			
		-- EntityAddComponent(particles_id, "LifetimeComponent", {
			-- lifetime="240",
		-- } )
	end
end

local theEntity = GetUpdatedEntityID()

local x, y = EntityGetTransform( theEntity )

--Constraint the boss to only move up and down
local character_data_component = EntityGetFirstComponent(theEntity, "CharacterDataComponent")
local vel_component = EntityGetFirstComponent(theEntity, "VelocityComponent")
local vel_x, vel_y = ComponentGetValue2( character_data_component, "mVelocity" )
local vel_x2, vel_y2 = ComponentGetValue2( vel_component, "mVelocity" )
ComponentSetValue2(character_data_component, "mVelocity", 0 , vel_y )
ComponentSetValue2(vel_component, "mVelocity", 0 , vel_y2 )

local closestEntity = get_players()[1]

local var_comp = EntityGetFirstComponentIncludingDisabled( theEntity, "VariableStorageComponent" )
local phase = ComponentGetValue2(var_comp, "value_bool")
	
SetRandomSeed( GameGetFrameNum(), x + y + theEntity )

local number = GetValueNumber("number", 0)
SetValueNumber("number", number + 1)
if phase == false then

	if (number < 1000 ) and ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 3 == 0 ) then
	
		x = x + rand(-1000, 1000)
		y = y + rand(-512, -512)

		shoot_projectile( theEntity, "data/entities/projectiles/arrow_rain.xml", x, y, 0, 10, false )
		
	elseif ( number >= 1000 ) and ( number < 2000 ) and ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 210 == 0 ) then

		spawn_portal("portal_sand","sand")
		
	elseif number >= 2000 then
	
		SetValueNumber("number", 0)
		
	end
	
else

	if (number < 500 ) and ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 3 == 0 ) then
	
		x = x + rand(-1000, 1000)
		y = y + rand(-512, -512)

		shoot_projectile( theEntity, "data/entities/projectiles/sand_shot_sky.xml", x, y, 0, 60, false )
		
	elseif ( number >= 500 ) and ( number < 1000 ) and ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 210 == 0 ) then
	
		EntityLoad( "data/entities/projectiles/sand_geyser_start.xml", x, y )
		
	elseif number >= 1000 then
	
		SetValueNumber("number", 0)
		
	end
end