dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()

local projectile_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ProjectileComponent")
local shooter_id = ComponentGetValue2(projectile_component, "mWhoShot") 
local x, y, rot, scale_x  = EntityGetTransform(shooter_id)
local character_data_component = EntityGetFirstComponent(shooter_id, "CharacterDataComponent")
local velocity_x, velocity_y = ComponentGetValue2(character_data_component, "mVelocity")
local character_platforming_component = EntityGetFirstComponent(shooter_id, "CharacterPlatformingComponent")

local animal_ai_component = EntityGetFirstComponentIncludingDisabled(shooter_id, "AnimalAIComponent")
local controls_component = EntityGetFirstComponentIncludingDisabled(shooter_id, "ControlsComponent")
		
if character_data_component then 

	if scale_x < 0 then	
		
		-- EntitySetComponentIsEnabled( shooter_id, animal_ai_component, false )
		-- EntitySetComponentIsEnabled( shooter_id, controls_component, false )
		-- EntitySetTransform(shooter_id, x, y, rot, scale_x * -1)

		-- EntitySetComponentIsEnabled( shooter_id, character_platforming_component, false )

		EntityAddComponent(shooter_id, "LuaComponent", {
			script_source_file="data/scripts/animals/restore_scale_left.lua",
			execute_on_added="1",
			execute_every_n_frame="1",
			execute_times="100",
		} )
		
		-- EntityLoad( "data/entities/misc/bazooka_recoil.xml", x - 5, y )
		shoot_projectile( entity_id, "data/entities/misc/bazooka_recoil.xml", x - 5, y, 400, 0, false )
		
		-- ComponentSetValue2(character_data_component, "mVelocity", velocity_x + 4000 , velocity_y )
		
	elseif scale_x > 0 then	
		
		-- EntitySetComponentIsEnabled( shooter_id, animal_ai_component, false )
		-- EntitySetComponentIsEnabled( shooter_id, controls_component, false )
		-- EntitySetTransform(shooter_id, x, y, rot, scale_x * -1)
		
		-- EntitySetComponentIsEnabled( shooter_id, character_platforming_component, false )
		
		EntityAddComponent(shooter_id, "LuaComponent", {
			script_source_file="data/scripts/animals/restore_scale_right.lua",
			execute_on_added="1",
			execute_every_n_frame="1",
			execute_times="100",
		} )
		
		-- EntityLoad( "data/entities/misc/bazooka_recoil.xml", x + 5, y )
		shoot_projectile( entity_id, "data/entities/misc/bazooka_recoil.xml", x + 5, y, -400, 0, false )
		
		-- ComponentSetValue2(character_data_component, "mVelocity", velocity_x - 4000 , velocity_y )
	end
	
end
