dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local range = 150
local target, targetX, targetY
local min_dist = 1000
for _,id in pairs(EntityGetInRadiusWithTag(x, y, range, "mortal")) do
	-- is target a valid enemy
	if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
		local target_x, target_y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(x, y, target_x, target_y)
		if dist < min_dist then
			min_dist = dist
			target = id
			targetX = target_x
			targetY = target_y
		end
	end
end

target_id = target

local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y , targetX, targetY)

if ( target_id ~= 0) and ( target_id ~= nil) and not did_hit then
	tx, ty = EntityGetTransform( target_id )
	angle = 0 - math.atan2( ty - y, tx - x )
	
	local length = Random( 150, 200 )

	vel_x = math.cos( angle ) * length
	vel_y = 0- math.sin( angle ) * length
	
	local velocity_component = EntityGetFirstComponent(entity_id, "VelocityComponent")
	if (velocity_component ~= nil) and (velocity_component > 0) then
		local velocity_x, velocity_y = ComponentGetValue2( velocity_component, "mVelocity")

		if(velocity_x ~= nil)then
			PhysicsApplyForce(entity_id, -velocity_x * 0.051 + Random(-40, 40), -velocity_y * 0.051 + Random(-40, 40))
		end
	end

	PhysicsApplyForce(entity_id, vel_x * 0.051 + Random(-40, 40), vel_y * 0.051 + Random(-40, 40))
	
end

--KILL IF IN WATER
local entity_in_water, hit_x, hit_y = RaytraceSurfacesAndLiquiform( x, y, x, y )

if entity_in_water then
	EntityKill(entity_id)
end