dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local projectile_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ProjectileComponent")
local shooter_id = ComponentGetValue2(projectile_component, "mWhoShot")   
local already_has_child = false
for _, child in ipairs(EntityGetAllChildren(shooter_id) or {} ) do
	if EntityGetName(child) == "laser_spawner" then
		already_has_child = true
	end
end
if already_has_child == false then
	EntityAddChild(shooter_id, entity_id)
	
	EntityAddComponent(entity_id, "LuaComponent", {
		script_source_file="data/scripts/projectiles/boss_eel_start_laser.lua",
		execute_every_n_frame="30",
		execute_times="1",
		remove_after_executed="1"
	})
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
else
	EntityKill(entity_id)
end