dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/gun/procedural/gun_action_utils.lua")

local entity_id = GetUpdatedEntityID()
local x,y,dir,sx,sy = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local var_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")

local projectile_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ProjectileComponent")
local shooter_id = ComponentGetValue2(projectile_component, "mWhoShot")
local sx,shy = EntityGetTransform( shooter_id )

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") <= 1 then
	if Random(1,2) == 1 then
		ComponentSetValue2(var_component, "value_bool", true)
	else
		ComponentSetValue2(var_component, "value_bool", false)
	end
end

local radius = GetValueNumber("radius", 1)
SetValueNumber("radius", radius + 1)

local laser_comps = EntityGetComponent(entity_id, "LaserEmitterComponent") or {}
for i, laser_comp in ipairs(laser_comps) do
	ComponentObjectSetValue( laser_comp, "laser", "beam_radius", math.min(32, radius * 0.1) )
	ComponentObjectSetValue( laser_comp, "laser", "damage_to_entities", math.min(0.25, radius*0.1) )
end

local dir2 = ComponentGetValue2(var_component, "value_bool")

if dir2 == true then
	EntitySetTransform(entity_id, sx, shy, dir + 0.002)
else
	EntitySetTransform(entity_id, sx, shy, dir - 0.002)
end