dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()

local radius = GetValueNumber("radius", 1)
SetValueNumber("radius", radius + 1)

edit_component( entity_id, "BlackHoleComponent", function(comp,vars)
	vars.radius = math.min(160, radius * 1.3)
	vars.particle_attractor_force = math.min( 8, radius * 0.8 )
end)

edit_component( entity_id, "CellEaterComponent", function(comp,vars)
	vars.radius = math.min(60, radius)
	vars.eat_probability = math.min( 80, radius * 0.8) 
end)

edit_component( entity_id, "MagicConvertMaterialComponent", function(comp,vars)
	vars.radius = math.min(120, radius)
end)

edit_component( entity_id, "DamageNearbyEntitiesComponent", function(comp,vars)
	vars.radius = math.min(85, radius)
end)

edit_component( entity_id, "SpriteComponent", function(comp,vars)
	vars.special_scale_x = math.min(1, radius * 0.01)
	vars.special_scale_y = math.min(1, radius * 0.01)
end)

local particle_comps = EntityGetComponent(entity_id, "ParticleEmitterComponent") or {}
for i, particle_comp in ipairs(particle_comps) do
	ComponentSetValue2(particle_comp, "area_circle_radius", math.min(24, radius), math.min(72, radius * 5))
	ComponentSetValue2(particle_comp, "velocity_always_away_from_center", math.min(300, radius * 5))
	ComponentSetValue2(particle_comp, "count_min", math.min(40, radius * 0.4))
	ComponentSetValue2(particle_comp, "count_max", math.min(60, radius * 0.6))
end