dofile_once( "data/scripts/lib/utilities.lua" )

function shot( projectile_id )
	local entity_id = GetUpdatedEntityID()
	local pos_x, pos_y, rot, scale_x  = EntityGetTransform(entity_id)

	local enemy, enemy_x, enemy_y
	local min_dist = 9999
	for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, 250, "mortal")) do
		-- is target a valid enemy
		if entity_id ~= id  and (EntityGetHerdRelation(entity_id, id) < 40) and EntityGetParent(id) ~= entity_id and (EntityGetComponent(id, "GenomeDataComponent") ~= nil)	then
			local entity_x, entity_y = EntityGetFirstHitboxCenter( id )
			local dist = get_distance(pos_x, pos_y, entity_x, entity_y)
			if dist < min_dist then
				min_dist = dist
				enemy = id
				enemy_x = entity_x
				enemy_y = entity_y
			end
		end
	end

	if not enemy then return end


	local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
	vel_x,vel_y = vec_normalize(vel_x, vel_y)

	-- apply velocity & shoot

	local projectile_velocity = 160
	vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)

	shoot_projectile( entity_id, "data/entities/projectiles/eggshot.xml", pos_x, pos_y + 5, vel_x, vel_y, false)
end