dofile_once("mods/brimstone_beam/scripts/get_modifier.lua")

function enabled_changed( entity_id, is_enabled )
    print("brimstone is in hand:"..tostring(is_enabled))
    local player_id= EntityGetWithTag( "player_unit" )[1]
    local px, py = EntityGetTransform( player_id)
    if player_id == nil then return end

    local children =EntityGetAllChildren( entity_id )
    local child_beam = nil
    if children ~= nil then
        for i,child in ipairs( children) do
            if EntityHasTag(child, "brimstone_beam" ) then
                child_beam = child
                break
            end
        end
    end


    local effect_entities = EntityGetWithTag( "disable_shot" )
    if is_enabled then
        if #effect_entities ~= 0 then
            for i,effect_entity in pairs(effect_entities) do
                EntityKill( effect_entity )
            end
        end
        local  effect_entity = EntityLoad( "mods/brimstone_beam/entities/fizzle.xml", px, py )
        EntityAddChild( player_id, effect_entity )

        ---检测杖里的法术
        local action_list = {}
        local charge_speed = 1
        local inventory = EntityGetFirstComponent(player_id, "Inventory2Component" )
        if  ( inventory ~= nil ) then
            local active_wand = ComponentGetValue2( inventory, "mActiveItem" )
            --法术
            local spells = EntityGetAllChildren( active_wand )
            if ( spells ~= nil ) then
                for j,spell_id in ipairs( spells ) do
                    local comp = EntityGetFirstComponentIncludingDisabled( spell_id, "ItemActionComponent" )
                    if ( comp ~= nil ) then
                        local action_id = ComponentGetValue2( comp, "action_id" )
                        table.insert( action_list, action_id )
                    end
                end
            end
            --回蓝
            local abl_comp = EntityGetFirstComponentIncludingDisabled( active_wand, "AbilityComponent" )
            if abl_comp ~= nil then
                local mana_charge_speed  = tonumber(ComponentGetValue(abl_comp, "mana_charge_speed"))
                charge_speed = mana_charge_speed/100
                GlobalsSetValue( "BRIMSTONE_CHARGE_SPEED", tostring(charge_speed))
            end
        end
        local damage_add,color = get_modifier( action_list)
        if damage_add~= 0 then
            local emitter_comps = EntityGetComponentIncludingDisabled( child_beam, "LaserEmitterComponent" )
            if ( emitter_comps ~= nil ) then
                for i,comp in ipairs(emitter_comps) do
                    --local width = ComponentObjectGetValue2( comp, "laser", "beam_radius" ) or 0
                    local dmg = ComponentObjectGetValue2( comp, "laser", "damage_to_entities" ) or 0
                    --local length = ComponentObjectGetValue2( comp, "laser", "max_length" ) or 0

                    --width = width + 2.0
                    dmg = 0.14+damage_add
                    --length = length + 36
                    if (ModSettingGet( "brimstone_beam.time" )) then
                        dmg = dmg * 1.8
                    end
                    --ComponentObjectSetValue2( comp, "laser", "beam_radius", width )
                    ComponentObjectSetValue2( comp, "laser", "damage_to_entities", dmg )
                    --ComponentObjectSetValue2( comp, "laser", "max_length", length )
                end
            end
        end
        if color ~="" and  (color == "blue" or  color == "white" or  color == "yellow")then
            local beam_sprite_comps_a = EntityGetComponentIncludingDisabled( child_beam, "SpriteComponent","color_change_a" )
            local beam_sprite_comps_b = EntityGetComponentIncludingDisabled( child_beam, "SpriteComponent","color_change" )
            local beam_sprite_comps_c = EntityGetComponentIncludingDisabled( child_beam, "SpriteComponent","color_change_c" )
            for i,comp in ipairs(beam_sprite_comps_a) do
                ComponentSetValue2( comp, "image_file", "mods/brimstone_beam/gfx/effect_brimstone_beam_a_"..color..".xml" )
            end
            for i,comp in ipairs(beam_sprite_comps_b) do
                ComponentSetValue2( comp, "image_file", "mods/brimstone_beam/gfx/effect_brimstone_beam_b_"..color..".xml" )
                --ComponentSetValue2( comp, "image_file", "mods/brimstone_beam/gfx/effect_brimstone_beam_b_green.xml" )
            end
            for i,comp in ipairs(beam_sprite_comps_c) do
                ComponentSetValue2( comp, "image_file", "mods/brimstone_beam/gfx/effect_brimstone_beam_c_"..color..".xml" )
            end
        end
--[[

        --]]
    else
        ----删除短路效果
        if #effect_entities ~= 0 then
            for i,effect_entity in pairs(effect_entities) do
                EntityKill( effect_entity )
            end
        end
        -----改回基础伤害
        local emitter_comps = EntityGetComponentIncludingDisabled( child_beam, "LaserEmitterComponent" )
        if ( emitter_comps ~= nil ) then
            for i,comp in ipairs(emitter_comps) do
                if (ModSettingGet( "brimstone_beam.time" )) then
                    ComponentObjectSetValue2( comp, "laser", "damage_to_entities",0.252 )
                else
                    ComponentObjectSetValue2( comp, "laser", "damage_to_entities",0.14 )
                end

            end
        end
        GlobalsSetValue( "BRIMSTONE_CHARGE_SPEED", "1")
        ----改回红色
        local beam_sprite_comps_a = EntityGetComponentIncludingDisabled( child_beam, "SpriteComponent","color_change_a" )
        local beam_sprite_comps_b = EntityGetComponentIncludingDisabled( child_beam, "SpriteComponent","color_change" )
        local beam_sprite_comps_c = EntityGetComponentIncludingDisabled( child_beam, "SpriteComponent","color_change_c" )
        for i,comp in ipairs(beam_sprite_comps_a) do
            ComponentSetValue2( comp, "image_file", "mods/brimstone_beam/gfx/effect_brimstone_beam_a.xml" )
        end
        for i,comp in ipairs(beam_sprite_comps_b) do
            ComponentSetValue2( comp, "image_file", "mods/brimstone_beam/gfx/effect_brimstone_beam_b.xml" )
        end
        for i,comp in ipairs(beam_sprite_comps_c) do
            ComponentSetValue2( comp, "image_file", "mods/brimstone_beam/gfx/effect_brimstone_beam_c.xml" )
        end
        ----取消发射
        EntitySetComponentsWithTagEnabled( child_beam, "enabled_when_release",false)
        local var_components = EntityGetComponentIncludingDisabled( entity_id, "VariableStorageComponent" )
        local var_comp = nil
        if( var_components ~= nil ) then
            for i,comp_id in pairs(var_components) do
                local var_name = ComponentGetValue( comp_id, "name" )
                if( var_name == "charge_comp") then
                    var_comp = comp_id
                end
                break
            end
        end
        ComponentSetValue2(var_comp,"value_float",0.0)
        ComponentSetValue2(var_comp,"value_string","wait")
    end

    --[[
    local lua_comp = EntityGetComponentIncludingDisabled( entity_id, "LuaComponent", "disable_shot" )
    if is_enabled then
        if lua_comp == nil then
            EntityAddComponent2( entity_id, "LuaComponent", {
                _tags="disable_shot",
                _enabled=true,
                script_shot="data/scripts/projectiles/neutralized.lua",
                execute_every_n_frame="-1"
            })
        end
    else
        if lua_comp ~= nil then
            EntityRemoveComponent( entity_id, lua_comp )
        end
    end
    --]]
end