dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/gun/procedural/gun_action_utils.lua")

local entity_id = GetUpdatedEntityID()
local x,y,dir,sx,sy = EntityGetTransform( entity_id )

local function getDistance(x1, y1, x2, y2)
	return math.sqrt(math.pow((y2-y1),2)+math.pow((x2-x1),2))
end

local x2 =x+ math.cos( dir ) * 288
local y2 = y+math.sin( dir ) * 288
local did_hit, hit_x,hit_y = RaytraceSurfacesAndLiquiform( x, y, x2, y2 )
local sprite_enable_num
local distance

local sprite_width = 9
local max_distance = 300

-- local time_counter = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")


if did_hit then

	distance= getDistance(x,y,hit_x,hit_y)

	local scale = math.min(distance, max_distance) / sprite_width
	
	EntitySetTransform(entity_id, x, y, dir , scale, sy)
	
	EntityLoad("data/entities/particles/particle_explosion/eradicator_laser_explosion.xml", hit_x, hit_y)
	
	
	--Here's an alternate attack which has an explosive laser.
	
	-- local entities = EntityGetInRadiusWithTag( hit_x, hit_y, 5, "vine_projectile" )

	-- if ( #entities > 1 ) then
		-- return
	-- else
		-- if time_counter % 10 == 0 then
		
			-- local exp_id = EntityCreateNew()
			-- EntitySetTransform(exp_id, hit_x, hit_y)
			
			-- local comp = EntityAddComponent2(exp_id, "LoadEntitiesComponent", {
				-- timeout_frames= (140-time_counter),
				-- kill_entity=true,
				-- entity_file="data/entities/projectiles/eradicator_explosion_delayed.xml"
			-- } )
			-- ComponentSetValue2(comp, "count", 1, 1)
			-- local explosion_entity = EntityLoad("data/entities/particles/particle_explosion/eradicator_laser_explosion_delayed.xml", hit_x, hit_y)
			-- local load_entities_component = EntityGetFirstComponent(explosion_entity, "LoadEntitiesComponent") 
			-- ComponentSetValue2(load_entities_component, "timeout_frames", 140 - time_counter)
		
		-- end
	-- end	
else

	distance= max_distance

	local scale = math.min(distance, max_distance) / sprite_width

	EntitySetTransform(entity_id, x, y, dir , scale, sy)

end

--Set enemy's x velocity to 0

function set_controls_enabled(id, enabled)
  local entity = id
  if entity then
    local controls_component = EntityGetFirstComponentIncludingDisabled(entity, "ControlsComponent")
    ComponentSetValue2(controls_component, "enabled", enabled)
  end
end

local parent_id = EntityGetParent( entity_id )

set_controls_enabled(parent_id, false)

local character_data_component = EntityGetFirstComponentIncludingDisabled(parent_id, "CharacterDataComponent")

if ComponentGetValue2( character_data_component, "is_on_ground" ) == true
or ComponentGetValue2( character_data_component, "is_on_slippery_ground" ) == true then

	local velocity_component = EntityGetFirstComponentIncludingDisabled(parent_id, "VelocityComponent")

	vel_x, vel_y = ComponentGetValue2( velocity_component, "mVelocity" )

	ComponentSetValue2(character_data_component, "mVelocity", 0, vel_y)
	ComponentSetValue2(velocity_component, "mVelocity", 0, vel_y)
	ComponentSetValue2(character_data_component, "ground_stickyness", 1)
	
end

