dofile_once("data/scripts/lib/utilities.lua")

--Particle Effects!

local entity_id = GetUpdatedEntityID()

local parent_id = EntityGetParent( entity_id )

if parent_id > 0 then
	local parent_x, parent_y = EntityGetTransform(parent_id)
	
	parent_y = parent_y - 5

	local particle_emitter_component = EntityGetFirstComponent(entity_id, "ParticleEmitterComponent")

	ComponentSetValue2(particle_emitter_component, "mExPosition", parent_x, parent_y)
end
	
--Entity Movement Towards Player:

local lerp_amount = 0.98
local offset_x = 15
local bob_h = 0
local bob_w = 0
local bob_speed_y = 0.023
local bob_speed_x = 0.02
local rotate_amount = math.pi * 0.05
local rotate_speed = 0.093

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

if pos_x == 0 and pos_y == 0 then
	pos_x, pos_y = EntityGetTransform(EntityGetParent(entity_id))
end


-- ghost continously lerps towards a target that floats around the parent

local players = EntityGetWithTag("player_unit")

if #players > 0 then

	local target_x, target_y = EntityGetTransform((players[1]))
	local body_x, body_y = target_x, target_y -- store for drawing the arms
	if target_x == nil then return end
	target_y = target_y

	-- handedness from variable storage
	local comp = get_variable_storage_component(entity_id, "is_right")
	if (comp ~= nil) and (comp > 0) then
		is_right = ComponentGetValue2(comp, "value_bool")
	end
	if not is_right then offset_x = -offset_x end

	target_x = target_x

	local time = GameGetFrameNum()
	local r = ProceduralRandomf(entity_id, 0, -1, 1)

	-- randomize times and speeds slightly so that multiple fists don't fly identically
	time = time + r * 10000
	bob_speed_y = bob_speed_y + (r * bob_speed_y * 0.1)
	bob_speed_x = bob_speed_x + (r * bob_speed_x * 0.1)
	lerp_amount = lerp_amount - (r * lerp_amount * 0.01)

	-- bob
	target_y = target_y + math.sin(time * bob_speed_y) * bob_h
	target_x = target_x + math.sin(time * bob_speed_x) * bob_w

	-- rotate
	rotate_amount = rotate_amount * math.sin(time * rotate_speed)

	-- move towards target
	pos_x,pos_y = vec_lerp(pos_x, pos_y, target_x, target_y, lerp_amount)
	EntitySetTransform( entity_id, pos_x, pos_y, rotate_amount, 1, 1)

end
