dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

-- Get the position and rotation of the enemy
local pos_x, pos_y, rot = EntityGetTransform(entity_id)

-- Calculate the target position using raycasting
local max_raycast_distance = 500
local did_hit, hit_x, hit_y = RaytracePlatforms(pos_x, pos_y, pos_x + math.cos(rot) * max_raycast_distance, pos_y + math.sin(rot) * max_raycast_distance)

if did_hit then
	-- Calculate the direction towards the target
	local dir_x = hit_x - pos_x
	local dir_y = hit_y - pos_y
	local dir_length = math.sqrt(dir_x * dir_x + dir_y * dir_y)

	-- Calculate the number of explosions to spawn
	local explosion_interval = 10  -- Adjust the interval between explosions
	local num_explosions = math.floor(dir_length / explosion_interval)

	-- Calculate the step size for each explosion
	local step_x = dir_x / num_explosions
	local step_y = dir_y / num_explosions

	-- Spawn explosions along the trajectory
	for i = 1, num_explosions do
		local explosion_x = pos_x + step_x * i
		local explosion_y = pos_y + step_y * i
		EntityLoad("data/entities/projectiles/gold_blast.xml", explosion_x, explosion_y)
	end
end