dofile_once("data/scripts/lib/utilities.lua")

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

function get_direction( x1, y1, x2, y2 )
    return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local state = get_state()
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local vx, vy = GameGetVelocityCompVelocity(entity_id)

state.tick = (state.tick or 0) + 1

local vx1, vy1 = vec_rotate(vx, vy, math.rad(90 - state.tick * 30))
shoot_projectile_from_projectile(entity_id, "data/entities/projectiles/hairling_laser_child.xml", x, y, vx1, vy1)
if state.tick < 3 then
  local vx2, vy2 = vec_rotate(vx, vy, -math.rad(90 - state.tick * 30))
  shoot_projectile_from_projectile(entity_id, "data/entities/projectiles/hairling_laser_child.xml", x, y, vx2, vy2)
end

if state.tick == 3 then
  EntityKill(entity_id)
  state[entity_id] = nil
end