dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local player = EntityGetWithName("DEBUG_NAME:player")
if player > 0 then
	local is_unseen = false
	for i, child_id in ipairs(EntityGetAllChildren(player) or {}) do

		local game_effect_component = EntityGetFirstComponentIncludingDisabled(child_id, "GameEffectComponent")
		
		if game_effect_component then
			local name = ComponentGetValue2( game_effect_component, "custom_effect_id" )
			if name == "NEW_ENEMIES_UNSEEN" then
				is_unseen = true
			else
				is_unseen = false
			end
		end

	end
	
	if is_unseen == false then
	
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		
		local proj_component = EntityGetFirstComponent(entity_id, "ProjectileComponent")
		ComponentSetValue2(proj_component, "muzzle_flash_file", "data/entities/particles/muzzle_flashes/muzzle_flash_small.xml")
		
		local sprite_particle_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteParticleEmitterComponent")
		ComponentSetValue2(sprite_particle_component, "is_emitting", true)
		
		local particle_components = EntityGetComponentIncludingDisabled(entity_id, "ParticleEmitterComponent") or {}
		for _, comp in ipairs(particle_components) do
			ComponentSetValue2(comp, "is_emitting", true)
		end
	end
else
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
	local proj_component = EntityGetFirstComponent(entity_id, "ProjectileComponent")
	ComponentSetValue2(proj_component, "muzzle_flash_file", "data/entities/particles/muzzle_flashes/muzzle_flash_small.xml")
	
	local sprite_particle_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteParticleEmitterComponent")
	ComponentSetValue2(sprite_particle_component, "is_emitting", true)
	
	local particle_components = EntityGetComponentIncludingDisabled(entity_id, "ParticleEmitterComponent") or {}
	for _, comp in ipairs(particle_components) do
		ComponentSetValue2(comp, "is_emitting", true)
	end
end