dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y, rot = EntityGetTransform( entity_id )

local entities = EntityGetInRadiusWithTag( pos_x, pos_y, 8, "fungitrap_02" )

if ( #entities < 1 ) then

	SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id )

	function get_state()
	  local entity_id = GetUpdatedEntityID()
	  state = state or {}
	  state[entity_id] = state[entity_id] or {}
	  return state[entity_id]
	end

	local state = get_state()

	state.tick = (state.tick or 0) % 3 + 1 -- Goes from 1 to 3 then resets back to 1
	
	-- pos_x = pos_x + rand(-4, 4)
	-- pos_y = pos_y + rand(-4, 4)
	-- local vel_x = rand(-20, 20)
	-- local vel_y = rand(-20, 20)

	local projectile = shoot_projectile_from_projectile( entity_id, "data/entities/projectiles/mwyah_tentacle_trail_head.xml", pos_x, pos_y, 0, 0 )

	local projectile_component = EntityGetFirstComponent( projectile, "ProjectileComponent" );

	if projectile_component then
		ComponentSetValue( projectile_component, "velocity_sets_rotation", "0" );
	end

	EntitySetTransform( projectile, pos_x, pos_y, rot )
	
elseif ( #entities >= 1 ) then
	for i, entity in ipairs(entities  or {}) do
      local sprite_comps = EntityGetComponent(entity, "SpriteComponent") or {}
      for i, sprite_comp in ipairs(sprite_comps) do
		EntityRefreshSprite(entity, sprite_comp)
	  end
	  
      local lt_comps = EntityGetComponent(entity, "ProjectileComponent") or {}
      for i, lt_comp in ipairs(lt_comps) do
		ComponentSetValue2(lt_comp, "lifetime", 45)
	  end
	end
end