function make_dead(entity_id)
  local effect_id = LoadGameEffectEntityTo(entity_id, "data/entities/misc/effect_necromancy_gazer.xml")
  local damage_model_component = EntityGetFirstComponent(entity_id, "DamageModelComponent")
  local physics_AI = EntityGetFirstComponent(enemy, "PhysicsAIComponent")
  
  if not physics_AI and damage_model_component then
	  --print("Applying necromancy to entity "..entity_id..". Entity hp before necromancy is "..ComponentGetValue2(damage_model_component, "hp")..".")
	  ComponentSetValue2(damage_model_component, "hp", 0)
	  -- ComponentSetValue2(damage_model_component, "air_needed", true)
	  ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
  end
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local enemies = EntityGetInRadiusWithTag(x, y, 300, "enemy")

for i, enemy in ipairs(enemies) do
  if enemy ~= entity_id and not EntityHasTag(enemy, "boss_tag") then
    local physics_AI = EntityGetFirstComponent(enemy, "PhysicsAIComponent")
    if physics_AI == nil then
      EntityAddComponent(enemy, "VariableStorageComponent", {
        _tags="no_gold_drop",
      })
      make_dead(enemy)
    end
  end
end