dofile_once("data/scripts/new_enemies_utils.lua")
dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/misc/coordinate_loader.lua" )

local max_amount_to_store = 300

local function getDistance(x1, y1, x2, y2)
	return math.sqrt(math.pow((y2-y1),2)+math.pow((x2-x1),2))
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local var_store = get_component_with_values(entity_id, "VariableStorageComponent", { name = "position_tracker" })
if var_store then
    local val = ComponentGetValue2(var_store, "value_string")
    local stored_coords = decode_stored_coords(val)
    table.insert(stored_coords, x)
    table.insert(stored_coords, y)
    
    if #stored_coords > max_amount_to_store then
      table.remove(stored_coords, 1)
      table.remove(stored_coords, 1)
    end
    
    local encode_string = encode_coords_to_store(stored_coords)
    
    ComponentSetValue2(var_store, "value_string", encode_string)
end
