dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()

local parent_id = EntityGetParent( entity_id )

local character_platforming_component = EntityGetFirstComponentIncludingDisabled(parent_id, "CharacterPlatformingComponent")

local properties_to_change = {
	run_velocity = 0,
	fly_speed_max_up = 0,
	jump_velocity_y = 0,
	jump_velocity_x = 0,
	fly_velocity_x = 0,
	fly_speed_max_up = 0
}

if character_platforming_component then
	local old_values = ""
	for k, v in pairs(properties_to_change) do
		local value = ComponentGetValue2(character_platforming_component, k)
		local string_value = tostring(value)
		if type(value) == "boolean" then
			string_value = value and "1" or "0"
		end
		old_values = old_values .. k .. ":" .. type(value) .. "=" .. string_value
		if next(properties_to_change, k) then
			old_values = old_values .. ","
		end
		ComponentSetValue2(character_platforming_component, k, v)
	end

	EntityAddComponent2(parent_id, "VariableStorageComponent", {
		name = "old_values",
		value_string = old_values,
	})
end

local animal_ai_component = EntityGetFirstComponentIncludingDisabled(parent_id, "AnimalAIComponent")
EntitySetComponentIsEnabled( parent_id, animal_ai_component, false )

--animation
local sprite_comps = EntityGetComponent(parent_id, "SpriteComponent") or {}
for i, comp in ipairs(sprite_comps) do

	ComponentRemoveTag( comp, "character" )
	
end

local entity_id    = GetUpdatedEntityID()

EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

local homing_component = EntityGetFirstComponent(entity_id, "HomingComponent")

ComponentSetValue2(homing_component, "max_turn_rate", 0.012)

local parent_id = EntityGetParent( entity_id )

-- local sprite_component = EntityGetFirstComponent(parent_id, "SpriteComponent")

-- ComponentSetValue2(sprite_component, "rect_animation", "attack_laser")

--animation
local sprite_comps = EntityGetComponent(parent_id, "SpriteComponent") or {}
for i, comp in ipairs(sprite_comps) do

	ComponentSetValue2(comp, "rect_animation", "attack_ranged2_loop")
	
end
