local players = EntityGetWithTag("player_unit")

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

if #players > 0 then
  local state = get_state()
  local player_x, player_y = EntityGetTransform(players[1])

  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)

  state.last_velocities = state.last_velocities or {}
  state.player_x_prev = state.player_x_prev or player_x
  state.player_y_prev = state.player_y_prev or player_y

  local avg_vel_x = 0
  local avg_vel_y = 0

  for i, v in ipairs(state.last_velocities) do
    avg_vel_x = avg_vel_x + v.x
    avg_vel_y = avg_vel_y + v.y
  end

  GlobalsSetValue("player_avg_vx", avg_vel_x / #state.last_velocities)
  GlobalsSetValue("player_avg_vy", avg_vel_y / #state.last_velocities)

  local player_vx, player_vy = GameGetVelocityCompVelocity(players[1])
  state.player_x_prev = player_x
  state.player_y_prev = player_y
  table.insert(state.last_velocities, { x = player_vx , y = player_vy })
  if #state.last_velocities > 10 then
    table.remove(state.last_velocities, 1)
  end
end
