dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local projectiles = EntityGetWithTag( "projectile" )

if ( #projectiles > 0 ) then
	for i,projectile_id in ipairs(projectiles) do	
		local px, py = EntityGetTransform( projectile_id )
		
		local distance = math.abs( x - px ) + math.abs( y - py )
		
		if ( distance < 64 ) then
			distance = math.sqrt( ( x - px ) ^ 2 + ( y - py ) ^ 2 )
	
			if ( distance < 48 ) then
				local projectile_component = EntityGetFirstComponent( projectile_id, "ProjectileComponent" )
				local sprite_component = EntityGetFirstComponent( projectile_id, "SpriteComponent" )
				local convert_to_lightning = true

				if ( sprite_component ~= nil and projectile_component ~= nil) then
					local image_file = ComponentGetValue(sprite_component, "image_file")
					if image_file == "data/projectiles_gfx/thunderball.xml" or image_file == "data/projectiles_gfx/meteor.xml" then
						convert_to_lightning = false
					end
				end
				
				if convert_to_lightning then
					local direction = 0 - math.atan2( ( py - y ), ( px - x ) )
					local speed = 6000
					local vel_x = math.cos( direction ) * speed
					local vel_y = 0 - math.sin( direction ) * speed
					shoot_projectile( projectile_id, "data/entities/projectiles/deck/projectile_thunder_lightning.xml", px, py, vel_x, vel_y, false )
					EntityKill( projectile_id )
				end
			end
		end
	end
end