dofile_once("data/scripts/lib/utilities.lua")

function get_direction( x1, y1, x2, y2 )
	return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local players = EntityGetWithTag("player_unit")

if #players > 0 then
  local avg_vel_x = GlobalsGetValue("player_avg_vx", "")
  local avg_vel_y = GlobalsGetValue("player_avg_vy", "")
  if avg_vel_x ~= "" then
    local player_x, player_y = EntityGetTransform(players[1])
    player_y = player_y - 2
    local distance_to_player = get_distance(x, y, player_x, player_y)

    local var_store_projectile_file = get_variable_storage_component(entity_id, "projectile_file")
    local projectile_file = ComponentGetValue(var_store_projectile_file, "value_string")
    local var_store_projectile_speed = get_variable_storage_component(entity_id, "projectile_speed")
    local projectile_speed = ComponentGetValueInt(var_store_projectile_speed, "value_int")
    local var_store_magic_value = get_variable_storage_component(entity_id, "magic_value")
    local magic_value = ComponentGetValueInt(var_store_magic_value, "value_int")
    local var_store_max_range = get_variable_storage_component(entity_id, "max_range")
    local max_range = ComponentGetValueInt(var_store_max_range, "value_int")

    local shoot_at_x = player_x + avg_vel_x * (distance_to_player / projectile_speed * magic_value)
    local shoot_at_y = player_y + avg_vel_y * (distance_to_player / projectile_speed * magic_value)

    local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, shoot_at_x, shoot_at_y)

    if not did_hit and distance_to_player < max_range then
      local dir = get_direction(x, y, shoot_at_x, shoot_at_y)
      local vx = math.cos(dir) * projectile_speed
      local vy = math.sin(dir) * projectile_speed
  
      shoot_projectile_from_projectile(entity_id, projectile_file, x, y, vx, vy)
    end
  end
  EntityKill(entity_id)
end

