local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local all_children = EntityGetAllChildren(entity_id)
local star_container
if all_children ~= nil then
  for i, child in ipairs(all_children) do
    if EntityGetName(child) == "star_container" then
      star_container = child
    end
  end
end

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local num_stars = 4
local radius = 46
local rotation_speed = 2
local state = get_state()
if star_container ~= nil then
  local all_stars = EntityGetAllChildren(star_container)
  if all_stars == nil then
    SetRandomSeed(GameGetFrameNum() + entity_id, GameGetFrameNum())
    for i=1, num_stars do
      local angle = math.rad(360 / num_stars * i)
      local star = EntityLoad("data/entities/projectiles/wraith_star2.xml", x + math.cos(angle) * radius, y + math.sin(angle) * radius)
      EntityAddChild(star_container, star)
    end
  else
    state.tick = (state.tick or 0) + rotation_speed
    if all_stars ~= nil then
      for i, star in ipairs(all_stars) do
        local angle = math.rad(360 / #all_stars * i + state.tick)
        EntitySetTransform(star, x + math.cos(angle) * radius, y + math.sin(angle) * radius)
      end
    end
  end
end
