dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local nearby_mortal = EntityGetClosestWithTag(  x, y, "drone_lasership" )

local energy_shield_component = EntityGetFirstComponentIncludingDisabled(entity_id, "EnergyShieldComponent")

if nearby_mortal > 0 then
	local px, py = EntityGetTransform( nearby_mortal )

	local distance_to_target = get_distance(x, y, px, py)

	if distance_to_target < 40 then
		
		EntitySetComponentIsEnabled( entity_id, energy_shield_component, false )
	else
	
		EntitySetComponentIsEnabled( entity_id, energy_shield_component, true )

	end
	
else

	EntitySetComponentIsEnabled( entity_id, energy_shield_component, true )
	
end

local angle = 0
local rotation = 0
local owner_id = 0
local length = 20

local variablestorages = EntityGetComponent( entity_id, "VariableStorageComponent" )
if ( variablestorages ~= nil ) then
	local anglestorage
	
	for j,storage_id in ipairs(variablestorages) do
		local var_name = ComponentGetValue( storage_id, "name" )
		if ( var_name == "angle" ) then
			angle = ComponentGetValue2( storage_id, "value_float" )
			anglestorage = storage_id
		elseif ( var_name == "rot" ) then
			rotation = ComponentGetValue2( storage_id, "value_int" )
		elseif ( var_name == "owner" ) then
			owner_id = ComponentGetValue2( storage_id, "value_int" )
		end
	end
	
	angle = angle + rotation * 0.02
	
	ComponentSetValue2( anglestorage, "value_float", angle )
end

angle = angle + rotation

if ( owner_id ~= NULL_ENTITY ) then
	local x, y = EntityGetTransform( owner_id )
	
	if ( x ~= nil ) and ( y ~= nil ) then
		local px = x + math.cos( angle ) * length
		local py = y - math.sin( angle ) * length
		
		EntitySetTransform( entity_id, px, py )
	else
		EntityKill( entity_id )
	end
end