dofile_once("data/scripts/lib/utilities.lua")

local max_distance = 3000
local field_of_view = 100
local orbcount = GameGetOrbCountThisRun()
local max_count = math.min(33, orbcount)
local velocity_z = -25 - max_count  -- Fixed velocity for z movement

local player_id = EntityGetWithTag("player_unit")[1]
local targetX, targetY = EntityGetTransform(player_id)
local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

SetRandomSeed(GameGetFrameNum(), x + y + entity_id)

function map(s, a1, a2, b1, b2)
    return b1 + (s - a1) * (b2 - b1) / (a2 - a1)
end

local z = GetValueNumber("z", max_distance)
if not GetValueBool("initialized", false) then
    if not targetX then
        EntityKill(entity_id)
        return
    end
    SetValueBool("initialized", true)
    local dist_x = targetX + (math.random(-10, 10)) - x
    local dist_y = targetY + (math.random(-10, 10)) - y
    local scale = field_of_view / (field_of_view + z)
    SetValueNumber("dist_x", dist_x)
    SetValueNumber("dist_y", dist_y)
    SetValueNumber("origin_x", x - scale * dist_x)
    SetValueNumber("origin_y", y - scale * dist_y)
	SetValueNumber("arc", 0)
end
local origin_x = GetValueNumber("origin_x", x)
local origin_y = GetValueNumber("origin_y", y)
local dist_x = GetValueNumber("dist_x", 0)
local dist_y = GetValueNumber("dist_y", 0)

-- GameCreateSpriteForXFrames( "data/projectiles_gfx/elephant_target.xml", dist_x, dist_y, true, 0, 0, 20, true )

local scale = map(z, max_distance, 0, 0, 1)
-- local visual_scale = map(scale, 0, 1, 0.1, 1)

-- Parameters for the arc
local arc_amplitude = 100  -- Adjust this value to control the height of the arc
local arc_frequency = math.pi / max_distance  -- Adjust this value to control the frequency of the arc

local arc_y = arc_amplitude * math.sin(z * arc_frequency)

EntitySetTransform(entity_id, origin_x + dist_x * scale, origin_y + dist_y * scale - arc_y, rot, 1, 1)

for i, child in ipairs(EntityGetAllChildren(entity_id)) do
    if EntityGetName(child) == "particle" then
        local scale_end = field_of_view / (field_of_view + 0)
        EntitySetTransform(child, origin_x + dist_x * scale_end, origin_y + dist_y * scale_end)
    end
end

z = z + velocity_z
SetValueNumber("z", z)

function get_distance( x1, y1, x2, y2 )
	local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
	return result
end

if z < 0 then

	if ( player_id ~= NULL_ENTITY ) and ( entity_id ~= player_id ) then
		local dist = get_distance(x, y, targetX, targetY)
		if dist < 10 then
			local c = EntityGetAllChildren( player_id )
			
			if ( c ~= nil ) then
				for i,v in ipairs( c ) do
					if EntityHasTag( v, "effect_protection" ) then
						EntitySetComponentsWithTagEnabled( v, "effect_protection", false )
					end
				end
			end
			EntityAddComponent2( player_id, "LuaComponent", 
			{ 
				script_source_file="data/scripts/status_effects/weaken_end_elephant.lua",
				execute_every_n_frame=5
			} )
		end
	end
	
    EntityKill(entity_id)
end