dofile_once("data/scripts/lib/utilities.lua")

local max_distance = 1700
local field_of_view = 5

-- local targetX, targetY = EntityGetTransform(EntityGetWithTag("player_unit")[1])
local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

local var_component = EntityGetFirstComponent(entity_id, "VariableStorageComponent")

function get_player()
  local players = get_players()
  if players ~= nil then
	return players[1]
  end

  -- TODO: What does this mean anyway? Player is dead..?
  return nil
end
	
local player_id = get_player()
local px, py = EntityGetTransform(player_id)


function map(s, a1, a2, b1, b2)
  return b1 + (s-a1)*(b2-b1)/(a2-a1)
end

god_warrior = EntityGetWithName("$god_warrior")
gx, gy = EntityGetTransform(god_warrior)
  
local z = GetValueNumber("z", max_distance)
local vz = -20
if GetValueBool("initialized", false) == false then
  if not px then EntityKill(entity_id) return end
  SetValueBool("initialized", true)
  local dist_x = px + (math.random(-250, 250)) - gx
  local dist_y = py + (math.random(-100, 100)) - gy
  SetValueNumber("dist_x", dist_x)
  SetValueNumber("dist_y", dist_y)
  
  SetValueNumber("origin_x", gx)
  SetValueNumber("origin_y", gy)
end

local origin_x = GetValueNumber("origin_x", gx)
local origin_y = GetValueNumber("origin_y", gy)

local dist_x = GetValueNumber("dist_x", 0)
local dist_y = GetValueNumber("dist_y", 0)
local scale = field_of_view / (field_of_view + ( z / 10 ))
local visual_scale = map(scale, 0, 1, 0.1, 1)

z = z + vz
SetValueNumber("z", z)

local cx, cy = GameGetCameraPos()

local parallaxFactor = GetValueNumber("parallax", 0)
if parallaxFactor >= 1 then
	SetValueNumber("parallax", parallaxFactor - 1/1500)
elseif parallaxFactor <= 0 then
	SetValueNumber("parallax", parallaxFactor + 1/200)
end


if ( god_warrior > 0 ) and ( god_warrior ~= nil ) then
	-- local ox, oy = EntityGetTransform(god_warrior)
	local var_comp2 = get_variable_storage_component( god_warrior, "origin" )
	local ox = ComponentGetValue2(var_comp2, "value_int")
	local oy = tonumber(ComponentGetValue2(var_comp2, "value_string"))

	local offset_x = (cx - gx) * parallaxFactor
	local offset_y = (cy - gy) * parallaxFactor

	new_x = origin_x + dist_x * scale + offset_x
	new_y = origin_y + dist_y * scale + offset_y
else
	new_x = origin_x + dist_x * scale
	new_y = origin_y + dist_y * scale
end

EntitySetTransform(entity_id, new_x, new_y, rot, visual_scale, visual_scale)

if z <= 0 then
	shoot_projectile(entity_id, "data/entities/projectiles/god_warrior_electrode.xml", ( origin_x + dist_x ), ( origin_y + dist_y ), 0, 0, false)
	EntityKill(entity_id)
end