dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

function constrain(entity, x2, y2, max_dist)
    local physcomp = EntityGetFirstComponent(entity, "PhysicsBodyComponent") or EntityGetFirstComponent(entity, "PhysicsBody2Component") or EntityGetFirstComponent(entity, "SimplePhysicsComponent")
    local x1, y1 = EntityGetTransform(entity)
    if (not x1) or (not x2) then return nil end
        
    local dist = math.sqrt(((x2-x1)^2) + ((y2-y1)^2))
    local target_x = x2 + (((x1-x2)/dist)*max_dist)
    local target_y = y2 + (((y1-y2)/dist)*max_dist)
    local target_vel_x = target_x - x1
    local target_vel_y = target_y - y1

    if dist > max_dist then
        if physcomp then
            PhysicsApplyForce(entity, target_vel_x * 10, target_vel_y * 10)
			EntitySetTransform(entity, target_x, target_y)
        end
    end
end
	
for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
	
	constrain(child_id, x, y, 10)

end