dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

local new_x, new_y = vec_rotate(0, -2, rot)
new_x = x + new_x
new_y = y + new_y

-- Adjustable parameters for the sine wave
local wave_frequency = 0.025  -- Adjust the frequency of the wave (lower value) NEEDS TO BE 1/4 of amplitude
local wave_amplitude = 0.1   -- Adjust the amplitude of the wave (higher value)

-- Add a small rotation based on a sine wave with adjustable parameters
local rotation_offset = (math.sin(GameGetFrameNum() * wave_frequency) * wave_amplitude) * 0.5

-- Ensure the rotation stays within the range [0, 2*pi)
rot = math.fmod(rot + rotation_offset, 2 * math.pi)

EntitySetTransform(entity_id, new_x, new_y, rot)

-- Disable fruit components when colliding or in the Holy Mountain biome
local did_hit, _, _ = RaytraceSurfaces(x, y, new_x, new_y)
if did_hit or BiomeMapGetName(x, y) == "$biome_holymountain" then
    EntitySetComponentsWithTagEnabled(entity_id, "fruit", false)
else
    EntitySetComponentsWithTagEnabled(entity_id, "fruit", true)
end

ComponentSetValue2( GetUpdatedComponentID(), "execute_every_n_frame", 3 )

if ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 6 == 0 ) then

	local entity_id = GetUpdatedEntityID()
	local pos_x, pos_y, rot, scale_x = EntityGetTransform( entity_id )

	local prev_entity_id = GetValueNumber("prev_entity_id", 0)
	
	local did_hit, _, _ = RaytraceSurfaces(pos_x, pos_y, pos_x, pos_y)
	if ( not did_hit ) and ( BiomeMapGetName(pos_x, pos_y) ~= "$biome_holymountain" ) then

		local e = EntityLoad( "data/entities/animals/twig.xml", pos_x, pos_y)
		
		local entity_count = GetValueNumber("entity_count", 1)
		SetValueNumber("entity_count", entity_count + 1)

		SetValueNumber("prev_entity_id", e)

		if prev_entity_id > 0 then
			EntityAddChild(prev_entity_id, e)
		end

		EntitySetTransform(e, pos_x, pos_y, rot)

		local value = GetValueNumber("sprite_number", -0.5)

		local sprite_component = EntityGetFirstComponentIncludingDisabled(e, "SpriteComponent")

		ComponentSetValue2( sprite_component, "z_index", value)
		
		local var_component = EntityGetFirstComponentIncludingDisabled(e, "VariableStorageComponent")
		
		-- local delay = 150 * entity_count

		ComponentSetValue2( var_component, "value_float", 1620 - (entity_count * 36) )

		EntityRefreshSprite( e, sprite_component )

		SetValueNumber("sprite_number", value - 0.1)
	else
		SetValueNumber("prev_entity_id", 0)
	end
end