
table.insert(streaming_events,
{
	id = "SEA_OF_URINE",
	ui_name = "Sea Of Urine",
	ui_description = "Summon a sea of urine",
	ui_icon = "data/ui_gfx/streaming_event_icons/health_plus.png",
	ui_author = STREAMING_EVENT_AUTHOR_NOLLAGAMES,
	weight = 0.5,
	kind = STREAMING_EVENT_NEUTRAL,
	delay_timer = 300,
	action_delayed = function(event)
		local players = get_players()
		local t = GameGetFrameNum()
		local opts = { "urine", "poo" }
		
		for i,entity_id in ipairs( players ) do
			local x, y = EntityGetTransform( entity_id )
			
			SetRandomSeed( entity_id, t )
			local rnd = Random( 1, #opts )
			local opt = opts[rnd]

			EntityLoad( "data/scripts/streaming_integration/entities/sea_" .. opt .. ".xml", x, y )
		end
	end,
})

table.insert(streaming_events,
{
	id = "TRANSFORM_BOMBS",
	ui_name = "All Projectiles to Bombs",
	ui_description = "All Projectiles turn to Bombs",
	ui_icon = "data/ui_gfx/streaming_event_icons/protect_enemies.png",
	ui_author = STREAMING_EVENT_AUTHOR_NOLLAGAMES,
	weight = 0.5,
	kind = STREAMING_EVENT_BAD,
	delay_timer = 180,
	action_delayed = function(event)
		for i,entity_id in pairs( get_players() ) do
			local x, y = EntityGetTransform( entity_id )
			
			local effect_id = EntityLoad( "data/scripts/streaming_integration/entities/all_bombs.xml", x, y )
			set_lifetime( effect_id )
			EntityAddChild( entity_id, effect_id )
			
			add_icon_in_hud( effect_id, "data/ui_gfx/status_indicators/bombs.png", event )
		end
	end,
})

for i,v in ipairs(streaming_events) do
  if v.id == "SEA_Of_X" then
	v.action_delayed = function(event)
		local players = get_players()
		local t = GameGetFrameNum()
		local opts = { "lava", "water", "oil", "alcohol", "acid_gas", "urine", "poo", "vomit" }
		
		for i,entity_id in ipairs( players ) do
			local x, y = EntityGetTransform( entity_id )
			
			SetRandomSeed( entity_id, t )
			local rnd = Random( 1, #opts )
			local opt = opts[rnd]

			EntityLoad( "data/scripts/streaming_integration/entities/sea_" .. opt .. ".xml", x, y )
		end
	end
  end
end