function shift_materials(materials_input, output)
	local player = get_player()
	if(player ~= nil)then
		local x, y = EntityGetTransform(player)
		converted_any = false

		from = {materials = {}}
		to = {material = output, twitch_extended = true}

		for i,it in ipairs(materials_input) do
			table.insert(from.materials, it)
			
			local from_material = CellFactory_GetType( it )
			local to_material = CellFactory_GetType( output )
			-- convert
			if ( from_material ~= to_material ) and
				( from_material ~= "ant" ) or
				( from_material ~= "spider_spawner" ) or
				( from_material ~= "spider" ) or
				( from_material ~= "spider_web" ) or
				( from_material ~= "earth_worm" ) or
				( from_material ~= "snake_seed" ) or
				( from_material ~= "snake" ) or
				( from_material ~= "snake_tail" ) or
				( from_material ~= "snake_flower_red" ) or
				( from_material ~= "snake_flower_red2" ) or
				( from_material ~= "snake_flower_red3" ) or
				( from_material ~= "snake_flower_yellow" ) or
				( from_material ~= "snake_flower_yellow2" ) or
				( from_material ~= "snake_flower_yellow3" ) or
				( from_material ~= "snake_flower_orange" ) or
				( from_material ~= "snake_flower_orange2" ) or
				( from_material ~= "snake_flower_orange3" ) or
				( from_material ~= "snake_flower_blue" ) or
				( from_material ~= "snake_flower_blue2" ) or
				( from_material ~= "snake_flower_blue3" ) or
				( from_material ~= "water_bug" ) or
				( from_material ~= "water_swamp_bug" ) or
				( from_material ~= "mosquito" ) or
				( from_material ~= "mosquito_wing" ) or
				( from_material ~= "soil_evaporate" ) or
				( from_material ~= "jungle_seed" ) or
				( from_material ~= "water_health" ) or
				( from_material ~= "rock_box2d_hard_damage" ) or
				( from_material ~= "blood_static" ) or
				( from_material ~= "lava2" ) or
				( from_material ~= "bone_fading" ) or
				( from_material ~= "rock_static_radioactive2" ) or
				( from_material ~= "meat_grey" ) or
				( from_material ~= "blood_grey" ) or
				( from_material ~= "radioactive_liquid2" ) or
				( from_material ~= "rock_hard_border2" ) or
				( from_material ~= "rock_hard_border3" ) or
				( from_material ~= "rock_hard_border4" ) or
				( from_material ~= "radioactive_gas2" ) or
				( from_material ~= "flea" ) or
				( to_material ~= "ant" ) or
				( to_material ~= "spider_spawner" ) or
				( to_material ~= "spider" ) or
				( to_material ~= "spider_web" ) or
				( to_material ~= "earth_worm" ) or
				( to_material ~= "snake_seed" ) or
				( to_material ~= "snake" ) or
				( to_material ~= "snake_tail" ) or
				( to_material ~= "snake_flower_red" ) or
				( to_material ~= "snake_flower_red2" ) or
				( to_material ~= "snake_flower_red3" ) or
				( to_material ~= "snake_flower_yellow" ) or
				( to_material ~= "snake_flower_yellow2" ) or
				( to_material ~= "snake_flower_yellow3" ) or
				( to_material ~= "snake_flower_orange" ) or
				( to_material ~= "snake_flower_orange2" ) or
				( to_material ~= "snake_flower_orange3" ) or
				( to_material ~= "snake_flower_blue" ) or
				( to_material ~= "snake_flower_blue2" ) or
				( to_material ~= "snake_flower_blue3" ) or
				( to_material ~= "water_bug" ) or
				( to_material ~= "water_swamp_bug" ) or
				( to_material ~= "mosquito" ) or
				( to_material ~= "mosquito_wing" ) or
				( to_material ~= "soil_evaporate" ) or
				( to_material ~= "jungle_seed" ) or
				( to_material ~= "water_health" ) or
				( to_material ~= "rock_box2d_hard_damage" ) or
				( to_material ~= "blood_static" ) or
				( to_material ~= "lava2" ) or
				( to_material ~= "bone_fading" ) or
				( to_material ~= "rock_static_radioactive2" ) or
				( to_material ~= "meat_grey" ) or
				( to_material ~= "blood_grey" ) or
				( to_material ~= "radioactive_liquid2" ) or
				( to_material ~= "rock_hard_border2" ) or
				( to_material ~= "rock_hard_border3" ) or
				( to_material ~= "rock_hard_border4" ) or
				( to_material ~= "radioactive_gas2" ) or
				( to_material ~= "flea" then
				
				ConvertMaterialEverywhere( from_material, to_material )
				converted_any = true

				-- shoot particles of new material
				--GameCreateParticle( CellFactory_GetName(from_material), x-10, y-10, 20, rand(-100,100), rand(-100,-30), true, true )
				--GameCreateParticle( CellFactory_GetName(from_material), x+10, y-10, 20, rand(-100,100), rand(-100,-30), true, true )
			end
		end

		if converted_any then
			-- audio
			GameTriggerMusicFadeOutAndDequeueAll( 5.0 )
			GameTriggerMusicEvent( "music/oneshot/tripping_balls_01", false, x, y )

			-- particle fx
			local eye = EntityLoad( "data/entities/particles/treble_eye.xml", x,y-10 )
			if eye ~= 0 then
				EntityAddChild( player, eye )
			end

			-- add ui icon
			local add_icon = true
			local children = EntityGetAllChildren(player)
			if children ~= nil then
				for i,it in ipairs(children) do
					if ( EntityGetName(it) == "fungal_shift_ui_icon" ) then
						add_icon = false
						break
					end
				end
			end

			if add_icon then
				local icon_entity = EntityCreateNew( "fungal_shift_ui_icon" )
				EntityAddComponent( icon_entity, "UIIconComponent", 
				{ 
					name = "$status_reality_mutation",
					description = "$statusdesc_reality_mutation",
					icon_sprite_file = "data/ui_gfx/status_indicators/fungal_shift.png"
				})
				EntityAddChild( player, icon_entity )
			end
		end
	end
end