dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)
local x2, y2 = vec_rotate(0, -25, rot)
local head_x = x + x2
local head_y = y + y2

local x3, y3 = vec_rotate(0, 25, rot)
local feet_x = x + x3
local feet_y = y + y3

if not GetValueBool("initialized", 0) then
  SetValueBool("initialized", 1)
  SetValueNumber("head_origin_x", head_x)
  SetValueNumber("head_origin_y", head_y)
  SetValueNumber("feet_origin_x", feet_x)
  SetValueNumber("feet_origin_y", feet_y)
end

local head_origin_x = GetValueNumber("head_origin_x", head_x)
local head_origin_y = GetValueNumber("head_origin_y", head_y)
local feet_origin_x = GetValueNumber("feet_origin_x", feet_x)
local feet_origin_y = GetValueNumber("feet_origin_y", feet_y)

local pull_back_power = 0.5
local damping = 0.5
local angular_damping = 0.5
-- local pull_back_power = 2.0
-- local damping = 10.0
-- local angular_damping = 5.0

local function pull_point_towards(x1, y1, x2, y2)
  PhysicsApplyForceOnArea(function(body_entity, body_mass, body_x, body_y, body_vel_x, body_vel_y, body_vel_angular)
    local target_x, target_y = x2, y2
    -- GameCreateSpriteForXFrames("data/ui_gfx/debug_marker.png", x1, y1, true, 0, 0, 1)
    -- GameCreateSpriteForXFrames("data/ui_gfx/debug_marker.png", target_x, target_y, true, 0, 0, 1)
    local distance = get_distance(x1, y1, target_x, target_y)
    local rx = x1-body_x
    local ry = y1-body_y
    local rvx, rvy = GameVecToPhysicsVec(-ry*body_vel_angular, rx*body_vel_angular)
    local vx = body_vel_x+rvx
    local vy = body_vel_y+rvy
    -- GameCreateSpriteForXFrames("data/ui_gfx/debug_marker.png", x1+vx, y1+vy, true, 0, 0, 1)
    local force_x = (target_x - x1) * distance * pull_back_power - vx*damping
    local force_y = (target_y - y1) * distance * pull_back_power - vy*damping
    local torque = -angular_damping*body_vel_angular
    return x1, y1, force_x, force_y, torque
  end, 0, x1 - 10, y1 - 10, x1 + 10, y1 + 10)
end

pull_point_towards(head_x, head_y, head_origin_x, head_origin_y)
pull_point_towards(feet_x, feet_y, feet_origin_x, feet_origin_y)