dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)
local x2, y2 = vec_rotate(0, -25, rot)
local head_x = x + x2
local head_y = y + y2

local x3, y3 = vec_rotate(0, 25, rot)
local feet_x = x + x3
local feet_y = y + y3

if not GetValueBool("initialized", 0) then
  SetValueBool("initialized", 1)
  SetValueNumber("head_origin_x", head_x)
  SetValueNumber("head_origin_y", head_y)
  SetValueNumber("feet_origin_x", feet_x)
  SetValueNumber("feet_origin_y", feet_y)
end
local head_origin_x = GetValueNumber("head_origin_x", head_x)
local head_origin_y = GetValueNumber("head_origin_y", head_y)
local feet_origin_x = GetValueNumber("feet_origin_x", feet_x)
local feet_origin_y = GetValueNumber("feet_origin_y", feet_y)

local pull_back_power = 0.8
-- if body_entity ~= entity_id then return 0, 0, 0, 0, 0 end

local function pull_point_towards(x1, y1, x2, y2)
  PhysicsApplyForceOnArea(function(body_entity, body_mass, body_x, body_y, body_vel_x, body_vel_y, body_vel_angular)
    local target_x, target_y = x2, y2
    -- GameCreateSpriteForXFrames("data/ui_gfx/debug_marker.png", x1, y1, true, 0, 0, 1)
    -- GameCreateSpriteForXFrames("data/ui_gfx/debug_marker.png", target_x, target_y, true, 0, 0, 1)
    local dx = target_x - x1
    local dy = target_y - y1
    local distance = math.sqrt(dx^2 + dy^2) -- get_distance(x1, y1, target_x, target_y)
    -- Calculate velocity at this point, factoring in the effects of rotational force
    --local tvx, tvy = vec_rotate()

    -- local new_angle = rot + body_vel_angular / 60

    -- Calculate velocity of point based on angular movement
    local point_offset_x = x1 - x
    local point_offset_y = y1 - y
    local new_point_x_offset, new_point_y_offset = vec_rotate(point_offset_x, point_offset_y, body_vel_angular / 60)
    local new_px = x + new_point_x_offset
    local new_py = y + new_point_y_offset
    -- GameCreateSpriteForXFrames("data/ui_gfx/debug_marker.png", new_px, new_py, true, 0, 0, 1)
    local pvx = new_px - x1
    local pvy = new_py - y1
    if not shid and body_vel_angular > 0 then
      shid = true
      -- print('aaax (' .. tostring(aaax) .. ':'.. type(aaax) .. ')')
      -- print('aaay (' .. tostring(aaay) .. ':'.. type(aaay) .. ')')
      -- print('ppppx (' .. tostring(ppppx) .. ':'.. type(ppppx) .. ')')
      -- print('ppppy (' .. tostring(ppppy) .. ':'.. type(ppppy) .. ')')
      -- print('x1 (' .. tostring(x1) .. ':'.. type(x1) .. ')')
      -- print('y1 (' .. tostring(y1) .. ':'.. type(y1) .. ')')
      -- print('new_px (' .. tostring(new_px) .. ':'.. type(new_px) .. ')')
      -- print('new_py (' .. tostring(new_py) .. ':'.. type(new_py) .. ')')
    end

    -- body_vel_x is per frame
    local force_x = (body_vel_x + pvx * 60) -- * -(distance / 2)
    local force_y = (body_vel_y + pvy * 60) -- * -(distance / 2)

    -- force_x = force_x - vx * 2
    -- force_y = force_y - vy * 2

    local gravity = 0.293701171875 --0.0489501953125 * 6
    --local gravity = 0.0489501953125
    -- return x1, y1, force_x, force_y, 0
    return x, y, 0, -(body_vel_y + gravity) * 60 * 10, 0
    --return x, y, 0, -body_vel_y * 60 * 10 + gravity * 60 * 60, 0
  end, 0, x1 - 10, y1 - 10, x1 + 10, y1 + 10)
end

local dy = (last_frame_y or y) - y
print('dy (' .. tostring(dy) .. ':'.. type(dy) .. ')')
last_frame_y = y

pull_point_towards(head_x, head_y, head_origin_x, head_origin_y)
-- pull_point_towards(feet_x, feet_y, feet_origin_x, feet_origin_y)

-- PhysicsApplyForceOnArea(function(body_entity, body_mass, body_x, body_y, body_vel_x, body_vel_y, body_vel_angular)
--   -- if body_entity ~= entity_id then return 0, 0, 0, 0, 0 end
--   local target_x, target_y = head_origin_x, head_origin_y
--   GameCreateSpriteForXFrames("data/debug/circle_16.png", head_x, head_y, true, 0, 0, 1)
--   GameCreateSpriteForXFrames("data/debug/circle_16.png", target_x, target_y, true, 0, 0, 1)
--   local distance = get_distance(head_x, head_y, target_x, target_y)
--   local force_x = (target_x - head_x) * distance * pull_back_power
--   local force_y = (target_y - head_y) * distance * pull_back_power
--   return head_x, head_y, force_x, force_y, 0
-- end, 0, head_x - 10, head_y - 10, head_x + 10, head_y + 10)

-- PhysicsApplyForceOnArea(function(body_entity, body_mass, body_x, body_y, body_vel_x, body_vel_y, body_vel_angular)
--   -- if body_entity ~= entity_id then return 0, 0, 0, 0, 0 end
--   --local x, y = 0, 0
--   local target_x, target_y = feet_origin_x, feet_origin_y
--   GameCreateSpriteForXFrames("data/debug/circle_16.png", feet_x, feet_y, true, 0, 0, 1)
--   GameCreateSpriteForXFrames("data/debug/circle_16.png", target_x, target_y, true, 0, 0, 1)
--   local distance = get_distance(feet_x, feet_y, target_x, target_y)
--   local force_x = (target_x - feet_x) * distance * pull_back_power
--   local force_y = (target_y - feet_y) * distance * pull_back_power
--   return feet_x, feet_y, force_x, force_y, 0
-- end, 0, feet_x - 10, feet_y - 10, feet_x + 10, feet_y + 10)




-- PhysicsApplyForceOnArea(function(body_entity, body_mass, body_x, body_y, body_vel_x, body_vel_y, body_vel_angular)
--   return force_world_pos_x, force_world_pos_y, force_x, force_y, force_angular
-- end, ignore_this_entity, area_min_x, area_min_y, area_max_x, area_max_y)