dofile_once( "data/scripts/lib/utilities.lua" )
local entity_id    = GetUpdatedEntityID()
local root_id = EntityGetRootEntity( entity_id )
local pos_x, pos_y = EntityGetTransform( entity_id )
local max_dir_ratio_change = 0.4
edit_component( entity_id, "VelocityComponent", function(comp,vars)
	local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity")
	local vel = get_magnitude(vel_x,vel_y)
	if vel <= 900 then
		if vel <= 30 then
			vel = 30
		end
		vel = vel * 1.3
	end
	local ratio =max_dir_ratio_change * (math.min(vel,600)/600)
	
	if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") <= 1 then
		x, y = EntityGetTransform( root_id )
		for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, 300, "mortal")) do
			-- is target a valid enemy
			if EntityGetComponent(id, "GenomeDataComponent") ~= nil and EntityGetHerdRelation(entity_id, id) < 40 and ( id ~= entity_id ) and ( id ~= root_id ) then
				x, y = EntityGetFirstHitboxCenter( id )
			end
		end

		local variable_storage_components = EntityGetComponent(entity_id, "VariableStorageComponent")
		if variable_storage_components ~= nil then
			for i, component in ipairs(variable_storage_components) do
				ComponentSetValue2( component, "value_string", tostring(x) )
				ComponentSetValue2( component, "value_float", y )
			end
		end
	else
		local varcomp = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")

		x=tonumber(ComponentGetValue2(varcomp, "value_string"))
		y=ComponentGetValue2(varcomp, "value_float")
	end
	
	if math.abs(pos_x-x,pos_y-y)<=10 then
		--newdir = dir
		EntityRemoveComponent(entity_id, GetUpdatedComponentID())
		return
	end

	local dir = get_direction(  x,y,pos_x, pos_y )
	local dir2 = 0 - math.atan2( vel_y, vel_x )
	local delta = math.atan2( math.sin( dir - dir2 ), math.cos( dir - dir2 ) )
	if math.abs(delta) >= math.pi/2 then
		delta = (math.pi/2) * (delta/math.abs(delta))
	end
	local newdir = dir2 + delta * ratio
	local addx = math.cos( newdir ) * vel
	local addy = 0 - math.sin( newdir ) * vel
	vel_x = addx
	vel_y = addy
	ComponentSetValueVector2( comp, "mVelocity", vel_x * 0.9, vel_y * 0.9)


end)