dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

-- local cx, cy = GameGetCameraPos()
local cbx, cby, cbw, cbh = GameGetCameraBounds()

local projectiles = EntityGetWithTag( "projectile" )

if ( #projectiles > 0 ) then

	for i,projectile in ipairs( projectiles ) do
	
		local px, py = EntityGetTransform( projectile )
		
		if ( px < cbx or
		px > cbx + cbw or
		py < cby or
		py > cby + cbh ) and
		
		( ComponentGetValue2(EntityGetFirstComponentIncludingDisabled( projectile, "ProjectileComponent"), "mWhoShot") ~= entity_id ) then
		
			EntityApplyTransform(projectile, 66666666, 66666666)
			
			local all_comps = EntityGetAllComponents( projectile ) or {}
			for i, comp in ipairs(all_comps) do
				EntityRemoveComponent( projectile, comp )
			end
			
			local lua_comp = EntityAddComponent2(projectile, "LuaComponent", {
				script_source_file="data/scripts/animals/kill_entity.lua",
				execute_every_n_frame=1,
				execute_on_added=false
			})
			
		end
	end

end