dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/magic/fungal_shift.lua")

materials_from = {}

water 	=	{ probability = 0.4, name = "water", materials = { "water", "water_static", "water_salt", "water_ice" }}
slime  	=	{ probability = 0.4, name = "oils and slimes", materials = { "oil", "swamp", "peat", "slime" }}
organic =	{ probability = 0.5, name = "organics", materials = { "sand_blue", "blood", "blood_fungi", "blood_cold", "blood_worm", "meat", "rotten_meat" }}
potions =	{ probability = 0.3, name = "potions", materials = { "magic_liquid_polymorph", "magic_liquid_unstable_polymorph", "magic_liquid_berserk", "magic_liquid_charm", "magic_liquid_invisibility" }}
metals 	=	{ probability = 0.8, name = "metals", materials = { "gold", "silver", "brass", "copper", "diamond", "steel", "steel_sand", "steel_rust", "steelfrost_static", "steel_static", "steelmoss_static", "steel_grey_static", "steelfrost_static", "steelpipe_static"}}
gas		=	{ probability = 0.8, name = "gasses", materials = { "acid_gas", "acid_gas_static", "poison_gas", "fungal_gas", "radioactive_gas", "radioactive_gas_static", "steam", "smoke", "cloud" }}
rock 	=	{ probability = 0.8, name = "rock", materials = { "rock_static_radioactive","rock_static", "rock_static_glow", "rock_static_purple", "rock_static_noedge", "rock_static_intro", "rock_static_intro_breakable", "rock_static_wet", "rock_static_grey", "snowrock_static", "rock_vault", "concrete_collapsed"} }
poison 	= 	{ probability = 0.5, name = "poisons and toxins", materials = { "acid", "cc_hydroxide", "radioactive_liquid", "poison", "material_darkness", "alcohol" }}
cold	=	{ probability = 0.8, name = "ice and snow", materials = { "ice_static", "ice_glass", "ice_acid_static", "ice_acid_glass", "ice_cold_static", "ice_cold_glass", "ice_radioactive_static", "ice_radioactive_glass", "ice_poison_static", "ice_poison_glass", "slush", "snow", "snow_sticky", "ice_ceiling", "ice_b2", "snow_b2", "snow_static" }}
plants  =	{ probability = 0.8, name = "plants", materials = { "soil_lush", "sand_static_rainforest", "wood_loose", "wood_prop_durable", "wood_prop", "grass_loose", "cactus", "wood", "wood_player_b2", "wood_player", "fungus_loose_trippy", "fungus_loose_green", "fungus_loose", "fungi", "fungus_powder", "grass", "wood_static", "wood_static_vertical", "moss"}}
brickwork = { probability = 1.0, name = "brickwork", materials = { "templebrick_static", "templebrick_noedge_static", "templebrick_static_soft", "templebrick_thick_static", "templebrick_thick_static_noedge", "templebrickdark_static"}}

function shift_materials_in_range(radius, materials_input, output, e_id)
	local shift_entity = EntityCreateNew("shifting_guy")
	if(e_id ~= nil)then
		local x,y = GameGetCameraPos()
		
		EntitySetTransform(shift_entity, x, y)
		for k, v in ipairs(materials_input)do
			EntityAddComponent2(shift_entity, "MagicConvertMaterialComponent", {
				radius = radius,
				from_material = CellFactory_GetType(v),
				to_material = CellFactory_GetType(output),
				kill_when_finished = true,
				is_circle = true,
				steps_per_frame = 256,
			})
			EntityAddComponent2(shift_entity, "LifetimeComponent", {
				lifetime = 5,
			})
			
			function getMaterialCount(material, inventory)
				local count_per_material_type = ComponentGetValue2( inventory, "count_per_material_type");
				for k,v in pairs(count_per_material_type) do
					if v ~= 0 then --material exists in the inventory
						material_name = CellFactory_GetName(k-1)

						material_amount = v
						if(material_name == material)then
							return material_amount
						end
					end
				end   
				return 0  
			end
		end
	end
end

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )

local biome = BiomeMapGetName(pos_x, pos_y)

if (biome == "$biome_coalmine") or (biome == "$biome_coalmine_alt") then
	table.insert(materials_from, water);
	table.insert(materials_from, plants);
	table.insert(materials_from, rock);
	table.insert(materials_from, metals);
	table.insert(materials_from, slime);
	table.insert(materials_from, potions);
	
elseif biome == "$biome_excavationsite" then
	table.insert(materials_from, water);
	table.insert(materials_from, rock);
	table.insert(materials_from, potions);
	table.insert(materials_from, gas);
	table.insert(materials_from, metals);
	table.insert(materials_from, slime);
	table.insert(materials_from, plants);
	
elseif biome == "$biome_snowcave" then
	table.insert(materials_from, cold);
	table.insert(materials_from, rock);
	table.insert(materials_from, gas);
	
	table.insert(materials_from, potions);
elseif biome == "$biome_snowcastle" then
	table.insert(materials_from, cold);
	table.insert(materials_from, rock);
	table.insert(materials_from, gas);
	table.insert(materials_from, metals);
	
	table.insert(materials_from, potions);
	
elseif biome == "$biome_rainforest" then
	table.insert(materials_from, poison);
	table.insert(materials_from, plants);
	table.insert(materials_from, organic);
	
	table.insert(materials_from, potions);
	
elseif biome == "$biome_fun" then
	table.insert(materials_from, water);
	table.insert(materials_from, slime);
	table.insert(materials_from, poison);
	table.insert(materials_from, plants);
	table.insert(materials_from, organic);
	table.insert(materials_from, potions);
	
elseif biome == "$biome_vault"  then
	table.insert(materials_from, gas);
	table.insert(materials_from, organic);
	table.insert(materials_from, rock);
	table.insert(materials_from, gas);
	table.insert(materials_from, metals);
	table.insert(materials_from, slime);
	
	
	table.insert(materials_from, potions);
elseif (biome == "$biome_crypt") or (biome == "$biome_pyramid") then
	table.insert(materials_from, brickwork);
	
	table.insert(materials_from, potions);
elseif biome == "$biome_desert" then
	table.insert(materials_from, { probability = 1.0, name = "sand", materials = {"sand_surface"}});

else
	table.insert(materials_from, water);
	table.insert(materials_from, slime);
	table.insert(materials_from, organic);
	table.insert(materials_from, potions);
	table.insert(materials_from, metals);
	table.insert(materials_from, gas);
	table.insert(materials_from, rock);
	table.insert(materials_from, poison);
	table.insert(materials_from, cold);
	table.insert(materials_from, plants);
	table.insert(materials_from, brickwork);
end

local frame = GameGetFrameNum()

SetRandomSeed( 89346, 42345+frame )

EntityAddComponent( entity_id, "AudioComponent", {
	file="data/audio/Desktop/projectiles.bank",
	event_root="player_projectiles/meteor",
	set_latest_event_position="1"
});

local rnd = random_create(9123,58925+frame )
local from = pick_random_from_table_weighted( rnd, materials_from )
local to = pick_random_from_table_weighted( rnd, materials_to )

local toname = ""
toname = CellFactory_GetUIName(CellFactory_GetType(to.material))
if string.sub(toname, 1, 1) == "$" then
	toname = GameTextGet(toname)
end

shift_materials_in_range(300, from.materials, to.material, entity_id)

