dofile_once("data/scripts/lib/utilities.lua")
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )
local var_comp = get_variable_storage_component( entity_id, "pinning" )
local var_comp2 = get_variable_storage_component( entity_id, "pin_x" )
local var_comp3 = get_variable_storage_component( entity_id, "pin_y" )

local entities = EntityGetInRadiusWithTag( x, y, 50, "fungitrap_02" )
if #entities > 0 then
	pin_var_comp = get_variable_storage_component( entities[0], "pinning" )
	pin_var_comp2 = get_variable_storage_component( entities[0], "pin_x" )
	pin_var_comp3 = get_variable_storage_component( entities[0], "pin_y" )
end

function get_distance( x1, y1, x2, y2 )
	local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
	return result
end
-- local entities2 = EntityGetInRadiusWithTag( x, y, 15, "fungitrap_02" )

if ComponentGetValue2(var_comp, "value_bool") == false then 
	local phys_component = EntityGetFirstComponent(entity_id, "PhysicsBodyComponent")
	-- local physcenter_x, physcenter_y = PhysicsComponentGetTransform( phys_component )
	-- physcenter_x, physcenter_y = PhysicsPosToGamePos( physcenter_x, physcenter_y )

	local physics_bodies = PhysicsBodyIDGetFromEntity( entity_id, phys_component )
	for i, body_id in ipairs(physics_bodies or {}) do
		if i == 2 then
			local bx, by, bangle, bvel_x, bvel_y, bangular_vel = PhysicsBodyIDGetTransform( body_id )
			local phx, phy, phw, phh = PhysicsBodyIDGetBodyAABB( body_id )
			local px, py = PhysicsPosToGamePos( phx, phy )
			local velx, vely = PhysicsVecToGameVec( bvel_x, bvel_y )
			local did_hit, hit_x, hit_y = RaytracePlatforms(px, py, px + (velx * 0.1), py + (vely * 0.1) )
			local wall_dist = get_distance(x, y, hit_x, hit_y)
			-- GameCreateSpriteForXFrames( "data/debug/sui_close_button.png", px + (velx * 0.1), py + (vely * 0.1), true, 0, 0, 1, true )
			if did_hit and (wall_dist < 10) then
				-- GamePrint(wall_dist)
				ComponentSetValue2(var_comp, "value_bool", true)
				ComponentSetValue2(var_comp2, "value_float", hit_x)
				ComponentSetValue2(var_comp3, "value_float", hit_y)
			end
		end
	end
else

	local duration_frames = GetValueNumber( "pin_duration", 0 )
	SetValueNumber( "pin_duration", duration_frames + 1 )
	local phys_component = EntityGetFirstComponent(entity_id, "PhysicsBodyComponent")

-- local physics_bodies = PhysicsBodyIDGetFromEntity( entity_id, phys_component )
-- for i, body_id in ipairs(physics_bodies or {}) do
-- if i == 2 then
	-- local bx, by, bangle, bvel_x, bvel_y, bangular_vel = PhysicsBodyIDGetTransform( body_id )
	local px = ComponentGetValue2(var_comp2, "value_float")
	local py = ComponentGetValue2(var_comp3, "value_float")
	
	local officialhitx = 0
	local officialhity = 0
	
	-- GameCreateSpriteForXFrames( "data/debug/sui_close_button.png", px, py, true, 0, 0, 1, true )
	local did_hit, hit_x, hit_y = RaytracePlatforms(px - 3, py, px + 3, py )
	local did_hit2, hit_x2, hit_y2 = RaytracePlatforms(px - 3, py - 3, px + 3, py + 3 )
	local did_hit3, hit_x3, hit_y3 = RaytracePlatforms(px, py - 3, px, py + 3 )
	local did_hit4, hit_x4, hit_y4 = RaytracePlatforms(px + 3, py - 3, px - 3, py + 3 )
	if did_hit or did_hit2 or did_hit3 or did_hit4 then
		if did_hit then
			officialhitx = hit_x
			officialhity = hit_y
		elseif did_hit2 then
			officialhitx = hit_x2
			officialhity = hit_y2
		elseif did_hit3 then
			officialhitx = hit_x3
			officialhity = hit_y3
		elseif did_hit4 then
			officialhitx = hit_x4
			officialhity = hit_y4
		end

		local bool = ComponentGetValue2(pin_var_comp, "value_bool")
		if ( #entities > 0 ) and ( bool == true ) then
			ex = ComponentGetValue2(pin_var_comp2, "value_float")
			ey = ComponentGetValue2(pin_var_comp3, "value_float")
		else
			ex = px
			ey = py
		end
	
		local direction_x, direction_y = ex - x, ey - y
		local length = math.sqrt(direction_x^2 + direction_y^2)
		
		-- Normalize the direction vector
		if length ~= 0 then
			direction_x = direction_x / length
			direction_y = direction_y / length
		end

		-- Set the magnitude of the force (adjust this value as needed)
		local force_magnitude = 40

		-- Calculate the force components
		local force_x = direction_x * force_magnitude
		local force_y = direction_y * force_magnitude

		-- Apply the force
		
		force_x, force_y = GameVecToPhysicsVec( force_x * 7, force_y * 7)
		
		local physics_bodies = PhysicsBodyIDGetFromEntity( entity_id, phys_component )
		for i, body_id in ipairs(physics_bodies or {}) do
			if i == 2 then
				local bx, by, bangle, bvel_x, bvel_y, bangular_vel = PhysicsBodyIDGetTransform( body_id )
				
				PhysicsBodyIDSetTransform( body_id, bx, by, bangle, force_x, force_y, 0 )
				
				-- if duration_frames > 20 then
				
					-- local phx, phy, phw, phh = PhysicsBodyIDGetBodyAABB( body_id )
					-- local px2, py2 = PhysicsPosToGamePos( phx, phy )
					
					-- LoadPixelScene( "mods/pin_corpse/joint.png", "", px, py, "", true, false, "", 50, true )
					PhysicsAddJoint( entity_id, 0, -1, officialhitx - px, officialhity - py, "REVOLUTE_JOINT" )	
					EntityKill(entity_id)
					-- PhysicsAddJoint( entity_id, 0, -1, -3, -3, "REVOLUTE_JOINT" )
					-- PhysicsAddJoint( entity_id, 0, -1, 3, -3, "REVOLUTE_JOINT" )
					-- PhysicsAddJoint( entity_id, 0, -1, -3, 3, "REVOLUTE_JOINT" )
					-- PhysicsAddJoint( entity_id, 0, -1, 0, 3, "REVOLUTE_JOINT" )	
					-- PhysicsAddJoint( entity_id, 0, -1, 3, 0, "REVOLUTE_JOINT" )	
					-- PhysicsAddJoint( entity_id, 0, -1, 0, -3, "REVOLUTE_JOINT" )
					-- PhysicsAddJoint( entity_id, 0, -1, -3, 0, "REVOLUTE_JOINT" )	
					-- GameCreateSpriteForXFrames( "mods/pin_corpse/dot1.png", px, py, true, 0, 0, 1, true )
					-- GamePrint("yes2")
				
					-- local did_hit, hit_x, hit_y = RaytracePlatforms(px - 5, py, px + 5, py )
					-- local did_hit2, hit_x2, hit_y2 = RaytracePlatforms(px - 5, py - 5, px + 5, py + 5 )
					-- local did_hit3, hit_x3, hit_y3 = RaytracePlatforms(px, py - 5, px, py + 5 )
					-- local did_hit4, hit_x4, hit_y4 = RaytracePlatforms(px + 5, py - 5, px - 5, py + 5 )
					-- if not (did_hit or did_hit2 or did_hit3 or did_hit4) then
						-- EntityKill(entity_id)
					end
				-- end
			end
		-- end
		-- px, py = GamePosToPhysicsPos( px, py )
		-- PhysicsBodyIDSetTransform( body_id, px, py, bangle, bvel_x, bvel_y, bangular_vel )
	else
		EntityKill(entity_id)
	end
		-- end
	-- end
end