dofile_once("mods/new_enemies/files/resize_entity_lib/shrink_lib.lua")
dofile_once("data/scripts/lib/utilities.lua")

function throw_item( from_x, from_y, to_x, to_y )
	local function entity_is_wand(entity_id)
		local ability_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AbilityComponent")
		return ComponentGetValue2(ability_component, "use_gun_script") == true
	end
	local this_entity = GetUpdatedEntityID()
	local scale = 1
	if entity_is_wand(this_entity) then
		scale_wand(this_entity, scale)
		local sprite_components = EntityGetComponentIncludingDisabled(this_entity, "SpriteComponent")
		if sprite_components ~= nil then
			for _, sprite_component in ipairs(sprite_components) do
				ComponentSetValue2(sprite_component, "has_special_scale", false)
				EntityRefreshSprite(this_entity, sprite_component)
			end
		end
		local var_comp = get_variable_storage_component( this_entity, "set_up_original_scale_adjuster" )
		if var_comp ~= nil then
			EntityRemoveComponent(this_entity, var_comp)
		end
		EntityRemoveComponent(this_entity, GetUpdatedComponentID())
	end
	
	if EntityHasTag(this_entity, "item_pickup") or EntityHasTag(this_entity, "item_physics") then
		local sprite_components = EntityGetComponentIncludingDisabled(this_entity, "SpriteComponent")
		if sprite_components ~= nil then
			for _, sprite_component in ipairs(sprite_components) do
				ComponentSetValue2(sprite_component, "has_special_scale", false)
				EntityRefreshSprite(this_entity, sprite_component)
			end
		end
		--handle any particle effects on the held item
		scale_particle_effects_on_entity(this_entity, scale)
		local var_comp = get_variable_storage_component( this_entity, "set_up_original_scale_adjuster" )
		if var_comp ~= nil then
			EntityRemoveComponent(this_entity, var_comp)
		end
		EntityRemoveComponent(this_entity, GetUpdatedComponentID())
	end
end
