dofile_once("mods/new_enemies/files/resize_entity_lib/shrink_lib.lua")

local scalable_entity = GetUpdatedEntityID()
local entity_id = EntityGetParent(scalable_entity)
local scale = update_entity_scale_from_combat(scalable_entity)

--determine if this entity has pieces that will need to be touched every frame or not
local initialized = GetValueBool("beeg_smol.initialized", false)
if not initialized then
    SetValueBool("beeg_smol.update_every_frame", false)

    local children = EntityGetAllChildren(entity_id)
    if children ~= nil then
        for _, child in ipairs(children) do
            --verlet chains need updating every frame for their position
            local verlet = EntityGetFirstComponentIncludingDisabled(child, "VerletPhysicsComponent")
            if verlet ~= nil then
                SetValueBool("beeg_smol.update_every_frame", true)
            end
        end
    end

    --worm components and make worm sprites, hitboxes
    local worm = EntityGetFirstComponentIncludingDisabled(entity_id, "WormComponent")
    if worm ~= nil then
        SetValueBool("beeg_smol.update_every_frame", true)
    end
    --worm components and make worm sprites, hitboxes
    local dragon = EntityGetFirstComponentIncludingDisabled(entity_id, "BossDragonComponent")
    if dragon ~= nil then
        SetValueBool("beeg_smol.update_every_frame", true)
    end

    SetValueBool("beeg_smol.initialized", true)
end

if scale ~= nil then
    scale_enemy(scalable_entity, scale)
end

if GetValueBool("beeg_smol.update_every_frame", false) == true then
    scale = get_scalable_entity_current_scale(scalable_entity)
    update_enemy_every_frame(scalable_entity, scale)
end