dofile_once("data/scripts/lib/utilities.lua")

function get_direction( x1, y1, x2, y2 )
	return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local distance_full = 15

local min_magnitude = 1
local max_magnitude = 10

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform( entity_id )

local velocitycomp = EntityGetFirstComponent( entity_id, "VelocityComponent" )
local vel_x,vel_y = ComponentGetValue2( velocitycomp, "mVelocity")
local magnitude = math.sqrt(vel_x^2 + vel_y^2)
local scaled_magnitude = math.min(max_magnitude, math.max(min_magnitude, magnitude))

local rotation_radians = get_direction(x, y, x + vel_x, y + vel_y)
EntitySetTransform(entity_id, x, y, rotation_radians, -scaled_magnitude)

local entities = EntityGetInRadiusWithTag(x, y, distance_full, "boss")
if #entities > 0 then
	EntityKill(entity_id)
end