--HERE'S A BEAUTIFUL EXAMPLE SCRIPT TO DETECT  WHETHER A COORDINATE IS WITHIN A POLYGON WITH MULTIPLE VERTICES

-- local function dotProduct(v1, v2)
    -- return v1.x * v2.x + v1.y * v2.y
-- end

-- function isPointInPolygon(point, polygon)
    -- local numVertices = #polygon
    -- local minDistanceSquared = dotProduct({x = point.x - polygon[1].x, y = point.y - polygon[1].y}, {x = point.x - polygon[1].x, y = point.y - polygon[1].y})

    -- for i = 1, numVertices do
        -- local j = i - 1
        -- if i == 1 then
            -- j = numVertices
        -- end

        -- -- Calculate distance
        -- local edgeVector = {x = polygon[j].x - polygon[i].x, y = polygon[j].y - polygon[i].y}
        -- local pointVector = {x = point.x - polygon[i].x, y = point.y - polygon[i].y}
        -- local dotProductWE = dotProduct(pointVector, edgeVector)
        -- local dotProductEE = dotProduct(edgeVector, edgeVector)
        -- local projectionScalar = math.min(math.max(dotProductWE / dotProductEE, 0), 1)
        -- local perpendicularVector = {x = pointVector.x - edgeVector.x * projectionScalar, y = pointVector.y - edgeVector.y * projectionScalar}
        -- minDistanceSquared = math.min(minDistanceSquared, dotProduct(perpendicularVector, perpendicularVector))

        -- -- Check the winding number
        -- local condition1 = point.y >= polygon[i].y
        -- local condition2 = point.y < polygon[j].y
        -- local condition3 = edgeVector.x * pointVector.y > edgeVector.y * pointVector.x
        -- if (condition1 and condition2 and condition3) or not (condition1 or condition2 or condition3) then
            -- return true
        -- end
    -- end

    -- return false
-- end

-- local polygon = {
  -- { x = 50, y = 50, },
  -- { x = 100, y = 150, },
  -- { x = 0, y = 150, },
-- }

-- print(tostring(isPointInPolygon({x = 60, y = 80 }, polygon)))

dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rotation = EntityGetTransform(entity_id)

--half width and height
local w = 30
local h = 15

-- Define the coordinates of the four corners of the rectangle
local right_x, right_y = vec_rotate(w, -h, rotation)
right_x = x + right_x
right_y = y + right_y

local left_x, left_y = vec_rotate(-w, -h, rotation)
left_x = x + left_x
left_y = y + left_y

local right_x2, right_y2 = vec_rotate(w, h, rotation)
right_x2 = x + right_x2
right_y2 = y + right_y2

local left_x2, left_y2 = vec_rotate(-w, h, rotation)
left_x2 = x + left_x2
left_y2 = y + left_y2

--Checking if coordinate is inside the rotating rectangle
local function pointInsideRect(x2, y2)
  local nx, ny = vec_rotate(x2 - x, y2 - y, -rotation)
  return (nx + x) >= x - w and (ny + y) >= y - h and (nx + x) <= x + w and (ny + y) <= y + h
end

function getClosestPointOnLine(line_x1, line_y1, line_x2, line_y2, x, y)
  local A = x - line_x1
  local B = y - line_y1
  local C = line_x2 - line_x1
  local D = line_y2 - line_y1

  local dot = A * C + B * D
  local len_sq = C * C + D * D
  local param = dot / len_sq

  local closest_x, closest_y
  if param < 0 then
    closest_x = line_x1
    closest_y = line_y1
  elseif param > 1 then
    closest_x = line_x2
    closest_y = line_y2
  else
    closest_x = line_x1 + param * C
    closest_y = line_y1 + param * D
  end

  local dx = x - closest_x
  local dy = y - closest_y
  local distance_squared = dx * dx + dy * dy

  return closest_x, closest_y, distance_squared
end

function getClosestPointOnLines(lines, x, y)
  local closest_point
  local closest_distance2 = math.huge
  for i, line in ipairs(lines) do
    local x, y, dist2 = getClosestPointOnLine(line[1], line[2], line[3], line[4], x, y)
    if dist2 < closest_distance2 then
      closest_distance2 = dist2
      closest_point = { x = x, y = y, dist2 = dist2 }
    end
  end
  return closest_point
end

for i, particle in ipairs(EntityGetAllChildren(entity_id) or {}) do
  local px, py = EntityGetTransform(particle)
  local closest_point = getClosestPointOnLines({
    { left_x, left_y, right_x, right_y },
    { left_x, left_y, left_x2, left_y2 },
    { right_x, right_y, right_x2, right_y2 },
    { left_x2, left_y2, right_x2, right_y2 },
  }, px, py)
  
  if not pointInsideRect(px, py) then
    pvx = (closest_point.x - px) * 1.5
    pvy = (closest_point.y - py) * 1.5

	EntitySetTransform(particle, closest_point.x, closest_point.y)

	local physcomp = EntityGetFirstComponent(particle, "PhysicsBodyComponent") or EntityGetFirstComponent(particle, "PhysicsBody2Component") or EntityGetFirstComponent(particle, "SimplePhysicsComponent")
	if physcomp then
		PhysicsApplyForce(particle, pvx * 0.5, pvy * 0.5)
	end
  end
end