--PolyTools
-- dofile_once("mods/new_enemies/files/polytools/polytools_init.lua").init("mods/new_enemies/files/polytools")

--Addition of custom genomes Heavily experimental
function split_string(inputstr, sep)
  sep = sep or "%s"
  local t= {}
  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
    table.insert(t, str)
  end
  return t
end

local content = ModTextFileGetContent("data/genome_relations.csv")
function add_new_genome(content, genome_name, default_relation_ab, default_relation_ba, self_relation, relations)
  local lines = split_string(content, "\r\n")
  local output = ""
  local genome_order = {}
  for i, line in ipairs(lines) do
    if i == 1 then
      output = output .. line .. "," .. genome_name .. "\r\n"
    else
      local herd = line:match("([%w_-]+),")
      output = output .. line .. ","..(relations[herd] or default_relation_ba).."\r\n"
      table.insert(genome_order, herd)
    end
  end
  
  local line = genome_name
  for i, v in ipairs(genome_order) do
    line = line .. "," .. (relations[v] or default_relation_ab)
  end
  output = output .. line .. "," .. self_relation

  return output
end

-- Example usage: (This sets all genome relations of this genome to 100, unless indicated so, in this case, I want 100 with everything, except the player and -1)
content = add_new_genome(content, "friendly", 100, 100, 100, {
  player = 0,
  ["-1"] = 0
})

--Please Note: Here I want the genome twin_mage to attack all other genomes except its own, AND I want other genomes to not attack it!
--So Look what I did here. I Illegaly set the horizontal row to be different than the vertical row.
--horizontal row is 0, and vertical row is 100 . This somehow achieves exactly what I want. Makes the twin_mage genome attack other genomes, without the other genomes considering it an enemy
content = add_new_genome(content, "twin_mage", 0, 100, 100, {})
content = add_new_genome(content, "twin_mage_b", 100, 100, 100, {
  player = 0,
  ["-1"] = 0
})

--Love Mage Genomes
content = add_new_genome(content, "charmed_target", 100, 100, 100, {})
content = add_new_genome(content, "love_mage", 0, 100, 100, {
	charmed_target = 100
})

-- content = add_new_genome(content, "parasite", 0, 100, 100, {})

ModTextFileSetContent("data/genome_relations.csv", content)


--Addition of Translations:

--General text translations
local content = ModTextFileGetContent("data/translations/common.csv")
ModTextFileSetContent("data/translations/common.csv", content .. [[
gods_destroy,The Gods will destroy you,Боги уничтожат тебя,,,,,,,,神々はあなたを滅しようとしています,,,,
ground_terror_name,Ground Terror,Земной ужас,,,,,,,,Ground Terror,,,,
ground_terror_desc,Become The Terror,Стань Ужасом,,,,,,,,恐怖を支配せよ,,,,
alcohol_immunity_perk_name,Alcohol Immunity,Иммунитет к алкоголю,,,,,,,,アルコール免疫,,,,
alcohol_immunity_perk_desc,You are Immune to Alcohol,Вы иммунны к алкоголю,,,,,,,,酒に強くなった,,,,
lava_immunity_perk_name,Lava Immunity,Иммунитет к лаве,,,,,,,,溶岩耐性,,,,
lava_immunity_perk_desc,You are immune to lava,Вы иммунны к лаве,,,,,,,,溶岩からダメージを受けることがなくなる,,,,
reward_ending_ne,New Enemies Mod Trophy,Трофей мода новых врагов,,,,,,,,New Enemies Modのトロフィー,,,,
reward_ending_ne_nightmare,New Enemies Mod Nightmare Trophy,Трофей «Новые Враги» в режиме кошмара,,,,,,,,New Enemies Modのトロフィー(ナイトメア),,,,
gold_reward_desert_skull,Gold Reward,Золотая награда,,,,,,,,試練の報酬,,,,
gold_nugget_5,Gold Nugget (5),Золотая крупица (5),,,,,,,,金塊(5),,,,
gold_nugget_5_blood,Bloody Gold Nugget (5),Кровавый золотой самородок (5),,,,,,,,ブラッディー金塊 (5),,,,
poison_immunity_name,Poison Immunity,Иммунитет к яду,,,,,,,,猛毒免疫,,,,
poison_immunity_desc,You're Immune to Poison,Вы иммунны к яду,,,,,,,,毒からダメージを受けることがなくなる,,,,
bleeding_status_name,Bleeding,Кровотечение,,,,,,,,出血,,,,
bleeding_status_desc,You're Bleeding,Вы истекаете кровью,,,,,,,,出血している！,,,,
shrinking_status_name,Shrinking,Уменьшение,,,,,,,,縮小,,,,
shrinking_status_desc,You're Shrinking,Вы уменьшаетесь,,,,,,,,身体が小さくなっていく！,,,,
time_status_name,Time Travel,Путешествие во времени,,,,,,,,タイムトラベル,,,,
time_status_desc,You're being sent back in time!,Вас отправляют назад во времени!,,,,,,,,時間が巻き戻っていく！,,,,
trip_status_name,Tripping,Галлюцинации,,,,,,,,トリップ,,,,
trip_status_desc,You're tripping out of your mind,Ты находишься в неадекватном состоянии!,,,,,,,,頭がどうにかなりそうだ。,,,,
webbed_status_name,Webbed,Завернут в паутину,,,,,,,,キャプチャー,,,,
webbed_status_desc,You're stuck in a cobweb. Can't move!,Вы запутались в паутине. Вы не можете двигаться!,,,,,,,,蜘蛛の巣に捕まって動けない！,,,,
charmed_custom_status_name,Charmed,Очарование,,,,,,,,魅了,,,,
charmed_custom_status_desc,You become a friend to most enemies,Вы становитесь другом для большинства врагов,,,,,,,,ほとんどの敵があなたと仲良しになった。,,,,
madness_status_name,Madness,Безумие,,,,,,,,狂気,,,,
madness_status_desc,You are being pulled into madness!,Вы тянетесь в безумие!,,,,,,,,狂気に冒されている！,,,,
slow_levitation_status_name,Slower Levitation,Замедленное парение,,,,,,,,浮遊速度ダウン,,,,
slow_levitation_status_desc,Your levitation slows by half,Ваше левитирование замедляется наполовину,,,,,,,,空中浮遊の上昇速度が半分になった。,,,,
stone_entity_status_name,Petrified,Обернулся в камень,,,,,,,,石化,,,,
stone_entity_status_desc,You have an exterior of stone,Ваша внешность сделана из камня,,,,,,,,全身が石に変えられてしまった。,,,,
mana_eater_status_name,Mana Deficiency,Дефицит маны,,,,,,,,マナ不足,,,,
mana_eater_status_desc,Your mana is being devoured,Ваша мана поглощается,,,,,,,,マナが失われていく！,,,,
no_protection_status_name,Protection Disabler,Отключена защита,,,,,,,,耐性無効化,,,,
no_protection_status_desc,Your Protection has no effect,Ваша защита не действует,,,,,,,,耐性系のステータス効果が無効化される。,,,,
disgust_status_name,Disgust,Отвращение,,,,,,,,嫌悪感,,,,
disgust_status_desc,Something smells awful,Что-то воняет ужасно,,,,,,,,ひどい臭いがする。,,,,
unseen_status_name,Unseen,Невидимка,,,,,,,,不可視化,,,,
unseen_status_desc,You're Gone!,Вас не видно!,,,,,,,,あなたの全身が透けている！,,,,
]])

--Progress translations:
local progress_language = ModSettingGet( "new_enemies.progress_language" )

if progress_language == "english" or not progress_language then

local content = ModTextFileGetContent("data/translations/common.csv")
ModTextFileSetContent("data/translations/common.csv", content .. [[
acidmonster,Acid Lurker,,,,,,,,,,,,,
alchaos,Alchaos,,,,,,,,,,,,,
alien,Suuka,,,,,,,,,,,,,
alligator_temple,Large Alligator,,,,,,,,,,,,,
alligator_temple_small,Alligator,,,,,,,,,,,,,
angler,Angler Eel,,,,,,,,,,,,,
aquatitan,Aquatitan,,,,,,,,,,,,,
archer,Archer,,,,,,,,,,,,,
axeman,Axeman,,,,,,,,,,,,,
bigfly,Giant Wasp,,,,,,,,,,,,,
bird,Phoenix,,,,,,,,,,,,,
blob_giant,Blob Infestant,,,,,,,,,,,,,
blood_teddy,Caddel,,,,,,,,,,,,,
bloodmage_greater,Greater Blood Mage,,,,,,,,,,,,,
bloodmage_lesser,Lesser Blood Mage,,,,,,,,,,,,,
bloodmonster,Blood Demon,,,,,,,,,,,,,
bloodskull,Blood Skull,,,,,,,,,,,,,
bloom_ceiling,Ceiling Bloom,,,,,,,,,,,,,
bluemancer,Bluemancer,,,,,,,,,,,,,
book,Bewitched Tome,,,,,,,,,,,,,
boss_rock_spirit,Rock Spirit Boss,,,,,,,,,,,,,
bot,Laser Mech,,,,,,,,,,,,,
bouncer,Bounce Bot,,,,,,,,,,,,,
camel,Camel,,,,,,,,,,,,,
cargobot,Cargo Bot,,,,,,,,,,,,,
ceilingflower,Ceiling Slush Flower,,,,,,,,,,,,,
cerebracle,Cerebracle,,,,,,,,,,,,,
chaoticpolyshooter,Chaotic Poly Shooter,,,,,,,,,,,,,
chest_great_mimic,Great Chest Mimic,,,,,,,,,,,,,
cobra,Cobra,,,,,,,,,,,,,
commander,Commander,,,,,,,,,,,,,
conduit,Conduit,,,,,,,,,,,,,
copter,Hiisi Copter,,,,,,,,,,,,,
corrupt_alchemist,Corrupted Alchemist,,,,,,,,,,,,,
crawler,Crawler,,,,,,,,,,,,,
creeper,Creeper,,,,,,,,,,,,,
cryogen,Cryogen,,,,,,,,,,,,,
cyborg,Cyborg,,,,,,,,,,,,,
darkghost2,Dark Gazer,,,,,,,,,,,,,
desert_skull,Desert Skull,,,,,,,,,,,,,
desulitor,Desulitor,,,,,,,,,,,,,
desulitor_fly,Combustive Flies,,,,,,,,,,,,,
draghoul,Hell Moth,,,,,,,,,,,,,
dragon_ice,Dragutt Kiesah,,,,,,,,,,,,,
drake_snake,Draken,,,,,,,,,,,,,
driller,Driller,,,,,,,,,,,,,
dripper,Dripper,,,,,,,,,,,,,
drone_beam,Beam Drone,,,,,,,,,,,,,
drone_face2,Inferno Drone,,,,,,,,,,,,,
drone_trail,Static Drone,,,,,,,,,,,,,
drone2,Swarmer Drone,,,,,,,,,,,,,
earthmage,Earth Mage,,,,,,,,,,,,,
earthskull,Earth Skull,,,,,,,,,,,,,
eldari_big,Giant Eldari,,,,,,,,,,,,,
electricskull,Electric Skull,,,,,,,,,,,,,
electrobot,Electro Bot,,,,,,,,,,,,,
enigma,Enigma,,,,,,,,,,,,,
ent,Ent,,,,,,,,,,,,,
eradicator,Eradicator Droid,,,,,,,,,,,,,
eye,Eyeling's Eye,,,,,,,,,,,,,
eye_bat,Eye Bat,,,,,,,,,,,,,
eye_monster,Cyclops Bat,,,,,,,,,,,,,
eyeling,Eyeling,,,,,,,,,,,,,
face_worm,Orro Worm,,,,,,,,,,,,,
fallen_alchemist,Fallen Alchemist,,,,,,,,,,,,,
fire_crawler,Lava Crawler,,,,,,,,,,,,,
fireflower,Dragon's Breath Flower,,,,,,,,,,,,,
firemage_big,Giant Fire Mage,,,,,,,,,,,,,
wall_of_flesh,Wall Of Flesh,,,,,,,,,,,,,
flesh_monster,Flesh Monster,,,,,,,,,,,,,
flutterpede,Flutterpede,,,,,,,,,,,,,
forgotten_alchemist,Forgotten Alchemist,,,,,,,,,,,,,
frog_bot,Frog Bot,,,,,,,,,,,,,
frog_tiny,Tiny Frog,,,,,,,,,,,,,
fungus_spore,Spore Fungus,,,,,,,,,,,,,
fungus_swamp2,Rotting Fungus,,,,,,,,,,,,,
fury,Fury,,,,,,,,,,,,,
gazer_laser,Laser Gazer,,,,,,,,,,,,,
gazer_necromancer,Necromancer Gazer,,,,,,,,,,,,,
ghostling,Ghostling,,,,,,,,,,,,,
ghust,Ghust,,,,,,,,,,,,,
ghuu,Ghuu,,,,,,,,,,,,,
giant_alt,Giant Summoner,,,,,,,,,,,,,
giant_energy,Energy Orb Giant,,,,,,,,,,,,,
giant_old,Ancient Giant,,,,,,,,,,,,,
giant_squid,Giant Squid,,,,,,,,,,,,,
giantfirebug,Massive Firefly,,,,,,,,,,,,,
gigashooter,Giga Shooter,,,,,,,,,,,,,
god,God,,,,,,,,,,,,,
golem,Stone Golem,,,,,,,,,,,,,
gonha,Gonha,,,,,,,,,,,,,
goomonster,Goo Monster,,,,,,,,,,,,,
goomonster_giant,Giant Goo Monster,,,,,,,,,,,,,
ground_terror,Ground Terror,,,,,,,,,,,,,
hairling,Hairling,,,,,,,,,,,,,
harpy,Harpy,,,,,,,,,,,,,
hazmat,Hazmat,,,,,,,,,,,,,
head_statue_physics,Frozen Soul,,,,,,,,,,,,,
hell_overseer,Infernal Colossus,,,,,,,,,,,,,
hell_overseer,Infernal Colossus,,,,,,,,,,,,,
hurpa,Hurpa,,,,,,,,,,,,,
hybrid,Hybrid,,,,,,,,,,,,,
hydra,Hydra,,,,,,,,,,,,,
icemage_big2,Giant Ice Mage,,,,,,,,,,,,,
icemage2,Ice Mage,,,,,,,,,,,,,
icicle,Icicle,,,,,,,,,,,,,
icicle_king,Icicle Master,,,,,,,,,,,,,
igu,Igu,,,,,,,,,,,,,
imp,Imp,,,,,,,,,,,,,
invisiman,Invisiman,,,,,,,,,,,,,
irtokki,Irtokki,,,,,,,,,,,,,
jellyfish,Jellyfish,,,,,,,,,,,,,
jungle_worm,Mutant Worm,,,,,,,,,,,,,
junkbot,Junk Bot,,,,,,,,,,,,,
khulu,Khulu,,,,,,,,,,,,,
knight,Knight,,,,,,,,,,,,,
lake_statue,Lake Statue,,,,,,,,,,,,,
landflower,Slush Flower,,,,,,,,,,,,,
laserbot,Death Laser Bot,,,,,,,,,,,,,
lava_monster,Lava Guardian,,,,,,,,,,,,,
lavashooter,Lava Tentacler,,,,,,,,,,,,,
lempo,Lempo,,,,,,,,,,,,,
lightling,Lightling,,,,,,,,,,,,,
llama,Llama,,,,,,,,,,,,,
locust,Locust,,,,,,,,,,,,,
long_ghost,Long Ghost,,,,,,,,,,,,,
longleg_big,Large Spidey,,,,,,,,,,,,,
lost_soul,Lost Soul,,,,,,,,,,,,,
lost_soul_big,Giant Lost Soul,,,,,,,,,,,,,
lukki_blue,Eerie Lukki,,,,,,,,,,,,,
lukki_ominous,Ominous Lukki,,,,,,,,,,,,,
lukki_red,Lava Lukki,,,,,,,,,,,,,
lukki_swamp2,Rotting Lukki,,,,,,,,,,,,,
lukki_weird,Putrid Lukki,,,,,,,,,,,,,
lukki_white,Darkness Lukki,,,,,,,,,,,,,
lurker2,Lurker,,,,,,,,,,,,,
mammoth,Mammoth,,,,,,,,,,,,,
mammoth_baby,Baby Mammoth,,,,,,,,,,,,,
manus,Manus,,,,,,,,,,,,,
medusa,Medusa,,,,,,,,,,,,,
menace,Menace,,,,,,,,,,,,,
menhir,Hell Menhir,,,,,,,,,,,,,
miner_alcohol,Boozer,,,,,,,,,,,,,
miner_boss,TNT Boss,,,,,,,,,,,,,
mirror_physics,Vollux,,,,,,,,,,,,,
moal,Moal,,,,,,,,,,,,,
monkey,Monkey,,,,,,,,,,,,,
mother_nature,Gaia,,,,,,,,,,,,,
mutant_blob,Mutant Blob,,,,,,,,,,,,,
mutant_blob_ceiling,Ceiling Mutant Blob,,,,,,,,,,,,,
mutant2,Mutant,,,,,,,,,,,,,
mwyah,Mwyah,,,,,,,,,,,,,
mwyah_phase1,Mwyah,,,,,,,,,,,,,
naga,Naga,,,,,,,,,,,,,
nautilus,Nautilus,,,,,,,,,,,,,
necromancer_omega,Omegamancer,,,,,,,,,,,,,
nightmare,Nightmare,,,,,,,,,,,,,
nova,Nova,,,,,,,,,,,,,
ooion,Ooion,,,,,,,,,,,,,
peasant,Peasant,,,,,,,,,,,,,
phan,Phan,,,,,,,,,,,,,
phantom_boss,Restless Phantom,,,,,,,,,,,,,
phantom_trapper,Trapper Phantom,,,,,,,,,,,,,
great_green_fish,Piranha,,,,,,,,,,,,,
player_ai_nemesis,Nemesis,,,,,,,,,,,,,
player_ai_clone,Clone,,,,,,,,,,,,,
player_ai_decoy,Ancient Scholar,,,,,,,,,,,,,
polyp_gas,Gasnacle,,,,,,,,,,,,,
polyshooter,Polymorphine Shooter,,,,,,,,,,,,,
potionmaster2,Potion Master,,,,,,,,,,,,,
quin,Quin,,,,,,,,,,,,,
radiobot,Radioactive Orb,,,,,,,,,,,,,
robot,Bazooka Mech,,,,,,,,,,,,,
sawbot,Saw Bot,,,,,,,,,,,,,
scavenger_alcohol,Alcohol Scavenger Hiisi,,,,,,,,,,,,,
scavenger_civilian,Hiisi Civilian,,,,,,,,,,,,,
scavenger_compressor,Compressor Scavenger Hiisi,,,,,,,,,,,,,
scavenger_compressor_robot,Robot Compressor Scavenger Hiisi,,,,,,,,,,,,,
scavenger_electrocuter2,Electrocuter Scavenger Hiisi,,,,,,,,,,,,,
scavenger_gas,Gas Scavenger Hiisi,,,,,,,,,,,,,
scavenger_gas_robot,Robot Gas Scavenger Hiisi,,,,,,,,,,,,,
scavenger_king,Hiisi King,,,,,,,,,,,,,
scavenger_king_robot,Robot Hiisi King,,,,,,,,,,,,,
scavenger_laser,Laser Scavenger Hiisi,,,,,,,,,,,,,
scavenger_monster,Parasite,,,,,,,,,,,,,
scavenger_oiler,Oil Grenade Scavenger Hiisi,,,,,,,,,,,,,
scavenger_plasma,Plasma Scavenger Hiisi,,,,,,,,,,,,,
scavenger_poison_immunity,Poison Medic Hiisi,,,,,,,,,,,,,
scavenger_radiolava,Radiolava Scavenger Hiisi,,,,,,,,,,,,,
scavenger_robot,Rocket Robot Hiisi,,,,,,,,,,,,,
scavenger_trigger,Trigger Scavenger Hiisi,,,,,,,,,,,,,
scavenger_turbo,Turbo Scavenger Hiisi,,,,,,,,,,,,,
scavenger_turbo_robot,Robot Turbo Scavenger Hiisi,,,,,,,,,,,,,
scavenger_undercover,Suspicious Hiisi,,,,,,,,,,,,,
seamonster,Sea Monster,,,,,,,,,,,,,
serpentor,Serpentor,,,,,,,,,,,,,
shapeshifter,Shape Shifter,,,,,,,,,,,,,
shark,Shark,,,,,,,,,,,,,
shiva,Shiva,,,,,,,,,,,,,
singularitor,Singularitron,,,,,,,,,,,,,
skeleboss,Skeleton Boss,,,,,,,,,,,,,
skeleton,Skeleton,,,,,,,,,,,,,
skull_abomination,Skull Abomination,,,,,,,,,,,,,
skullmage,Skull Mage,,,,,,,,,,,,,
skullspider,Skull Spider,,,,,,,,,,,,,
skymonster,Sky Monster,,,,,,,,,,,,,
slime_ghoul,Sleaze Ghoul,,,,,,,,,,,,,
slime_roller,Tumbler Sleaze Baby,,,,,,,,,,,,,
slime_turret,Sleaze Pod,,,,,,,,,,,,,
slimeshooter_golden,Midas Sleaze Bag,,,,,,,,,,,,,
slimeshooter_mega,Mother Sleaze Bag,,,,,,,,,,,,,
smoke_bot,Smoke Machine,,,,,,,,,,,,,
sneeker,Sneaker,,,,,,,,,,,,,
snowman,Snowman,,,,,,,,,,,,,
sochaos,Sochaos,,,,,,,,,,,,,
sorceress,Sorceress,,,,,,,,,,,,,
spider,Ancient Spider,,,,,,,,,,,,,
spooky_ghost,Spooky Ghost,,,,,,,,,,,,,
sporeling,Medium Sporeling,,,,,,,,,,,,,
sporeling_large,Large Sporeling,,,,,,,,,,,,,
sporeling_tiny,Tiny Sporeling,,,,,,,,,,,,,
stalker,Stalker,,,,,,,,,,,,,
stalker_ceiling,Ceiling Stalker,,,,,,,,,,,,,
stingray,Stingray,,,,,,,,,,,,,
stone_crab,Stone Crab,,,,,,,,,,,,,
stone_physics,Acid Touch Stone,,,,,,,,,,,,,
summoner,Summoner,,,,,,,,,,,,,
tank_boss,Tank Boss,,,,,,,,,,,,,
tank_fire2,Flame Tank,,,,,,,,,,,,,
tank_propane,April Fools Tank,,,,,,,,,,,,,
tardigrade,Tardigrade,,,,,,,,,,,,,
terminator,Terminator,,,,,,,,,,,,,
thou,Thou,,,,,,,,,,,,,
toxicmage_acid2,Acid Mage,,,,,,,,,,,,,
toxicmage2,Sludge Mage,,,,,,,,,,,,,
train,Underground Train,,,,,,,,,,,,,
twig,Nook,,,,,,,,,,,,,
valkyrie2,Valkyrie,,,,,,,,,,,,,
vine_monster,Vine Monster,,,,,,,,,,,,,
void_mask2,Void Skull,,,,,,,,,,,,,
wanderer,Abu,,,,,,,,,,,,,
wandmaster2,Wand Master,,,,,,,,,,,,,
watermonster,Water Spirit,,,,,,,,,,,,,
welder,Hiisi Welder,,,,,,,,,,,,,
whale,Whale,,,,,,,,,,,,,
windmill,Hiisi Airship,,,,,,,,,,,,,
wizard_earthquake,Earthquake Mage,,,,,,,,,,,,,
wizard_madness,Mage Of Madness,,,,,,,,,,,,,
wizard_random,Master of Multitudes,,,,,,,,,,,,,
wizard_time,Time Mage,,,,,,,,,,,,,
wizard_trip,Trip Mage,,,,,,,,,,,,,
wizard_twin,Mage of Cloning,,,,,,,,,,,,,
worm_eel,Electric Worm,,,,,,,,,,,,,
worm_fungal,Fungal Abomination,,,,,,,,,,,,,
worm_robot,Mecha Worm,,,,,,,,,,,,,
wraith_boss,Wraith Boss,,,,,,,,,,,,,
wraith_speed,Speed Wraith,,,,,,,,,,,,,
wraith_void2,Void Wraith,,,,,,,,,,,,,
zombie_giant,Giant Zombie,,,,,,,,,,,,,
zombie3,Zombie Ghoul,,,,,,,,,,,,,
beanpodupine,Podupine,,,,,,,,,,,,,
scarab,Scarab Beetle,,,,,,,,,,,,,
stork,Avian Overseer,,,,,,,,,,,,,
devourer,Morsa,,,,,,,,,,,,,
fish_angler2,Angler Fish,,,,,,,,,,,,,
zap_eel2,Electric Eel,,,,,,,,,,,,,
minabomination,Alchemist Abomination,,,,,,,,,,,,,
desert_mage,Eldirood,,,,,,,,,,,,,
camel_robot,I160,,,,,,,,,,,,,
doom_bringer,Doom Bringer,,,,,,,,,,,,,
magiconstruct,The Sanctuary,,,,,,,,,,,,,
magiconstruct_statue,Sanctuary Wing,,,,,,,,,,,,,
elephant,Vulcan,,,,,,,,,,,,,
yikka,Yikka,,,,,,,,,,,,,
lukki_dark_huge,Sarlacc,,,,,,,,,,,,,
giant_boss,Rock Spirit Colossus,,,,,,,,,,,,,
god_warrior,God Warrior,,,,,,,,,,,,,
worm_skull_old,Ancient Skull Worm,,,,,,,,,,,,,
cthulhu,Abyssum,,,,,,,,,,,,,
wizard_tiny,Master Of Shrinking,,,,,,,,,,,,,
flopper_mother,Emesus,,,,,,,,,,,,,
xopon,Xopon,,,,,,,,,,,,,
oruai,Oruai Sphere,,,,,,,,,,,,,
jungle_flower,Grappling Bloom,,,,,,,,,,,,,
boid,Sparrow Bird,,,,,,,,,,,,,
sand_worm,Colossal Sand Worm,,,,,,,,,,,,,
kiwiki,Kiwiki,,,,,,,,,,,,,
shield_physics,Sentinel,,,,,,,,,,,,,
flopper_mother_giant,Giant Emesus,,,,,,,,,,,,,
flopper_mother_giant_progeny,Giant Emesus Progeny,,,,,,,,,,,,,
crawler_bug,Fire Bug,,,,,,,,,,,,,
platoon,Platoon,,,,,,,,,,,,,
scorpio,Scorpio,,,,,,,,,,,,,
mountain,The Mountain,,,,,,,,,,,,,
peeper,Ephemeris,,,,,,,,,,,,,
mantis,Mantis,,,,,,,,,,,,,
gold_face_physics,God's Finger,,,,,,,,,,,,,
chameleon,Chameleon,,,,,,,,,,,,,
bloodmage_enlightened,Ascended Blood Mage,,,,,,,,,,,,,
elephant_robot,Titan Tusk,,,,,,,,,,,,,
fireworkman,Fire Worker,,,,,,,,,,,,,
beehive,Beehive,,,,,,,,,,,,,
mountain_large,Geocolossus,,,,,,,,,,,,,
spider_crawler,Crawling Spider,,,,,,,,,,,,,
larva_crawler,Silk Worm,,,,,,,,,,,,,
plant_boss,Overgrowth,,,,,,,,,,,,,
drill_giant,Excavator Drill,,,,,,,,,,,,,
drill_giant_segment,Excavator Drill Segment,,,,,,,,,,,,,
mule,Mule,,,,,,,,,,,,,
ear_boss,Enchanted Corridor,,,,,,,,,,,,,
cyclops_slime,Aberrant Abomination,,,,,,,,,,,,,
boss_eel,Basilisk Eel,,,,,,,,,,,,,
boss_fungal,Fungal Colossus,,,,,,,,,,,,,
corpse_lily,Corpse Lily,,,,,,,,,,,,,
hell_door,Chaos Door,,,,,,,,,,,,,
mummy,Mummy,,,,,,,,,,,,,
worm_portal,Portal Worm,,,,,,,,,,,,,
mexxi,Mexxi,,,,,,,,,,,,,
]])

elseif progress_language == "finnish" then
local content = ModTextFileGetContent("data/translations/common.csv")
ModTextFileSetContent("data/translations/common.csv", content .. [[
acidmonster,Happo-otus,,,,,,,,,,,,,
alchaos,Muodonmuutosmöykky,,,,,,,,,,,,,
alien,Maagimuurahainen,,,,,,,,,,,,,
alligator_temple,Alligaattori,,,,,,,,,,,,,
alligator_temple_small,Pikkualligaattori,,,,,,,,,,,,,
angler,Lehtikala,,,,,,,,,,,,,
aquatitan,Vellamo,,,,,,,,,,,,,
archer,Jousipyssypoika,,,,,,,,,,,,,
axeman,Kirveshiisi,,,,,,,,,,,,,
bigfly,Suuramppari,,,,,,,,,,,,,
bird,Feeniks,,,,,,,,,,,,,
blob_giant,Suurmöykky,,,,,,,,,,,,,
blood_teddy,Pelle,,,,,,,,,,,,,
bloodmage_greater,Suurvihulainen,,,,,,,,,,,,,
bloodmage_lesser,Vihulainen,,,,,,,,,,,,,
bloodmonster,Veritähti,,,,,,,,,,,,,
bloodskull,Verikkö,,,,,,,,,,,,,
bloom_ceiling,Kattokukka,,,,,,,,,,,,,
bluemancer,Siniotus,,,,,,,,,,,,,
book,Lumottu hautakivi,,,,,,,,,,,,,
boss_rock_spirit,Sinilohkare,,,,,,,,,,,,,
bot,Laserrobotti,,,,,,,,,,,,,
bouncer,Hyppylennokki,,,,,,,,,,,,,
camel,Kameli,,,,,,,,,,,,,
cargobot,Tuhorobotti,,,,,,,,,,,,,
ceilingflower,Sinikattokukka,,,,,,,,,,,,,
cerebracle,Hylkiö,,,,,,,,,,,,,
chaoticpolyshooter,Muodonmuutosmustikka,,,,,,,,,,,,,
chest_great_mimic,Mahtimatkija,,,,,,,,,,,,,
cobra,Kärmes,,,,,,,,,,,,,
commander,Hiisikomentaja,,,,,,,,,,,,,
conduit,Sähköinsinööri,,,,,,,,,,,,,
copter,Hiisikopteri,,,,,,,,,,,,,
corrupt_alchemist,Repaleinen Alkemisti,,,,,,,,,,,,,
crawler,Ötökkä,,,,,,,,,,,,,
creeper,Yökötys,,,,,,,,,,,,,
cryogen,Kylmäkalle,,,,,,,,,,,,,
cyborg,Puolihiisi,,,,,,,,,,,,,
darkghost2,Tihrustaja,,,,,,,,,,,,,
desert_skull,Muinainen Kallo,,,,,,,,,,,,,
desulitor,Raapskärpäsparvi,,,,,,,,,,,,,
desulitor_fly,Raapskärpäset,,,,,,,,,,,,,
draghoul,Tuonelanyökkö,,,,,,,,,,,,,
dragon_ice,Jäälohikäärme,,,,,,,,,,,,,
drake_snake,Yönkorento,,,,,,,,,,,,,
driller,Pora,,,,,,,,,,,,,
dripper,Valuvainen,,,,,,,,,,,,,
drone_beam,Rak,,,,,,,,,,,,,
drone_face2,Infernohäivealus,,,,,,,,,,,,,
drone_trail,Suihkukone,,,,,,,,,,,,,
drone2,Drooni,,,,,,,,,,,,,
earthmage,Tapio,,,,,,,,,,,,,
earthskull,Viherhippunen,,,,,,,,,,,,,
eldari_big,Suureldari,,,,,,,,,,,,,
electricskull,Sähköjuttelija,,,,,,,,,,,,,
electrobot,Yhdistäjä,,,,,,,,,,,,,
enigma,Varoituksen Sana,,,,,,,,,,,,,
ent,Metsämahti,,,,,,,,,,,,,
eradicator,Tunteeton,,,,,,,,,,,,,
eye,Silmä,,,,,,,,,,,,,
eye_bat,Kolikkolepakko,,,,,,,,,,,,,
eye_monster,Räpyttelijä,,,,,,,,,,,,,
eyeling,Silmäjoukko,,,,,,,,,,,,,
face_worm,Ilmemato,,,,,,,,,,,,,
fallen_alchemist,Säihkysilmä,,,,,,,,,,,,,
fire_crawler,Tuliötökkä,,,,,,,,,,,,,
fireflower,Tulikukka,,,,,,,,,,,,,
firemage_big,Suurstendari,,,,,,,,,,,,,
wall_of_flesh,Lihamuuri,,,,,,,,,,,,,
flesh_monster,Lihis,,,,,,,,,,,,,
flutterpede,Sudenkorento,,,,,,,,,,,,,
forgotten_alchemist,Varjoalkemisti,,,,,,,,,,,,,
frog_bot,Metallisammakko,,,,,,,,,,,,,
frog_tiny,Pikkupikkusammakko,,,,,,,,,,,,,
fungus_spore,Röyhtäilijä,,,,,,,,,,,,,
fungus_swamp2,Suokas,,,,,,,,,,,,,
fury,Erinys,,,,,,,,,,,,,
gazer_laser,Hohtokatse,,,,,,,,,,,,,
gazer_necromancer,Ruumiskatse,,,,,,,,,,,,,
ghostling,Kaapukallo,,,,,,,,,,,,,
ghust,Kammotus,,,,,,,,,,,,,
ghuu,Muikelo,,,,,,,,,,,,,
giant_alt,Lohkaremuhku,,,,,,,,,,,,,
giant_energy,Syöttäjä,,,,,,,,,,,,,
giant_old,Muhku,,,,,,,,,,,,,
giant_squid,Nahkiainen,,,,,,,,,,,,,
giantfirebug,Megatulikärpänen,,,,,,,,,,,,,
gigashooter,Katsoja,,,,,,,,,,,,,
god,Jumalukko,,,,,,,,,,,,,
golem,Kivigolem,,,,,,,,,,,,,
gonha,Demoninpala,,,,,,,,,,,,,
goomonster,Limaörvelö,,,,,,,,,,,,,
goomonster_giant,Suurlimaörvelö,,,,,,,,,,,,,
ground_terror,Iso Haukku,,,,,,,,,,,,,
hairling,Hapsunuljaska,,,,,,,,,,,,,
harpy,Harpyija,,,,,,,,,,,,,
hazmat,Suojautunut,,,,,,,,,,,,,
head_statue_physics,Lapasten Tarpeessa,,,,,,,,,,,,,
hell_overseer,Mahtilaavarapu,,,,,,,,,,,,,
hurpa,Hurpa,,,,,,,,,,,,,
hybrid,Hämishiisi,,,,,,,,,,,,,
hydra,Monipäinen Käärme,,,,,,,,,,,,,
icemage_big2,Megapakkasukko,,,,,,,,,,,,,
icemage2,Jäätelömestari,,,,,,,,,,,,,
icicle,Jääpuikko,,,,,,,,,,,,,
icicle_king,Jääpuikkomestari,,,,,,,,,,,,,
igu,Kätyri,,,,,,,,,,,,,
imp,Piru,,,,,,,,,,,,,
invisiman,Lasimestari,,,,,,,,,,,,,
irtokki,Irtokki,,,,,,,,,,,,,
jellyfish,Meduusa,,,,,,,,,,,,,
jungle_worm,Lukkimato,,,,,,,,,,,,,
junkbot,Kyhäelmä,,,,,,,,,,,,,
khulu,Niveljalkainen,,,,,,,,,,,,,
knight,Ritari,,,,,,,,,,,,,
lake_statue,Huru-ukko,,,,,,,,,,,,,
landflower,Sinikukka,,,,,,,,,,,,,
laserbot,Kolmijalkalaser,,,,,,,,,,,,,
lava_monster,Laavasoturi,,,,,,,,,,,,,
lavashooter,Laavanuljaska,,,,,,,,,,,,,
lempo,Lempo,,,,,,,,,,,,,
lightling,Lennokas,,,,,,,,,,,,,
llama,Laama,,,,,,,,,,,,,
locust,Kulkusirkka,,,,,,,,,,,,,
long_ghost,Vetelehtijäaave,,,,,,,,,,,,,
longleg_big,Möhköhämis,,,,,,,,,,,,,
lost_soul,Pikkuastia,,,,,,,,,,,,,
lost_soul_big,Astia,,,,,,,,,,,,,
lukki_blue,Sinilukki,,,,,,,,,,,,,
lukki_ominous,Hammaslukki,,,,,,,,,,,,,
lukki_red,Laavalukki,,,,,,,,,,,,,
lukki_swamp2,Mätälukki,,,,,,,,,,,,,
lukki_weird,Jätelukki,,,,,,,,,,,,,
lukki_white,Valkolukki,,,,,,,,,,,,,
lurker2,Myrkkypilvi,,,,,,,,,,,,,
mammoth,Mammutti,,,,,,,,,,,,,
mammoth_baby,Mammutinpoikanen,,,,,,,,,,,,,
manus,Hyppynen,,,,,,,,,,,,,
medusa,Lonkeroinen,,,,,,,,,,,,,
menace,Ketku,,,,,,,,,,,,,
menhir,Purkaus,,,,,,,,,,,,,
miner_alcohol,Juomahiisi,,,,,,,,,,,,,
miner_boss,Ärtsyhiisi,,,,,,,,,,,,,
mirror_physics,Sekoittaja,,,,,,,,,,,,,
moal,Mököttäjä,,,,,,,,,,,,,
monkey,Apina,,,,,,,,,,,,,
mother_nature,Mielikki,,,,,,,,,,,,,
mutant_blob,Alkulima,,,,,,,,,,,,,
mutant_blob_ceiling,Kattoalkulima,,,,,,,,,,,,,
mutant2,Mutantti,,,,,,,,,,,,,
mwyah,Läpivalaistu,,,,,,,,,,,,,
mwyah_phase1,Läpivalaistu,,,,,,,,,,,,,
naga,Naga,,,,,,,,,,,,,
nautilus,Kotilonkero,,,,,,,,,,,,,
necromancer_omega,Hylätty Vartija,,,,,,,,,,,,,
nightmare,Lihaleijona,,,,,,,,,,,,,
nova,Nova,,,,,,,,,,,,,
ooion,Painoton,,,,,,,,,,,,,
peasant,Talonpoika,,,,,,,,,,,,,
phan,Kummituslepakko,,,,,,,,,,,,,
phantom_boss,Käsienlevittelijä,,,,,,,,,,,,,
phantom_trapper,Ansastaja,,,,,,,,,,,,,
great_green_fish,Piraija,,,,,,,,,,,,,
player_ai_nemesis,Nemesis,,,,,,,,,,,,,
player_ai_clone,Klooni,,,,,,,,,,,,,
player_ai_decoy,Kultisti,,,,,,,,,,,,,
polyp_gas,Kaasusiimajalkainen,,,,,,,,,,,,,
polyshooter,Muodonmuutosmansikka,,,,,,,,,,,,,
potionmaster2,Cocktailmestari,,,,,,,,,,,,,
quin,Uiskentelija,,,,,,,,,,,,,
radiobot,Säteilykeskus,,,,,,,,,,,,,
robot,Koljatti,,,,,,,,,,,,,
sawbot,Saharobotti,,,,,,,,,,,,,
scavenger_alcohol,Illanviettäjähiisi,,,,,,,,,,,,,
scavenger_civilian,Pakokauhuhiisi,,,,,,,,,,,,,
scavenger_compressor,Puksutinhiisi,,,,,,,,,,,,,
scavenger_compressor_robot,Robottipuksutinhiisi,,,,,,,,,,,,,
scavenger_electrocuter2,Tuikkaajahiisi,,,,,,,,,,,,,
scavenger_gas,Posautushiisi,,,,,,,,,,,,,
scavenger_gas_robot,Kaasuhiisi,,,,,,,,,,,,,
scavenger_king,Kuningashiisi,,,,,,,,,,,,,
scavenger_king_robot,Robottikuningashiisi,,,,,,,,,,,,,
scavenger_laser,Laserhiisi,,,,,,,,,,,,,
scavenger_monster,Lonkeroviitta,,,,,,,,,,,,,
scavenger_oiler,Hirvihiisi,,,,,,,,,,,,,
scavenger_plasma,Plasmahiisi,,,,,,,,,,,,,
scavenger_poison_immunity,Lääkintähiisi,,,,,,,,,,,,,
scavenger_radiolava,Laavahiisi,,,,,,,,,,,,,
scavenger_robot,Rakettihiisi,,,,,,,,,,,,,
scavenger_trigger,Kypärähiisi,,,,,,,,,,,,,
scavenger_turbo,Luksushiisi,,,,,,,,,,,,,
scavenger_turbo_robot,Turbohiisi,,,,,,,,,,,,,
scavenger_undercover,Salahiisi,,,,,,,,,,,,,
seamonster,Merihirviö,,,,,,,,,,,,,
serpentor,Kaksoiskärmes,,,,,,,,,,,,,
shapeshifter,Muodonmuuttaja,,,,,,,,,,,,,
shark,Hai,,,,,,,,,,,,,
shiva,Suursuu,,,,,,,,,,,,,
singularitor,Sinkauttaja,,,,,,,,,,,,,
skeleboss,Epäkuollut Luuranko,,,,,,,,,,,,,
skeleton,Luuranko,,,,,,,,,,,,,
skull_abomination,Kallokauhistus,,,,,,,,,,,,,
skullmage,Kallollinen,,,,,,,,,,,,,
skullspider,Suurkallohämis,,,,,,,,,,,,,
skymonster,Ilmojen Pitelijä,,,,,,,,,,,,,
slime_ghoul,Pikku-Cthulhu,,,,,,,,,,,,,
slime_roller,Pyörölima,,,,,,,,,,,,,
slime_turret,Ärtsylonkero,,,,,,,,,,,,,
slimeshooter_golden,Kultanuljaska,,,,,,,,,,,,,
slimeshooter_mega,Äitilima,,,,,,,,,,,,,
smoke_bot,Savukone,,,,,,,,,,,,,
sneeker,Veistos,,,,,,,,,,,,,
snowman,Pakastaja,,,,,,,,,,,,,
sochaos,Sauvojen Mestari,,,,,,,,,,,,,
sorceress,Velhotar,,,,,,,,,,,,,
spider,Seititär,,,,,,,,,,,,,
spooky_ghost,Kauhea Aave,,,,,,,,,,,,,
sporeling,Suurpore,,,,,,,,,,,,,
sporeling_large,Porepaukku,,,,,,,,,,,,,
sporeling_tiny,Pikkuporepaukku,,,,,,,,,,,,,
stalker,Tuijottelija,,,,,,,,,,,,,
stalker_ceiling,Kattotuijottelija,,,,,,,,,,,,,
stingray,Rausku,,,,,,,,,,,,,
stone_crab,Matkijarapu,,,,,,,,,,,,,
stone_physics,Happokivi,,,,,,,,,,,,,
summoner,Laumanjohtaja,,,,,,,,,,,,,
tank_boss,Luksustankki,,,,,,,,,,,,,
tank_fire2,Tulitankki,,,,,,,,,,,,,
tank_propane,Jäynätankki,,,,,,,,,,,,,
tardigrade,Karhukainen,,,,,,,,,,,,,
terminator,Terminaattori,,,,,,,,,,,,,
thou,Jojolohkare,,,,,,,,,,,,,
toxicmage_acid2,Happomestari,,,,,,,,,,,,,
toxicmage2,Myrkkymestari,,,,,,,,,,,,,
train,Juna,,,,,,,,,,,,,
twig,Monistusköynnös,,,,,,,,,,,,,
valkyrie2,Valkyria,,,,,,,,,,,,,
vine_monster,Köynnös,,,,,,,,,,,,,
void_mask2,Kirottu Kallo,,,,,,,,,,,,,
wanderer,Liehutin,,,,,,,,,,,,,
wandmaster2,Sauvojentekijä,,,,,,,,,,,,,
watermonster,Henkiolento,,,,,,,,,,,,,
welder,Hitsaajahiisi,,,,,,,,,,,,,
whale,Valas,,,,,,,,,,,,,
windmill,Laivue,,,,,,,,,,,,,
wizard_earthquake,Maamestari,,,,,,,,,,,,,
wizard_madness,Mahdottomuuksien Mestari,,,,,,,,,,,,,
wizard_random,Moninaismestari,,,,,,,,,,,,,
wizard_time,Aikamestari,,,,,,,,,,,,,
wizard_trip,Sienimestari,,,,,,,,,,,,,
wizard_twin,Alennusmestari,,,,,,,,,,,,,
worm_eel,Sähkömato,,,,,,,,,,,,,
worm_fungal,Sienirihmasto,,,,,,,,,,,,,
worm_robot,Robottimato,,,,,,,,,,,,,
wraith_boss,Epäkuolleiden Mestari,,,,,,,,,,,,,
wraith_speed,Hohtava Epäkuollut,,,,,,,,,,,,,
wraith_void2,Olio Olematon,,,,,,,,,,,,,
zombie_giant,Zombikalma,,,,,,,,,,,,,
zombie3,Kalmakoira,,,,,,,,,,,,,
beanpodupine,Paukkupalkosika,,,,,,,,,,,,,
scarab,Louskutin,,,,,,,,,,,,,
stork,Kenkänokka,,,,,,,,,,,,,
devourer,Morsa,,,,,,,,,,,,,
fish_angler2,Merikrotti,,,,,,,,,,,,,
zap_eel2,Sähköankerias,,,,,,,,,,,,,
minabomination,Ällökemisti,,,,,,,,,,,,,
desert_mage,Eldirood,,,,,,,,,,,,,
camel_robot,I160,,,,,,,,,,,,,
doom_bringer,Tuomion Tuoja,,,,,,,,,,,,,
magiconstruct,Pyhäkkö,,,,,,,,,,,,,
magiconstruct_statue,Pyhäkön Siipi,,,,,,,,,,,,,
elephant,Hönkäle,,,,,,,,,,,,,
yikka,Yikka,,,,,,,,,,,,,
lukki_dark_huge,Hirmukita,,,,,,,,,,,,,
giant_boss,Järkäle,,,,,,,,,,,,,
god_warrior,Perkele,,,,,,,,,,,,,
worm_skull_old,Muinainen Kallomato,,,,,,,,,,,,,
cthulhu,Antero Vipunen,,,,,,,,,,,,,
wizard_tiny,Kutistusmestari,,,,,,,,,,,,,
flopper_mother,Emesus,,,,,,,,,,,,,
xopon,Xopon,,,,,,,,,,,,,
oruai,Vahtaaja,,,,,,,,,,,,,
jungle_flower,Villiviini,,,,,,,,,,,,,
boid,Pääskynen,,,,,,,,,,,,,
sand_worm,Uskomato,,,,,,,,,,,,,
kiwiki,Kiwikii,,,,,,,,,,,,,
shield_physics,Tarkkailija,,,,,,,,,,,,,
flopper_mother_giant,Suur Emesus,,,,,,,,,,,,,
flopper_mother_giant_progeny,Suur Emesus Progeny,,,,,,,,,,,,,
crawler_bug,Kusiainen,,,,,,,,,,,,,
platoon,Komppania,,,,,,,,,,,,,
scorpio,Lepakkorpioni,,,,,,,,,,,,,
mountain,Vuori,,,,,,,,,,,,,
peeper,Vilahdus,,,,,,,,,,,,,
mantis,Sirkka,,,,,,,,,,,,,
gold_face_physics,Jumalan Sormi,,,,,,,,,,,,,
chameleon,Kamelerontti,,,,,,,,,,,,,
bloodmage_enlightened,Arkkivihulainen,,,,,,,,,,,,,
elephant_robot,Moottorinorsu,,,,,,,,,,,,,
fireworkman,Ilotulittaja,,,,,,,,,,,,,
beehive,Mehiläispesä,,,,,,,,,,,,,
mountain_large,Maajätti,,,,,,,,,,,,,
spider_crawler,Ryömiä Hämis,,,,,,,,,,,,,
larva_crawler,Silkkiäistoukka,,,,,,,,,,,,,
plant_boss,Rehevys,,,,,,,,,,,,,
drill_giant,Porakaivinkone,,,,,,,,,,,,,
drill_giant_segment,Excavator Drill Segment,,,,,,,,,,,,,
mule,Muuli,,,,,,,,,,,,,
ear_boss,Syöveri,,,,,,,,,,,,,
cyclops_slime,Jättilimanuljaska,,,,,,,,,,,,,
boss_eel,Basiliskiankerias,,,,,,,,,,,,,
boss_fungus,Sienititaani,,,,,,,,,,,,,
corpse_lily,Ruholilja,,,,,,,,,,,,,
hell_door,Helvetin Portti,,,,,,,,,,,,,
mummy,Muumio,,,,,,,,,,,,,
worm_portal,Extradimensionaalimato,,,,,,,,,,,,,
mexxi,Mexxi,,,,,,,,,,,,,
]])
end

--Magic Numbers Test
-- ModMagicNumbersFileAdd("data/entities/debug_magic_numbers.xml")

--Loading in poly tools
-- dofile_once("mods/new_enemies/files/polytools/polytools_init.lua").init("mods/new_enemies/files/polytools")

--Addition of Custom sounds:
ModRegisterAudioEventMappings("mods/new_enemies/data/sound/GUIDs.txt")
ModRegisterAudioEventMappings("mods/new_enemies/data/sound/more_sounds/GUIDs.txt")

--Addition of Materials
ModMaterialsFileAdd("mods/new_enemies/files/materials/materials.xml")

--Addition of staining textures to enemy sprites:
-- ModDevGenerateSpriteUVsForDirectory( "data/enemies_gfx/" )

--Addition of Twitch Events
if ModSettingGet("new_enemies.twitch_events_enabled") then
	ModLuaFileAppend( "data/scripts/streaming_integration/event_list.lua", "data/scripts/twitch_events/twitch_events.lua" )
	-- ModLuaFileAppend( "mods/twitch_extended/files/scripts/config/config_list.lua", "data/scripts/twitch_events/config_list.lua" )
end
--Addition of Status Effects
ModLuaFileAppend( "data/scripts/status_effects/status_list.lua", "mods/new_enemies/data/scripts/status_effects/ne_status_effects.lua" )

--Addition of lake creatures
ModLuaFileAppend( "data/scripts/biomes/lake_deep.lua", "data/scripts/biomes/lake_sharks.lua" )

--Addition of Ritualists, Peasants, Mammoths, Camels and Huts:
ModLuaFileAppend( "data/scripts/biomes/mountain/mountain_hall.lua", "data/scripts/biomes/mountain/mountain_hall_enemies.lua" )

--Addition of Underground Train to Vault
ModLuaFileAppend( "data/scripts/biomes/vault.lua", "data/scripts/biomes/vault_trains.lua" )

--Addition of Airship boss to ocarina area
ModLuaFileAppend( "data/scripts/biomes/ocarina.lua", "data/scripts/biomes/ocarina_enemies.lua" )

--Addition of enemy adding lua scripts:
local mode = ModSettingGet( "new_enemies.difficulty_level" )

if mode == "normal" or not mode then
	ModLuaFileAppend( "data/scripts/biomes/coalmine.lua", "data/scripts/biomes/coalmine_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/coalmine_alt.lua", "data/scripts/biomes/coalmine_alt_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/excavationsite.lua", "data/scripts/biomes/excavationsite_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/snowcave.lua", "data/scripts/biomes/snowcave_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/snowcastle.lua", "data/scripts/biomes/snowcastle_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/rainforest.lua", "data/scripts/biomes/rainforest_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/vault.lua", "data/scripts/biomes/vault_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/crypt.lua", "data/scripts/biomes/crypt_enemies.lua" )
	
	ModLuaFileAppend( "data/scripts/biomes/fungicave.lua", "data/scripts/biomes/fungicave_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/pyramid.lua", "data/scripts/biomes/pyramid_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/liquidcave.lua", "data/scripts/biomes/liquidcave_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/wandcave.lua", "data/scripts/biomes/wandcave_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/sandcave.lua", "data/scripts/biomes/sandcave_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/vault_frozen.lua", "data/scripts/biomes/vault_frozen_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/wizardcave.lua", "data/scripts/biomes/wizardcave_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/rainforest_dark.lua", "data/scripts/biomes/rainforest_dark_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/winter.lua", "data/scripts/biomes/winter_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/fungiforest.lua", "data/scripts/biomes/fungiforest_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/robobase.lua", "data/scripts/biomes/robobase_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/clouds.lua", "data/scripts/biomes/clouds_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/the_end.lua", "mods/new_enemies/data/scripts/biomes/the_end_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/the_end.lua", "mods/new_enemies/data/scripts/biomes/the_sky_enemies.lua" )
	
	ModLuaFileAppend( "data/scripts/biomes/desert.lua", "data/scripts/biomes/desert_enemies.lua" )
elseif mode == "easy" then
	ModLuaFileAppend( "data/scripts/biomes/coalmine.lua", "data/scripts/biomes/coalmine_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/coalmine_alt.lua", "data/scripts/biomes/coalmine_alt_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/excavationsite.lua", "data/scripts/biomes/excavationsite_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/snowcave.lua", "data/scripts/biomes/snowcave_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/snowcastle.lua", "data/scripts/biomes/snowcastle_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/rainforest.lua", "data/scripts/biomes/rainforest_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/vault.lua", "data/scripts/biomes/vault_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/crypt.lua", "data/scripts/biomes/crypt_enemies_easy.lua" )
	
	ModLuaFileAppend( "data/scripts/biomes/fungicave.lua", "data/scripts/biomes/fungicave_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/pyramid.lua", "data/scripts/biomes/pyramid_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/liquidcave.lua", "data/scripts/biomes/liquidcave_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/wandcave.lua", "data/scripts/biomes/wandcave_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/sandcave.lua", "data/scripts/biomes/sandcave_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/vault_frozen.lua", "data/scripts/biomes/vault_frozen_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/wizardcave.lua", "data/scripts/biomes/wizardcave_enemies_easy.lua" )
	--ModLuaFileAppend( "data/scripts/biomes/rainforest_dark.lua", "data/scripts/biomes/rainforest_dark_enemies_easy.lua" )
	--ModLuaFileAppend( "data/scripts/biomes/winter.lua", "data/scripts/biomes/winter_enemies.lua" )
	ModLuaFileAppend( "data/scripts/biomes/fungiforest.lua", "data/scripts/biomes/fungiforest_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/the_end.lua", "mods/new_enemies/data/scripts/biomes/the_end_enemies_easy.lua" )
	ModLuaFileAppend( "data/scripts/biomes/the_end.lua", "mods/new_enemies/data/scripts/biomes/the_sky_enemies_easy.lua" )
end

--Addition of Scenes:
ModLuaFileAppend( "data/scripts/biomes/coalmine.lua", "data/scripts/biomes/coalmine_pixel_scenes.lua" )
ModLuaFileAppend( "data/scripts/biomes/snowcave.lua", "data/scripts/biomes/snowcave_pixel_scenes.lua" )
-- ModLuaFileAppend( "data/scripts/biomes/rainforest.lua", "data/scripts/biomes/rainforest_pixel_scenes.lua" )

--Editing an annoying local in the surface scripts:
-- function fix_overworld_desert()
	-- local content = ModTextFileGetContent("data/scripts/props/overworld_desert_prop_spawner.lua")
	-- content = content:gsub("local props", "props")
	-- ModTextFileSetContent("data/scripts/props/overworld_desert_prop_spawner.lua", content)
-- end
-- fix_overworld_desert()
-- --Addition of surface creatures to surface biomes/LANDING
-- ModLuaFileAppend( "data/scripts/props/overworld_desert_prop_spawner.lua", "data/scripts/biomes/desert_entity_spawner.lua" )

--Add Poly steven to holy mountains:
-- ModLuaFileAppend( "data/scripts/biomes/temple_shared.lua", "data/scripts/biomes/temple_altar_right_necromancer_poly.lua" )

--Secret Mimic:
local biome_scripts_content = ModTextFileGetContent("data/scripts/biome_scripts.lua")
if biome_scripts_content and not HasFlagPersistent("ned_chest_great_mimic") then
  local string_to_look_for = [[local entity%s?=%s?EntityLoad%s?%(%s?"data/entities/animals/chest_mimic.xml"%s?,%s?x,%s?y%s?%)]]
  local insertion_point = string.find(biome_scripts_content, string_to_look_for)
  if insertion_point then
    biome_scripts_content = string.gsub(biome_scripts_content, string_to_look_for, [[
  if Random(1, 100) < 50 then
                  local entity = EntityLoad( "data/entities/animals/chest_mimic.xml", x, y)
                else
                  local entity = EntityLoad( "data/entities/animals/chest_great_mimic.xml", x, y)
                end]])
    ModTextFileSetContent("data/scripts/biome_scripts.lua", biome_scripts_content)
  end
end

--Secret Boss Spawner:
ModLuaFileAppend( "data/scripts/biomes/desert.lua", "data/scripts/biomes/desert_skull.lua" )

--secret1:
ModLuaFileAppend( "data/scripts/biomes/mountain_tree.lua", "data/scripts/biomes/mountain_tree_enemies.lua" )

function replace_value(path, input, output, print_contents)
	local content = ModTextFileGetContent(path)
	content = content:gsub(input, output)
	ModTextFileSetContent(path, content)
	if print_contents == true then
		print(content)
	end
end

--Removing particle life from twitch extended
if ModIsEnabled("twitch_extended") then

	-- ModLuaFileAppend( "mods/twitch_extended/files/scripts/config/config_list.lua", "data/scripts/twitch_extended_append.lua" )
	-- ModLuaFileAppend( "mods/twitch_extended/files/scripts/utils/utilities.lua", "data/scripts/twitch_extended_append.lua" )

	--this isn't doing anything: (Not working)
	replace_value("mods/twitch_extended/files/scripts/config/config_list.lua", 
		[[shift_material_blacklist_inputs %= %{]], 
		[[shift_material_blacklist_inputs = {
			ant = true,
			spider_spawner = true,
			spider = true,
			spider_web = true,
			earth_worm = true,
			snake_seed = true,
			snake = true,
			snake_tail = true,
			snake_flower_red = true,
			snake_flower_red2 = true,
			snake_flower_red3 = true,
			snake_flower_yellow = true,
			snake_flower_yellow2 = true,
			snake_flower_yellow3 = true,
			snake_flower_orange = true,
			snake_flower_orange2 = true,
			snake_flower_orange3 = true,
			snake_flower_blue = true,
			snake_flower_blue2 = true,
			snake_flower_blue3 = true,
			water_bug = true,
			water_swamp_bug = true,
			mosquito = true,
			mosquito_wing = true,
			soil_evaporate = true,
			jungle_seed = true,
			water_health = true,
			rock_box2d_hard_damage = true,
			blood_static = true,
			lava2 = true,
			bone_fading = true,
			rock_static_radioactive2 = true,
			meat_grey = true,
			blood_grey = true,
			radioactive_liquid2 = true,
			rock_hard_border2 = true,
			rock_hard_border3 = true,
			rock_hard_border4 = true,
			radioactive_gas2 = true,
			flea = true, 
		]]
	)
	
	replace_value("mods/twitch_extended/files/scripts/config/config_list.lua", 
		[[shift_material_blacklist_outputs  %= %{]], 
		[[shift_material_blacklist_outputs  = {
			ant = true,
			spider_spawner = true,
			spider = true,
			spider_web = true,
			earth_worm = true,
			snake_seed = true,
			snake = true,
			snake_tail = true,
			snake_flower_red = true,
			snake_flower_red2 = true,
			snake_flower_red3 = true,
			snake_flower_yellow = true,
			snake_flower_yellow2 = true,
			snake_flower_yellow3 = true,
			snake_flower_orange = true,
			snake_flower_orange2 = true,
			snake_flower_orange3 = true,
			snake_flower_blue = true,
			snake_flower_blue2 = true,
			snake_flower_blue3 = true,
			water_bug = true,
			water_swamp_bug = true,
			mosquito = true,
			mosquito_wing = true,
			soil_evaporate = true,
			jungle_seed = true,
			water_health = true,
			rock_box2d_hard_damage = true,
			blood_static = true,
			lava2 = true,
			bone_fading = true,
			rock_static_radioactive2 = true,
			meat_grey = true,
			blood_grey = true,
			radioactive_liquid2 = true,
			rock_hard_border2 = true,
			rock_hard_border3 = true,
			rock_hard_border4 = true,
			radioactive_gas2 = true,
			flea = true, 
		]]
	)
	
	-- print(ModTextFileGetContent("mods/twitch_extended/files/scripts/config/config_list.lua"))

end

--Option to reduce Jungle Lag
if ModSettingGet("new_enemies.jungle_lag_reducer_enabled") then
	ModLuaFileAppend( "data/scripts/biomes/coalmine.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/coalmine_alt.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/snowcave.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/fungiforest.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/rainforest.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/rainforest_dark.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/temple_altar_left.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/tower.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/wizardcave.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
	ModLuaFileAppend( "data/scripts/biomes/vault_frozen.lua", "data/scripts/biomes/rainforest_lag_reducer.lua" )
end

-- if not ModIsEnabled("particle_life") then
	-- if HasFlagPersistent("nee_ants") then
		-- replace_value("data/scripts/biomes/rainforest.lua", 
		-- [[%-%- spawn_hp_mult%(g_small_enemies]], 
		-- [[
		-- SetRandomSeed( GameGetFrameNum(), x + y )

		-- local random_number = Random(1,4)
		-- if random_number == 1 then
			-- EntityLoad( "data/entities/materials/ant_spawner.xml", x, y )
		-- end
		
		-- -- spawn_hp_mult(g_small_enemies]]
		-- )
		-- replace_value("data/scripts/biomes/excavationsite.lua", 
		-- [[function spawn_small_enemies%(x%, y%)]], 
		-- [[
		-- function spawn_small_enemies(x, y)
		-- SetRandomSeed( GameGetFrameNum(), x + y )

		-- local random_number = Random(1,4)
		-- if random_number == 1 then
			-- EntityLoad( "data/entities/materials/ant_spawner.xml", x, y )
		-- end]]
		-- )
		-- replace_value("data/scripts/biomes/coalmine.lua", 
		-- [[function spawn_small_enemies%(x%, y%, w%, h%, is_open_path%)]], 
		-- [[
		-- function spawn_small_enemies(x, y, w, h, is_open_path)
		-- SetRandomSeed( GameGetFrameNum(), x + y )

		-- local random_number = Random(1,4)
		-- if random_number == 1 then
			-- EntityLoad( "data/entities/materials/ant_spawner.xml", x, y )
		-- end]]
		-- )
		-- replace_value("data/scripts/biomes/coalmine_alt.lua", 
		-- [[function spawn_small_enemies%(x%, y%)]], 
		-- [[
		-- function spawn_small_enemies(x, y)
		-- SetRandomSeed( GameGetFrameNum(), x + y )

		-- local random_number = Random(1,4)
		-- if random_number == 1 then
			-- EntityLoad( "data/entities/materials/ant_spawner.xml", x, y )
		-- end]]
		-- )
	-- end

	-- if ( HasFlagPersistent("nee_spiders") ) or ( HasFlagPersistent("nee_earth_worms") ) or ( HasFlagPersistent("nee_water_bugs") ) then
		-- --particle bugs and creatures
		-- replace_value("data/scripts/biomes/coalmine.lua", 
		-- [[-- this is a special function tweaked for spawning things in coalmine]], 
		-- [[-- this is a special function tweaked for spawning things in coalmine
		
		-- RegisterSpawnFunction(0xffffeedd, "init")
		
		-- function init(x, y, w, h)
			-- EntityLoad("data/entities/materials/material_bug_spawner.xml", x, y)
		-- end]]
		-- )
		
		-- replace_value("data/scripts/biomes/coalmine_alt.lua", 
		-- [[-- this is a special function tweaked for spawning things in coalmine]], 
		-- [[-- this is a special function tweaked for spawning things in coalmine
		
		-- RegisterSpawnFunction(0xffffeedd, "init")
		
		-- function init(x, y, w, h)
			-- EntityLoad("data/entities/materials/material_bug_spawner.xml", x, y)
		-- end]]
		-- )
		
		-- replace_value("data/scripts/biomes/excavationsite.lua", 
		-- [[-- this is a special function tweaked for spawning things in coal mines]], 
		-- [[-- this is a special function tweaked for spawning things in coal mines
		
		-- RegisterSpawnFunction(0xffffeedd, "init")
		
		-- function init(x, y, w, h)
			-- EntityLoad("data/entities/materials/material_bug_spawner.xml", x, y)
		-- end]]
		-- )
		
		-- replace_value("data/scripts/biomes/fungiforest.lua", 
		-- [[function init%(x%, y%, w%, h%)]], 
		-- [[function init(x, y, w, h)
			-- EntityLoad("data/entities/materials/material_bug_spawner.xml", x, y)]]
		-- )
		
		-- replace_value("data/scripts/biomes/fungicave.lua", 
		-- [[function init%(x%, y%, w%, h%)]], 
		-- [[function init(x, y, w, h)
			-- EntityLoad("data/entities/materials/material_bug_spawner.xml", x, y)]]
		-- )
		
		-- replace_value("data/scripts/biomes/rainforest.lua", 
		-- [[function init%(x%, y%, w%, h%)]], 
		-- [[function init(x, y, w, h)
			-- EntityLoad("data/entities/materials/material_bug_spawner.xml", x, y)]]
		-- )
		-- --particle bugs and creatures
	-- end
-- end

--Removing particle life from fungal shifts
replace_value("data/scripts/magic/fungal_shift.lua", 
[[local held_material %= get_held_item_material%( entity %)]], 
[[local held_material = get_held_item_material( entity )
local held_material_name = CellFactory_GetName(held_material)
if held_material_name == "spider_spawner" or
held_material_name == "spider" or
held_material_name == "spider_web" or
held_material_name == "earth_worm" or
held_material_name == "snake_seed" or
held_material_name == "snake" or
held_material_name == "snake_tail" or
held_material_name == "snake_flower_red" or
held_material_name == "snake_flower_red2" or
held_material_name == "snake_flower_red3" or
held_material_name == "snake_flower_yellow" or
held_material_name == "snake_flower_yellow2" or
held_material_name == "snake_flower_yellow3" or
held_material_name == "snake_flower_orange" or
held_material_name == "snake_flower_orange2" or
held_material_name == "snake_flower_orange3" or
held_material_name == "snake_flower_blue" or
held_material_name == "snake_flower_blue2" or
held_material_name == "snake_flower_blue3" or
held_material_name == "water_bug" or
held_material_name == "water_swamp_bug" or
held_material_name == "mosquito" or
held_material_name == "mosquito_wing" or
held_material_name == "soil_evaporate" or
held_material_name == "jungle_seed" or
held_material_name == "water_health" or
held_material_name == "rock_box2d_hard_damage" or
held_material_name == "blood_static" or
held_material_name == "lava2" or
held_material_name == "bone_fading" or
held_material_name == "rock_static_radioactive2" or
held_material_name == "meat_grey" or
held_material_name == "blood_grey" or
held_material_name == "radioactive_liquid2" or
held_material_name == "rock_hard_border2" or
held_material_name == "rock_hard_border3" or
held_material_name == "rock_hard_border4" or
held_material_name == "radioactive_gas2" or
held_material_name == "flea" then
	held_material = 0
end
]]
)

--Removing particle life from fungal twitch
-- if ModIsEnabled("fungal-twitch") then

	-- replace_value("mods/fungal-twitch/files/utils.lua", 
	-- [[function doShift%(from%, to%)]], 
	-- [[function doShift(from, to)
		-- local held_material_name = from
		-- if held_material_name == "spider_spawner" or
			-- held_material_name == "spider" or
			-- held_material_name == "spider_web" or
			-- held_material_name == "earth_worm" or
			-- held_material_name == "snake_seed" or
			-- held_material_name == "snake" or
			-- held_material_name == "snake_tail" or
			-- held_material_name == "snake_flower_red" or
			-- held_material_name == "snake_flower_red2" or
			-- held_material_name == "snake_flower_red3" or
			-- held_material_name == "snake_flower_yellow" or
			-- held_material_name == "snake_flower_yellow2" or
			-- held_material_name == "snake_flower_yellow3" or
			-- held_material_name == "snake_flower_orange" or
			-- held_material_name == "snake_flower_orange2" or
			-- held_material_name == "snake_flower_orange3" or
			-- held_material_name == "snake_flower_blue" or
			-- held_material_name == "snake_flower_blue2" or
			-- held_material_name == "snake_flower_blue3" or
			-- held_material_name == "water_bug" or
			-- held_material_name == "water_swamp_bug" or
			-- held_material_name == "mosquito" or
			-- held_material_name == "mosquito_wing" or
			-- held_material_name == "soil_evaporate" or
			-- held_material_name == "jungle_seed" or
			-- held_material_name == "water_health" or
			-- held_material_name == "rock_box2d_hard_damage" or
			-- held_material_name == "blood_static" or
			-- held_material_name == "lava2" or
			-- held_material_name == "bone_fading" or
			-- held_material_name == "rock_static_radioactive2" or
			-- held_material_name == "meat_grey" or
			-- held_material_name == "blood_grey" or
			-- held_material_name == "radioactive_liquid2" or
			-- held_material_name == "rock_hard_border2" or
			-- held_material_name == "rock_hard_border3" or
			-- held_material_name == "rock_hard_border4" or
			-- held_material_name == "radioactive_gas2" or
			-- held_material_name == "flea" then
			-- return
		-- end]]
	-- )

-- end

--Add surface passive creatures
replace_value("data/scripts/director_helpers.lua", 
[[-- default biome functions that get called if we can%'t find a a specific biome that works for us]], 
[[RegisterSpawnFunction( 0xff123469, "spawn_peasant" )

function spawn_peasant(x, y)
	EntityLoad("data/entities/animals/peasant.xml", x, y)
end

RegisterSpawnFunction( 0xff123468, "spawn_peasant_blue" )

function spawn_peasant_blue(x, y)
	EntityLoad("data/entities/animals/peasant_blue.xml", x, y)
end

RegisterSpawnFunction( 0xff123467, "spawn_peasant_red" )

function spawn_peasant_red(x, y)
	EntityLoad("data/entities/animals/peasant_red.xml", x, y)
end

RegisterSpawnFunction( 0xff123466, "spawn_hut" )

function spawn_hut(x, y)
	EntityLoad("data/entities/buildings/hut.xml", x, y)
end

RegisterSpawnFunction( 0xff123465, "spawn_mammoth" )

function spawn_mammoth(x, y)
	EntityLoad("data/entities/animals/mammoth.xml", x, y)
end

RegisterSpawnFunction( 0xff123464, "spawn_mammoth_baby" )

function spawn_mammoth_baby(x, y)
	EntityLoad("data/entities/animals/mammoth_baby.xml", x, y)
end

RegisterSpawnFunction( 0xff123463, "spawn_camel" )

function spawn_camel(x, y)
	EntityLoad("data/entities/animals/camel.xml", x, y)
end

RegisterSpawnFunction( 0xff123462, "spawn_scorpion" )

function spawn_scorpion(x, y)
	EntityLoad("data/entities/animals/scorpion.xml", x, y)
end

RegisterSpawnFunction( 0xff123461, "spawn_locust" )

function spawn_locust(x, y)
	EntityLoad("data/entities/animals/locust.xml", x, y)
end

RegisterSpawnFunction( 0xff123460, "spawn_frog_tiny" )

function spawn_frog_tiny(x, y)
	EntityLoad("data/entities/animals/frog_tiny.xml", x, y)
end

RegisterSpawnFunction( 0xff123459, "spawn_llama" )

function spawn_llama(x, y)
	EntityLoad("data/entities/animals/llama.xml", x, y)
end

RegisterSpawnFunction( 0xffb2e367, "spawn_boids" )

function spawn_boids(x, y)
	EntityLoad("data/entities/spawn_boids_air_checker.xml", x, y)
end

-- default biome functions that get called if we can't find a a specific biome that works for us]]
)



--Omega Steve
if not HasFlagPersistent("ned_necromancer_omega") then
	replace_value("data/entities/animals/necromancer_super.xml", 
	[[<!%-%- protections %-%->]], 
	[[    <LuaComponent 
			script_death="data/scripts/animals/necromancer_super_death.lua" 
		>
		</LuaComponent>]]
	)
	
	replace_value("data/scripts/animals/necromancer_shop_spawn.lua", 
	[[then]], 
	[[and tonumber(GlobalsGetValue("SKOUDE_DEATHS", 0)) < 6 then]]
	)

	replace_value("data/scripts/animals/necromancer_shop_spawn.lua", 
	[[else]], 
	[[elseif tonumber(GlobalsGetValue("STEVARI_DEATHS", 0)) >= 3 and tonumber(GlobalsGetValue("SKOUDE_DEATHS", 0)) < 6 then]]
	)

	replace_value("data/scripts/animals/necromancer_shop_spawn.lua", 
	[[end]], 
	[[elseif tonumber(GlobalsGetValue("SKOUDE_DEATHS", 0)) >= 6 then
		EntityLoad("data/entities/animals/necromancer_omega.xml", pos_x, pos_y)
	end]]
	)
end

--secret2:
replace_value("data/scripts/biomes/funroom.lua", 
[[function init%( x, y, w, h %)]], 
[[function init( x, y, w, h ) 
	EntityLoad("data/entities/animals/lemming.xml", x + 315,y + 300)
	EntityLoad("data/entities/animals/lemming.xml", x + 329,y + 300)
	EntityLoad("data/entities/animals/lemming.xml", x + 347,y + 300)
	EntityLoad("data/entities/animals/lemming.xml", x + 377,y + 300)
]]
)

--Addition of enemies to Custom biome:
if ModIsEnabled("New Biomes + Secrets") then

	ModLuaFileAppend( "data/scripts/biomes/LANDING.lua", "data/scripts/biomes/landing_enemies.lua" )

end

--Adding a ton of shaders for mirror orbs effect
--This is for Vollux or data/entities/animals/mirror_physics.xml
if not HasFlagPersistent("ned_mirror_physics") then

	dofile_once("mods/new_enemies/files/shader_utilities.lua")

	local s = "    uniform vec4 ballpos_#i;"
	local final = ""
	for i=1, 9 do
	  final = final .. s:gsub("#i", i) .. "\n"
	end
	postfx.append(final,
	"uniform sampler2D tex_fog;",
	"data/shaders/post_final.frag"
	)

	local s = [[
	if ( ballpos_#i.w > 0.0 ) {
		vec4 ballpos_#i = vec4(
        (ballpos_#i.x/world_viewport_size.x) - (camera_pos.x/world_viewport_size.x),
        (-ballpos_#i.y/world_viewport_size.y) + (camera_pos.y/world_viewport_size.y) + 1.0,
        ballpos_#i.z,
        ballpos_#i.w
        );
	
		float stretch_#i = world_viewport_size.y/world_viewport_size.x;
		float l_#i = length(vec2((tex_coord.x-ballpos_#i.x)/stretch_#i, tex_coord.y-ballpos_#i.y) - vec2(0.0,0.0)); //distance from pixel to ball center
		float mult_#i = step(l_#i,ballpos_#i.z);

		vec2 edge_#i = vec2( //the outline of the ball
			ballpos_#i.x + ((tex_coord.x-ballpos_#i.x)/l_#i)*ballpos_#i.z,
			ballpos_#i.y + ((tex_coord.y-ballpos_#i.y)/l_#i)*ballpos_#i.z
			);
		vec2 move_#i = vec2(edge_#i.x - ((tex_coord.x-edge_#i.x)/(l_#i*20.0)), edge_#i.y - ((tex_coord.y-edge_#i.y)/(l_#i*20.0))) - tex_coord;
		tex_coord += move_#i*mult_#i*ballpos_#i.w;
		tex_coord_glow += vec2(move_#i.x, -move_#i.y)*mult_#i*ballpos_#i.w;
	}
	]]
	local final = ""
	for i=1, 9 do
	  final = final .. s:gsub("#i", i) .. "\n"
	end

	postfx.append(final,
	  "// sample the original color =================================================================================",
	  "data/shaders/post_final.frag"
	)
	
	-- local s = [[
	-- vec4 ballpos_#i = vec4(
        -- (ballpos_#i.x/world_viewport_size.x) - (camera_pos.x/world_viewport_size.x),
        -- (-ballpos_#i.y/world_viewport_size.y) + (camera_pos.y/world_viewport_size.y) + 1.0,
        -- ballpos_#i.z,
        -- 0.0
        -- );

    -- float stretch_#i = world_viewport_size.y/world_viewport_size.x;
    -- float l_#i = length(vec2((tex_coord.x-ballpos_#i.x)/stretch_#i, tex_coord.y-ballpos_#i.y) - vec2(0.0,0.0)); //distance from pixel to ball center
    -- float mult_#i = step(l_#i,ballpos_#i.z);

    -- vec2 edge_#i = vec2( //the outline of the ball
        -- ballpos_#i.x + ((tex_coord.x-ballpos_#i.x)/l_#i)*ballpos_#i.z,
        -- ballpos_#i.y + ((tex_coord.y-ballpos_#i.y)/l_#i)*ballpos_#i.z
        -- );
	-- vec2 move_#i = vec2(edge_#i.x - ((tex_coord.x-edge_#i.x)/(l_#i*20.0)), edge_#i.y - ((tex_coord.y-edge_#i.y)/(l_#i*20.0))) - tex_coord;
    -- tex_coord += move_#i*mult_#i*ballpos_#i.w;
    -- tex_coord_glow += vec2(move_#i.x, -move_#i.y)*mult_#i*ballpos_#i.w;
	-- ]]
	-- local final = ""
	-- for i=1, 3 do
	  -- final = final .. s:gsub("#i", i) .. "\n"
	-- end

	-- postfx.append(final,
	  -- "// sample the original color =================================================================================",
	  -- "data/shaders/post_final.frag"
	-- )

end

--Adding shader stuff for lighting of corridor boss
if HasFlagPersistent("nee_ear_boss") then
	replace_value("data/shaders/post_final.frag", 
	[[varying vec2 tex_coord_fogofwar%;]], 
	[[varying vec2 tex_coord_fogofwar;
uniform vec4 bossroom_lighting;]]
	)
	
	replace_value("data/shaders/post_final.frag", 
	[[color_fg%.rgb %*%= lights%;]], 
	[[color_fg.rgb *= max(lights, bossroom_lighting.x);]]
	)
end

--Adding shrinking zoom in shader
if not HasFlagPersistent("ned_wizard_tiny") then
	replace_value("data/shaders/post_final.frag", 
	[[varying vec2 tex_coord_fogofwar%;]], 
	[[varying vec2 tex_coord_fogofwar;
uniform vec4 zoom_in_amount;]]
	)

	replace_value("data/shaders/post_final.frag", 
	[[vec2 tex_coord_glow %= tex_coord_glow_%;]], 
	[[vec2 tex_coord_glow = tex_coord_glow_;

// MY ADDITION =================================
	float zoom_screen_amount = 1.0;
	if ( zoom_in_amount.x <= 1.0 ) {
		zoom_screen_amount = zoom_in_amount.x;
	}
	vec2 zoom = vec2(zoom_screen_amount,zoom_screen_amount); //where zoom_in_amount is a number between 0 and 1
	vec2 center = vec2(0.5,0.5);
	tex_coord = (tex_coord*zoom) + (center*(vec2(1.0,1.0)-zoom));
	tex_coord_y_inverted = vec2( (tex_coord_y_inverted.x*zoom.x)+(center.x*(1.0-zoom.x)), (tex_coord_y_inverted.y*zoom.y)+(center.y*(1.0-zoom.y)) );
	tex_coord_glow = (tex_coord_glow*zoom) + (center*(vec2(1.0,1.0)-zoom));]]
	)
GameSetPostFxParameter("zoom_in_amount", 1.0, 0, 0, 0)

end

--Adding Platoon or Titan Tusk to Parallel Worlds

replace_value("data/scripts/biome_scripts.lua", 
[[if %( r %>%= 98 %) then]], 
[[local enemy_table = {}
if not HasFlagPersistent("ned_platoon") then
	table.insert(enemy_table, "platoon")
end
if not HasFlagPersistent("ned_elephant_robot") then
	table.insert(enemy_table, "elephant_robot")
end
local random_val = Random(1, #enemy_table)
local enemy = enemy_table[random_val]
	
if ( r >= 100 ) and ( #enemy_table > 0 ) then
	EntityLoad( "data/entities/animals/" .. enemy .. ".xml", x + rx, y )
elseif ( r >= 98 ) then]]
)

if not HasFlagPersistent("ned_peeper") then
	replace_value("data/scripts/biomes/wandcave.lua", 
	[[function spawn%_lamp%(x%, y%)]], 
	[[function spawn_lamp(x, y)
		-- SetRandomSeed( GameGetFrameNum(), x + y )
		-- if Random(1,2) == 1 then
			EntityLoad( "data/entities/animals/peeper.xml", x, y )
		-- end]]
	)
	replace_value("data/scripts/biomes/pyramid.lua", 
	[[function spawn%_lamp2%(x%, y%)]], 
	[[function spawn_lamp2(x, y)
		-- SetRandomSeed( GameGetFrameNum(), x + y )
		-- if Random(1,3) == 1 then
			EntityLoad( "data/entities/animals/peeper.xml", x, y )
		-- end]]
	)
	replace_value("data/scripts/biomes/crypt.lua", 
	[[function spawn%_lamp%(x%, y%)]], 
	[[function spawn_lamp(x, y)
		-- SetRandomSeed( GameGetFrameNum(), x + y )
		-- if Random(1,2) == 1 then
			EntityLoad( "data/entities/animals/peeper.xml", x, y )
		-- end]]
	)
end

--Patching Disc runestone (THIS HAS BEEN FIXED BY NOLLA)

-- Please note that I'm adding % before the ( or ) so that they count as literal characters, not anything related to the code.
-- replace_value("data/scripts/items/runestones/runestone_disc.lua", 
-- [[shoot_projectile_from_projectile%( projectile_id, "data/entities/projectiles/deck/disc_bullet.xml", px, py, vel_x, vel_y %)]], 
-- [[local projectile_component = EntityGetFirstComponent(projectile_id, "ProjectileComponent")
-- mWhoShot = ComponentGetValue2(projectile_component, "mWhoShot")

-- local lua_comps = EntityGetComponent(mWhoShot, "LuaComponent") or {}

-- local found = false

-- for i, comp in ipairs(lua_comps) do
	-- if ComponentGetValue2(comp, "script_shot") ~= "" and ComponentGetValue2(comp, "script_shot") ~= "mods/raksa/files/powers/correct_friendly_fire.lua" then
		-- found = true
		-- break
	-- end        
-- end

-- if found then
	-- shoot_projectile( projectile_id, "data/entities/projectiles/deck/disc_bullet.xml", px, py, vel_x, vel_y )
-- else
	-- shoot_projectile_from_projectile( projectile_id, "data/entities/projectiles/deck/disc_bullet.xml", px, py, vel_x, vel_y )
-- end]]
-- )

-- --Patching Fireball runestone
-- replace_value("data/scripts/items/runestones/runestone_fireball.lua", 
-- [[shoot_projectile_from_projectile%( projectile_id, "data/entities/projectiles/deck/fireball.xml", px, py, vel_x, vel_y %)]], 
-- [[local projectile_component = EntityGetFirstComponent(projectile_id, "ProjectileComponent")
-- mWhoShot = ComponentGetValue2(projectile_component, "mWhoShot")

-- local lua_comps = EntityGetComponent(mWhoShot, "LuaComponent") or {}

-- local found = false

-- for i, comp in ipairs(lua_comps) do
	-- if ComponentGetValue2(comp, "script_shot") ~= "" and ComponentGetValue2(comp, "script_shot") ~= "mods/raksa/files/powers/correct_friendly_fire.lua" then
		-- found = true
		-- break
	-- end        
-- end

-- if found then
	-- shoot_projectile( projectile_id, "data/entities/projectiles/deck/fireball.xml", px, py, vel_x, vel_y )
-- else
	-- shoot_projectile_from_projectile( projectile_id, "data/entities/projectiles/deck/fireball.xml", px, py, vel_x, vel_y )
-- end]]
-- )

-- --Patching Laser runestone
-- replace_value("data/scripts/items/runestones/runestone_laser.lua", 
-- [[shoot_projectile_from_projectile%( projectile_id, "data/entities/projectiles/deck/laser.xml", px, py, vel_x, vel_y %)]], 
-- [[local projectile_component = EntityGetFirstComponent(projectile_id, "ProjectileComponent")
-- mWhoShot = ComponentGetValue2(projectile_component, "mWhoShot")

-- local lua_comps = EntityGetComponent(mWhoShot, "LuaComponent") or {}

-- local found = false

-- for i, comp in ipairs(lua_comps) do
	-- if ComponentGetValue2(comp, "script_shot") ~= "" and ComponentGetValue2(comp, "script_shot") ~= "mods/raksa/files/powers/correct_friendly_fire.lua" then
		-- found = true
		-- break
	-- end        
-- end

-- if found then
	-- shoot_projectile( projectile_id, "data/entities/projectiles/deck/laser.xml", px, py, vel_x, vel_y )
-- else
	-- shoot_projectile_from_projectile( projectile_id, "data/entities/projectiles/deck/laser.xml", px, py, vel_x, vel_y )
-- end]]
-- )

if ModIsEnabled("biome-plus") then
	
	if mode == "normal" or not mode then
	
		--addition of enemies to alternate biomes mod
		ModLuaFileAppend( "data/scripts/biomes/mod/irradiated_mines.lua", "data/scripts/biomes/coalmine_alt_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/floodcave.lua", "data/scripts/biomes/coalmine_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/blast_pit.lua", "data/scripts/biomes/excavationsite_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/frozen_passages.lua", "data/scripts/biomes/snowcave_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/the_void.lua", "mods/new_enemies/data/scripts/biomes/the_end_enemies.lua" )
		-- ModLuaFileAppend( "data/scripts/biomes/mod/floating_mountain.lua", "mods/new_enemies/data/scripts/biomes/the_sky_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/collapsed_lab.lua", "data/scripts/biomes/fungicave_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/catacombs.lua", "data/scripts/biomes/wandcave_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/swamp.lua", "data/scripts/biomes/rainforest_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/robofactory.lua", "data/scripts/biomes/vault_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/holy_temple.lua", "data/scripts/biomes/crypt_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/snowvillage.lua", "data/scripts/biomes/snowcastle_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/tomb.lua", "data/scripts/biomes/sandcave_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/rainforest_wormy.lua", "data/scripts/biomes/rainforest_dark_enemies.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/sulfur_cave.lua", "data/scripts/biomes/fungiforest_enemies.lua" )
	
	elseif mode == "easy" then
	
		ModLuaFileAppend( "data/scripts/biomes/mod/irradiated_mines.lua", "data/scripts/biomes/coalmine_alt_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/floodcave.lua", "data/scripts/biomes/coalmine_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/blast_pit.lua", "data/scripts/biomes/excavationsite_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/frozen_passages.lua", "data/scripts/biomes/snowcave_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/the_void.lua", "mods/new_enemies/data/scripts/biomes/the_end_enemies_easy.lua" )
		-- ModLuaFileAppend( "data/scripts/biomes/mod/floating_mountain.lua", "mods/new_enemies/data/scripts/biomes/the_sky_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/collapsed_lab.lua", "data/scripts/biomes/fungicave_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/catacombs.lua", "data/scripts/biomes/wandcave_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/swamp.lua", "data/scripts/biomes/rainforest_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/robofactory.lua", "data/scripts/biomes/vault_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/holy_temple.lua", "data/scripts/biomes/crypt_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/snowvillage.lua", "data/scripts/biomes/snowcastle_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/tomb.lua", "data/scripts/biomes/sandcave_enemies_easy.lua" )
		ModLuaFileAppend( "data/scripts/biomes/mod/sulfur_cave.lua", "data/scripts/biomes/fungiforest_enemies_easy.lua" )
	
	end
	
	--Fixes for the giant runestones so they don't trigger script_shot each frame when enemies with script_shot are in the aura:
	
	--Patching Giga Sawblade Runestone
	replace_value("data/scripts/props/mod/runestone_disc_big.lua", 
	[[shoot_projectile_from_projectile%( projectile_id, "data/entities/projectiles/deck/disc_bullet_big.xml", px, py, vel_x/1.5, vel_y/1.5 %)]], 
    [[local projectile_component = EntityGetFirstComponent(projectile_id, "ProjectileComponent")
    mWhoShot = ComponentGetValue2(projectile_component, "mWhoShot")
    
    local lua_comps = EntityGetComponent(mWhoShot, "LuaComponent") or {}
    
    local found = false
    
    for i, comp in ipairs(lua_comps) do
        if ComponentGetValue2(comp, "script_shot") ~= "" and ComponentGetValue2(comp, "script_shot") ~= "mods/raksa/files/powers/correct_friendly_fire.lua" then
            found = true
            break
        end        
    end
    
    if found then
        shoot_projectile( projectile_id, "data/entities/projectiles/deck/disc_bullet_big.xml", px, py, vel_x, vel_y )
    else
        shoot_projectile_from_projectile( projectile_id, "data/entities/projectiles/deck/disc_bullet_big.xml", px, py, vel_x, vel_y )
    end]]
	)
	
	--Patching Plasma beam RuneStone
	replace_value("data/scripts/props/mod/runestone_laser_big.lua", 
	[[shoot_projectile_from_projectile%( projectile_id, "data/entities/projectiles/mod/orb_laseremitter_runestone.xml", px, py, vel_x/2, vel_y/2 %)]], 
    [[local projectile_component = EntityGetFirstComponent(projectile_id, "ProjectileComponent")
    mWhoShot = ComponentGetValue2(projectile_component, "mWhoShot")
    
    local lua_comps = EntityGetComponent(mWhoShot, "LuaComponent") or {}
    
    local found = false
    
    for i, comp in ipairs(lua_comps) do
        if ComponentGetValue2(comp, "script_shot") ~= "" and ComponentGetValue2(comp, "script_shot") ~= "mods/raksa/files/powers/correct_friendly_fire.lua" then
            found = true
            break
        end        
    end
    
    if found then
        shoot_projectile( projectile_id, "data/entities/projectiles/mod/orb_laseremitter_runestone.xml", px, py, vel_x/2, vel_y/2 )
    else
        shoot_projectile_from_projectile( projectile_id, "data/entities/projectiles/mod/orb_laseremitter_runestone.xml", px, py, vel_x/2, vel_y/2 )
    end]]
	)
	
	--Patching Meteor Runestone
	replace_value("data/scripts/props/mod/runestone_fireball_big.lua", 
	[[shoot_projectile_from_projectile%( projectile_id, "data/entities/projectiles/mod/meteor_runestone.xml", px, py, vel_x, vel_y %)]], 
    [[local projectile_component = EntityGetFirstComponent(projectile_id, "ProjectileComponent")
    mWhoShot = ComponentGetValue2(projectile_component, "mWhoShot")
    
    local lua_comps = EntityGetComponent(mWhoShot, "LuaComponent") or {}
    
    local found = false
    
    for i, comp in ipairs(lua_comps) do
        if ComponentGetValue2(comp, "script_shot") ~= "" and ComponentGetValue2(comp, "script_shot") ~= "mods/raksa/files/powers/correct_friendly_fire.lua" then
            found = true
            break
        end        
    end
    
    if found then
        shoot_projectile( projectile_id, "data/entities/projectiles/mod/meteor_runestone.xml", px, py, vel_x, vel_y )
    else
        shoot_projectile_from_projectile( projectile_id, "data/entities/projectiles/mod/meteor_runestone.xml", px, py, vel_x, vel_y )
    end]]
	)
end

--Lake Statue
if HasFlagPersistent("nee_lake_statue") then
	ModLuaFileAppend( "data/scripts/biomes/lake_statue.lua", "data/scripts/biomes/lake_statue_append.lua" )
end

--Add New enemies trophy in the work
if not ModIsEnabled("nightmare") then
	replace_value("data/entities/animals/boss_centipede/rewards/spawn_rewards.lua", 
	[[%-%- sun]], 
	[[if( ModIsEnabled("new_enemies") ) and not ( ModIsEnabled("nightmare") ) then
		if( spawned_n <= 0 ) then
			spawned_n = 1
		end
		entity = EntityLoad( "data/entities/animals/boss_centipede/rewards/reward_ne.xml", x + spawned_n * 20, y - spawned_n * 10 )
		spawned_n = spawned_n + 1
	end

	-- sun]]
	)

--Add New Enemies Trophy in the work if we're on Nightmare mode
elseif ModIsEnabled("nightmare") then
	
	replace_value("data/entities/animals/boss_centipede/rewards/spawn_rewards.lua", 
	[[%-%- sun]], 
    [[if( ModIsEnabled("nightmare") ) then
		if( spawned_n <= 0 ) then
			spawned_n = 1
		end
		entity = EntityLoad( "data/entities/animals/boss_centipede/rewards/reward_ne_nightmare.xml", x + spawned_n * 20, y - spawned_n * 10 )
		spawned_n = spawned_n + 1
	end
	
	-- sun]]
	)
end

-- Addition of enemies to Conjurer Mod:
if ModIsEnabled("raksa") then
  ModLuaFileAppend( "mods/raksa/files/scripts/lists/entity_categories.lua", "data/scripts/conjurer_mod/conjurer_list.lua" )
end

--5 gold drop for eye bats:

function string.insert(str1, str2, pos)
    return str1:sub(1,pos)..str2..str1:sub(pos+1)
end

function add_goldnugget_5(lua_file)
    local lua_content = ModTextFileGetContent(lua_file)
    if lua_content then
        local insertion_point = string.find(lua_content, "if.health.>.1.0.then")
        local code_to_insert = [[
            if EntityGetName(entity) == "$spider_crawler" or EntityGetName(entity) == "$larva_crawler" or EntityGetName(entity) == "$crawler_bug" or EntityGetName(entity) == "$eye_bat" or EntityGetName(entity) == "Eye Bat Birthday" or EntityGetName(entity) == "Eye Bat Pumpkin" or EntityGetName(entity) == "Eye Bat Valentines" or EntityGetName(entity) == "Floating Eye" then
                amount = 0.5
				use_goldnugget_5 = true
            end
        ]]
        if insertion_point ~= nil then
            lua_content = string.insert(lua_content, code_to_insert .. "\n", insertion_point-1)
        end

        insertion_point = string.find(lua_content, "local.money")
        code_to_insert = [[
            if EntityGetName(entity) == "$gonha" then
                amount = amount * 10
            end
            if EntityGetName(entity) == "$summoner" then
                amount = amount * 2
            end
            if EntityGetName(entity) == "$twig" then
                amount = amount * 2
            end
            if EntityGetName(entity) == "$longleg_big" then
                amount = amount * 2
            end
        ]]
        if insertion_point ~= nil then
            lua_content = string.insert(lua_content, code_to_insert .. "\n", insertion_point-1)
        end

        insertion_point = string.find(lua_content, "if..trick_kill")
        code_to_insert = [[
            if EntityGetName(entity) == "Eye Bat Birthday" or EntityGetName(entity) == "Eye Bat Pumpkin" or EntityGetName(entity) == "Eye Bat Valentines" or EntityGetName(entity) == "Valentines Skeleton" or EntityGetName(entity) == "Birthday Skeleton" then
                gold_entity = "data/entities/items/pickup/bloodmoney_"
                drop_first_10 = false
            end
        ]]
        if insertion_point ~= nil then
            lua_content = string.insert(lua_content, code_to_insert .. "\n", insertion_point-1)
        end
        
        insertion_point = string.find(lua_content, "end....function.death")
        code_to_insert = [[
            while use_goldnugget_5 ~= nil and money >= 5 do
                load_gold_entity( gold_entity .. "5.xml", x, y-8, remove_timer )
                money = money - 5
            end  
        ]]
        if insertion_point ~= nil then
            lua_content = string.insert(lua_content, code_to_insert .. "\n", insertion_point-1)
        end
        
        ModTextFileSetContent(lua_file, lua_content)
    end
end
add_goldnugget_5("data/scripts/items/drop_money.lua")

--Quin 50% chance for spawn:

-- if not GameHasFlagRun( "quin_spawned" ) and not GameHasFlagRun( "quin_excavationsite" ) and not GameHasFlagRun( "quin_snowcave" ) then
    -- local a1, a2, a3, a4, a5, a6 = GameGetDateAndTimeUTC()
    -- SetRandomSeed( a1*a2*a3*a4*a5*a6, a1*a2*a3*a4*a5*a6 )
    -- if Random(1,2) == 1 then
        -- GameAddFlagRun( "quin_excavationsite" )
    -- else
        -- GameAddFlagRun( "quin_snowcave" )
    -- end
-- end

--Materials that damage function:

function add_materials_that_damage(entity_id, materials)
  local damage_model_component = EntityGetFirstComponent(entity_id, "DamageModelComponent")
  if damage_model_component ~= nil then
    -- Store all old values
    local old_values = {}
    local old_damage_multipliers = {}
    for k,v in pairs(ComponentGetMembers(damage_model_component)) do
      if k == "ragdoll_fx_forced" then
        v = ComponentGetValue2(damage_model_component, k)
      end
      old_values[k] = v
      -- print(k, v)
    end
    for k,_ in pairs(ComponentObjectGetMembers(damage_model_component, "damage_multipliers")) do
      old_damage_multipliers[k] = ComponentObjectGetValue(damage_model_component, "damage_multipliers", k)
    end

    -- Rebuild the comma separated string
    for material, damage in pairs(materials) do
      old_values.materials_that_damage = old_values.materials_that_damage .. "," .. material
      old_values.materials_how_much_damage = old_values.materials_how_much_damage .. "," .. damage
    end

    EntityRemoveComponent(entity_id, damage_model_component)
    damage_model_component = EntityAddComponent(entity_id, "DamageModelComponent", old_values)

    ComponentSetValue2(damage_model_component, "ragdoll_fx_forced", old_values.ragdoll_fx_forced)

    for k, v in pairs(old_damage_multipliers) do
      ComponentObjectSetValue(damage_model_component, "damage_multipliers", k, v)
    end
  end
end

--Addition of Freeze Field Materials:

-- local xml2lua = dofile("mods/new_enemies/files/xml2lua_library/xml2lua.lua")
-- local xml_content = ModTextFileGetContent("data/entities/misc/perks/freeze_field.xml")
-- local handler = xml2lua.parse(xml_content)
-- handler.root.Entity.MagicConvertMaterialComponent = handler.root.Entity.MagicConvertMaterialComponent or {}
-- table.insert(handler.root.Entity.MagicConvertMaterialComponent, {
  -- _attr = {
	-- from_material="radioactive_liquid_blue",
	-- to_material="ice_radioactive_static",
	-- steps_per_frame="20",
	-- loop="1",
	-- is_circle="1",
	-- radius="20",
  -- }
-- })
-- table.insert(handler.root.Entity.MagicConvertMaterialComponent, {
  -- _attr = {
	-- from_material="radioactive_goo",
	-- to_material="ice_radioactive_static",
	-- steps_per_frame="20",
	-- loop="1",
	-- is_circle="1",
	-- radius="20",
  -- }
-- })
-- local xml_output = xml2lua.toXml(handler.root, "Entity", 0)
-- ModTextFileSetContent("data/entities/misc/perks/freeze_field.xml", xml_output)

--Addition of Tags to some entities:

function add_tags_seamine()

	local xml2lua = dofile("mods/new_enemies/files/xml2lua_library/xml2lua.lua")
	local xml_content = ModTextFileGetContent("data/entities/props/physics_seamine.xml")
	local handler = xml2lua.parse(xml_content)
	handler.root.Entity._attr = handler.root.Entity._attr or {}
	if handler.root.Entity._attr.tags then
	  handler.root.Entity._attr.tags = handler.root.Entity._attr.tags .. ",erasable"
	else
	  handler.root.Entity._attr.tags = "erasable"
	end
	local xml_output = xml2lua.toXml(handler.root, "Entity", 0)
	ModTextFileSetContent("data/entities/props/physics_seamine.xml", xml_output)

end

function add_tags_crumbling_earth_projectile()

	local xml2lua = dofile("mods/new_enemies/files/xml2lua_library/xml2lua.lua")
	local xml_content = ModTextFileGetContent("data/entities/misc/crumbling_earth_projectile.xml")
	local handler = xml2lua.parse(xml_content)
	handler.root.Entity._attr = handler.root.Entity._attr or {}
	if handler.root.Entity._attr.tags then
	  handler.root.Entity._attr.tags = handler.root.Entity._attr.tags .. ",erasable"
	else
	  handler.root.Entity._attr.tags = "erasable"
	end
	local xml_output = xml2lua.toXml(handler.root, "Entity", 0)
	ModTextFileSetContent("data/entities/misc/crumbling_earth_projectile.xml", xml_output)

end

function add_tags_crumbling_earth()

	local xml2lua = dofile("mods/new_enemies/files/xml2lua_library/xml2lua.lua")
	local xml_content = ModTextFileGetContent("data/entities/projectiles/deck/crumbling_earth.xml")
	local handler = xml2lua.parse(xml_content)
	handler.root.Entity._attr = handler.root.Entity._attr or {}
	if handler.root.Entity._attr.tags then
	  handler.root.Entity._attr.tags = handler.root.Entity._attr.tags .. ",erasable"
	else
	  handler.root.Entity._attr.tags = "erasable"
	end
	local xml_output = xml2lua.toXml(handler.root, "Entity", 0)
	ModTextFileSetContent("data/entities/projectiles/deck/crumbling_earth.xml", xml_output)

end

function add_tags_crumbling_earth_effect()

	local xml2lua = dofile("mods/new_enemies/files/xml2lua_library/xml2lua.lua")
	local xml_content = ModTextFileGetContent("data/entities/projectiles/deck/crumbling_earth_effect.xml")
	local handler = xml2lua.parse(xml_content)
	handler.root.Entity._attr = handler.root.Entity._attr or {}
	if handler.root.Entity._attr.tags then
	  handler.root.Entity._attr.tags = handler.root.Entity._attr.tags .. ",erasable"
	else
	  handler.root.Entity._attr.tags = "erasable"
	end
	local xml_output = xml2lua.toXml(handler.root, "Entity", 0)
	ModTextFileSetContent("data/entities/projectiles/deck/crumbling_earth_effect.xml", xml_output)

end

-- function add_tags_nuke()

	-- local xml2lua = dofile("mods/new_enemies/files/xml2lua_library/xml2lua.lua")
	-- local xml_content = ModTextFileGetContent("data/entities/projectiles/deck/nuke.xml")
	-- local handler = xml2lua.parse(xml_content)
	-- handler.root.Entity._attr = handler.root.Entity._attr or {}
	-- if handler.root.Entity._attr.tags then
	  -- handler.root.Entity._attr.tags = handler.root.Entity._attr.tags .. ",erasable"
	-- else
	  -- handler.root.Entity._attr.tags = "erasable"
	-- end
	-- local xml_output = xml2lua.toXml(handler.root, "Entity", 0)
	-- ModTextFileSetContent("data/entities/projectiles/deck/nuke.xml", xml_output)

-- end

function add_tags_rocks()

	for loop = 1,4 do

		local xml2lua = dofile("mods/new_enemies/files/xml2lua_library/xml2lua.lua")
		local xml_content = ModTextFileGetContent("data/entities/props/physics_stone_0" .. loop .. ".xml")
		local handler = xml2lua.parse(xml_content)
		if handler.root.Entity._attr.tags then
		  handler.root.Entity._attr.tags = handler.root.Entity._attr.tags .. ",erasable"
		else
		  handler.root.Entity._attr.tags = "erasable"
		end
		local xml_output = xml2lua.toXml(handler.root, "Entity", 0)
		ModTextFileSetContent("data/entities/props/physics_stone_0" .. loop .. ".xml", xml_output)
		
	end
	
end

add_tags_seamine()
add_tags_crumbling_earth_projectile()
-- add_tags_crumbling_earth()
-- add_tags_crumbling_earth_effect()
add_tags_rocks()
-- add_tags_nuke()


--Single enemy per biome spawn script:
function add_delete_function(lua_file)
    local lua_content = ModTextFileGetContent(lua_file)
    if lua_content then
        local insertion_point = string.find(lua_content, "return.v")
        local code_to_insert = [[
            if v.delete ~= nil then
                v.delete()
            end
        ]]
        lua_content = string.insert(lua_content, code_to_insert .. "\n", insertion_point-1)    
        ModTextFileSetContent(lua_file, lua_content)
    end
end
add_delete_function("data/scripts/director_helpers.lua")

--Remove muzzle flashes during mwyah Fight

if HasFlagPersistent("nee_mwyah") then
	function remove_muzzle(file_path)
		replace_value(file_path, 
		[[<%/Entity>]], 
		[[<LuaComponent
			script_source_file="data/scripts/misc/muzzle_negate.lua"
			execute_every_n_frame="1"
			execute_on_added="1"
			>
		</LuaComponent>
		</Entity>]]
		)
		
		replace_value(file_path, 
		[[is%_emitting%=%"1%"]], 
		[[is_emitting="0"]]
		)
	end
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_air.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_circular.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_circular_blue.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_circular_large_pink.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_circular_large_pink_reverse.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_circular_pink.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_large.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_large_pink.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_laser.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_laser_green.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_launcher.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_launcher_large.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_large.xml")	
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_launcher.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_launcher_blue.xml")	
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_launcher_holy.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_launcher_large.xml")	
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_launcher_large_blue.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_launcher_trailer.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_medium.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_magic_small.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_medium.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_pink.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_small.xml")
	remove_muzzle("data/entities/particles/muzzle_flashes/muzzle_flash_small_pink.xml")
end

--Mod Settings
local ne_gui_enabled = ModSettingGet("new_enemies.show_button")

if ne_gui_enabled then

    function OnWorldPreUpdate()
	
	  --GUI
	  
		dofile("data/scripts/enemies_gui/gui.lua")
	  
		--PLEASE REMOVE THIS WHEN DONE TESTING
		-- if ModSettingGet("new_enemies.poly_expansion_enabled") then

			-- local players = EntityGetWithTag("polymorphed_player")

			-- if #players > 0 then
				-- local player_id = players[1]
				-- local comps = EntityGetAllComponents(player_id)
				-- local concomp = nil
				-- for i,v in ipairs(comps) do
					-- if ComponentGetTypeName(v) == "ControlsComponent" then concomp = v; break end
				-- end
				-- local input = {
					-- ComponentGetValue(concomp, "mButtonDownKick"),
				-- }
				-- if input[1] == "1" then
					-- for i, child_id in ipairs(EntityGetAllChildren(player_id) or {}) do
						-- local game_effects = EntityGetComponentIncludingDisabled(child_id, "GameEffectComponent") or {}
						-- for _, game_effect in ipairs(game_effects) do
							-- if ComponentGetValue2(game_effect, "effect") == "POLYMORPH_RANDOM" then
								-- ComponentSetValue2(game_effect, "frames", 1)
							-- end
						-- end

					-- end
				-- end
				
			-- end
		  
		-- end
	end
end

--Fixes Goki's perks causing issues with enemy spawning in nightmare mode, especially in Hiisi Base (these issues happen even when not using New Enemies Mod)
function OnModPreInit()
    if ModIsEnabled("gkbrkn_noita") then
        local replace_with = ModTextFileGetContent("mods/new_enemies/data/scripts/fixes/goki_perks_fix.lua")
        ModTextFileSetContent("mods/gkbrkn_noita/files/gkbrkn/content/perks.lua", replace_with)
    end
end

local nxml = dofile_once("mods/new_enemies/files/nxml.lua")

--Adding orb room bosses to apotheosis
if ModIsEnabled("Apotheosis") then
	--Infinitely Looping Corridor Boss Fight
	path = "mods/apotheosis/files/scripts/biomes/newbiome/orbroom_15.lua"
	content = ModTextFileGetContent(path)
	content = content:gsub("EntityLoad%( \"mods/apotheosis/files/entities/items/orbs/custom/orb_15.xml\", x, y %)", "if not HasFlagPersistent(\"nee_ear_boss\") then EntityLoad( \"mods/apotheosis/files/entities/items/orbs/custom/orb_15.xml\", x, y ) else EntityLoad( \"data/entities/buildings/ear_boss_spot.xml\", x, y ) end")
	content = content:gsub("EntityLoad%( \"mods/apotheosis/files/entities/items/books/orbrooms/book_15.xml\", x %- 30, y %- 30 %)", "if not HasFlagPersistent(\"nee_ear_boss\") then EntityLoad( \"mods/apotheosis/files/entities/items/books/orbrooms/book_15.xml\", x - 30, y - 30 ) end")
	ModTextFileSetContent(path, content)

	--Sludge Monkey Boss Fight
	path = "mods/apotheosis/files/scripts/biomes/newbiome/orbroom_14.lua"
	content = ModTextFileGetContent(path)
	content = content:gsub("LoadPixelScene%( \"data/biome_impl/orbroom_noxioussludge.png\", \"data/biome_impl/orbroom_visual.png\", x, y, \"data/biome_impl/orbroom_background.png\", true %)", "if not HasFlagPersistent(\"nee_cyclops_slime\") then LoadPixelScene( \"data/biome_impl/orbroom_noxioussludge.png\", \"data/biome_impl/orbroom_visual.png\", x, y, \"data/biome_impl/orbroom_background.png\", true ) else LoadPixelScene( \"data/biome_impl/apotheosis/orbroom_slime.png\", \"data/biome_impl/apotheosis/orbroom_visual_slime.png\", x, y, \"data/biome_impl/orbroom_background.png\", true ) end")
	content = content:gsub("EntityLoad%( \"mods/apotheosis/files/entities/items/orbs/custom/orb_14.xml\", x, y %)", "if not HasFlagPersistent(\"nee_cyclops_slime\") then EntityLoad( \"mods/apotheosis/files/entities/items/orbs/custom/orb_14.xml\", x, y ) else EntityLoad( \"data/entities/buildings/cyclops_slime_spot.xml\", x, y + 25 ) end")
	content = content:gsub("EntityLoad%( \"mods/apotheosis/files/entities/items/books/orbrooms/book_14.xml\", x %- 30, y %- 30 %)", "if not HasFlagPersistent(\"nee_cyclops_slime\") then EntityLoad( \"mods/apotheosis/files/entities/items/books/orbrooms/book_14.xml\", x - 30, y - 30 ) end")
	ModTextFileSetContent(path, content)

	--Basilisk Eel Boss Fight
	path = "mods/apotheosis/files/scripts/biomes/newbiome/orbroom_13.lua"
	content = ModTextFileGetContent(path)
	content = content:gsub("EntityLoad%( \"mods/apotheosis/files/entities/items/orbs/custom/orb_13.xml\", x, y %)", "if not HasFlagPersistent(\"nee_boss_eel\") then EntityLoad( \"mods/apotheosis/files/entities/items/orbs/custom/orb_13.xml\", x, y ) else EntityLoad( \"data/entities/buildings/boss_eel_spot.xml\", x, y + 25 ) end")
	content = content:gsub("EntityLoad%( \"mods/apotheosis/files/entities/items/books/orbrooms/book_13.xml\", x %- 30, y %- 30 %)", "if not HasFlagPersistent(\"nee_boss_eel\") then EntityLoad( \"mods/apotheosis/files/entities/items/books/orbrooms/book_13.xml\", x - 30, y - 30 ) end")
	ModTextFileSetContent(path, content)
	
	--Fungal Guardian Boss Fight
	path = "mods/apotheosis/files/scripts/biomes/newbiome/essenceroom_fungus.lua"
	content = ModTextFileGetContent(path)
	content = content:gsub("LoadPixelScene%( \"data/biome_impl/essenceroom.png\", \"data/biome_impl/essenceroom_visual.png\", x, y, \"data/biome_impl/essenceroom_background_with_diamond.png\"%, true %)", "if not HasFlagPersistent(\"nee_boss_fungus\") then LoadPixelScene%( \"data/biome_impl/essenceroom.png\", \"data/biome_impl/essenceroom_visual.png\", x, y, \"data/biome_impl/essenceroom_background_with_diamond.png\", true %) else LoadPixelScene( \"data/biome_impl/apotheosis/secret_lab.png\", \"data/biome_impl/apotheosis/secret_lab_visual.png\", x, y, \"data/biome_impl/apotheosis/secret_lab_background.png\", true ) end")
	content = content:gsub("EntityLoad%( \"mods/Apotheosis/files/entities/items/pickups/essence_fungus.xml\", x, y %)", "if not HasFlagPersistent(\"nee_boss_fungus\") then EntityLoad( \"mods/Apotheosis/files/entities/items/pickups/essence_fungus.xml\", x, y ) else EntityLoad( \"data/entities/buildings/boss_fungus_sleep.xml\", x, y ) end")
	ModTextFileSetContent(path, content)
	
	--TOTAL HAX> NO IDEA WHY THIS works
	--Just trying to only enable progress icons for this if apotheosis is enabled
	-- content = ModTextFileGetContent("data/ui_gfx/animal_icons/_list.txt")
	-- content = content .. "\n\\extras/ear_boss.png\n\\extras/cyclops_slime.png\n\\extras/boss_eel.png\n\\extras/boss_fungus.png"
	-- ModTextFileSetContent("data/ui_gfx/animal_icons/_list.txt", content)
	-- content = ModTextFileGetContent("data/ui_gfx/animal_icons/_list.txt")
end

--God spawner function:
--REMEMBER THAT I DISABLED THESE IN CONJURER BECAUSE THEY GIVE OUT AN ERROR!!!
if ModIsEnabled("raksa") == false then
	if HasFlagPersistent("nee_god_warrior") then
		local path = "data/biome/_pixel_scenes.xml"
		local content = ModTextFileGetContent(path)
		local xml = nxml.parse(content)
		xml:first_of("mBufferedPixelScenes"):add_child(nxml.parse([[
		  <PixelScene pos_x="256" pos_y="-25856" just_load_an_entity="data/entities/buildings/god_spot.xml" />]]))
		ModTextFileSetContent(path, tostring(xml))
		-- print(tostring(xml))
		-- replace_value("data/biome/_pixel_scenes.xml", 
		-- [[%<%!%-%- music machines have copies on both directly adjacent parallel worlds %-%-%>]], 
		-- [[<PixelScene pos_x="256" pos_y="-25856" just_load_an_entity="data/entities/buildings/god_spot.xml" /> 
		-- <!-- music machines have copies on both directly adjacent parallel worlds -->]]
		-- )
	end

	--Anti God spawner function:
	if HasFlagPersistent("nee_cthulhu") then
		local path = "data/biome/_pixel_scenes.xml"
		local content = ModTextFileGetContent(path)
		local xml = nxml.parse(content)
		xml:first_of("mBufferedPixelScenes"):add_child(nxml.parse([[
		  <PixelScene pos_x="265" pos_y="37769" just_load_an_entity="data/entities/buildings/cthulhu_spot.xml" />]]))
		ModTextFileSetContent(path, tostring(xml))
		-- print(tostring(xml))
		
		-- replace_value("data/biome/_pixel_scenes.xml", 
		-- [[%<%!%-%- music machines have copies on both directly adjacent parallel worlds %-%-%>]], 
		-- [[<PixelScene pos_x="265" pos_y="37769" just_load_an_entity="data/entities/buildings/cthulhu_spot.xml" /> 
		-- <!-- music machines have copies on both directly adjacent parallel worlds -->]]
		-- )
	end
end

-- function add_god_spot_spawner_script(player_entity)
    -- local lua_components = EntityGetComponent(player_entity, "LuaComponent") or {}
    -- local god_spot_spawner_found = false
    -- for i, comp in ipairs(lua_components) do
        -- local script_source_file = ComponentGetValue(comp, "script_source_file")
        -- if script_source_file == "data/scripts/god_spot_spawner.lua" then
            -- god_spot_spawner_found = true
            -- break
        -- end
    -- end
    -- if not god_spot_spawner_found and not GameHasFlagRun("god_spot_spawned") then
        -- EntityAddComponent(player_entity, "LuaComponent", {
            -- script_source_file="data/scripts/god_spot_spawner.lua",
            -- execute_times="-1",
            -- execute_every_n_frame="61",
        -- })
		-- GameAddFlagRun("god_spot_spawned")
    -- end
-- end


--Add New Enemies to Tower:
if not HasFlagPersistent("ned_tower_enemies") then
	if mode == "normal" or not mode then

		-- Specify the enemy name and flag name in this format: {enemy_name = enemy_flag_name}
		local enemies_to_check = {
		  mexxi = "mexxi",
		  worm_portal = "worm_portal",
		  coffin_mummy = "mummy",
		  hell_door = "hell_door",
		  corpse_lily = "corpse_lily",
		  beehive = "beehive",
		  fireworkman = "fireworkman",
		  skullspider = "skullspider",
		  phantom_boss = "phantom_boss",
		  plant_boss = "plant_boss",
		  mule_sleep = "mule",
		  bloodmage_enlightened = "bloodmage_enlightened",
		  gold_face_physics = "gold_face_physics",
		  chameleon = "chameleon",
		  mantis = "mantis",
		  scorpio = "scorpio",
		  crawler_bug = "crawler_bug",
		  larva_crawler = "larva_crawler",
		  spider_crawler = "spider_crawler",
		  flopper_mother_giant = "flopper_mother_giant",
		  shield_physics = "shield_physics",
		  kiwiki = "kiwiki",
		  jungle_flower = "jungle_flower",
		  oruai = "oruai",
		  flopper_mother = "flopper_mother",
		  wizard_tiny = "wizard_tiny",
		  minabomination = "minabomination",
		  scarab = "scarab",
		  beanpodupine = "beanpodupine",
		  skullspider = "skullspider",
		  cryogen = "cryogen",
		  welder = "welder",
		  flutterpede = "flutterpede",
		  hurpa = "hurpa",
		  manus = "manus",
		  polyp_gas = "polyp_gas",
		  conduit = "conduit",
		  drone_trail = "drone_trail",
		  irtokki = "irtokki",
		  tank_fire2 = "tank_fire2",
		  scavenger_poison_immunity = "scavenger_poison_immunity",
		  sporeling_tiny = "sporeling_tiny",
		  sporeling = "sporeling",
		  sporeling_large = "sporeling_large",
		  wizard_madness = "wizard_madness",
		  eradicator = "eradicator",
		  mirror_physics = "mirror_physics",
		  drone_beam = "drone_beam",
		  hazmat = "hazmat",
		  radiobot = "radiobot",
		  electrobot = "electrobot",
		  cargobot = "cargobot",
		  commander = "commander",
		  sawbot = "sawbot",
		  singularitor = "singularitor",
		  wraith_void2 = "wraith_void2",
		  -- blob_giant = "blob_giant",
		  -- giantfirebug = "giantfirebug",
		  alien = "alien",
		  mutant2 = "mutant2",
		  smoke_bot = "smoke_bot",
		  lukki_swamp2 = "lukki_swamp2",
		  fungus_swamp2 = "fungus_swamp2",
		  scavenger_electrocuter2 = "scavenger_electrocuter2",
		  drone_face2 = "drone_face2",
		  valkyrie2 = "valkyrie2",
		  wandmaster2 = "wandmaster2",
		  void_mask2 = "void_mask2",
		  phantom_trapper = "phantom_trapper",
		  potionmaster2 = "potionmaster2",
		  toxicmage_acid2 = "toxicmage_acid2",
		  toxicmage2 = "toxicmage2",
		  lost_soul_big = "lost_soul_big",
		  lost_soul = "lost_soul",
		  twig_grower = "twig",
		  player_ai = "player_ai",
		  menhir = "menhir",
		  knight = "knight",
		  wizard_trip = "wizard_trip",
		  -- worm_fungal = "worm_fungal",
		  igu = "igu",
		  chest_great_mimic = "chest_great_mimic",
		  hybrid = "hybrid",
		  scavenger_undercover = "scavenger_undercover",
		  zombie_giant = "zombie_giant",
		  head_statue_physics = "head_statue_physics",
		  fallen_alchemist = "fallen_alchemist",
		  icemage_big2 = "icemage_big2",
		  cyborg = "cyborg",
		  scavenger_laser = "scavenger_laser",
		  icicle_king = "icicle_king",
		  corrupt_alchemist = "corrupt_alchemist",
		  longleg_big = "longleg_big",
		  forgotten_alchemist = "forgotten_alchemist",
		  eldari_big = "eldari_big",
		  firemage_big = "firemage_big",
		  -- desulitor = "desulitor",
		  alchaos = "alchaos",
		  bloodmage_greater = "bloodmage_greater",
		  fire_crawler = "fire_crawler",
		  gazer_laser = "gazer_laser",
		  menace = "menace",
		  giant_energy = "giant_energy",
		  giant_alt = "giant_alt",
		  bloodmage_lesser = "bloodmage_lesser",
		  thou = "thou",
		  giant_old = "giant_old",
		  wizard_time = "wizard_time",
		  flesh_monster = "flesh_monster",
		  wizard_earthquake = "wizard_earthquake",
		  nova = "nova",
		  ghuu = "ghuu",
		  gonha = "gonha",
		  miner_alcohol = "miner_alcohol",
		  scavenger_alcohol = "scavenger_alcohol",
		  -- worm_eel = "worm_eel",
		  -- worm_robot = "worm_robot",
		  jellyfish = "jellyfish",
		  scavenger_radiolava = "scavenger_radiolava",
		  scavenger_compressor_robot = "scavenger_compressor_robot",
		  scavenger_turbo_robot = "scavenger_turbo_robot",
		  scavenger_gas_robot = "scavenger_gas_robot",
		  slime_turret = "slime_turret",
		  enigma = "enigma",
		  flesh_wall = "flesh_wall",
		  frog_bot = "frog_bot",
		  eye_bat = "eye_bat",
		  snowman = "snowman",
		  wraith_speed = "wraith_speed",
		  phan = "phan",
		  ooion = "ooion",
		  moal = "moal",
		  mutant_blob = "mutant_blob",
		  stone_crab = "stone_crab",
		  stalker_ceiling = "stalker_ceiling",
		  dripper = "dripper",
		  -- driller = "driller",
		  vine_monster = "vine_monster",
		  sneeker = "sneeker",
		  ground_terror = "ground_terror",
		  bouncer = "bouncer",
		  fungus_spore = "fungus_spore",
		  stalker = "stalker",
		  monkey = "monkey",
		  invisiman = "invisiman",
		  eye_monster = "eye_monster",
		  scavenger_robot = "scavenger_robot",
		  scavenger_compressor = "scavenger_compressor",
		  scavenger_turbo = "scavenger_turbo",
		  scavenger_gas = "scavenger_gas",
		  scavenger_oiler = "scavenger_oiler",
		  hairling = "hairling",
		  goomonster = "goomonster",
		  -- face_worm = "face_worm",
		  shapeshifter = "shapeshifter",
		  lukki_white = "lukki_white",
		  draghoul = "draghoul",
		  imp = "imp",
		  lukki_blue = "lukki_blue",
		  lukki_red = "lukki_red",
		  scavenger_trigger = "scavenger_trigger",
		  crawler = "crawler",
		  bot = "bot",
		  laserbot = "laserbot",
		  robot = "robot",
		  bluemancer = "bluemancer",
		  lavashooter = "lavashooter",
		  gigashooter = "gigashooter",
		  archer = "archer",
		  axeman = "axeman",
		  bigfly = "bigfly",
		  -- bloodskull = "bloodskull",
		  drone = "drone2",
		  earthskull = "earthskull",
		  electricskull = "electricskull",
		  earthmage = "earthmage",
		  polyshooter = "polyshooter",
		  chaoticpolyshooter = "chaoticpolyshooter",
		  watermonster = "watermonster",
		  acidmonster = "acidmonster",
		  bloodmonster = "bloodmonster",
		  scavenger_plasma = "scavenger_plasma",
		  creeper = "creeper",
		  bloom_ceiling = "ceiling_bloom",
		  ceilingflower = "ceilingflower",
		  landflower = "landflower",
		  book = "book",
		  darkghost = "darkghost2",
		  ent = "ent",
		  eyeling = "eyeling",
		  ghostling = "ghostling",
		  icemage = "icemage",
		  jungle_worm = "jungle_worm",
		  long_ghost = "long_ghost",
		  nautilus = "nautilus",
		  nightmare = "nightmare",
		  skeleton = "skeleton",
		  skullmage = "skullmage",
		  spider = "spider",
		  spooky_ghost = "spooky_ghost",
		  -- stone_physics = "stone_physics",
		  summoner = "summoner"
		  -- Add more enemies here
		}

		local creature_table = {}

		-- Check for the flag for each enemy
		for enemy_name, enemy_flag_name in pairs(enemies_to_check) do
		  if not HasFlagPersistent("ned_" .. enemy_flag_name) then
			table.insert(creature_table, enemy_name)
		  end
		end

		local concat_table = table.concat(creature_table, "\",\"")

		local path = "data/scripts/biomes/tower.lua"
		local content = ModTextFileGetContent(path)
		content = content:gsub([[local enemy_list = { "acidshooter", "alchemist", "ant",]], table.concat({[[enemy_list = { "acidshooter", "alchemist", "ant","]],concat_table,"\","}))
		ModTextFileSetContent(path, content)
		
	elseif mode == "easy" then
		-- Specify the enemy name and flag name in this format: {enemy_name = enemy_flag_name}
		local enemies_to_check = {
		  beehive = "beehive",
		  fireworkman = "fireworkman",
		  crawler_bug = "crawler_bug",
		  larva_crawler = "larva_crawler",
		  spider_crawler = "spider_crawler",
		  jungle_flower = "jungle_flower",
		  wizard_tiny = "wizard_tiny",
		  beanpodupine = "beanpodupine",
		  cryogen = "cryogen",
		  welder = "welder",
		  conduit = "conduit",
		  slime_ghoul = "slime_ghoul",
		  hazmat = "hazmat",
		  radiobot = "radiobot",
		  electrobot = "electrobot",
		  cargobot = "cargobot",
		  commander = "commander",
		  sawbot = "sawbot",
		  alien = "alien",
		  mutant2 = "mutant2",
		  lukki_swamp2 = "lukki_swamp2",
		  fungus_swamp2 = "fungus_swamp2",
		  scavenger_electrocuter2 = "scavenger_electrocuter2",
		  drone_face2 = "drone_face2",
		  valkyrie2 = "valkyrie2",
		  phantom_trapper = "phantom_trapper",
		  potionmaster2 = "potionmaster2",
		  toxicmage2 = "toxicmage2",
		  lost_soul = "lost_soul",
		  twig = "twig_grower",
		  menhir = "menhir",
		  knight = "knight",
		  wizard_trip = "wizard_trip",
		  hybrid = "hybrid",
		  scavenger_undercover = "scavenger_undercover",
		  zombie_giant = "zombie_giant",
		  head_statue_physics = "head_statue_physics",
		  fallen_alchemist = "fallen_alchemist",
		  cyborg = "cyborg",
		  scavenger_laser = "scavenger_laser",
		  corrupt_alchemist = "corrupt_alchemist",
		  longleg_big = "longleg_big",
		  forgotten_alchemist = "forgotten_alchemist",
		  eldari_big = "eldari_big",
		  firemage_big = "firemage_big",
		  -- desulitor = "desulitor",
		  fire_crawler = "fire_crawler",
		  giant_energy = "giant_energy",
		  giant_alt = "giant_alt",
		  bloodmage_lesser = "bloodmage_lesser",
		  giant_old = "giant_old",
		  wizard_time = "wizard_time",
		  wizard_earthquake = "wizard_earthquake",
		  gonha = "gonha",
		  miner_alcohol = "miner_alcohol",
		  scavenger_alcohol = "scavenger_alcohol",
		  enigma = "enigma",
		  frog_bot = "frog_bot",
		  eye_bat = "eye_bat",
		  snowman = "snowman",
		  ooion = "ooion",
		  moal = "moal",
		  mutant_blob = "mutant_blob",
		  stalker_ceiling = "stalker_ceiling",
		  dripper = "dripper",
		  -- driller = "driller",
		  vine_monster = "vine_monster",
		  sneeker = "sneeker",
		  bouncer = "bouncer",
		  stalker = "stalker",
		  monkey = "monkey",
		  invisiman = "invisiman",
		  eye_monster = "eye_monster",
		  scavenger_compressor = "scavenger_compressor",
		  scavenger_gas = "scavenger_gas",
		  scavenger_oiler = "scavenger_oiler",
		  goomonster = "goomonster",
		  shapeshifter = "shapeshifter",
		  draghoul = "draghoul",
		  imp = "imp",
		  scavenger_trigger = "scavenger_trigger",
		  crawler = "crawler",
		  bot = "bot",
		  laserbot = "laserbot",
		  bluemancer = "bluemancer",
		  gigashooter = "gigashooter",
		  archer = "archer",
		  axeman = "axeman",
		  bigfly = "bigfly",
		  -- bloodskull = "bloodskull",
		  drone2 = "drone2",
		  earthmage = "earthmage",
		  scavenger_plasma = "scavenger_plasma",
		  creeper = "creeper",
		  darkghost2 = "darkghost2",
		  ent = "ent",
		  eyeling = "eyeling",
		  ghostling = "ghostling",
		  icemage = "icemage",
		  icicle = "icicle",
		  long_ghost = "long_ghost",
		  nautilus = "nautilus",
		  nightmare = "nightmare",
		  skeleton = "skeleton",
		  skullmage = "skullmage",
		  spider = "spider",
		  summoner = "summoner"
		  -- Add more enemies here
		}

		local creature_table = {}

		-- Check for the flag for each enemy
		for enemy_name, enemy_flag_name in pairs(enemies_to_check) do
		  if not HasFlagPersistent("ned_" .. enemy_flag_name) then
			table.insert(creature_table, enemy_name)
		  end
		end

		local concat_table = table.concat(creature_table, "\",\"")

		local path = "data/scripts/biomes/tower.lua"
		local content = ModTextFileGetContent(path)
		content = content:gsub([[local enemy_list = { "acidshooter", "alchemist", "ant",]], table.concat({[[local enemy_list = { "acidshooter", "alchemist", "ant","]],concat_table,"\","}))
		ModTextFileSetContent(path, content)
	end
end

--This is for mwyah's platforming stage
--Modify gun.lua a bit for temporary removal of recoil from wands
ModLuaFileAppend( "data/scripts/gun/gun.lua", "data/scripts/misc/gun_append.lua" )

--On Player Spawned
function OnPlayerSpawned(player_entity)

    if (GlobalsGetValue("new_enemies_mod_load_done", 0) == "1") then
      return
    end

	--Another Shader Check Just In Case
	if not HasFlagPersistent("ned_wizard_tiny") then
		GameSetPostFxParameter("zoom_in_amount", 1.0, 0, 0, 0)
	end
	
	--Addition of custom polymorph enemies
	if ModSettingGet("new_enemies.poly_expansion_enabled") then
		--PolymorphTableAddEntity( entity_xml:string, is_rare:bool = false, add_only_one_copy:bool = true )
		PolymorphTableAddEntity( "data/entities/animals/acidmonster.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/alchaos.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/alien.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/alligator_temple.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/alligator_temple_small.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/angler.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/archer.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/axeman.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/babon.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/beanpodupine.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/angler.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/blob_giant.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/bloodmage_greater.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/bloodmage_lesser.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/bloodmonster.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/bloodskull.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/bloom_ceiling.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/bluemancer.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/book.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/bot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/bouncer.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/camel.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/cargobot.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/ceilingflower.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/chaoticpolyshooter.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/chest_great_mimic.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/cobra.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/commander.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/conduit.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/copter.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/corrupt_alchemist.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/crawler.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/creeper.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/cyborg.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/darkghost2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/flutterpede.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/cryogen.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/desulitor.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/desulitor_fly.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/doom_bringer.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/draghoul.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/poly/drake_snake.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/driller.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/dripper.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/drone_beam.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/drone_face2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/drone_trail.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/drone2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/earthmage.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/earthskull.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/eldari_big.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/electricskull.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/electrobot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/draghoul.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/enigma.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/ent.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/eradicator.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/eye.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/eye_bat.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/eye_bat_birthday.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/eye_bat_easter.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/eye_bat_pumpkin.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/eye_bat_valentines.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/eye_monster.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/eyeling.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/face_worm.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/fallen_alchemist.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/fire_crawler.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/firemage_big.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/fish_angler2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/flesh_monster.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/flutterpede.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/forgotten_alchemist.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/frog_bot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/frog_tiny.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/fungus_spore.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/fungus_swamp2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/gazer_laser.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/ghostling.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/ghuu.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/giant_alt.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/giant_energy.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/giant_old.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/giant_squid.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/giantfirebug.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/gigashooter.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/gonha.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/goomonster.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/goomonster_giant.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/ground_terror.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/hairling.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/hazmat.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/head_statue_physics.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/hurpa.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/hybrid.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/icemage_big2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/icemage2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/icicle.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/icicle_ceiling.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/icicle_king.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/igu.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/imp.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/invisiman.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/irtokki.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/jellyfish.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/jungle_worm.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/junkbot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/knight.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/landflower.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/laserbot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lavashooter.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lightling.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/llama.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/locust.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/long_ghost.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/longleg_big.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lost_soul.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lost_soul_big.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lukki_blue.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lukki_ominous.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lukki_red.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lukki_swamp2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lukki_weird.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/lukki_white.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/mammoth.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/mammoth_baby.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/manus.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/menace.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/menhir.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/minabomination.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/miner_alcohol.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/mirror_physics.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/moal.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/monkey.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/mutant2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/nautilus.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/nightmare.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/nova.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/ooion.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/peasant.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/peasant_blue.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/peasant_red.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/phan.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/phantom_trapper.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/poly/phantom_boss.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/poly/mutant_blob.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/player_ai.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/player_clone.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/player_decoy.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/polyp_gas.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/polyshooter.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/potionmaster2.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/quin.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/radiobot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/robot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/sawbot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scarab.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_alcohol.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_civilian.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_compressor.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_compressor_robot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_electrocuter2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_gas.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_gas_robot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_laser.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_monster.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_oiler.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_plasma.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_poison_immunity.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_radiolava.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_robot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_trigger.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_turbo.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_turbo_robot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_undercover.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/serpentor.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/shark.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/singularitor.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_4th_july.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_4th_july_firework.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_antlorz.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_beer.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_birthday.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_bull_fighting.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_candy.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_carnevale.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_carnival.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_champagne.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_christmas.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_diwalli.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_easter_bunny.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_green.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_lunar_new_year.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_guitar.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_guitar2.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_guitarron.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_guitarron2.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_harp.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_harp2.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_maraca.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_maraca2.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_trumpet.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_trumpet2.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_violin.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_mariachi_violin2.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_oriental.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_present.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_pride.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_pumpkin.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_thanksgiving.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_valentines.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skeleton_vampire.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skullmage.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/skullspider.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/slime_ghoul.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/slime_roller.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/slime_turret.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/slimeshooter_golden.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/smoke_bot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/sneeker.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/snowman.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/spider.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/spooky_ghost.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/sporeling.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/sporeling_large.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/sporeling_tiny.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/stalker.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/stalker_ceiling.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/stingray.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/stone_crab.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/stone_physics.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/summoner.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/tank_fire2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/thou.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/toxicmage_acid2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/toxicmage2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/trumpet.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/twig.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/valkyrie2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/vine_monster.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/void_mask2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wandmaster2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/watermonster.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/welder.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wizard_earthquake.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wizard_madness.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wizard_random.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wizard_time.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wizard_trip.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wizard_twin.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/worm_eel.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/worm_fungal.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/worm_robot.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/worm_skull_old.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wraith_speed.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/wraith_void2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/zap_eel2.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/zombie_giant.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/zombie3.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/flopper_mother.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/oruai.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/jungle_flower.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/kiwiki.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/shield_physics.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/flopper_mother_giant.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/scorpio.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/mantis.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/chameleon.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/corpse_lily.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/mexxi.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/mummy.xml", false, true )
		
		--Minibosses
		PolymorphTableAddEntity( "data/entities/animals/gazer_necromancer.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/blood_teddy.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/cerebracle.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/dragon_ice.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/khulu.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/lempo.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/medusa.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/miner_boss.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/mother_nature.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/necromancer_omega.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_king.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/scavenger_king_robot.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/shiva.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/skull_abomination.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/slimeshooter_mega.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/sochaos.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/tardigrade.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/tank_boss.xml", true, true )
		PolymorphTableAddEntity( "data/entities/animals/terminator.xml", true, true )
		
		--Colossi
		-- PolymorphTableAddEntity( "data/entities/animals/aquatitan.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/hell_overseer.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/devourer.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/stork.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/whale.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/piranha.xml", false, true )
		
		--Bosses
		PolymorphTableAddEntity( "data/entities/animals/bird.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/camel_robot.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/cthulhu.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/desert_mage.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/desert_skull.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/elephant.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/giant_boss.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/god_warrior.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/golem.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/hydra.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/lake_statue.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/lukki_dark_huge.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/mwyah.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/mwyah_face.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/seamonster.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/skymonster.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/windmill.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/wraith_boss.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/yikka.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/yikka_ghost.xml", false, true )

		--Removed enemies
		-- PolymorphTableAddEntity( "data/entities/animals/fireflower.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/glyptodillo.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/lurker2.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/mysterious_wanderer.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/necromancer_polymorph.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/sneeker_weak.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/temple_skeleton.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/wanderer.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/wizard_toxic.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/wizard_water.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/wraith_old.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/wyrm.xml", false, true )
		
		--Removed mini bosses
		-- PolymorphTableAddEntity( "data/entities/animals/boss_rock_spirit.xml", true, true )
		
		--Removed Bosses
		-- PolymorphTableAddEntity( "data/entities/animals/fury1.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/fury2.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/fury3.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/god.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/harpy1.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/harpy2.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/harpy3.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/lava_monster.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/naga.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/skeleboss.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/sorceress.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/ghust.xml", false, true )
		-- PolymorphTableAddEntity( "data/entities/animals/temple_creep_skull.xml", true, true )
		
		--Easter Eggs
		PolymorphTableAddEntity( "data/entities/animals/lemming.xml", false, true )
		PolymorphTableAddEntity( "data/entities/animals/tank_propane.xml", false, true )
	end

	--Addition of God spot in moon
	
	-- if HasFlagPersistent("nee_god") then
		-- add_god_spot_spawner_script(player_entity)
	-- end
	
	--Addition of materials that damage to player
	
    add_materials_that_damage(player_entity, {
	  boss_fungus_gas = 0.0006,
      cloud_acid = 0.005,
      acid_weak = 0.00075,
      midas_toxic = 0.0005,
      rock_static_cursed_green2 = 0.001,
	  rock_box2d_hard_damage = 0.0003,
	  rock_box2d_harder_damage = 0.001
    })
	
	--Addition of position tracker to player
	
	-- EntityAddComponent(player_entity, "VariableStorageComponent", {
		-- name="position_tracker",
		-- value_string=""
	-- })
					
	-- EntityAddComponent(player_entity, "LuaComponent", {
		-- script_source_file="data/scripts/misc/position_tracker.lua",
		-- execute_every_n_frame=2,
		-- execute_on_added=0,
	-- }) 
	
	--flag reset:
	
	-- EntityAddComponent(player_entity, "LuaComponent", {
		-- script_source_file="data/scripts/misc/flag_reset.lua",
		-- execute_every_n_frame=-1,
		-- execute_on_added=0,
		-- execute_on_removed=1,
	-- })
	if ModSettingGet("new_enemies.disable_offscreen_attacks_enabled") then
		EntityAddComponent2(player_entity, "LuaComponent", {
			script_source_file="mods/new_enemies/files/disable_offscreen_attacks.lua",
			execute_every_n_frame=1,
			execute_on_added=false,
		})
	end
	
	GlobalsSetValue("new_enemies_mod_load_done", "1")
	
end